/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*115 cases */, 5|128,11/*1413*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1418
/*     5*/  OPC_Scope, 120|128,10/*1400*/, /*->1408*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 16|128,1/*144*/, TARGET_VAL(ISD::AssertZext),// ->158
/*    14*/    OPC_MoveChild0,
/*    15*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    18*/    OPC_RecordMemRef,
/*    19*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    20*/    OPC_CheckFoldableChainNode,
/*    21*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    22*/    OPC_Scope, 66, /*->90*/ // 2 children in Scope
/*    24*/     OPC_CheckChild1Type, MVT::i32,
/*    26*/     OPC_MoveChild2,
/*    27*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    30*/     OPC_RecordChild0, // #2 = $exp
/*    31*/     OPC_MoveParent,
/*    32*/     OPC_MoveChild3,
/*    33*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    36*/     OPC_RecordChild0, // #3 = $new
/*    37*/     OPC_MoveParent,
/*    38*/     OPC_Scope, 24, /*->64*/ // 2 children in Scope
/*    40*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*    42*/      OPC_MoveParent,
/*    43*/      OPC_MoveParent,
/*    44*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    46*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    49*/      OPC_EmitMergeInputChains1_0,
/*    50*/      OPC_EmitInteger, MVT::i32, 0, 
/*    53*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    64*/     /*Scope*/ 24, /*->89*/
/*    65*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*    67*/      OPC_MoveParent,
/*    68*/      OPC_MoveParent,
/*    69*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    71*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    74*/      OPC_EmitMergeInputChains1_0,
/*    75*/      OPC_EmitInteger, MVT::i32, 0, 
/*    78*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    89*/     0, /*End of Scope*/
/*    90*/    /*Scope*/ 66, /*->157*/
/*    91*/     OPC_CheckChild1Type, MVT::i64,
/*    93*/     OPC_MoveChild2,
/*    94*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    97*/     OPC_RecordChild0, // #2 = $exp
/*    98*/     OPC_MoveParent,
/*    99*/     OPC_MoveChild3,
/*   100*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   103*/     OPC_RecordChild0, // #3 = $new
/*   104*/     OPC_MoveParent,
/*   105*/     OPC_Scope, 24, /*->131*/ // 2 children in Scope
/*   107*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*   109*/      OPC_MoveParent,
/*   110*/      OPC_MoveParent,
/*   111*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   113*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   116*/      OPC_EmitMergeInputChains1_0,
/*   117*/      OPC_EmitInteger, MVT::i32, 0, 
/*   120*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   131*/     /*Scope*/ 24, /*->156*/
/*   132*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*   134*/      OPC_MoveParent,
/*   135*/      OPC_MoveParent,
/*   136*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   138*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   141*/      OPC_EmitMergeInputChains1_0,
/*   142*/      OPC_EmitInteger, MVT::i32, 0, 
/*   145*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   156*/     0, /*End of Scope*/
/*   157*/    0, /*End of Scope*/
/*   158*/   /*SwitchOpcode*/ 81, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->242
/*   161*/    OPC_RecordMemRef,
/*   162*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   163*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   164*/    OPC_Scope, 37, /*->203*/ // 2 children in Scope
/*   166*/     OPC_CheckChild1Type, MVT::i32,
/*   168*/     OPC_MoveChild2,
/*   169*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   172*/     OPC_RecordChild0, // #2 = $exp
/*   173*/     OPC_MoveParent,
/*   174*/     OPC_MoveChild3,
/*   175*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   178*/     OPC_RecordChild0, // #3 = $new
/*   179*/     OPC_MoveParent,
/*   180*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/*   182*/     OPC_MoveParent,
/*   183*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   185*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   188*/     OPC_EmitMergeInputChains1_0,
/*   189*/     OPC_EmitInteger, MVT::i32, 0, 
/*   192*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   203*/    /*Scope*/ 37, /*->241*/
/*   204*/     OPC_CheckChild1Type, MVT::i64,
/*   206*/     OPC_MoveChild2,
/*   207*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   210*/     OPC_RecordChild0, // #2 = $exp
/*   211*/     OPC_MoveParent,
/*   212*/     OPC_MoveChild3,
/*   213*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   216*/     OPC_RecordChild0, // #3 = $new
/*   217*/     OPC_MoveParent,
/*   218*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/*   220*/     OPC_MoveParent,
/*   221*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   223*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   226*/     OPC_EmitMergeInputChains1_0,
/*   227*/     OPC_EmitInteger, MVT::i32, 0, 
/*   230*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   241*/    0, /*End of Scope*/
/*   242*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->411
/*   246*/    OPC_RecordMemRef,
/*   247*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   248*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   249*/    OPC_Scope, 79, /*->330*/ // 2 children in Scope
/*   251*/     OPC_CheckChild1Type, MVT::i32,
/*   253*/     OPC_MoveChild2,
/*   254*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   257*/     OPC_RecordChild0, // #2 = $val
/*   258*/     OPC_MoveParent,
/*   259*/     OPC_Scope, 22, /*->283*/ // 3 children in Scope
/*   261*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*   263*/      OPC_MoveParent,
/*   264*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   266*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   269*/      OPC_EmitMergeInputChains1_0,
/*   270*/      OPC_EmitInteger, MVT::i32, 0, 
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     /*Scope*/ 22, /*->306*/
/*   284*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*   286*/      OPC_MoveParent,
/*   287*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   289*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   292*/      OPC_EmitMergeInputChains1_0,
/*   293*/      OPC_EmitInteger, MVT::i32, 0, 
/*   296*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   306*/     /*Scope*/ 22, /*->329*/
/*   307*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*   309*/      OPC_MoveParent,
/*   310*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   312*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   315*/      OPC_EmitMergeInputChains1_0,
/*   316*/      OPC_EmitInteger, MVT::i32, 0, 
/*   319*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   329*/     0, /*End of Scope*/
/*   330*/    /*Scope*/ 79, /*->410*/
/*   331*/     OPC_CheckChild1Type, MVT::i64,
/*   333*/     OPC_MoveChild2,
/*   334*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   337*/     OPC_RecordChild0, // #2 = $val
/*   338*/     OPC_MoveParent,
/*   339*/     OPC_Scope, 22, /*->363*/ // 3 children in Scope
/*   341*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*   343*/      OPC_MoveParent,
/*   344*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   346*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   349*/      OPC_EmitMergeInputChains1_0,
/*   350*/      OPC_EmitInteger, MVT::i32, 0, 
/*   353*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   363*/     /*Scope*/ 22, /*->386*/
/*   364*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*   366*/      OPC_MoveParent,
/*   367*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   369*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   372*/      OPC_EmitMergeInputChains1_0,
/*   373*/      OPC_EmitInteger, MVT::i32, 0, 
/*   376*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   386*/     /*Scope*/ 22, /*->409*/
/*   387*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*   389*/      OPC_MoveParent,
/*   390*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   395*/      OPC_EmitMergeInputChains1_0,
/*   396*/      OPC_EmitInteger, MVT::i32, 0, 
/*   399*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   409*/     0, /*End of Scope*/
/*   410*/    0, /*End of Scope*/
/*   411*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->580
/*   415*/    OPC_RecordMemRef,
/*   416*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   417*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   418*/    OPC_Scope, 79, /*->499*/ // 2 children in Scope
/*   420*/     OPC_CheckChild1Type, MVT::i32,
/*   422*/     OPC_MoveChild2,
/*   423*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   426*/     OPC_RecordChild0, // #2 = $val
/*   427*/     OPC_MoveParent,
/*   428*/     OPC_Scope, 22, /*->452*/ // 3 children in Scope
/*   430*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*   432*/      OPC_MoveParent,
/*   433*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   435*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   438*/      OPC_EmitMergeInputChains1_0,
/*   439*/      OPC_EmitInteger, MVT::i32, 0, 
/*   442*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   452*/     /*Scope*/ 22, /*->475*/
/*   453*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*   455*/      OPC_MoveParent,
/*   456*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   458*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger, MVT::i32, 0, 
/*   465*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   475*/     /*Scope*/ 22, /*->498*/
/*   476*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*   478*/      OPC_MoveParent,
/*   479*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   481*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   484*/      OPC_EmitMergeInputChains1_0,
/*   485*/      OPC_EmitInteger, MVT::i32, 0, 
/*   488*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   498*/     0, /*End of Scope*/
/*   499*/    /*Scope*/ 79, /*->579*/
/*   500*/     OPC_CheckChild1Type, MVT::i64,
/*   502*/     OPC_MoveChild2,
/*   503*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   506*/     OPC_RecordChild0, // #2 = $val
/*   507*/     OPC_MoveParent,
/*   508*/     OPC_Scope, 22, /*->532*/ // 3 children in Scope
/*   510*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*   512*/      OPC_MoveParent,
/*   513*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   515*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger, MVT::i32, 0, 
/*   522*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   532*/     /*Scope*/ 22, /*->555*/
/*   533*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*   535*/      OPC_MoveParent,
/*   536*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   538*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   541*/      OPC_EmitMergeInputChains1_0,
/*   542*/      OPC_EmitInteger, MVT::i32, 0, 
/*   545*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   555*/     /*Scope*/ 22, /*->578*/
/*   556*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*   558*/      OPC_MoveParent,
/*   559*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   561*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   564*/      OPC_EmitMergeInputChains1_0,
/*   565*/      OPC_EmitInteger, MVT::i32, 0, 
/*   568*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   578*/     0, /*End of Scope*/
/*   579*/    0, /*End of Scope*/
/*   580*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->749
/*   584*/    OPC_RecordMemRef,
/*   585*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   586*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   587*/    OPC_Scope, 79, /*->668*/ // 2 children in Scope
/*   589*/     OPC_CheckChild1Type, MVT::i32,
/*   591*/     OPC_MoveChild2,
/*   592*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   595*/     OPC_RecordChild0, // #2 = $val
/*   596*/     OPC_MoveParent,
/*   597*/     OPC_Scope, 22, /*->621*/ // 3 children in Scope
/*   599*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*   601*/      OPC_MoveParent,
/*   602*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   604*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   607*/      OPC_EmitMergeInputChains1_0,
/*   608*/      OPC_EmitInteger, MVT::i32, 0, 
/*   611*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   621*/     /*Scope*/ 22, /*->644*/
/*   622*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*   624*/      OPC_MoveParent,
/*   625*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   627*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   630*/      OPC_EmitMergeInputChains1_0,
/*   631*/      OPC_EmitInteger, MVT::i32, 0, 
/*   634*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   644*/     /*Scope*/ 22, /*->667*/
/*   645*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*   647*/      OPC_MoveParent,
/*   648*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   650*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   653*/      OPC_EmitMergeInputChains1_0,
/*   654*/      OPC_EmitInteger, MVT::i32, 0, 
/*   657*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   667*/     0, /*End of Scope*/
/*   668*/    /*Scope*/ 79, /*->748*/
/*   669*/     OPC_CheckChild1Type, MVT::i64,
/*   671*/     OPC_MoveChild2,
/*   672*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   675*/     OPC_RecordChild0, // #2 = $val
/*   676*/     OPC_MoveParent,
/*   677*/     OPC_Scope, 22, /*->701*/ // 3 children in Scope
/*   679*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*   681*/      OPC_MoveParent,
/*   682*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   684*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   687*/      OPC_EmitMergeInputChains1_0,
/*   688*/      OPC_EmitInteger, MVT::i32, 0, 
/*   691*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   701*/     /*Scope*/ 22, /*->724*/
/*   702*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*   704*/      OPC_MoveParent,
/*   705*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   707*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   710*/      OPC_EmitMergeInputChains1_0,
/*   711*/      OPC_EmitInteger, MVT::i32, 0, 
/*   714*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   724*/     /*Scope*/ 22, /*->747*/
/*   725*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*   727*/      OPC_MoveParent,
/*   728*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   730*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   733*/      OPC_EmitMergeInputChains1_0,
/*   734*/      OPC_EmitInteger, MVT::i32, 0, 
/*   737*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   747*/     0, /*End of Scope*/
/*   748*/    0, /*End of Scope*/
/*   749*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->918
/*   753*/    OPC_RecordMemRef,
/*   754*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   755*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   756*/    OPC_Scope, 79, /*->837*/ // 2 children in Scope
/*   758*/     OPC_CheckChild1Type, MVT::i32,
/*   760*/     OPC_MoveChild2,
/*   761*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   764*/     OPC_RecordChild0, // #2 = $val
/*   765*/     OPC_MoveParent,
/*   766*/     OPC_Scope, 22, /*->790*/ // 3 children in Scope
/*   768*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*   770*/      OPC_MoveParent,
/*   771*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   773*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   776*/      OPC_EmitMergeInputChains1_0,
/*   777*/      OPC_EmitInteger, MVT::i32, 0, 
/*   780*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   790*/     /*Scope*/ 22, /*->813*/
/*   791*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*   793*/      OPC_MoveParent,
/*   794*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   796*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   799*/      OPC_EmitMergeInputChains1_0,
/*   800*/      OPC_EmitInteger, MVT::i32, 0, 
/*   803*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   813*/     /*Scope*/ 22, /*->836*/
/*   814*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*   816*/      OPC_MoveParent,
/*   817*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   819*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   822*/      OPC_EmitMergeInputChains1_0,
/*   823*/      OPC_EmitInteger, MVT::i32, 0, 
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     0, /*End of Scope*/
/*   837*/    /*Scope*/ 79, /*->917*/
/*   838*/     OPC_CheckChild1Type, MVT::i64,
/*   840*/     OPC_MoveChild2,
/*   841*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   844*/     OPC_RecordChild0, // #2 = $val
/*   845*/     OPC_MoveParent,
/*   846*/     OPC_Scope, 22, /*->870*/ // 3 children in Scope
/*   848*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*   850*/      OPC_MoveParent,
/*   851*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   853*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   856*/      OPC_EmitMergeInputChains1_0,
/*   857*/      OPC_EmitInteger, MVT::i32, 0, 
/*   860*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   870*/     /*Scope*/ 22, /*->893*/
/*   871*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*   873*/      OPC_MoveParent,
/*   874*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   876*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   879*/      OPC_EmitMergeInputChains1_0,
/*   880*/      OPC_EmitInteger, MVT::i32, 0, 
/*   883*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   893*/     /*Scope*/ 22, /*->916*/
/*   894*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*   896*/      OPC_MoveParent,
/*   897*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   899*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   902*/      OPC_EmitMergeInputChains1_0,
/*   903*/      OPC_EmitInteger, MVT::i32, 0, 
/*   906*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   916*/     0, /*End of Scope*/
/*   917*/    0, /*End of Scope*/
/*   918*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1087
/*   922*/    OPC_RecordMemRef,
/*   923*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   924*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   925*/    OPC_Scope, 79, /*->1006*/ // 2 children in Scope
/*   927*/     OPC_CheckChild1Type, MVT::i32,
/*   929*/     OPC_MoveChild2,
/*   930*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   933*/     OPC_RecordChild0, // #2 = $val
/*   934*/     OPC_MoveParent,
/*   935*/     OPC_Scope, 22, /*->959*/ // 3 children in Scope
/*   937*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*   939*/      OPC_MoveParent,
/*   940*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   942*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   945*/      OPC_EmitMergeInputChains1_0,
/*   946*/      OPC_EmitInteger, MVT::i32, 0, 
/*   949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   959*/     /*Scope*/ 22, /*->982*/
/*   960*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   965*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   968*/      OPC_EmitMergeInputChains1_0,
/*   969*/      OPC_EmitInteger, MVT::i32, 0, 
/*   972*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   982*/     /*Scope*/ 22, /*->1005*/
/*   983*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*   985*/      OPC_MoveParent,
/*   986*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   988*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   991*/      OPC_EmitMergeInputChains1_0,
/*   992*/      OPC_EmitInteger, MVT::i32, 0, 
/*   995*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1005*/     0, /*End of Scope*/
/*  1006*/    /*Scope*/ 79, /*->1086*/
/*  1007*/     OPC_CheckChild1Type, MVT::i64,
/*  1009*/     OPC_MoveChild2,
/*  1010*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1013*/     OPC_RecordChild0, // #2 = $val
/*  1014*/     OPC_MoveParent,
/*  1015*/     OPC_Scope, 22, /*->1039*/ // 3 children in Scope
/*  1017*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  1019*/      OPC_MoveParent,
/*  1020*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1022*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1025*/      OPC_EmitMergeInputChains1_0,
/*  1026*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1029*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1039*/     /*Scope*/ 22, /*->1062*/
/*  1040*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  1042*/      OPC_MoveParent,
/*  1043*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1045*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1048*/      OPC_EmitMergeInputChains1_0,
/*  1049*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1052*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1062*/     /*Scope*/ 22, /*->1085*/
/*  1063*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*  1065*/      OPC_MoveParent,
/*  1066*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1068*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1071*/      OPC_EmitMergeInputChains1_0,
/*  1072*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1075*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1085*/     0, /*End of Scope*/
/*  1086*/    0, /*End of Scope*/
/*  1087*/   /*SwitchOpcode*/ 37|128,1/*165*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1256
/*  1091*/    OPC_RecordMemRef,
/*  1092*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1093*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1094*/    OPC_Scope, 79, /*->1175*/ // 2 children in Scope
/*  1096*/     OPC_CheckChild1Type, MVT::i32,
/*  1098*/     OPC_MoveChild2,
/*  1099*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1102*/     OPC_RecordChild0, // #2 = $val
/*  1103*/     OPC_MoveParent,
/*  1104*/     OPC_Scope, 22, /*->1128*/ // 3 children in Scope
/*  1106*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  1108*/      OPC_MoveParent,
/*  1109*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1111*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1114*/      OPC_EmitMergeInputChains1_0,
/*  1115*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1118*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1128*/     /*Scope*/ 22, /*->1151*/
/*  1129*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  1131*/      OPC_MoveParent,
/*  1132*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1134*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1137*/      OPC_EmitMergeInputChains1_0,
/*  1138*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1141*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1151*/     /*Scope*/ 22, /*->1174*/
/*  1152*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/*  1154*/      OPC_MoveParent,
/*  1155*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1157*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1160*/      OPC_EmitMergeInputChains1_0,
/*  1161*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1164*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1174*/     0, /*End of Scope*/
/*  1175*/    /*Scope*/ 79, /*->1255*/
/*  1176*/     OPC_CheckChild1Type, MVT::i64,
/*  1178*/     OPC_MoveChild2,
/*  1179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1182*/     OPC_RecordChild0, // #2 = $val
/*  1183*/     OPC_MoveParent,
/*  1184*/     OPC_Scope, 22, /*->1208*/ // 3 children in Scope
/*  1186*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  1188*/      OPC_MoveParent,
/*  1189*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1191*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1194*/      OPC_EmitMergeInputChains1_0,
/*  1195*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1198*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1208*/     /*Scope*/ 22, /*->1231*/
/*  1209*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  1211*/      OPC_MoveParent,
/*  1212*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1214*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1217*/      OPC_EmitMergeInputChains1_0,
/*  1218*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1221*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1231*/     /*Scope*/ 22, /*->1254*/
/*  1232*/      OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/*  1234*/      OPC_MoveParent,
/*  1235*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1237*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1240*/      OPC_EmitMergeInputChains1_0,
/*  1241*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1244*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1254*/     0, /*End of Scope*/
/*  1255*/    0, /*End of Scope*/
/*  1256*/   /*SwitchOpcode*/ 19|128,1/*147*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1407
/*  1260*/    OPC_RecordMemRef,
/*  1261*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1262*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1263*/    OPC_Scope, 70, /*->1335*/ // 2 children in Scope
/*  1265*/     OPC_CheckChild1Type, MVT::i32,
/*  1267*/     OPC_Scope, 21, /*->1290*/ // 3 children in Scope
/*  1269*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  1271*/      OPC_MoveParent,
/*  1272*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  1274*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1277*/      OPC_EmitMergeInputChains1_0,
/*  1278*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1281*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1290*/     /*Scope*/ 21, /*->1312*/
/*  1291*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  1293*/      OPC_MoveParent,
/*  1294*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  1296*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1299*/      OPC_EmitMergeInputChains1_0,
/*  1300*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1312*/     /*Scope*/ 21, /*->1334*/
/*  1313*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  1315*/      OPC_MoveParent,
/*  1316*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  1318*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1321*/      OPC_EmitMergeInputChains1_0,
/*  1322*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1325*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1334*/     0, /*End of Scope*/
/*  1335*/    /*Scope*/ 70, /*->1406*/
/*  1336*/     OPC_CheckChild1Type, MVT::i64,
/*  1338*/     OPC_Scope, 21, /*->1361*/ // 3 children in Scope
/*  1340*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  1342*/      OPC_MoveParent,
/*  1343*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  1345*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1348*/      OPC_EmitMergeInputChains1_0,
/*  1349*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1352*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1361*/     /*Scope*/ 21, /*->1383*/
/*  1362*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  1364*/      OPC_MoveParent,
/*  1365*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  1367*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1370*/      OPC_EmitMergeInputChains1_0,
/*  1371*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1374*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1383*/     /*Scope*/ 21, /*->1405*/
/*  1384*/      OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  1386*/      OPC_MoveParent,
/*  1387*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  1389*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1392*/      OPC_EmitMergeInputChains1_0,
/*  1393*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1396*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1405*/     0, /*End of Scope*/
/*  1406*/    0, /*End of Scope*/
/*  1407*/   0, // EndSwitchOpcode
/*  1408*/  /*Scope*/ 8, /*->1417*/
/*  1409*/   OPC_RecordChild0, // #0 = $src
/*  1410*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1417*/  0, /*End of Scope*/
/*  1418*/ /*SwitchOpcode*/ 106|128,7/*1002*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2424
/*  1422*/  OPC_Scope, 93|128,7/*989*/, /*->2414*/ // 2 children in Scope
/*  1425*/   OPC_MoveChild0,
/*  1426*/   OPC_SwitchOpcode /*8 cases */, 16|128,1/*144*/, TARGET_VAL(ISD::AssertZext),// ->1575
/*  1431*/    OPC_MoveChild0,
/*  1432*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1435*/    OPC_RecordMemRef,
/*  1436*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1437*/    OPC_CheckFoldableChainNode,
/*  1438*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1439*/    OPC_Scope, 66, /*->1507*/ // 2 children in Scope
/*  1441*/     OPC_CheckChild1Type, MVT::i32,
/*  1443*/     OPC_MoveChild2,
/*  1444*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1447*/     OPC_RecordChild0, // #2 = $exp
/*  1448*/     OPC_MoveParent,
/*  1449*/     OPC_MoveChild3,
/*  1450*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1453*/     OPC_RecordChild0, // #3 = $new
/*  1454*/     OPC_MoveParent,
/*  1455*/     OPC_Scope, 24, /*->1481*/ // 2 children in Scope
/*  1457*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*  1459*/      OPC_MoveParent,
/*  1460*/      OPC_MoveParent,
/*  1461*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1463*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1466*/      OPC_EmitMergeInputChains1_0,
/*  1467*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1470*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1481*/     /*Scope*/ 24, /*->1506*/
/*  1482*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*  1484*/      OPC_MoveParent,
/*  1485*/      OPC_MoveParent,
/*  1486*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1488*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1491*/      OPC_EmitMergeInputChains1_0,
/*  1492*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1495*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1506*/     0, /*End of Scope*/
/*  1507*/    /*Scope*/ 66, /*->1574*/
/*  1508*/     OPC_CheckChild1Type, MVT::i64,
/*  1510*/     OPC_MoveChild2,
/*  1511*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1514*/     OPC_RecordChild0, // #2 = $exp
/*  1515*/     OPC_MoveParent,
/*  1516*/     OPC_MoveChild3,
/*  1517*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1520*/     OPC_RecordChild0, // #3 = $new
/*  1521*/     OPC_MoveParent,
/*  1522*/     OPC_Scope, 24, /*->1548*/ // 2 children in Scope
/*  1524*/      OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/*  1526*/      OPC_MoveParent,
/*  1527*/      OPC_MoveParent,
/*  1528*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1530*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1533*/      OPC_EmitMergeInputChains1_0,
/*  1534*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1537*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1548*/     /*Scope*/ 24, /*->1573*/
/*  1549*/      OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/*  1551*/      OPC_MoveParent,
/*  1552*/      OPC_MoveParent,
/*  1553*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1555*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1558*/      OPC_EmitMergeInputChains1_0,
/*  1559*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1562*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1573*/     0, /*End of Scope*/
/*  1574*/    0, /*End of Scope*/
/*  1575*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1697
/*  1578*/    OPC_RecordMemRef,
/*  1579*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1580*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1581*/    OPC_Scope, 56, /*->1639*/ // 2 children in Scope
/*  1583*/     OPC_CheckChild1Type, MVT::i32,
/*  1585*/     OPC_MoveChild2,
/*  1586*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1589*/     OPC_RecordChild0, // #2 = $val
/*  1590*/     OPC_MoveParent,
/*  1591*/     OPC_Scope, 22, /*->1615*/ // 2 children in Scope
/*  1593*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  1595*/      OPC_MoveParent,
/*  1596*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1598*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1601*/      OPC_EmitMergeInputChains1_0,
/*  1602*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1605*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1615*/     /*Scope*/ 22, /*->1638*/
/*  1616*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  1618*/      OPC_MoveParent,
/*  1619*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1621*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1624*/      OPC_EmitMergeInputChains1_0,
/*  1625*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1628*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1638*/     0, /*End of Scope*/
/*  1639*/    /*Scope*/ 56, /*->1696*/
/*  1640*/     OPC_CheckChild1Type, MVT::i64,
/*  1642*/     OPC_MoveChild2,
/*  1643*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1646*/     OPC_RecordChild0, // #2 = $val
/*  1647*/     OPC_MoveParent,
/*  1648*/     OPC_Scope, 22, /*->1672*/ // 2 children in Scope
/*  1650*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  1652*/      OPC_MoveParent,
/*  1653*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1655*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1658*/      OPC_EmitMergeInputChains1_0,
/*  1659*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1662*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1672*/     /*Scope*/ 22, /*->1695*/
/*  1673*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  1675*/      OPC_MoveParent,
/*  1676*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1678*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1681*/      OPC_EmitMergeInputChains1_0,
/*  1682*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1685*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1695*/     0, /*End of Scope*/
/*  1696*/    0, /*End of Scope*/
/*  1697*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1819
/*  1700*/    OPC_RecordMemRef,
/*  1701*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1702*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1703*/    OPC_Scope, 56, /*->1761*/ // 2 children in Scope
/*  1705*/     OPC_CheckChild1Type, MVT::i32,
/*  1707*/     OPC_MoveChild2,
/*  1708*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1711*/     OPC_RecordChild0, // #2 = $val
/*  1712*/     OPC_MoveParent,
/*  1713*/     OPC_Scope, 22, /*->1737*/ // 2 children in Scope
/*  1715*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  1717*/      OPC_MoveParent,
/*  1718*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1720*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1723*/      OPC_EmitMergeInputChains1_0,
/*  1724*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1727*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1737*/     /*Scope*/ 22, /*->1760*/
/*  1738*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  1740*/      OPC_MoveParent,
/*  1741*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1743*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1746*/      OPC_EmitMergeInputChains1_0,
/*  1747*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1760*/     0, /*End of Scope*/
/*  1761*/    /*Scope*/ 56, /*->1818*/
/*  1762*/     OPC_CheckChild1Type, MVT::i64,
/*  1764*/     OPC_MoveChild2,
/*  1765*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1768*/     OPC_RecordChild0, // #2 = $val
/*  1769*/     OPC_MoveParent,
/*  1770*/     OPC_Scope, 22, /*->1794*/ // 2 children in Scope
/*  1772*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  1774*/      OPC_MoveParent,
/*  1775*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1777*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1780*/      OPC_EmitMergeInputChains1_0,
/*  1781*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1784*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1794*/     /*Scope*/ 22, /*->1817*/
/*  1795*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  1797*/      OPC_MoveParent,
/*  1798*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1800*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1803*/      OPC_EmitMergeInputChains1_0,
/*  1804*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1817*/     0, /*End of Scope*/
/*  1818*/    0, /*End of Scope*/
/*  1819*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1941
/*  1822*/    OPC_RecordMemRef,
/*  1823*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1824*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1825*/    OPC_Scope, 56, /*->1883*/ // 2 children in Scope
/*  1827*/     OPC_CheckChild1Type, MVT::i32,
/*  1829*/     OPC_MoveChild2,
/*  1830*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1833*/     OPC_RecordChild0, // #2 = $val
/*  1834*/     OPC_MoveParent,
/*  1835*/     OPC_Scope, 22, /*->1859*/ // 2 children in Scope
/*  1837*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  1839*/      OPC_MoveParent,
/*  1840*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1842*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1845*/      OPC_EmitMergeInputChains1_0,
/*  1846*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1849*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1859*/     /*Scope*/ 22, /*->1882*/
/*  1860*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  1862*/      OPC_MoveParent,
/*  1863*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1865*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1868*/      OPC_EmitMergeInputChains1_0,
/*  1869*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1872*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1882*/     0, /*End of Scope*/
/*  1883*/    /*Scope*/ 56, /*->1940*/
/*  1884*/     OPC_CheckChild1Type, MVT::i64,
/*  1886*/     OPC_MoveChild2,
/*  1887*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1890*/     OPC_RecordChild0, // #2 = $val
/*  1891*/     OPC_MoveParent,
/*  1892*/     OPC_Scope, 22, /*->1916*/ // 2 children in Scope
/*  1894*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  1896*/      OPC_MoveParent,
/*  1897*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1899*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1902*/      OPC_EmitMergeInputChains1_0,
/*  1903*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1906*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1916*/     /*Scope*/ 22, /*->1939*/
/*  1917*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  1919*/      OPC_MoveParent,
/*  1920*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1922*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1925*/      OPC_EmitMergeInputChains1_0,
/*  1926*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1929*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1939*/     0, /*End of Scope*/
/*  1940*/    0, /*End of Scope*/
/*  1941*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->2063
/*  1944*/    OPC_RecordMemRef,
/*  1945*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1946*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1947*/    OPC_Scope, 56, /*->2005*/ // 2 children in Scope
/*  1949*/     OPC_CheckChild1Type, MVT::i32,
/*  1951*/     OPC_MoveChild2,
/*  1952*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1955*/     OPC_RecordChild0, // #2 = $val
/*  1956*/     OPC_MoveParent,
/*  1957*/     OPC_Scope, 22, /*->1981*/ // 2 children in Scope
/*  1959*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  1961*/      OPC_MoveParent,
/*  1962*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1964*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1967*/      OPC_EmitMergeInputChains1_0,
/*  1968*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1971*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1981*/     /*Scope*/ 22, /*->2004*/
/*  1982*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  1984*/      OPC_MoveParent,
/*  1985*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1987*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1990*/      OPC_EmitMergeInputChains1_0,
/*  1991*/      OPC_EmitInteger, MVT::i32, 0, 
/*  1994*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2004*/     0, /*End of Scope*/
/*  2005*/    /*Scope*/ 56, /*->2062*/
/*  2006*/     OPC_CheckChild1Type, MVT::i64,
/*  2008*/     OPC_MoveChild2,
/*  2009*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2012*/     OPC_RecordChild0, // #2 = $val
/*  2013*/     OPC_MoveParent,
/*  2014*/     OPC_Scope, 22, /*->2038*/ // 2 children in Scope
/*  2016*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  2018*/      OPC_MoveParent,
/*  2019*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2021*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2024*/      OPC_EmitMergeInputChains1_0,
/*  2025*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2028*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2038*/     /*Scope*/ 22, /*->2061*/
/*  2039*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  2041*/      OPC_MoveParent,
/*  2042*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2044*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2047*/      OPC_EmitMergeInputChains1_0,
/*  2048*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2051*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2061*/     0, /*End of Scope*/
/*  2062*/    0, /*End of Scope*/
/*  2063*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->2185
/*  2066*/    OPC_RecordMemRef,
/*  2067*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  2068*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  2069*/    OPC_Scope, 56, /*->2127*/ // 2 children in Scope
/*  2071*/     OPC_CheckChild1Type, MVT::i32,
/*  2073*/     OPC_MoveChild2,
/*  2074*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2077*/     OPC_RecordChild0, // #2 = $val
/*  2078*/     OPC_MoveParent,
/*  2079*/     OPC_Scope, 22, /*->2103*/ // 2 children in Scope
/*  2081*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  2083*/      OPC_MoveParent,
/*  2084*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2086*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2089*/      OPC_EmitMergeInputChains1_0,
/*  2090*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2093*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2103*/     /*Scope*/ 22, /*->2126*/
/*  2104*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  2106*/      OPC_MoveParent,
/*  2107*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2109*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2112*/      OPC_EmitMergeInputChains1_0,
/*  2113*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2116*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2126*/     0, /*End of Scope*/
/*  2127*/    /*Scope*/ 56, /*->2184*/
/*  2128*/     OPC_CheckChild1Type, MVT::i64,
/*  2130*/     OPC_MoveChild2,
/*  2131*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2134*/     OPC_RecordChild0, // #2 = $val
/*  2135*/     OPC_MoveParent,
/*  2136*/     OPC_Scope, 22, /*->2160*/ // 2 children in Scope
/*  2138*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  2140*/      OPC_MoveParent,
/*  2141*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2143*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2146*/      OPC_EmitMergeInputChains1_0,
/*  2147*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2150*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2160*/     /*Scope*/ 22, /*->2183*/
/*  2161*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  2163*/      OPC_MoveParent,
/*  2164*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2166*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2169*/      OPC_EmitMergeInputChains1_0,
/*  2170*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2173*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2183*/     0, /*End of Scope*/
/*  2184*/    0, /*End of Scope*/
/*  2185*/   /*SwitchOpcode*/ 119, TARGET_VAL(ISD::ATOMIC_SWAP),// ->2307
/*  2188*/    OPC_RecordMemRef,
/*  2189*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  2190*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  2191*/    OPC_Scope, 56, /*->2249*/ // 2 children in Scope
/*  2193*/     OPC_CheckChild1Type, MVT::i32,
/*  2195*/     OPC_MoveChild2,
/*  2196*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2199*/     OPC_RecordChild0, // #2 = $val
/*  2200*/     OPC_MoveParent,
/*  2201*/     OPC_Scope, 22, /*->2225*/ // 2 children in Scope
/*  2203*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  2205*/      OPC_MoveParent,
/*  2206*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2208*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2211*/      OPC_EmitMergeInputChains1_0,
/*  2212*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2215*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2225*/     /*Scope*/ 22, /*->2248*/
/*  2226*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  2228*/      OPC_MoveParent,
/*  2229*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2231*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  2234*/      OPC_EmitMergeInputChains1_0,
/*  2235*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2238*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2248*/     0, /*End of Scope*/
/*  2249*/    /*Scope*/ 56, /*->2306*/
/*  2250*/     OPC_CheckChild1Type, MVT::i64,
/*  2252*/     OPC_MoveChild2,
/*  2253*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2256*/     OPC_RecordChild0, // #2 = $val
/*  2257*/     OPC_MoveParent,
/*  2258*/     OPC_Scope, 22, /*->2282*/ // 2 children in Scope
/*  2260*/      OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  2262*/      OPC_MoveParent,
/*  2263*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2265*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2268*/      OPC_EmitMergeInputChains1_0,
/*  2269*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2272*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2282*/     /*Scope*/ 22, /*->2305*/
/*  2283*/      OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  2285*/      OPC_MoveParent,
/*  2286*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2288*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2291*/      OPC_EmitMergeInputChains1_0,
/*  2292*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2295*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2305*/     0, /*End of Scope*/
/*  2306*/    0, /*End of Scope*/
/*  2307*/   /*SwitchOpcode*/ 103, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2413
/*  2310*/    OPC_RecordMemRef,
/*  2311*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  2312*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  2313*/    OPC_Scope, 48, /*->2363*/ // 2 children in Scope
/*  2315*/     OPC_CheckChild1Type, MVT::i32,
/*  2317*/     OPC_Scope, 21, /*->2340*/ // 2 children in Scope
/*  2319*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  2321*/      OPC_MoveParent,
/*  2322*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2324*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  2327*/      OPC_EmitMergeInputChains1_0,
/*  2328*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2331*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2340*/     /*Scope*/ 21, /*->2362*/
/*  2341*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  2343*/      OPC_MoveParent,
/*  2344*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2346*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  2349*/      OPC_EmitMergeInputChains1_0,
/*  2350*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2353*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2362*/     0, /*End of Scope*/
/*  2363*/    /*Scope*/ 48, /*->2412*/
/*  2364*/     OPC_CheckChild1Type, MVT::i64,
/*  2366*/     OPC_Scope, 21, /*->2389*/ // 2 children in Scope
/*  2368*/      OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  2370*/      OPC_MoveParent,
/*  2371*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2373*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2376*/      OPC_EmitMergeInputChains1_0,
/*  2377*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2380*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2389*/     /*Scope*/ 21, /*->2411*/
/*  2390*/      OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  2392*/      OPC_MoveParent,
/*  2393*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2395*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2398*/      OPC_EmitMergeInputChains1_0,
/*  2399*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2402*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2411*/     0, /*End of Scope*/
/*  2412*/    0, /*End of Scope*/
/*  2413*/   0, // EndSwitchOpcode
/*  2414*/  /*Scope*/ 8, /*->2423*/
/*  2415*/   OPC_RecordChild0, // #0 = $src
/*  2416*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2423*/  0, /*End of Scope*/
/*  2424*/ /*SwitchOpcode*/ 110|128,8/*1134*/, TARGET_VAL(ISD::STORE),// ->3562
/*  2428*/  OPC_RecordMemRef,
/*  2429*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2430*/  OPC_Scope, 63|128,2/*319*/, /*->2752*/ // 2 children in Scope
/*  2433*/   OPC_MoveChild1,
/*  2434*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2437*/   OPC_RecordChild0, // #1 = $vec
/*  2438*/   OPC_Scope, 79, /*->2519*/ // 4 children in Scope
/*  2440*/    OPC_CheckChild0Type, MVT::v16i8,
/*  2442*/    OPC_RecordChild1, // #2 = $idx
/*  2443*/    OPC_MoveChild1,
/*  2444*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2447*/    OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/*  2449*/    OPC_CheckType, MVT::i32,
/*  2451*/    OPC_MoveParent,
/*  2452*/    OPC_CheckType, MVT::i32,
/*  2454*/    OPC_MoveParent,
/*  2455*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2456*/    OPC_Scope, 29, /*->2487*/ // 2 children in Scope
/*  2458*/     OPC_CheckChild2Type, MVT::i32,
/*  2460*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2462*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2464*/     OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2466*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2468*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2471*/     OPC_EmitMergeInputChains1_0,
/*  2472*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2475*/     OPC_EmitConvertToTarget, 2,
/*  2477*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2487*/    /*Scope*/ 30, /*->2518*/
/*  2488*/     OPC_CheckChild2Type, MVT::i64,
/*  2490*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2492*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2494*/     OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2496*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2498*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2501*/     OPC_EmitMergeInputChains1_0,
/*  2502*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2505*/     OPC_EmitConvertToTarget, 2,
/*  2507*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64:{ *:[v16i8] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2518*/    0, /*End of Scope*/
/*  2519*/   /*Scope*/ 79, /*->2599*/
/*  2520*/    OPC_CheckChild0Type, MVT::v8i16,
/*  2522*/    OPC_RecordChild1, // #2 = $idx
/*  2523*/    OPC_MoveChild1,
/*  2524*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2527*/    OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/*  2529*/    OPC_CheckType, MVT::i32,
/*  2531*/    OPC_MoveParent,
/*  2532*/    OPC_CheckType, MVT::i32,
/*  2534*/    OPC_MoveParent,
/*  2535*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2536*/    OPC_Scope, 29, /*->2567*/ // 2 children in Scope
/*  2538*/     OPC_CheckChild2Type, MVT::i32,
/*  2540*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2542*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2544*/     OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2546*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2548*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2551*/     OPC_EmitMergeInputChains1_0,
/*  2552*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2555*/     OPC_EmitConvertToTarget, 2,
/*  2557*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2567*/    /*Scope*/ 30, /*->2598*/
/*  2568*/     OPC_CheckChild2Type, MVT::i64,
/*  2570*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2572*/     OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2574*/     OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2576*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2578*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2581*/     OPC_EmitMergeInputChains1_0,
/*  2582*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2585*/     OPC_EmitConvertToTarget, 2,
/*  2587*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64:{ *:[v16i8] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2598*/    0, /*End of Scope*/
/*  2599*/   /*Scope*/ 75, /*->2675*/
/*  2600*/    OPC_CheckChild0Type, MVT::v4i32,
/*  2602*/    OPC_RecordChild1, // #2 = $idx
/*  2603*/    OPC_MoveChild1,
/*  2604*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2607*/    OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/*  2609*/    OPC_CheckType, MVT::i32,
/*  2611*/    OPC_MoveParent,
/*  2612*/    OPC_CheckType, MVT::i32,
/*  2614*/    OPC_MoveParent,
/*  2615*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2616*/    OPC_Scope, 27, /*->2645*/ // 2 children in Scope
/*  2618*/     OPC_CheckChild2Type, MVT::i32,
/*  2620*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2622*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2624*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2626*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2629*/     OPC_EmitMergeInputChains1_0,
/*  2630*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2633*/     OPC_EmitConvertToTarget, 2,
/*  2635*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2645*/    /*Scope*/ 28, /*->2674*/
/*  2646*/     OPC_CheckChild2Type, MVT::i64,
/*  2648*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2650*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2652*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2654*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2657*/     OPC_EmitMergeInputChains1_0,
/*  2658*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2661*/     OPC_EmitConvertToTarget, 2,
/*  2663*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64:{ *:[v16i8] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2674*/    0, /*End of Scope*/
/*  2675*/   /*Scope*/ 75, /*->2751*/
/*  2676*/    OPC_CheckChild0Type, MVT::v2i64,
/*  2678*/    OPC_RecordChild1, // #2 = $idx
/*  2679*/    OPC_MoveChild1,
/*  2680*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2683*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/*  2685*/    OPC_CheckType, MVT::i32,
/*  2687*/    OPC_MoveParent,
/*  2688*/    OPC_CheckType, MVT::i64,
/*  2690*/    OPC_MoveParent,
/*  2691*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2692*/    OPC_Scope, 27, /*->2721*/ // 2 children in Scope
/*  2694*/     OPC_CheckChild2Type, MVT::i32,
/*  2696*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2698*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2700*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2702*/     OPC_CheckComplexPat, /*CP*/0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2705*/     OPC_EmitMergeInputChains1_0,
/*  2706*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2709*/     OPC_EmitConvertToTarget, 2,
/*  2711*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2721*/    /*Scope*/ 28, /*->2750*/
/*  2722*/     OPC_CheckChild2Type, MVT::i64,
/*  2724*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2726*/     OPC_CheckPredicate, 10, // Predicate_store
/*  2728*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2730*/     OPC_CheckComplexPat, /*CP*/1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2733*/     OPC_EmitMergeInputChains1_0,
/*  2734*/     OPC_EmitInteger, MVT::i32, 0, 
/*  2737*/     OPC_EmitConvertToTarget, 2,
/*  2739*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64:{ *:[v16i8] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2750*/    0, /*End of Scope*/
/*  2751*/   0, /*End of Scope*/
/*  2752*/  /*Scope*/ 39|128,6/*807*/, /*->3561*/
/*  2754*/   OPC_RecordChild1, // #1 = $val
/*  2755*/   OPC_Scope, 27|128,1/*155*/, /*->2913*/ // 10 children in Scope
/*  2758*/    OPC_CheckChild1Type, MVT::i32,
/*  2760*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2761*/    OPC_Scope, 74, /*->2837*/ // 2 children in Scope
/*  2763*/     OPC_CheckChild2Type, MVT::i32,
/*  2765*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2767*/     OPC_Scope, 20, /*->2789*/ // 2 children in Scope
/*  2769*/      OPC_CheckPredicate, 10, // Predicate_store
/*  2771*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2773*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2776*/      OPC_EmitMergeInputChains1_0,
/*  2777*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2780*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2789*/     /*Scope*/ 46, /*->2836*/
/*  2790*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2792*/      OPC_Scope, 20, /*->2814*/ // 2 children in Scope
/*  2794*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2796*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2798*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2801*/       OPC_EmitMergeInputChains1_0,
/*  2802*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2805*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2814*/      /*Scope*/ 20, /*->2835*/
/*  2815*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2817*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2819*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2822*/       OPC_EmitMergeInputChains1_0,
/*  2823*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2826*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2835*/      0, /*End of Scope*/
/*  2836*/     0, /*End of Scope*/
/*  2837*/    /*Scope*/ 74, /*->2912*/
/*  2838*/     OPC_CheckChild2Type, MVT::i64,
/*  2840*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2842*/     OPC_Scope, 20, /*->2864*/ // 2 children in Scope
/*  2844*/      OPC_CheckPredicate, 10, // Predicate_store
/*  2846*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2848*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2851*/      OPC_EmitMergeInputChains1_0,
/*  2852*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2855*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2864*/     /*Scope*/ 46, /*->2911*/
/*  2865*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2867*/      OPC_Scope, 20, /*->2889*/ // 2 children in Scope
/*  2869*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2871*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2873*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2876*/       OPC_EmitMergeInputChains1_0,
/*  2877*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2880*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2889*/      /*Scope*/ 20, /*->2910*/
/*  2890*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2892*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  2894*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2897*/       OPC_EmitMergeInputChains1_0,
/*  2898*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2901*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2910*/      0, /*End of Scope*/
/*  2911*/     0, /*End of Scope*/
/*  2912*/    0, /*End of Scope*/
/*  2913*/   /*Scope*/ 69|128,1/*197*/, /*->3112*/
/*  2915*/    OPC_CheckChild1Type, MVT::i64,
/*  2917*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2918*/    OPC_Scope, 95, /*->3015*/ // 2 children in Scope
/*  2920*/     OPC_CheckChild2Type, MVT::i32,
/*  2922*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  2924*/     OPC_Scope, 20, /*->2946*/ // 2 children in Scope
/*  2926*/      OPC_CheckPredicate, 10, // Predicate_store
/*  2928*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2930*/      OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2933*/      OPC_EmitMergeInputChains1_0,
/*  2934*/      OPC_EmitInteger, MVT::i32, 0, 
/*  2937*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2946*/     /*Scope*/ 67, /*->3014*/
/*  2947*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  2949*/      OPC_Scope, 20, /*->2971*/ // 3 children in Scope
/*  2951*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  2953*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2955*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2958*/       OPC_EmitMergeInputChains1_0,
/*  2959*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2962*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2971*/      /*Scope*/ 20, /*->2992*/
/*  2972*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  2974*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2976*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2979*/       OPC_EmitMergeInputChains1_0,
/*  2980*/       OPC_EmitInteger, MVT::i32, 0, 
/*  2983*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2992*/      /*Scope*/ 20, /*->3013*/
/*  2993*/       OPC_CheckPredicate, 12, // Predicate_truncstorei32
/*  2995*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  2997*/       OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3000*/       OPC_EmitMergeInputChains1_0,
/*  3001*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3004*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  3013*/      0, /*End of Scope*/
/*  3014*/     0, /*End of Scope*/
/*  3015*/    /*Scope*/ 95, /*->3111*/
/*  3016*/     OPC_CheckChild2Type, MVT::i64,
/*  3018*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3020*/     OPC_Scope, 20, /*->3042*/ // 2 children in Scope
/*  3022*/      OPC_CheckPredicate, 10, // Predicate_store
/*  3024*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3026*/      OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3029*/      OPC_EmitMergeInputChains1_0,
/*  3030*/      OPC_EmitInteger, MVT::i32, 0, 
/*  3033*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3042*/     /*Scope*/ 67, /*->3110*/
/*  3043*/      OPC_CheckPredicate, 5, // Predicate_truncstore
/*  3045*/      OPC_Scope, 20, /*->3067*/ // 3 children in Scope
/*  3047*/       OPC_CheckPredicate, 6, // Predicate_truncstorei8
/*  3049*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3051*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3054*/       OPC_EmitMergeInputChains1_0,
/*  3055*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3058*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3067*/      /*Scope*/ 20, /*->3088*/
/*  3068*/       OPC_CheckPredicate, 8, // Predicate_truncstorei16
/*  3070*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3072*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3075*/       OPC_EmitMergeInputChains1_0,
/*  3076*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3079*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3088*/      /*Scope*/ 20, /*->3109*/
/*  3089*/       OPC_CheckPredicate, 12, // Predicate_truncstorei32
/*  3091*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3093*/       OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3096*/       OPC_EmitMergeInputChains1_0,
/*  3097*/       OPC_EmitInteger, MVT::i32, 0, 
/*  3100*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  3109*/      0, /*End of Scope*/
/*  3110*/     0, /*End of Scope*/
/*  3111*/    0, /*End of Scope*/
/*  3112*/   /*Scope*/ 55, /*->3168*/
/*  3113*/    OPC_CheckChild1Type, MVT::f32,
/*  3115*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3116*/    OPC_Scope, 24, /*->3142*/ // 2 children in Scope
/*  3118*/     OPC_CheckChild2Type, MVT::i32,
/*  3120*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3122*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3124*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3126*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3129*/     OPC_EmitMergeInputChains1_0,
/*  3130*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3133*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  3142*/    /*Scope*/ 24, /*->3167*/
/*  3143*/     OPC_CheckChild2Type, MVT::i64,
/*  3145*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3147*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3149*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3151*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3154*/     OPC_EmitMergeInputChains1_0,
/*  3155*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3158*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  3167*/    0, /*End of Scope*/
/*  3168*/   /*Scope*/ 55, /*->3224*/
/*  3169*/    OPC_CheckChild1Type, MVT::f64,
/*  3171*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3172*/    OPC_Scope, 24, /*->3198*/ // 2 children in Scope
/*  3174*/     OPC_CheckChild2Type, MVT::i32,
/*  3176*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3178*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3180*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3182*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3185*/     OPC_EmitMergeInputChains1_0,
/*  3186*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3189*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  3198*/    /*Scope*/ 24, /*->3223*/
/*  3199*/     OPC_CheckChild2Type, MVT::i64,
/*  3201*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3203*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3205*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3207*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3210*/     OPC_EmitMergeInputChains1_0,
/*  3211*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3214*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  3223*/    0, /*End of Scope*/
/*  3224*/   /*Scope*/ 55, /*->3280*/
/*  3225*/    OPC_CheckChild1Type, MVT::v16i8,
/*  3227*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3228*/    OPC_Scope, 24, /*->3254*/ // 2 children in Scope
/*  3230*/     OPC_CheckChild2Type, MVT::i32,
/*  3232*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3234*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3236*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3238*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3241*/     OPC_EmitMergeInputChains1_0,
/*  3242*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3245*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  3254*/    /*Scope*/ 24, /*->3279*/
/*  3255*/     OPC_CheckChild2Type, MVT::i64,
/*  3257*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3259*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3261*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3263*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3266*/     OPC_EmitMergeInputChains1_0,
/*  3267*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3270*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  3279*/    0, /*End of Scope*/
/*  3280*/   /*Scope*/ 55, /*->3336*/
/*  3281*/    OPC_CheckChild1Type, MVT::v8i16,
/*  3283*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3284*/    OPC_Scope, 24, /*->3310*/ // 2 children in Scope
/*  3286*/     OPC_CheckChild2Type, MVT::i32,
/*  3288*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3290*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3292*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3294*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3297*/     OPC_EmitMergeInputChains1_0,
/*  3298*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3301*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  3310*/    /*Scope*/ 24, /*->3335*/
/*  3311*/     OPC_CheckChild2Type, MVT::i64,
/*  3313*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3315*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3317*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3319*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3322*/     OPC_EmitMergeInputChains1_0,
/*  3323*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3326*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  3335*/    0, /*End of Scope*/
/*  3336*/   /*Scope*/ 55, /*->3392*/
/*  3337*/    OPC_CheckChild1Type, MVT::v4i32,
/*  3339*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3340*/    OPC_Scope, 24, /*->3366*/ // 2 children in Scope
/*  3342*/     OPC_CheckChild2Type, MVT::i32,
/*  3344*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3346*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3348*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3350*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3353*/     OPC_EmitMergeInputChains1_0,
/*  3354*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3357*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  3366*/    /*Scope*/ 24, /*->3391*/
/*  3367*/     OPC_CheckChild2Type, MVT::i64,
/*  3369*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3371*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3373*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3375*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3378*/     OPC_EmitMergeInputChains1_0,
/*  3379*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3382*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  3391*/    0, /*End of Scope*/
/*  3392*/   /*Scope*/ 55, /*->3448*/
/*  3393*/    OPC_CheckChild1Type, MVT::v2i64,
/*  3395*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3396*/    OPC_Scope, 24, /*->3422*/ // 2 children in Scope
/*  3398*/     OPC_CheckChild2Type, MVT::i32,
/*  3400*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3402*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3404*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3406*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3409*/     OPC_EmitMergeInputChains1_0,
/*  3410*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3413*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  3422*/    /*Scope*/ 24, /*->3447*/
/*  3423*/     OPC_CheckChild2Type, MVT::i64,
/*  3425*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3427*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3429*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3431*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3434*/     OPC_EmitMergeInputChains1_0,
/*  3435*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3438*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  3447*/    0, /*End of Scope*/
/*  3448*/   /*Scope*/ 55, /*->3504*/
/*  3449*/    OPC_CheckChild1Type, MVT::v4f32,
/*  3451*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3452*/    OPC_Scope, 24, /*->3478*/ // 2 children in Scope
/*  3454*/     OPC_CheckChild2Type, MVT::i32,
/*  3456*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3458*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3460*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3462*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3465*/     OPC_EmitMergeInputChains1_0,
/*  3466*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3469*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  3478*/    /*Scope*/ 24, /*->3503*/
/*  3479*/     OPC_CheckChild2Type, MVT::i64,
/*  3481*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3483*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3485*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3487*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3490*/     OPC_EmitMergeInputChains1_0,
/*  3491*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3494*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  3503*/    0, /*End of Scope*/
/*  3504*/   /*Scope*/ 55, /*->3560*/
/*  3505*/    OPC_CheckChild1Type, MVT::v2f64,
/*  3507*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3508*/    OPC_Scope, 24, /*->3534*/ // 2 children in Scope
/*  3510*/     OPC_CheckChild2Type, MVT::i32,
/*  3512*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3514*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3516*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  3518*/     OPC_CheckComplexPat, /*CP*/0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3521*/     OPC_EmitMergeInputChains1_0,
/*  3522*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3525*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  3534*/    /*Scope*/ 24, /*->3559*/
/*  3535*/     OPC_CheckChild2Type, MVT::i64,
/*  3537*/     OPC_CheckPredicate, 4, // Predicate_unindexedstore
/*  3539*/     OPC_CheckPredicate, 10, // Predicate_store
/*  3541*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  3543*/     OPC_CheckComplexPat, /*CP*/1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3546*/     OPC_EmitMergeInputChains1_0,
/*  3547*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3550*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  3559*/    0, /*End of Scope*/
/*  3560*/   0, /*End of Scope*/
/*  3561*/  0, /*End of Scope*/
/*  3562*/ /*SwitchOpcode*/ 55|128,1/*183*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3749
/*  3566*/  OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3567*/  OPC_Scope, 42, /*->3611*/ // 6 children in Scope
/*  3569*/   OPC_CheckChild1Integer, 66|128,26|128,1/*19778*/, 
/*  3573*/   OPC_MoveChild2,
/*  3574*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3577*/   OPC_RecordChild0, // #1 = $table1
/*  3578*/   OPC_MoveChild0,
/*  3579*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3582*/   OPC_MoveParent,
/*  3583*/   OPC_MoveParent,
/*  3584*/   OPC_MoveChild3,
/*  3585*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3588*/   OPC_RecordChild0, // #2 = $table2
/*  3589*/   OPC_MoveChild0,
/*  3590*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3593*/   OPC_MoveParent,
/*  3594*/   OPC_MoveParent,
/*  3595*/   OPC_RecordChild4, // #3 = $d
/*  3596*/   OPC_RecordChild5, // #4 = $s
/*  3597*/   OPC_RecordChild6, // #5 = $n
/*  3598*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3600*/   OPC_EmitMergeInputChains1_0,
/*  3601*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_COPY), 0|OPFL_Chain,
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 9889:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3611*/  /*Scope*/ 28, /*->3640*/
/*  3612*/   OPC_CheckChild1Integer, 82|128,26|128,1/*19794*/, 
/*  3616*/   OPC_MoveChild2,
/*  3617*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3620*/   OPC_RecordChild0, // #1 = $table
/*  3621*/   OPC_MoveChild0,
/*  3622*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3625*/   OPC_MoveParent,
/*  3626*/   OPC_MoveParent,
/*  3627*/   OPC_RecordChild3, // #2 = $i
/*  3628*/   OPC_RecordChild4, // #3 = $val
/*  3629*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3631*/   OPC_EmitMergeInputChains1_0,
/*  3632*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (intrinsic_void 9897:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
             // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3640*/  /*Scope*/ 30, /*->3671*/
/*  3641*/   OPC_CheckChild1Integer, 70|128,26|128,1/*19782*/, 
/*  3645*/   OPC_MoveChild2,
/*  3646*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3649*/   OPC_RecordChild0, // #1 = $table
/*  3650*/   OPC_MoveChild0,
/*  3651*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3654*/   OPC_MoveParent,
/*  3655*/   OPC_MoveParent,
/*  3656*/   OPC_RecordChild3, // #2 = $i
/*  3657*/   OPC_RecordChild4, // #3 = $val
/*  3658*/   OPC_RecordChild5, // #4 = $n
/*  3659*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3661*/   OPC_EmitMergeInputChains1_0,
/*  3662*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF), 0|OPFL_Chain,
                 4/*#Ops*/, 1, 2, 3, 4, 
             // Src: (intrinsic_void 9891:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
             // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3671*/  /*Scope*/ 28, /*->3700*/
/*  3672*/   OPC_CheckChild1Integer, 80|128,26|128,1/*19792*/, 
/*  3676*/   OPC_MoveChild2,
/*  3677*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3680*/   OPC_RecordChild0, // #1 = $table
/*  3681*/   OPC_MoveChild0,
/*  3682*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3685*/   OPC_MoveParent,
/*  3686*/   OPC_MoveParent,
/*  3687*/   OPC_RecordChild3, // #2 = $i
/*  3688*/   OPC_RecordChild4, // #3 = $val
/*  3689*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3691*/   OPC_EmitMergeInputChains1_0,
/*  3692*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (intrinsic_void 9896:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
             // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3700*/  /*Scope*/ 30, /*->3731*/
/*  3701*/   OPC_CheckChild1Integer, 68|128,26|128,1/*19780*/, 
/*  3705*/   OPC_MoveChild2,
/*  3706*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3709*/   OPC_RecordChild0, // #1 = $table
/*  3710*/   OPC_MoveChild0,
/*  3711*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3714*/   OPC_MoveParent,
/*  3715*/   OPC_MoveParent,
/*  3716*/   OPC_RecordChild3, // #2 = $i
/*  3717*/   OPC_RecordChild4, // #3 = $val
/*  3718*/   OPC_RecordChild5, // #4 = $n
/*  3719*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3721*/   OPC_EmitMergeInputChains1_0,
/*  3722*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF), 0|OPFL_Chain,
                 4/*#Ops*/, 1, 2, 3, 4, 
             // Src: (intrinsic_void 9890:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
             // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3731*/  /*Scope*/ 16, /*->3748*/
/*  3732*/   OPC_CheckChild1Integer, 56|128,26|128,1/*19768*/, 
/*  3736*/   OPC_CheckPatternPredicate, 5, // (Subtarget->hasExceptionHandling())
/*  3738*/   OPC_EmitMergeInputChains1_0,
/*  3739*/   OPC_EmitInteger, MVT::i32, 0, 
/*  3742*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETHROW), 0|OPFL_Chain,
                 1/*#Ops*/, 1, 
             // Src: (intrinsic_void 9884:{ *:[iPTR] }) - Complexity = 8
             // Dst: (RETHROW 0:{ *:[i32] })
/*  3748*/  0, /*End of Scope*/
/*  3749*/ /*SwitchOpcode*/ 22|128,3/*406*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->4159
/*  3753*/  OPC_Scope, 46|128,1/*174*/, /*->3930*/ // 2 children in Scope
/*  3756*/   OPC_RecordMemRef,
/*  3757*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3758*/   OPC_Scope, 53, /*->3813*/ // 3 children in Scope
/*  3760*/    OPC_CheckChild1Integer, 0|128,26|128,1/*19712*/, 
/*  3764*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3765*/    OPC_Scope, 22, /*->3789*/ // 2 children in Scope
/*  3767*/     OPC_CheckChild2Type, MVT::i32,
/*  3769*/     OPC_RecordChild3, // #2 = $count
/*  3770*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3772*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3775*/     OPC_EmitMergeInputChains1_0,
/*  3776*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3779*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9856:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3789*/    /*Scope*/ 22, /*->3812*/
/*  3790*/     OPC_CheckChild2Type, MVT::i64,
/*  3792*/     OPC_RecordChild3, // #2 = $count
/*  3793*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3795*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3798*/     OPC_EmitMergeInputChains1_0,
/*  3799*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3802*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9856:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3812*/    0, /*End of Scope*/
/*  3813*/   /*Scope*/ 57, /*->3871*/
/*  3814*/    OPC_CheckChild1Integer, 2|128,26|128,1/*19714*/, 
/*  3818*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3819*/    OPC_Scope, 24, /*->3845*/ // 2 children in Scope
/*  3821*/     OPC_CheckChild2Type, MVT::i32,
/*  3823*/     OPC_RecordChild3, // #2 = $exp
/*  3824*/     OPC_RecordChild4, // #3 = $timeout
/*  3825*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3827*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3830*/     OPC_EmitMergeInputChains1_0,
/*  3831*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3834*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9857:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3845*/    /*Scope*/ 24, /*->3870*/
/*  3846*/     OPC_CheckChild2Type, MVT::i64,
/*  3848*/     OPC_RecordChild3, // #2 = $exp
/*  3849*/     OPC_RecordChild4, // #3 = $timeout
/*  3850*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3852*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3855*/     OPC_EmitMergeInputChains1_0,
/*  3856*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3859*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9857:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3870*/    0, /*End of Scope*/
/*  3871*/   /*Scope*/ 57, /*->3929*/
/*  3872*/    OPC_CheckChild1Integer, 4|128,26|128,1/*19716*/, 
/*  3876*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3877*/    OPC_Scope, 24, /*->3903*/ // 2 children in Scope
/*  3879*/     OPC_CheckChild2Type, MVT::i32,
/*  3881*/     OPC_RecordChild3, // #2 = $exp
/*  3882*/     OPC_RecordChild4, // #3 = $timeout
/*  3883*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3885*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3888*/     OPC_EmitMergeInputChains1_0,
/*  3889*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3892*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9858:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3903*/    /*Scope*/ 24, /*->3928*/
/*  3904*/     OPC_CheckChild2Type, MVT::i64,
/*  3906*/     OPC_RecordChild3, // #2 = $exp
/*  3907*/     OPC_RecordChild4, // #3 = $timeout
/*  3908*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3910*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3913*/     OPC_EmitMergeInputChains1_0,
/*  3914*/     OPC_EmitInteger, MVT::i32, 0, 
/*  3917*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9858:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3928*/    0, /*End of Scope*/
/*  3929*/   0, /*End of Scope*/
/*  3930*/  /*Scope*/ 98|128,1/*226*/, /*->4158*/
/*  3932*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3933*/   OPC_Scope, 27, /*->3962*/ // 7 children in Scope
/*  3935*/    OPC_CheckChild1Integer, 74|128,26|128,1/*19786*/, 
/*  3939*/    OPC_MoveChild2,
/*  3940*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3943*/    OPC_RecordChild0, // #1 = $table
/*  3944*/    OPC_MoveChild0,
/*  3945*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3948*/    OPC_MoveParent,
/*  3949*/    OPC_MoveParent,
/*  3950*/    OPC_RecordChild3, // #2 = $i
/*  3951*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3953*/    OPC_EmitMergeInputChains1_0,
/*  3954*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain,
                  MVT::funcref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 9893:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3962*/   /*Scope*/ 29, /*->3992*/
/*  3963*/    OPC_CheckChild1Integer, 78|128,26|128,1/*19790*/, 
/*  3967*/    OPC_MoveChild2,
/*  3968*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3971*/    OPC_RecordChild0, // #1 = $table
/*  3972*/    OPC_MoveChild0,
/*  3973*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3976*/    OPC_MoveParent,
/*  3977*/    OPC_MoveParent,
/*  3978*/    OPC_RecordChild3, // #2 = $val
/*  3979*/    OPC_RecordChild4, // #3 = $n
/*  3980*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  3982*/    OPC_EmitMergeInputChains1_0,
/*  3983*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF), 0|OPFL_Chain,
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 9895:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3992*/   /*Scope*/ 27, /*->4020*/
/*  3993*/    OPC_CheckChild1Integer, 72|128,26|128,1/*19784*/, 
/*  3997*/    OPC_MoveChild2,
/*  3998*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4001*/    OPC_RecordChild0, // #1 = $table
/*  4002*/    OPC_MoveChild0,
/*  4003*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4006*/    OPC_MoveParent,
/*  4007*/    OPC_MoveParent,
/*  4008*/    OPC_RecordChild3, // #2 = $i
/*  4009*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  4011*/    OPC_EmitMergeInputChains1_0,
/*  4012*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain,
                  MVT::externref, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 9892:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  4020*/   /*Scope*/ 29, /*->4050*/
/*  4021*/    OPC_CheckChild1Integer, 76|128,26|128,1/*19788*/, 
/*  4025*/    OPC_MoveChild2,
/*  4026*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4029*/    OPC_RecordChild0, // #1 = $table
/*  4030*/    OPC_MoveChild0,
/*  4031*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4034*/    OPC_MoveParent,
/*  4035*/    OPC_MoveParent,
/*  4036*/    OPC_RecordChild3, // #2 = $val
/*  4037*/    OPC_RecordChild4, // #3 = $n
/*  4038*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  4040*/    OPC_EmitMergeInputChains1_0,
/*  4041*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF), 0|OPFL_Chain,
                  MVT::i32, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 9894:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  4050*/   /*Scope*/ 25, /*->4076*/
/*  4051*/    OPC_CheckChild1Integer, 84|128,26|128,1/*19796*/, 
/*  4055*/    OPC_MoveChild2,
/*  4056*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  4059*/    OPC_RecordChild0, // #1 = $table
/*  4060*/    OPC_MoveChild0,
/*  4061*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  4064*/    OPC_MoveParent,
/*  4065*/    OPC_MoveParent,
/*  4066*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/*  4068*/    OPC_EmitMergeInputChains1_0,
/*  4069*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_SIZE), 0|OPFL_Chain,
                  MVT::i32, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 9898:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  4076*/   /*Scope*/ 36, /*->4113*/
/*  4077*/    OPC_CheckChild1Integer, 8|128,26|128,1/*19720*/, 
/*  4081*/    OPC_RecordChild2, // #1 = $flags
/*  4082*/    OPC_MoveChild2,
/*  4083*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4086*/    OPC_MoveParent,
/*  4087*/    OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->4100
/*  4090*/     OPC_EmitMergeInputChains1_0,
/*  4091*/     OPC_EmitConvertToTarget, 1,
/*  4093*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_4063MEMORY_SIZE_A32), 0|OPFL_Chain,
                   MVT::i32, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9860:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_4063MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  4100*/    /*SwitchType*/ 10, MVT::i64,// ->4112
/*  4102*/     OPC_EmitMergeInputChains1_0,
/*  4103*/     OPC_EmitConvertToTarget, 1,
/*  4105*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_4064MEMORY_SIZE_A64), 0|OPFL_Chain,
                   MVT::i64, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 9860:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_4064MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  4112*/    0, // EndSwitchType
/*  4113*/   /*Scope*/ 43, /*->4157*/
/*  4114*/    OPC_CheckChild1Integer, 6|128,26|128,1/*19718*/, 
/*  4118*/    OPC_RecordChild2, // #1 = $flags
/*  4119*/    OPC_MoveChild2,
/*  4120*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4123*/    OPC_MoveParent,
/*  4124*/    OPC_RecordChild3, // #2 = $delta
/*  4125*/    OPC_SwitchType /*2 cases */, 13, MVT::i32,// ->4141
/*  4128*/     OPC_CheckChild3Type, MVT::i32,
/*  4130*/     OPC_EmitMergeInputChains1_0,
/*  4131*/     OPC_EmitConvertToTarget, 1,
/*  4133*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_4063MEMORY_GROW_A32), 0|OPFL_Chain,
                   MVT::i32, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 9859:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_4063MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  4141*/    /*SwitchType*/ 13, MVT::i64,// ->4156
/*  4143*/     OPC_CheckChild3Type, MVT::i64,
/*  4145*/     OPC_EmitMergeInputChains1_0,
/*  4146*/     OPC_EmitConvertToTarget, 1,
/*  4148*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::anonymous_4064MEMORY_GROW_A64), 0|OPFL_Chain,
                   MVT::i64, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 9859:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_4064MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  4156*/    0, // EndSwitchType
/*  4157*/   0, /*End of Scope*/
/*  4158*/  0, /*End of Scope*/
/*  4159*/ /*SwitchOpcode*/ 95|128,2/*351*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4514
/*  4163*/  OPC_RecordMemRef,
/*  4164*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  4165*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  4166*/  OPC_Scope, 43|128,1/*171*/, /*->4340*/ // 2 children in Scope
/*  4169*/   OPC_CheckChild1Type, MVT::i32,
/*  4171*/   OPC_Scope, 71, /*->4244*/ // 2 children in Scope
/*  4173*/    OPC_MoveChild2,
/*  4174*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4177*/    OPC_RecordChild0, // #2 = $val
/*  4178*/    OPC_MoveParent,
/*  4179*/    OPC_Scope, 20, /*->4201*/ // 3 children in Scope
/*  4181*/     OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4183*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4185*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4188*/     OPC_EmitMergeInputChains1_0,
/*  4189*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4192*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4201*/    /*Scope*/ 20, /*->4222*/
/*  4202*/     OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4204*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4206*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4209*/     OPC_EmitMergeInputChains1_0,
/*  4210*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4213*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4222*/    /*Scope*/ 20, /*->4243*/
/*  4223*/     OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4225*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4227*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4230*/     OPC_EmitMergeInputChains1_0,
/*  4231*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4234*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4243*/    0, /*End of Scope*/
/*  4244*/   /*Scope*/ 94, /*->4339*/
/*  4245*/    OPC_RecordChild2, // #2 = $val
/*  4246*/    OPC_Scope, 67, /*->4315*/ // 2 children in Scope
/*  4248*/     OPC_CheckChild2Type, MVT::i32,
/*  4250*/     OPC_Scope, 20, /*->4272*/ // 3 children in Scope
/*  4252*/      OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4254*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4256*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4259*/      OPC_EmitMergeInputChains1_0,
/*  4260*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4263*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4272*/     /*Scope*/ 20, /*->4293*/
/*  4273*/      OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4275*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4277*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4280*/      OPC_EmitMergeInputChains1_0,
/*  4281*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4284*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4293*/     /*Scope*/ 20, /*->4314*/
/*  4294*/      OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4296*/      OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4298*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4301*/      OPC_EmitMergeInputChains1_0,
/*  4302*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4305*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4314*/     0, /*End of Scope*/
/*  4315*/    /*Scope*/ 22, /*->4338*/
/*  4316*/     OPC_CheckChild2Type, MVT::i64,
/*  4318*/     OPC_CheckPredicate, 13, // Predicate_atomic_store_64
/*  4320*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4322*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  4325*/     OPC_EmitMergeInputChains1_0,
/*  4326*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4329*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4338*/    0, /*End of Scope*/
/*  4339*/   0, /*End of Scope*/
/*  4340*/  /*Scope*/ 43|128,1/*171*/, /*->4513*/
/*  4342*/   OPC_CheckChild1Type, MVT::i64,
/*  4344*/   OPC_Scope, 71, /*->4417*/ // 2 children in Scope
/*  4346*/    OPC_MoveChild2,
/*  4347*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  4350*/    OPC_RecordChild0, // #2 = $val
/*  4351*/    OPC_MoveParent,
/*  4352*/    OPC_Scope, 20, /*->4374*/ // 3 children in Scope
/*  4354*/     OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4356*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4358*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4361*/     OPC_EmitMergeInputChains1_0,
/*  4362*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4365*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4374*/    /*Scope*/ 20, /*->4395*/
/*  4375*/     OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4377*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4379*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4382*/     OPC_EmitMergeInputChains1_0,
/*  4383*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4386*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4395*/    /*Scope*/ 20, /*->4416*/
/*  4396*/     OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4398*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4400*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4403*/     OPC_EmitMergeInputChains1_0,
/*  4404*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4407*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4416*/    0, /*End of Scope*/
/*  4417*/   /*Scope*/ 94, /*->4512*/
/*  4418*/    OPC_RecordChild2, // #2 = $val
/*  4419*/    OPC_Scope, 67, /*->4488*/ // 2 children in Scope
/*  4421*/     OPC_CheckChild2Type, MVT::i32,
/*  4423*/     OPC_Scope, 20, /*->4445*/ // 3 children in Scope
/*  4425*/      OPC_CheckPredicate, 2, // Predicate_atomic_store_32
/*  4427*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4429*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4432*/      OPC_EmitMergeInputChains1_0,
/*  4433*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4436*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4445*/     /*Scope*/ 20, /*->4466*/
/*  4446*/      OPC_CheckPredicate, 0, // Predicate_atomic_store_8
/*  4448*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4450*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4453*/      OPC_EmitMergeInputChains1_0,
/*  4454*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4457*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4466*/     /*Scope*/ 20, /*->4487*/
/*  4467*/      OPC_CheckPredicate, 1, // Predicate_atomic_store_16
/*  4469*/      OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4471*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4474*/      OPC_EmitMergeInputChains1_0,
/*  4475*/      OPC_EmitInteger, MVT::i32, 0, 
/*  4478*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4487*/     0, /*End of Scope*/
/*  4488*/    /*Scope*/ 22, /*->4511*/
/*  4489*/     OPC_CheckChild2Type, MVT::i64,
/*  4491*/     OPC_CheckPredicate, 13, // Predicate_atomic_store_64
/*  4493*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4495*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  4498*/     OPC_EmitMergeInputChains1_0,
/*  4499*/     OPC_EmitInteger, MVT::i32, 0, 
/*  4502*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_store (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4511*/    0, /*End of Scope*/
/*  4512*/   0, /*End of Scope*/
/*  4513*/  0, /*End of Scope*/
/*  4514*/ /*SwitchOpcode*/ 120|128,2/*376*/, TARGET_VAL(ISD::AND),// ->4894
/*  4518*/  OPC_Scope, 126, /*->4646*/ // 6 children in Scope
/*  4520*/   OPC_MoveChild0,
/*  4521*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4524*/   OPC_Scope, 59, /*->4585*/ // 2 children in Scope
/*  4526*/    OPC_CheckChild0Integer, 104|128,25|128,1/*19688*/, 
/*  4530*/    OPC_RecordChild1, // #0 = $x
/*  4531*/    OPC_Scope, 12, /*->4545*/ // 4 children in Scope
/*  4533*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4535*/     OPC_MoveParent,
/*  4536*/     OPC_CheckChild1Integer, 2, 
/*  4538*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4545*/    /*Scope*/ 12, /*->4558*/
/*  4546*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4548*/     OPC_MoveParent,
/*  4549*/     OPC_CheckChild1Integer, 2, 
/*  4551*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4558*/    /*Scope*/ 12, /*->4571*/
/*  4559*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4561*/     OPC_MoveParent,
/*  4562*/     OPC_CheckChild1Integer, 2, 
/*  4564*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4571*/    /*Scope*/ 12, /*->4584*/
/*  4572*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4574*/     OPC_MoveParent,
/*  4575*/     OPC_CheckChild1Integer, 2, 
/*  4577*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4584*/    0, /*End of Scope*/
/*  4585*/   /*Scope*/ 59, /*->4645*/
/*  4586*/    OPC_CheckChild0Integer, 102|128,25|128,1/*19686*/, 
/*  4590*/    OPC_RecordChild1, // #0 = $x
/*  4591*/    OPC_Scope, 12, /*->4605*/ // 4 children in Scope
/*  4593*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4595*/     OPC_MoveParent,
/*  4596*/     OPC_CheckChild1Integer, 2, 
/*  4598*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4605*/    /*Scope*/ 12, /*->4618*/
/*  4606*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4608*/     OPC_MoveParent,
/*  4609*/     OPC_CheckChild1Integer, 2, 
/*  4611*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4618*/    /*Scope*/ 12, /*->4631*/
/*  4619*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4621*/     OPC_MoveParent,
/*  4622*/     OPC_CheckChild1Integer, 2, 
/*  4624*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4631*/    /*Scope*/ 12, /*->4644*/
/*  4632*/     OPC_CheckChild1Type, MVT::v2i64,
/*  4634*/     OPC_MoveParent,
/*  4635*/     OPC_CheckChild1Integer, 2, 
/*  4637*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4644*/    0, /*End of Scope*/
/*  4645*/   0, /*End of Scope*/
/*  4646*/  /*Scope*/ 33, /*->4680*/
/*  4647*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4650*/   OPC_MoveChild0,
/*  4651*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4654*/   OPC_RecordChild0, // #0 = $vec
/*  4655*/   OPC_CheckChild0Type, MVT::v16i8,
/*  4657*/   OPC_RecordChild1, // #1 = $idx
/*  4658*/   OPC_MoveChild1,
/*  4659*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4662*/   OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/*  4664*/   OPC_CheckType, MVT::i32,
/*  4666*/   OPC_MoveParent,
/*  4667*/   OPC_MoveParent,
/*  4668*/   OPC_CheckType, MVT::i32,
/*  4670*/   OPC_EmitConvertToTarget, 1,
/*  4672*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4680*/  /*Scope*/ 34, /*->4715*/
/*  4681*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4685*/   OPC_MoveChild0,
/*  4686*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4689*/   OPC_RecordChild0, // #0 = $vec
/*  4690*/   OPC_CheckChild0Type, MVT::v8i16,
/*  4692*/   OPC_RecordChild1, // #1 = $idx
/*  4693*/   OPC_MoveChild1,
/*  4694*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4697*/   OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/*  4699*/   OPC_CheckType, MVT::i32,
/*  4701*/   OPC_MoveParent,
/*  4702*/   OPC_MoveParent,
/*  4703*/   OPC_CheckType, MVT::i32,
/*  4705*/   OPC_EmitConvertToTarget, 1,
/*  4707*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4715*/  /*Scope*/ 79, /*->4795*/
/*  4716*/   OPC_RecordChild0, // #0 = $lhs
/*  4717*/   OPC_Scope, 23, /*->4742*/ // 2 children in Scope
/*  4719*/    OPC_RecordChild1, // #1 = $rhs
/*  4720*/    OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->4731
/*  4723*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_I32), 0,
                   MVT::i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4731*/    /*SwitchType*/ 8, MVT::i64,// ->4741
/*  4733*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND_I64), 0,
                   MVT::i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4741*/    0, // EndSwitchType
/*  4742*/   /*Scope*/ 51, /*->4794*/
/*  4743*/    OPC_MoveChild1,
/*  4744*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4747*/    OPC_RecordChild0, // #1 = $rhs
/*  4748*/    OPC_MoveChild1,
/*  4749*/    OPC_CheckImmAllOnesV,
/*  4750*/    OPC_MoveParent,
/*  4751*/    OPC_MoveParent,
/*  4752*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->4763
/*  4755*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4763*/    /*SwitchType*/ 8, MVT::v8i16,// ->4773
/*  4765*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4773*/    /*SwitchType*/ 8, MVT::v4i32,// ->4783
/*  4775*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4783*/    /*SwitchType*/ 8, MVT::v2i64,// ->4793
/*  4785*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4793*/    0, // EndSwitchType
/*  4794*/   0, /*End of Scope*/
/*  4795*/  /*Scope*/ 52, /*->4848*/
/*  4796*/   OPC_MoveChild0,
/*  4797*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4800*/   OPC_RecordChild0, // #0 = $rhs
/*  4801*/   OPC_MoveChild1,
/*  4802*/   OPC_CheckImmAllOnesV,
/*  4803*/   OPC_MoveParent,
/*  4804*/   OPC_MoveParent,
/*  4805*/   OPC_RecordChild1, // #1 = $lhs
/*  4806*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->4817
/*  4809*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v16i8, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4817*/   /*SwitchType*/ 8, MVT::v8i16,// ->4827
/*  4819*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v8i16, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4827*/   /*SwitchType*/ 8, MVT::v4i32,// ->4837
/*  4829*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v4i32, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4837*/   /*SwitchType*/ 8, MVT::v2i64,// ->4847
/*  4839*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANDNOT), 0,
                  MVT::v2i64, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4847*/   0, // EndSwitchType
/*  4848*/  /*Scope*/ 44, /*->4893*/
/*  4849*/   OPC_RecordChild0, // #0 = $lhs
/*  4850*/   OPC_RecordChild1, // #1 = $rhs
/*  4851*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->4862
/*  4854*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4862*/   /*SwitchType*/ 8, MVT::v8i16,// ->4872
/*  4864*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4872*/   /*SwitchType*/ 8, MVT::v4i32,// ->4882
/*  4874*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4882*/   /*SwitchType*/ 8, MVT::v2i64,// ->4892
/*  4884*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AND), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4892*/   0, // EndSwitchType
/*  4893*/  0, /*End of Scope*/
/*  4894*/ /*SwitchOpcode*/ 109|128,12/*1645*/, TARGET_VAL(ISD::SETCC),// ->6543
/*  4898*/  OPC_Scope, 24|128,2/*280*/, /*->5181*/ // 2 children in Scope
/*  4901*/   OPC_MoveChild0,
/*  4902*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4905*/   OPC_Scope, 7|128,1/*135*/, /*->5043*/ // 2 children in Scope
/*  4908*/    OPC_CheckChild0Integer, 104|128,25|128,1/*19688*/, 
/*  4912*/    OPC_RecordChild1, // #0 = $x
/*  4913*/    OPC_Scope, 31, /*->4946*/ // 4 children in Scope
/*  4915*/     OPC_CheckChild1Type, MVT::v16i8,
/*  4917*/     OPC_MoveParent,
/*  4918*/     OPC_CheckType, MVT::i32,
/*  4920*/     OPC_Scope, 11, /*->4933*/ // 2 children in Scope
/*  4922*/      OPC_CheckChild1Integer, 0, 
/*  4924*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4926*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4933*/     /*Scope*/ 11, /*->4945*/
/*  4934*/      OPC_CheckChild1Integer, 2, 
/*  4936*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4938*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4945*/     0, /*End of Scope*/
/*  4946*/    /*Scope*/ 31, /*->4978*/
/*  4947*/     OPC_CheckChild1Type, MVT::v8i16,
/*  4949*/     OPC_MoveParent,
/*  4950*/     OPC_CheckType, MVT::i32,
/*  4952*/     OPC_Scope, 11, /*->4965*/ // 2 children in Scope
/*  4954*/      OPC_CheckChild1Integer, 0, 
/*  4956*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4958*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4965*/     /*Scope*/ 11, /*->4977*/
/*  4966*/      OPC_CheckChild1Integer, 2, 
/*  4968*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4970*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4977*/     0, /*End of Scope*/
/*  4978*/    /*Scope*/ 31, /*->5010*/
/*  4979*/     OPC_CheckChild1Type, MVT::v4i32,
/*  4981*/     OPC_MoveParent,
/*  4982*/     OPC_CheckType, MVT::i32,
/*  4984*/     OPC_Scope, 11, /*->4997*/ // 2 children in Scope
/*  4986*/      OPC_CheckChild1Integer, 0, 
/*  4988*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4990*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4997*/     /*Scope*/ 11, /*->5009*/
/*  4998*/      OPC_CheckChild1Integer, 2, 
/*  5000*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5002*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  5009*/     0, /*End of Scope*/
/*  5010*/    /*Scope*/ 31, /*->5042*/
/*  5011*/     OPC_CheckChild1Type, MVT::v2i64,
/*  5013*/     OPC_MoveParent,
/*  5014*/     OPC_CheckType, MVT::i32,
/*  5016*/     OPC_Scope, 11, /*->5029*/ // 2 children in Scope
/*  5018*/      OPC_CheckChild1Integer, 0, 
/*  5020*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5022*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  5029*/     /*Scope*/ 11, /*->5041*/
/*  5030*/      OPC_CheckChild1Integer, 2, 
/*  5032*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5034*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  5041*/     0, /*End of Scope*/
/*  5042*/    0, /*End of Scope*/
/*  5043*/   /*Scope*/ 7|128,1/*135*/, /*->5180*/
/*  5045*/    OPC_CheckChild0Integer, 102|128,25|128,1/*19686*/, 
/*  5049*/    OPC_RecordChild1, // #0 = $x
/*  5050*/    OPC_Scope, 31, /*->5083*/ // 4 children in Scope
/*  5052*/     OPC_CheckChild1Type, MVT::v16i8,
/*  5054*/     OPC_MoveParent,
/*  5055*/     OPC_CheckType, MVT::i32,
/*  5057*/     OPC_Scope, 11, /*->5070*/ // 2 children in Scope
/*  5059*/      OPC_CheckChild1Integer, 0, 
/*  5061*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5063*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  5070*/     /*Scope*/ 11, /*->5082*/
/*  5071*/      OPC_CheckChild1Integer, 2, 
/*  5073*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5075*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  5082*/     0, /*End of Scope*/
/*  5083*/    /*Scope*/ 31, /*->5115*/
/*  5084*/     OPC_CheckChild1Type, MVT::v8i16,
/*  5086*/     OPC_MoveParent,
/*  5087*/     OPC_CheckType, MVT::i32,
/*  5089*/     OPC_Scope, 11, /*->5102*/ // 2 children in Scope
/*  5091*/      OPC_CheckChild1Integer, 0, 
/*  5093*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5095*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  5102*/     /*Scope*/ 11, /*->5114*/
/*  5103*/      OPC_CheckChild1Integer, 2, 
/*  5105*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5107*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  5114*/     0, /*End of Scope*/
/*  5115*/    /*Scope*/ 31, /*->5147*/
/*  5116*/     OPC_CheckChild1Type, MVT::v4i32,
/*  5118*/     OPC_MoveParent,
/*  5119*/     OPC_CheckType, MVT::i32,
/*  5121*/     OPC_Scope, 11, /*->5134*/ // 2 children in Scope
/*  5123*/      OPC_CheckChild1Integer, 0, 
/*  5125*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5127*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  5134*/     /*Scope*/ 11, /*->5146*/
/*  5135*/      OPC_CheckChild1Integer, 2, 
/*  5137*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5139*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  5146*/     0, /*End of Scope*/
/*  5147*/    /*Scope*/ 31, /*->5179*/
/*  5148*/     OPC_CheckChild1Type, MVT::v2i64,
/*  5150*/     OPC_MoveParent,
/*  5151*/     OPC_CheckType, MVT::i32,
/*  5153*/     OPC_Scope, 11, /*->5166*/ // 2 children in Scope
/*  5155*/      OPC_CheckChild1Integer, 0, 
/*  5157*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5159*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  5166*/     /*Scope*/ 11, /*->5178*/
/*  5167*/      OPC_CheckChild1Integer, 2, 
/*  5169*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5171*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  5178*/     0, /*End of Scope*/
/*  5179*/    0, /*End of Scope*/
/*  5180*/   0, /*End of Scope*/
/*  5181*/  /*Scope*/ 79|128,10/*1359*/, /*->6542*/
/*  5183*/   OPC_RecordChild0, // #0 = $src
/*  5184*/   OPC_SwitchType /*5 cases */, 32|128,4/*544*/, MVT::i32,// ->5732
/*  5188*/    OPC_Scope, 2|128,1/*130*/, /*->5321*/ // 4 children in Scope
/*  5191*/     OPC_CheckChild0Type, MVT::i32,
/*  5193*/     OPC_Scope, 11, /*->5206*/ // 2 children in Scope
/*  5195*/      OPC_CheckChild1Integer, 0, 
/*  5197*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5199*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQZ_I32), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  5206*/     /*Scope*/ 113, /*->5320*/
/*  5207*/      OPC_RecordChild1, // #1 = $rhs
/*  5208*/      OPC_Scope, 10, /*->5220*/ // 10 children in Scope
/*  5210*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5212*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5220*/      /*Scope*/ 10, /*->5231*/
/*  5221*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  5223*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5231*/      /*Scope*/ 10, /*->5242*/
/*  5232*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  5234*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5242*/      /*Scope*/ 10, /*->5253*/
/*  5243*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  5245*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5253*/      /*Scope*/ 10, /*->5264*/
/*  5254*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  5256*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5264*/      /*Scope*/ 10, /*->5275*/
/*  5265*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5267*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5275*/      /*Scope*/ 10, /*->5286*/
/*  5276*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  5278*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5286*/      /*Scope*/ 10, /*->5297*/
/*  5287*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  5289*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5297*/      /*Scope*/ 10, /*->5308*/
/*  5298*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  5300*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5308*/      /*Scope*/ 10, /*->5319*/
/*  5309*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5311*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I32), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  5319*/      0, /*End of Scope*/
/*  5320*/     0, /*End of Scope*/
/*  5321*/    /*Scope*/ 2|128,1/*130*/, /*->5453*/
/*  5323*/     OPC_CheckChild0Type, MVT::i64,
/*  5325*/     OPC_Scope, 11, /*->5338*/ // 2 children in Scope
/*  5327*/      OPC_CheckChild1Integer, 0, 
/*  5329*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5331*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQZ_I64), 0,
                    MVT::i32, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  5338*/     /*Scope*/ 113, /*->5452*/
/*  5339*/      OPC_RecordChild1, // #1 = $rhs
/*  5340*/      OPC_Scope, 10, /*->5352*/ // 10 children in Scope
/*  5342*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5344*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5352*/      /*Scope*/ 10, /*->5363*/
/*  5353*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  5355*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5363*/      /*Scope*/ 10, /*->5374*/
/*  5364*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  5366*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5374*/      /*Scope*/ 10, /*->5385*/
/*  5375*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  5377*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5385*/      /*Scope*/ 10, /*->5396*/
/*  5386*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  5388*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5396*/      /*Scope*/ 10, /*->5407*/
/*  5397*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5399*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5407*/      /*Scope*/ 10, /*->5418*/
/*  5408*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  5410*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5418*/      /*Scope*/ 10, /*->5429*/
/*  5419*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  5421*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5429*/      /*Scope*/ 10, /*->5440*/
/*  5430*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  5432*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5440*/      /*Scope*/ 10, /*->5451*/
/*  5441*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5443*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I64), 0,
                     MVT::i32, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5451*/      0, /*End of Scope*/
/*  5452*/     0, /*End of Scope*/
/*  5453*/    /*Scope*/ 9|128,1/*137*/, /*->5592*/
/*  5455*/     OPC_CheckChild0Type, MVT::f32,
/*  5457*/     OPC_RecordChild1, // #1 = $rhs
/*  5458*/     OPC_Scope, 10, /*->5470*/ // 12 children in Scope
/*  5460*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5462*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5470*/     /*Scope*/ 10, /*->5481*/
/*  5471*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5473*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5481*/     /*Scope*/ 10, /*->5492*/
/*  5482*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5484*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5492*/     /*Scope*/ 10, /*->5503*/
/*  5493*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5495*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5503*/     /*Scope*/ 10, /*->5514*/
/*  5504*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5506*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5514*/     /*Scope*/ 10, /*->5525*/
/*  5515*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5517*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5525*/     /*Scope*/ 10, /*->5536*/
/*  5526*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5528*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5536*/     /*Scope*/ 10, /*->5547*/
/*  5537*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5539*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5547*/     /*Scope*/ 10, /*->5558*/
/*  5548*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5550*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5558*/     /*Scope*/ 10, /*->5569*/
/*  5559*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5561*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5569*/     /*Scope*/ 10, /*->5580*/
/*  5570*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5572*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5580*/     /*Scope*/ 10, /*->5591*/
/*  5581*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5583*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5591*/     0, /*End of Scope*/
/*  5592*/    /*Scope*/ 9|128,1/*137*/, /*->5731*/
/*  5594*/     OPC_CheckChild0Type, MVT::f64,
/*  5596*/     OPC_RecordChild1, // #1 = $rhs
/*  5597*/     OPC_Scope, 10, /*->5609*/ // 12 children in Scope
/*  5599*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5601*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5609*/     /*Scope*/ 10, /*->5620*/
/*  5610*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5612*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5620*/     /*Scope*/ 10, /*->5631*/
/*  5621*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5623*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5631*/     /*Scope*/ 10, /*->5642*/
/*  5632*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5634*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5642*/     /*Scope*/ 10, /*->5653*/
/*  5643*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5645*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5653*/     /*Scope*/ 10, /*->5664*/
/*  5654*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5656*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5664*/     /*Scope*/ 10, /*->5675*/
/*  5665*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5667*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5675*/     /*Scope*/ 10, /*->5686*/
/*  5676*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5678*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5686*/     /*Scope*/ 10, /*->5697*/
/*  5687*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5689*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5697*/     /*Scope*/ 10, /*->5708*/
/*  5698*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5700*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5708*/     /*Scope*/ 10, /*->5719*/
/*  5709*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5711*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5719*/     /*Scope*/ 10, /*->5730*/
/*  5720*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5722*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64), 0,
                    MVT::i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5730*/     0, /*End of Scope*/
/*  5731*/    0, /*End of Scope*/
/*  5732*/   /*SwitchType*/ 7|128,1/*135*/, MVT::v16i8,// ->5870
/*  5735*/    OPC_CheckChild0Type, MVT::v16i8,
/*  5737*/    OPC_RecordChild1, // #1 = $rhs
/*  5738*/    OPC_Scope, 12, /*->5752*/ // 10 children in Scope
/*  5740*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5742*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5744*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5752*/    /*Scope*/ 12, /*->5765*/
/*  5753*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5755*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5757*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5765*/    /*Scope*/ 12, /*->5778*/
/*  5766*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5768*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5770*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5778*/    /*Scope*/ 12, /*->5791*/
/*  5779*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5781*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5783*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5791*/    /*Scope*/ 12, /*->5804*/
/*  5792*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5794*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5796*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5804*/    /*Scope*/ 12, /*->5817*/
/*  5805*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5807*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5809*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5817*/    /*Scope*/ 12, /*->5830*/
/*  5818*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5820*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5822*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5830*/    /*Scope*/ 12, /*->5843*/
/*  5831*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5833*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5835*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5843*/    /*Scope*/ 12, /*->5856*/
/*  5844*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5846*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5848*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5856*/    /*Scope*/ 12, /*->5869*/
/*  5857*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5859*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5861*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5869*/    0, /*End of Scope*/
/*  5870*/   /*SwitchType*/ 7|128,1/*135*/, MVT::v8i16,// ->6008
/*  5873*/    OPC_CheckChild0Type, MVT::v8i16,
/*  5875*/    OPC_RecordChild1, // #1 = $rhs
/*  5876*/    OPC_Scope, 12, /*->5890*/ // 10 children in Scope
/*  5878*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5880*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5882*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5890*/    /*Scope*/ 12, /*->5903*/
/*  5891*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5893*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5895*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5903*/    /*Scope*/ 12, /*->5916*/
/*  5904*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5906*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5908*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5916*/    /*Scope*/ 12, /*->5929*/
/*  5917*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5919*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5921*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5929*/    /*Scope*/ 12, /*->5942*/
/*  5930*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5932*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5934*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5942*/    /*Scope*/ 12, /*->5955*/
/*  5943*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5945*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5947*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5955*/    /*Scope*/ 12, /*->5968*/
/*  5956*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5958*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5960*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5968*/    /*Scope*/ 12, /*->5981*/
/*  5969*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5971*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5973*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5981*/    /*Scope*/ 12, /*->5994*/
/*  5982*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5984*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5986*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5994*/    /*Scope*/ 12, /*->6007*/
/*  5995*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5997*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  5999*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  6007*/    0, /*End of Scope*/
/*  6008*/   /*SwitchType*/ 34|128,2/*290*/, MVT::v4i32,// ->6301
/*  6011*/    OPC_Scope, 7|128,1/*135*/, /*->6149*/ // 2 children in Scope
/*  6014*/     OPC_CheckChild0Type, MVT::v4i32,
/*  6016*/     OPC_RecordChild1, // #1 = $rhs
/*  6017*/     OPC_Scope, 12, /*->6031*/ // 10 children in Scope
/*  6019*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  6021*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6023*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6031*/     /*Scope*/ 12, /*->6044*/
/*  6032*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  6034*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6036*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6044*/     /*Scope*/ 12, /*->6057*/
/*  6045*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  6047*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6049*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6057*/     /*Scope*/ 12, /*->6070*/
/*  6058*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  6060*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6062*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6070*/     /*Scope*/ 12, /*->6083*/
/*  6071*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  6073*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6075*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6083*/     /*Scope*/ 12, /*->6096*/
/*  6084*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  6086*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6088*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6096*/     /*Scope*/ 12, /*->6109*/
/*  6097*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  6099*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6101*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6109*/     /*Scope*/ 12, /*->6122*/
/*  6110*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  6112*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6114*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6122*/     /*Scope*/ 12, /*->6135*/
/*  6123*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  6125*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6127*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6135*/     /*Scope*/ 12, /*->6148*/
/*  6136*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  6138*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6140*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_U_I32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  6148*/     0, /*End of Scope*/
/*  6149*/    /*Scope*/ 21|128,1/*149*/, /*->6300*/
/*  6151*/     OPC_CheckChild0Type, MVT::v4f32,
/*  6153*/     OPC_RecordChild1, // #1 = $rhs
/*  6154*/     OPC_Scope, 12, /*->6168*/ // 12 children in Scope
/*  6156*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  6158*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6160*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6168*/     /*Scope*/ 12, /*->6181*/
/*  6169*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  6171*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6173*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6181*/     /*Scope*/ 12, /*->6194*/
/*  6182*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  6184*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6186*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6194*/     /*Scope*/ 12, /*->6207*/
/*  6195*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  6197*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6199*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6207*/     /*Scope*/ 12, /*->6220*/
/*  6208*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  6210*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6212*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6220*/     /*Scope*/ 12, /*->6233*/
/*  6221*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  6223*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6225*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  6233*/     /*Scope*/ 10, /*->6244*/
/*  6234*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  6236*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6244*/     /*Scope*/ 10, /*->6255*/
/*  6245*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  6247*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6255*/     /*Scope*/ 10, /*->6266*/
/*  6256*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  6258*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6266*/     /*Scope*/ 10, /*->6277*/
/*  6267*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  6269*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6277*/     /*Scope*/ 10, /*->6288*/
/*  6278*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  6280*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6288*/     /*Scope*/ 10, /*->6299*/
/*  6289*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  6291*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F32x4), 0,
                    MVT::v4i32, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  6299*/     0, /*End of Scope*/
/*  6300*/    0, /*End of Scope*/
/*  6301*/   /*SwitchType*/ 109|128,1/*237*/, MVT::v2i64,// ->6541
/*  6304*/    OPC_Scope, 83, /*->6389*/ // 2 children in Scope
/*  6306*/     OPC_CheckChild0Type, MVT::v2i64,
/*  6308*/     OPC_RecordChild1, // #1 = $rhs
/*  6309*/     OPC_Scope, 12, /*->6323*/ // 6 children in Scope
/*  6311*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  6313*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6315*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6323*/     /*Scope*/ 12, /*->6336*/
/*  6324*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  6326*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6328*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6336*/     /*Scope*/ 12, /*->6349*/
/*  6337*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  6339*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6341*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6349*/     /*Scope*/ 12, /*->6362*/
/*  6350*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  6352*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6354*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6362*/     /*Scope*/ 12, /*->6375*/
/*  6363*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  6365*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6367*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6375*/     /*Scope*/ 12, /*->6388*/
/*  6376*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  6378*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6380*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_S_I64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  6388*/     0, /*End of Scope*/
/*  6389*/    /*Scope*/ 21|128,1/*149*/, /*->6540*/
/*  6391*/     OPC_CheckChild0Type, MVT::v2f64,
/*  6393*/     OPC_RecordChild1, // #1 = $rhs
/*  6394*/     OPC_Scope, 12, /*->6408*/ // 12 children in Scope
/*  6396*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  6398*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6400*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6408*/     /*Scope*/ 12, /*->6421*/
/*  6409*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  6411*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6413*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6421*/     /*Scope*/ 12, /*->6434*/
/*  6422*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  6424*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6426*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6434*/     /*Scope*/ 12, /*->6447*/
/*  6435*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  6437*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6439*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6447*/     /*Scope*/ 12, /*->6460*/
/*  6448*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  6450*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6452*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6460*/     /*Scope*/ 12, /*->6473*/
/*  6461*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  6463*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/*  6465*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6473*/     /*Scope*/ 10, /*->6484*/
/*  6474*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  6476*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EQ_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6484*/     /*Scope*/ 10, /*->6495*/
/*  6485*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  6487*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6495*/     /*Scope*/ 10, /*->6506*/
/*  6496*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  6498*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6506*/     /*Scope*/ 10, /*->6517*/
/*  6507*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  6509*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GT_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6517*/     /*Scope*/ 10, /*->6528*/
/*  6518*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  6520*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6528*/     /*Scope*/ 10, /*->6539*/
/*  6529*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  6531*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GE_F64x2), 0,
                    MVT::v2i64, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6539*/     0, /*End of Scope*/
/*  6540*/    0, /*End of Scope*/
/*  6541*/   0, // EndSwitchType
/*  6542*/  0, /*End of Scope*/
/*  6543*/ /*SwitchOpcode*/ 11|128,13/*1675*/, TARGET_VAL(ISD::LOAD),// ->8222
/*  6547*/  OPC_RecordMemRef,
/*  6548*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  6549*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  6550*/  OPC_Scope, 65|128,6/*833*/, /*->7386*/ // 2 children in Scope
/*  6553*/   OPC_CheckChild1Type, MVT::i32,
/*  6555*/   OPC_CheckPredicate, 14, // Predicate_unindexedload
/*  6557*/   OPC_Scope, 44, /*->6603*/ // 16 children in Scope
/*  6559*/    OPC_CheckPredicate, 15, // Predicate_load
/*  6561*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->6582
/*  6564*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6566*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6569*/     OPC_EmitMergeInputChains1_0,
/*  6570*/     OPC_EmitInteger, MVT::i32, 0, 
/*  6573*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6582*/    /*SwitchType*/ 18, MVT::i64,// ->6602
/*  6584*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6586*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6589*/     OPC_EmitMergeInputChains1_0,
/*  6590*/     OPC_EmitInteger, MVT::i32, 0, 
/*  6593*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6602*/    0, // EndSwitchType
/*  6603*/   /*Scope*/ 117, /*->6721*/
/*  6604*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  6606*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->6653
/*  6609*/     OPC_Scope, 20, /*->6631*/ // 2 children in Scope
/*  6611*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  6613*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6615*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6618*/      OPC_EmitMergeInputChains1_0,
/*  6619*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6622*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6631*/     /*Scope*/ 20, /*->6652*/
/*  6632*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  6634*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6636*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6639*/      OPC_EmitMergeInputChains1_0,
/*  6640*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6643*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6652*/     0, /*End of Scope*/
/*  6653*/    /*SwitchType*/ 65, MVT::i64,// ->6720
/*  6655*/     OPC_Scope, 20, /*->6677*/ // 3 children in Scope
/*  6657*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  6659*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6661*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6664*/      OPC_EmitMergeInputChains1_0,
/*  6665*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6668*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6677*/     /*Scope*/ 20, /*->6698*/
/*  6678*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  6680*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6682*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6685*/      OPC_EmitMergeInputChains1_0,
/*  6686*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6689*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6698*/     /*Scope*/ 20, /*->6719*/
/*  6699*/      OPC_CheckPredicate, 2, // Predicate_sextloadi32
/*  6701*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6703*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6706*/      OPC_EmitMergeInputChains1_0,
/*  6707*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6710*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6719*/     0, /*End of Scope*/
/*  6720*/    0, // EndSwitchType
/*  6721*/   /*Scope*/ 117, /*->6839*/
/*  6722*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  6724*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->6771
/*  6727*/     OPC_Scope, 20, /*->6749*/ // 2 children in Scope
/*  6729*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  6731*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6733*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6736*/      OPC_EmitMergeInputChains1_0,
/*  6737*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6740*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6749*/     /*Scope*/ 20, /*->6770*/
/*  6750*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  6752*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6754*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6757*/      OPC_EmitMergeInputChains1_0,
/*  6758*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6761*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6770*/     0, /*End of Scope*/
/*  6771*/    /*SwitchType*/ 65, MVT::i64,// ->6838
/*  6773*/     OPC_Scope, 20, /*->6795*/ // 3 children in Scope
/*  6775*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  6777*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6779*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6782*/      OPC_EmitMergeInputChains1_0,
/*  6783*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6786*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6795*/     /*Scope*/ 20, /*->6816*/
/*  6796*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  6798*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6800*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6803*/      OPC_EmitMergeInputChains1_0,
/*  6804*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6816*/     /*Scope*/ 20, /*->6837*/
/*  6817*/      OPC_CheckPredicate, 2, // Predicate_zextloadi32
/*  6819*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6821*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6824*/      OPC_EmitMergeInputChains1_0,
/*  6825*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6828*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6837*/     0, /*End of Scope*/
/*  6838*/    0, // EndSwitchType
/*  6839*/   /*Scope*/ 117, /*->6957*/
/*  6840*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  6842*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->6889
/*  6845*/     OPC_Scope, 20, /*->6867*/ // 2 children in Scope
/*  6847*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  6849*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6851*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6854*/      OPC_EmitMergeInputChains1_0,
/*  6855*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6858*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6867*/     /*Scope*/ 20, /*->6888*/
/*  6868*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  6870*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6872*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6875*/      OPC_EmitMergeInputChains1_0,
/*  6876*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6879*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6888*/     0, /*End of Scope*/
/*  6889*/    /*SwitchType*/ 65, MVT::i64,// ->6956
/*  6891*/     OPC_Scope, 20, /*->6913*/ // 3 children in Scope
/*  6893*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  6895*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6897*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6900*/      OPC_EmitMergeInputChains1_0,
/*  6901*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6904*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6913*/     /*Scope*/ 20, /*->6934*/
/*  6914*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  6916*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6918*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6921*/      OPC_EmitMergeInputChains1_0,
/*  6922*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6925*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6934*/     /*Scope*/ 20, /*->6955*/
/*  6935*/      OPC_CheckPredicate, 2, // Predicate_extloadi32
/*  6937*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6939*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6942*/      OPC_EmitMergeInputChains1_0,
/*  6943*/      OPC_EmitInteger, MVT::i32, 0, 
/*  6946*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6955*/     0, /*End of Scope*/
/*  6956*/    0, // EndSwitchType
/*  6957*/   /*Scope*/ 124, /*->7082*/
/*  6958*/    OPC_CheckPredicate, 15, // Predicate_load
/*  6960*/    OPC_SwitchType /*6 cases */, 18, MVT::f32,// ->6981
/*  6963*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6965*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6968*/     OPC_EmitMergeInputChains1_0,
/*  6969*/     OPC_EmitInteger, MVT::i32, 0, 
/*  6972*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6981*/    /*SwitchType*/ 18, MVT::f64,// ->7001
/*  6983*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  6985*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6988*/     OPC_EmitMergeInputChains1_0,
/*  6989*/     OPC_EmitInteger, MVT::i32, 0, 
/*  6992*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7001*/    /*SwitchType*/ 18, MVT::v16i8,// ->7021
/*  7003*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7005*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7008*/     OPC_EmitMergeInputChains1_0,
/*  7009*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7012*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7021*/    /*SwitchType*/ 18, MVT::v8i16,// ->7041
/*  7023*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7025*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7028*/     OPC_EmitMergeInputChains1_0,
/*  7029*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7032*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7041*/    /*SwitchType*/ 18, MVT::v4i32,// ->7061
/*  7043*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7045*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7048*/     OPC_EmitMergeInputChains1_0,
/*  7049*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7052*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7061*/    /*SwitchType*/ 18, MVT::v2i64,// ->7081
/*  7063*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7065*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7068*/     OPC_EmitMergeInputChains1_0,
/*  7069*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7072*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7081*/    0, // EndSwitchType
/*  7082*/   /*Scope*/ 24, /*->7107*/
/*  7083*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7085*/    OPC_CheckPredicate, 19, // Predicate_sextloadvi8
/*  7087*/    OPC_CheckType, MVT::v8i16,
/*  7089*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7091*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7094*/    OPC_EmitMergeInputChains1_0,
/*  7095*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7098*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7107*/   /*Scope*/ 24, /*->7132*/
/*  7108*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7110*/    OPC_CheckPredicate, 19, // Predicate_zextloadvi8
/*  7112*/    OPC_CheckType, MVT::v8i16,
/*  7114*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7116*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7119*/    OPC_EmitMergeInputChains1_0,
/*  7120*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7123*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7132*/   /*Scope*/ 24, /*->7157*/
/*  7133*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7135*/    OPC_CheckPredicate, 19, // Predicate_extloadvi8
/*  7137*/    OPC_CheckType, MVT::v8i16,
/*  7139*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7141*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7144*/    OPC_EmitMergeInputChains1_0,
/*  7145*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7148*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7157*/   /*Scope*/ 24, /*->7182*/
/*  7158*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7160*/    OPC_CheckPredicate, 20, // Predicate_sextloadvi16
/*  7162*/    OPC_CheckType, MVT::v4i32,
/*  7164*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7166*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7169*/    OPC_EmitMergeInputChains1_0,
/*  7170*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7173*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7182*/   /*Scope*/ 24, /*->7207*/
/*  7183*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7185*/    OPC_CheckPredicate, 20, // Predicate_zextloadvi16
/*  7187*/    OPC_CheckType, MVT::v4i32,
/*  7189*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7191*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7194*/    OPC_EmitMergeInputChains1_0,
/*  7195*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7198*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7207*/   /*Scope*/ 24, /*->7232*/
/*  7208*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7210*/    OPC_CheckPredicate, 20, // Predicate_extloadvi16
/*  7212*/    OPC_CheckType, MVT::v4i32,
/*  7214*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7216*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7219*/    OPC_EmitMergeInputChains1_0,
/*  7220*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7223*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7232*/   /*Scope*/ 24, /*->7257*/
/*  7233*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7235*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi32
/*  7237*/    OPC_CheckType, MVT::v2i64,
/*  7239*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7241*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7244*/    OPC_EmitMergeInputChains1_0,
/*  7245*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7248*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7257*/   /*Scope*/ 24, /*->7282*/
/*  7258*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7260*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi32
/*  7262*/    OPC_CheckType, MVT::v2i64,
/*  7264*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7266*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7269*/    OPC_EmitMergeInputChains1_0,
/*  7270*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7273*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7282*/   /*Scope*/ 24, /*->7307*/
/*  7283*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7285*/    OPC_CheckPredicate, 21, // Predicate_extloadvi32
/*  7287*/    OPC_CheckType, MVT::v2i64,
/*  7289*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7291*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7294*/    OPC_EmitMergeInputChains1_0,
/*  7295*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7298*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7307*/   /*Scope*/ 44, /*->7352*/
/*  7308*/    OPC_CheckPredicate, 15, // Predicate_load
/*  7310*/    OPC_SwitchType /*2 cases */, 18, MVT::v4f32,// ->7331
/*  7313*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7315*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7318*/     OPC_EmitMergeInputChains1_0,
/*  7319*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7322*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7331*/    /*SwitchType*/ 18, MVT::v2f64,// ->7351
/*  7333*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7335*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7338*/     OPC_EmitMergeInputChains1_0,
/*  7339*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7342*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7351*/    0, // EndSwitchType
/*  7352*/   /*Scope*/ 32, /*->7385*/
/*  7353*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7355*/    OPC_CheckType, MVT::v2f64,
/*  7357*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  7359*/    OPC_EmitMergeInputChains1_0,
/*  7360*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7363*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7366*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7375*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::promote_low_F64x2), 0,
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  7382*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  7385*/   0, /*End of Scope*/
/*  7386*/  /*Scope*/ 65|128,6/*833*/, /*->8221*/
/*  7388*/   OPC_CheckChild1Type, MVT::i64,
/*  7390*/   OPC_CheckPredicate, 14, // Predicate_unindexedload
/*  7392*/   OPC_Scope, 44, /*->7438*/ // 16 children in Scope
/*  7394*/    OPC_CheckPredicate, 15, // Predicate_load
/*  7396*/    OPC_SwitchType /*2 cases */, 18, MVT::i32,// ->7417
/*  7399*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7401*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7404*/     OPC_EmitMergeInputChains1_0,
/*  7405*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7408*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7417*/    /*SwitchType*/ 18, MVT::i64,// ->7437
/*  7419*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7421*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7424*/     OPC_EmitMergeInputChains1_0,
/*  7425*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7428*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7437*/    0, // EndSwitchType
/*  7438*/   /*Scope*/ 117, /*->7556*/
/*  7439*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7441*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->7488
/*  7444*/     OPC_Scope, 20, /*->7466*/ // 2 children in Scope
/*  7446*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  7448*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7450*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7453*/      OPC_EmitMergeInputChains1_0,
/*  7454*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7457*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7466*/     /*Scope*/ 20, /*->7487*/
/*  7467*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  7469*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7471*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7474*/      OPC_EmitMergeInputChains1_0,
/*  7475*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7478*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7487*/     0, /*End of Scope*/
/*  7488*/    /*SwitchType*/ 65, MVT::i64,// ->7555
/*  7490*/     OPC_Scope, 20, /*->7512*/ // 3 children in Scope
/*  7492*/      OPC_CheckPredicate, 0, // Predicate_sextloadi8
/*  7494*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7496*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7499*/      OPC_EmitMergeInputChains1_0,
/*  7500*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7503*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7512*/     /*Scope*/ 20, /*->7533*/
/*  7513*/      OPC_CheckPredicate, 1, // Predicate_sextloadi16
/*  7515*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7517*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7520*/      OPC_EmitMergeInputChains1_0,
/*  7521*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7524*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7533*/     /*Scope*/ 20, /*->7554*/
/*  7534*/      OPC_CheckPredicate, 2, // Predicate_sextloadi32
/*  7536*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7538*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7541*/      OPC_EmitMergeInputChains1_0,
/*  7542*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7545*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7554*/     0, /*End of Scope*/
/*  7555*/    0, // EndSwitchType
/*  7556*/   /*Scope*/ 117, /*->7674*/
/*  7557*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7559*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->7606
/*  7562*/     OPC_Scope, 20, /*->7584*/ // 2 children in Scope
/*  7564*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  7566*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7568*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7571*/      OPC_EmitMergeInputChains1_0,
/*  7572*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7575*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7584*/     /*Scope*/ 20, /*->7605*/
/*  7585*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  7587*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7589*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7592*/      OPC_EmitMergeInputChains1_0,
/*  7593*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7596*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7605*/     0, /*End of Scope*/
/*  7606*/    /*SwitchType*/ 65, MVT::i64,// ->7673
/*  7608*/     OPC_Scope, 20, /*->7630*/ // 3 children in Scope
/*  7610*/      OPC_CheckPredicate, 0, // Predicate_zextloadi8
/*  7612*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7614*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7617*/      OPC_EmitMergeInputChains1_0,
/*  7618*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7621*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7630*/     /*Scope*/ 20, /*->7651*/
/*  7631*/      OPC_CheckPredicate, 1, // Predicate_zextloadi16
/*  7633*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7635*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7638*/      OPC_EmitMergeInputChains1_0,
/*  7639*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7642*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7651*/     /*Scope*/ 20, /*->7672*/
/*  7652*/      OPC_CheckPredicate, 2, // Predicate_zextloadi32
/*  7654*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7656*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7659*/      OPC_EmitMergeInputChains1_0,
/*  7660*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7663*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7672*/     0, /*End of Scope*/
/*  7673*/    0, // EndSwitchType
/*  7674*/   /*Scope*/ 117, /*->7792*/
/*  7675*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7677*/    OPC_SwitchType /*2 cases */, 44, MVT::i32,// ->7724
/*  7680*/     OPC_Scope, 20, /*->7702*/ // 2 children in Scope
/*  7682*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  7684*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7686*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7689*/      OPC_EmitMergeInputChains1_0,
/*  7690*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7693*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7702*/     /*Scope*/ 20, /*->7723*/
/*  7703*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  7705*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7707*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7710*/      OPC_EmitMergeInputChains1_0,
/*  7711*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7714*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7723*/     0, /*End of Scope*/
/*  7724*/    /*SwitchType*/ 65, MVT::i64,// ->7791
/*  7726*/     OPC_Scope, 20, /*->7748*/ // 3 children in Scope
/*  7728*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/*  7730*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7732*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7735*/      OPC_EmitMergeInputChains1_0,
/*  7736*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7739*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7748*/     /*Scope*/ 20, /*->7769*/
/*  7749*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/*  7751*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7753*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7756*/      OPC_EmitMergeInputChains1_0,
/*  7757*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7760*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7769*/     /*Scope*/ 20, /*->7790*/
/*  7770*/      OPC_CheckPredicate, 2, // Predicate_extloadi32
/*  7772*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7774*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7777*/      OPC_EmitMergeInputChains1_0,
/*  7778*/      OPC_EmitInteger, MVT::i32, 0, 
/*  7781*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7790*/     0, /*End of Scope*/
/*  7791*/    0, // EndSwitchType
/*  7792*/   /*Scope*/ 124, /*->7917*/
/*  7793*/    OPC_CheckPredicate, 15, // Predicate_load
/*  7795*/    OPC_SwitchType /*6 cases */, 18, MVT::f32,// ->7816
/*  7798*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7800*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7803*/     OPC_EmitMergeInputChains1_0,
/*  7804*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7807*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7816*/    /*SwitchType*/ 18, MVT::f64,// ->7836
/*  7818*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7820*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7823*/     OPC_EmitMergeInputChains1_0,
/*  7824*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7827*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7836*/    /*SwitchType*/ 18, MVT::v16i8,// ->7856
/*  7838*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7840*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7843*/     OPC_EmitMergeInputChains1_0,
/*  7844*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7847*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7856*/    /*SwitchType*/ 18, MVT::v8i16,// ->7876
/*  7858*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7860*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7863*/     OPC_EmitMergeInputChains1_0,
/*  7864*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7867*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7876*/    /*SwitchType*/ 18, MVT::v4i32,// ->7896
/*  7878*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7880*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7883*/     OPC_EmitMergeInputChains1_0,
/*  7884*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7887*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7896*/    /*SwitchType*/ 18, MVT::v2i64,// ->7916
/*  7898*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7900*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7903*/     OPC_EmitMergeInputChains1_0,
/*  7904*/     OPC_EmitInteger, MVT::i32, 0, 
/*  7907*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7916*/    0, // EndSwitchType
/*  7917*/   /*Scope*/ 24, /*->7942*/
/*  7918*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7920*/    OPC_CheckPredicate, 19, // Predicate_sextloadvi8
/*  7922*/    OPC_CheckType, MVT::v8i16,
/*  7924*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7926*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7929*/    OPC_EmitMergeInputChains1_0,
/*  7930*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7933*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7942*/   /*Scope*/ 24, /*->7967*/
/*  7943*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  7945*/    OPC_CheckPredicate, 19, // Predicate_zextloadvi8
/*  7947*/    OPC_CheckType, MVT::v8i16,
/*  7949*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7951*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7954*/    OPC_EmitMergeInputChains1_0,
/*  7955*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7958*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7967*/   /*Scope*/ 24, /*->7992*/
/*  7968*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  7970*/    OPC_CheckPredicate, 19, // Predicate_extloadvi8
/*  7972*/    OPC_CheckType, MVT::v8i16,
/*  7974*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  7976*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7979*/    OPC_EmitMergeInputChains1_0,
/*  7980*/    OPC_EmitInteger, MVT::i32, 0, 
/*  7983*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7992*/   /*Scope*/ 24, /*->8017*/
/*  7993*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  7995*/    OPC_CheckPredicate, 20, // Predicate_sextloadvi16
/*  7997*/    OPC_CheckType, MVT::v4i32,
/*  7999*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8001*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8004*/    OPC_EmitMergeInputChains1_0,
/*  8005*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8008*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8017*/   /*Scope*/ 24, /*->8042*/
/*  8018*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  8020*/    OPC_CheckPredicate, 20, // Predicate_zextloadvi16
/*  8022*/    OPC_CheckType, MVT::v4i32,
/*  8024*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8026*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8029*/    OPC_EmitMergeInputChains1_0,
/*  8030*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8033*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8042*/   /*Scope*/ 24, /*->8067*/
/*  8043*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  8045*/    OPC_CheckPredicate, 20, // Predicate_extloadvi16
/*  8047*/    OPC_CheckType, MVT::v4i32,
/*  8049*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8051*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8054*/    OPC_EmitMergeInputChains1_0,
/*  8055*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8058*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8067*/   /*Scope*/ 24, /*->8092*/
/*  8068*/    OPC_CheckPredicate, 16, // Predicate_sextload
/*  8070*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi32
/*  8072*/    OPC_CheckType, MVT::v2i64,
/*  8074*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8076*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8079*/    OPC_EmitMergeInputChains1_0,
/*  8080*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8083*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8092*/   /*Scope*/ 24, /*->8117*/
/*  8093*/    OPC_CheckPredicate, 17, // Predicate_zextload
/*  8095*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi32
/*  8097*/    OPC_CheckType, MVT::v2i64,
/*  8099*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8101*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8104*/    OPC_EmitMergeInputChains1_0,
/*  8105*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8108*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8117*/   /*Scope*/ 24, /*->8142*/
/*  8118*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  8120*/    OPC_CheckPredicate, 21, // Predicate_extloadvi32
/*  8122*/    OPC_CheckType, MVT::v2i64,
/*  8124*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8126*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8129*/    OPC_EmitMergeInputChains1_0,
/*  8130*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8133*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8142*/   /*Scope*/ 44, /*->8187*/
/*  8143*/    OPC_CheckPredicate, 15, // Predicate_load
/*  8145*/    OPC_SwitchType /*2 cases */, 18, MVT::v4f32,// ->8166
/*  8148*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8150*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8153*/     OPC_EmitMergeInputChains1_0,
/*  8154*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8157*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8166*/    /*SwitchType*/ 18, MVT::v2f64,// ->8186
/*  8168*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8170*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8173*/     OPC_EmitMergeInputChains1_0,
/*  8174*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8177*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8186*/    0, // EndSwitchType
/*  8187*/   /*Scope*/ 32, /*->8220*/
/*  8188*/    OPC_CheckPredicate, 18, // Predicate_extload
/*  8190*/    OPC_CheckType, MVT::v2f64,
/*  8192*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8194*/    OPC_EmitMergeInputChains1_0,
/*  8195*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8198*/    OPC_EmitInteger, MVT::i64, 0, 
/*  8201*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::v16i8, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  8210*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::promote_low_F64x2), 0,
                  MVT::v2f64, 1/*#Ops*/, 4,  // Results = #5
/*  8217*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_I64x2_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  8220*/   0, /*End of Scope*/
/*  8221*/  0, /*End of Scope*/
/*  8222*/ /*SwitchOpcode*/ 65|128,1/*193*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->8419
/*  8226*/  OPC_RecordMemRef,
/*  8227*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  8228*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8229*/  OPC_Scope, 93, /*->8324*/ // 2 children in Scope
/*  8231*/   OPC_CheckChild1Type, MVT::i32,
/*  8233*/   OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->8301
/*  8236*/    OPC_Scope, 20, /*->8258*/ // 3 children in Scope
/*  8238*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  8240*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  8242*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  8245*/     OPC_EmitMergeInputChains1_0,
/*  8246*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8249*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  8258*/    /*Scope*/ 20, /*->8279*/
/*  8259*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  8261*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  8263*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  8266*/     OPC_EmitMergeInputChains1_0,
/*  8267*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8270*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  8279*/    /*Scope*/ 20, /*->8300*/
/*  8280*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  8282*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  8284*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  8287*/     OPC_EmitMergeInputChains1_0,
/*  8288*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8291*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  8300*/    0, /*End of Scope*/
/*  8301*/   /*SwitchType*/ 20, MVT::i64,// ->8323
/*  8303*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_64
/*  8305*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/*  8307*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  8310*/    OPC_EmitMergeInputChains1_0,
/*  8311*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8314*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  8323*/   0, // EndSwitchType
/*  8324*/  /*Scope*/ 93, /*->8418*/
/*  8325*/   OPC_CheckChild1Type, MVT::i64,
/*  8327*/   OPC_SwitchType /*2 cases */, 65, MVT::i32,// ->8395
/*  8330*/    OPC_Scope, 20, /*->8352*/ // 3 children in Scope
/*  8332*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_32
/*  8334*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8336*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8339*/     OPC_EmitMergeInputChains1_0,
/*  8340*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8343*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8352*/    /*Scope*/ 20, /*->8373*/
/*  8353*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_8
/*  8355*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8357*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8360*/     OPC_EmitMergeInputChains1_0,
/*  8361*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8364*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8373*/    /*Scope*/ 20, /*->8394*/
/*  8374*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_16
/*  8376*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8378*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8381*/     OPC_EmitMergeInputChains1_0,
/*  8382*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8385*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8394*/    0, /*End of Scope*/
/*  8395*/   /*SwitchType*/ 20, MVT::i64,// ->8417
/*  8397*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_64
/*  8399*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/*  8401*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  8404*/    OPC_EmitMergeInputChains1_0,
/*  8405*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8408*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  8417*/   0, // EndSwitchType
/*  8418*/  0, /*End of Scope*/
/*  8419*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->8716
/*  8423*/  OPC_RecordMemRef,
/*  8424*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  8425*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8426*/  OPC_Scope, 14|128,1/*142*/, /*->8571*/ // 2 children in Scope
/*  8429*/   OPC_CheckChild1Type, MVT::i32,
/*  8431*/   OPC_RecordChild2, // #2 = $val
/*  8432*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->8547
/*  8435*/    OPC_Scope, 21, /*->8458*/ // 5 children in Scope
/*  8437*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*  8439*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8441*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8444*/     OPC_EmitMergeInputChains1_0,
/*  8445*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8448*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8458*/    /*Scope*/ 21, /*->8480*/
/*  8459*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  8461*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8463*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8466*/     OPC_EmitMergeInputChains1_0,
/*  8467*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8470*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8480*/    /*Scope*/ 21, /*->8502*/
/*  8481*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  8483*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8485*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8488*/     OPC_EmitMergeInputChains1_0,
/*  8489*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8492*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8502*/    /*Scope*/ 21, /*->8524*/
/*  8503*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  8505*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8507*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8510*/     OPC_EmitMergeInputChains1_0,
/*  8511*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8514*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8524*/    /*Scope*/ 21, /*->8546*/
/*  8525*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  8527*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8529*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8532*/     OPC_EmitMergeInputChains1_0,
/*  8533*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8536*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8546*/    0, /*End of Scope*/
/*  8547*/   /*SwitchType*/ 21, MVT::i64,// ->8570
/*  8549*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_add_64
/*  8551*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8553*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8556*/    OPC_EmitMergeInputChains1_0,
/*  8557*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8560*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8570*/   0, // EndSwitchType
/*  8571*/  /*Scope*/ 14|128,1/*142*/, /*->8715*/
/*  8573*/   OPC_CheckChild1Type, MVT::i64,
/*  8575*/   OPC_RecordChild2, // #2 = $val
/*  8576*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->8691
/*  8579*/    OPC_Scope, 21, /*->8602*/ // 5 children in Scope
/*  8581*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_add_32
/*  8583*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8585*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8588*/     OPC_EmitMergeInputChains1_0,
/*  8589*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8592*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8602*/    /*Scope*/ 21, /*->8624*/
/*  8603*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  8605*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8607*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8610*/     OPC_EmitMergeInputChains1_0,
/*  8611*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8614*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8624*/    /*Scope*/ 21, /*->8646*/
/*  8625*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  8627*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8629*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8632*/     OPC_EmitMergeInputChains1_0,
/*  8633*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8636*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8646*/    /*Scope*/ 21, /*->8668*/
/*  8647*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_add_8
/*  8649*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8651*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8654*/     OPC_EmitMergeInputChains1_0,
/*  8655*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8658*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8668*/    /*Scope*/ 21, /*->8690*/
/*  8669*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_add_16
/*  8671*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8673*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8676*/     OPC_EmitMergeInputChains1_0,
/*  8677*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8680*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8690*/    0, /*End of Scope*/
/*  8691*/   /*SwitchType*/ 21, MVT::i64,// ->8714
/*  8693*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_add_64
/*  8695*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8697*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8700*/    OPC_EmitMergeInputChains1_0,
/*  8701*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8704*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8714*/   0, // EndSwitchType
/*  8715*/  0, /*End of Scope*/
/*  8716*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->9013
/*  8720*/  OPC_RecordMemRef,
/*  8721*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  8722*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8723*/  OPC_Scope, 14|128,1/*142*/, /*->8868*/ // 2 children in Scope
/*  8726*/   OPC_CheckChild1Type, MVT::i32,
/*  8728*/   OPC_RecordChild2, // #2 = $val
/*  8729*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->8844
/*  8732*/    OPC_Scope, 21, /*->8755*/ // 5 children in Scope
/*  8734*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*  8736*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8738*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8741*/     OPC_EmitMergeInputChains1_0,
/*  8742*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8745*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8755*/    /*Scope*/ 21, /*->8777*/
/*  8756*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8758*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8760*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8763*/     OPC_EmitMergeInputChains1_0,
/*  8764*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8767*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8777*/    /*Scope*/ 21, /*->8799*/
/*  8778*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8780*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8782*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8785*/     OPC_EmitMergeInputChains1_0,
/*  8786*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8789*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8799*/    /*Scope*/ 21, /*->8821*/
/*  8800*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8802*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8804*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8807*/     OPC_EmitMergeInputChains1_0,
/*  8808*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8811*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8821*/    /*Scope*/ 21, /*->8843*/
/*  8822*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8824*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8826*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8829*/     OPC_EmitMergeInputChains1_0,
/*  8830*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8833*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8843*/    0, /*End of Scope*/
/*  8844*/   /*SwitchType*/ 21, MVT::i64,// ->8867
/*  8846*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_sub_64
/*  8848*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8850*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8853*/    OPC_EmitMergeInputChains1_0,
/*  8854*/    OPC_EmitInteger, MVT::i32, 0, 
/*  8857*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8867*/   0, // EndSwitchType
/*  8868*/  /*Scope*/ 14|128,1/*142*/, /*->9012*/
/*  8870*/   OPC_CheckChild1Type, MVT::i64,
/*  8872*/   OPC_RecordChild2, // #2 = $val
/*  8873*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->8988
/*  8876*/    OPC_Scope, 21, /*->8899*/ // 5 children in Scope
/*  8878*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_sub_32
/*  8880*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8882*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8885*/     OPC_EmitMergeInputChains1_0,
/*  8886*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8889*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8899*/    /*Scope*/ 21, /*->8921*/
/*  8900*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8902*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8904*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8907*/     OPC_EmitMergeInputChains1_0,
/*  8908*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8911*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8921*/    /*Scope*/ 21, /*->8943*/
/*  8922*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8924*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8926*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8929*/     OPC_EmitMergeInputChains1_0,
/*  8930*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8933*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8943*/    /*Scope*/ 21, /*->8965*/
/*  8944*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_sub_8
/*  8946*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8948*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8951*/     OPC_EmitMergeInputChains1_0,
/*  8952*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8955*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8965*/    /*Scope*/ 21, /*->8987*/
/*  8966*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_sub_16
/*  8968*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8970*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8973*/     OPC_EmitMergeInputChains1_0,
/*  8974*/     OPC_EmitInteger, MVT::i32, 0, 
/*  8977*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8987*/    0, /*End of Scope*/
/*  8988*/   /*SwitchType*/ 21, MVT::i64,// ->9011
/*  8990*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_sub_64
/*  8992*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8994*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8997*/    OPC_EmitMergeInputChains1_0,
/*  8998*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9001*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9011*/   0, // EndSwitchType
/*  9012*/  0, /*End of Scope*/
/*  9013*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->9310
/*  9017*/  OPC_RecordMemRef,
/*  9018*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  9019*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9020*/  OPC_Scope, 14|128,1/*142*/, /*->9165*/ // 2 children in Scope
/*  9023*/   OPC_CheckChild1Type, MVT::i32,
/*  9025*/   OPC_RecordChild2, // #2 = $val
/*  9026*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9141
/*  9029*/    OPC_Scope, 21, /*->9052*/ // 5 children in Scope
/*  9031*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*  9033*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9035*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9038*/     OPC_EmitMergeInputChains1_0,
/*  9039*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9042*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9052*/    /*Scope*/ 21, /*->9074*/
/*  9053*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  9055*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9057*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9060*/     OPC_EmitMergeInputChains1_0,
/*  9061*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9064*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9074*/    /*Scope*/ 21, /*->9096*/
/*  9075*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  9077*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9079*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9082*/     OPC_EmitMergeInputChains1_0,
/*  9083*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9086*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9096*/    /*Scope*/ 21, /*->9118*/
/*  9097*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  9099*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9101*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9104*/     OPC_EmitMergeInputChains1_0,
/*  9105*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9108*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9118*/    /*Scope*/ 21, /*->9140*/
/*  9119*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  9121*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9123*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9126*/     OPC_EmitMergeInputChains1_0,
/*  9127*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9130*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9140*/    0, /*End of Scope*/
/*  9141*/   /*SwitchType*/ 21, MVT::i64,// ->9164
/*  9143*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_and_64
/*  9145*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9147*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9150*/    OPC_EmitMergeInputChains1_0,
/*  9151*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9154*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  9164*/   0, // EndSwitchType
/*  9165*/  /*Scope*/ 14|128,1/*142*/, /*->9309*/
/*  9167*/   OPC_CheckChild1Type, MVT::i64,
/*  9169*/   OPC_RecordChild2, // #2 = $val
/*  9170*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9285
/*  9173*/    OPC_Scope, 21, /*->9196*/ // 5 children in Scope
/*  9175*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_and_32
/*  9177*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9179*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9182*/     OPC_EmitMergeInputChains1_0,
/*  9183*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9186*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9196*/    /*Scope*/ 21, /*->9218*/
/*  9197*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  9199*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9201*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9204*/     OPC_EmitMergeInputChains1_0,
/*  9205*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9208*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9218*/    /*Scope*/ 21, /*->9240*/
/*  9219*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  9221*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9223*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9226*/     OPC_EmitMergeInputChains1_0,
/*  9227*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9230*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9240*/    /*Scope*/ 21, /*->9262*/
/*  9241*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_and_8
/*  9243*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9245*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9248*/     OPC_EmitMergeInputChains1_0,
/*  9249*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9252*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9262*/    /*Scope*/ 21, /*->9284*/
/*  9263*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_and_16
/*  9265*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9267*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9270*/     OPC_EmitMergeInputChains1_0,
/*  9271*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9274*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9284*/    0, /*End of Scope*/
/*  9285*/   /*SwitchType*/ 21, MVT::i64,// ->9308
/*  9287*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_and_64
/*  9289*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9291*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9294*/    OPC_EmitMergeInputChains1_0,
/*  9295*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9298*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9308*/   0, // EndSwitchType
/*  9309*/  0, /*End of Scope*/
/*  9310*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->9607
/*  9314*/  OPC_RecordMemRef,
/*  9315*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  9316*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9317*/  OPC_Scope, 14|128,1/*142*/, /*->9462*/ // 2 children in Scope
/*  9320*/   OPC_CheckChild1Type, MVT::i32,
/*  9322*/   OPC_RecordChild2, // #2 = $val
/*  9323*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9438
/*  9326*/    OPC_Scope, 21, /*->9349*/ // 5 children in Scope
/*  9328*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*  9330*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9332*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9335*/     OPC_EmitMergeInputChains1_0,
/*  9336*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9339*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9349*/    /*Scope*/ 21, /*->9371*/
/*  9350*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  9352*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9354*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9357*/     OPC_EmitMergeInputChains1_0,
/*  9358*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9361*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9371*/    /*Scope*/ 21, /*->9393*/
/*  9372*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  9374*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9376*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9379*/     OPC_EmitMergeInputChains1_0,
/*  9380*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9383*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9393*/    /*Scope*/ 21, /*->9415*/
/*  9394*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  9396*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9398*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9401*/     OPC_EmitMergeInputChains1_0,
/*  9402*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9405*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9415*/    /*Scope*/ 21, /*->9437*/
/*  9416*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  9418*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9420*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9423*/     OPC_EmitMergeInputChains1_0,
/*  9424*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9427*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9437*/    0, /*End of Scope*/
/*  9438*/   /*SwitchType*/ 21, MVT::i64,// ->9461
/*  9440*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_or_64
/*  9442*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9444*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9447*/    OPC_EmitMergeInputChains1_0,
/*  9448*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9451*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  9461*/   0, // EndSwitchType
/*  9462*/  /*Scope*/ 14|128,1/*142*/, /*->9606*/
/*  9464*/   OPC_CheckChild1Type, MVT::i64,
/*  9466*/   OPC_RecordChild2, // #2 = $val
/*  9467*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9582
/*  9470*/    OPC_Scope, 21, /*->9493*/ // 5 children in Scope
/*  9472*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_or_32
/*  9474*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9476*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9479*/     OPC_EmitMergeInputChains1_0,
/*  9480*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9483*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9493*/    /*Scope*/ 21, /*->9515*/
/*  9494*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  9496*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9498*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9501*/     OPC_EmitMergeInputChains1_0,
/*  9502*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9505*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9515*/    /*Scope*/ 21, /*->9537*/
/*  9516*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  9518*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9520*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9523*/     OPC_EmitMergeInputChains1_0,
/*  9524*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9527*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9537*/    /*Scope*/ 21, /*->9559*/
/*  9538*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_or_8
/*  9540*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9542*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9545*/     OPC_EmitMergeInputChains1_0,
/*  9546*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9549*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9559*/    /*Scope*/ 21, /*->9581*/
/*  9560*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_or_16
/*  9562*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9564*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9567*/     OPC_EmitMergeInputChains1_0,
/*  9568*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9571*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9581*/    0, /*End of Scope*/
/*  9582*/   /*SwitchType*/ 21, MVT::i64,// ->9605
/*  9584*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_or_64
/*  9586*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9588*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9591*/    OPC_EmitMergeInputChains1_0,
/*  9592*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9595*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9605*/   0, // EndSwitchType
/*  9606*/  0, /*End of Scope*/
/*  9607*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->9904
/*  9611*/  OPC_RecordMemRef,
/*  9612*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  9613*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9614*/  OPC_Scope, 14|128,1/*142*/, /*->9759*/ // 2 children in Scope
/*  9617*/   OPC_CheckChild1Type, MVT::i32,
/*  9619*/   OPC_RecordChild2, // #2 = $val
/*  9620*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9735
/*  9623*/    OPC_Scope, 21, /*->9646*/ // 5 children in Scope
/*  9625*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*  9627*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9629*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9632*/     OPC_EmitMergeInputChains1_0,
/*  9633*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9636*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9646*/    /*Scope*/ 21, /*->9668*/
/*  9647*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9649*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9651*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9654*/     OPC_EmitMergeInputChains1_0,
/*  9655*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9658*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9668*/    /*Scope*/ 21, /*->9690*/
/*  9669*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9671*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9673*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9676*/     OPC_EmitMergeInputChains1_0,
/*  9677*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9680*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9690*/    /*Scope*/ 21, /*->9712*/
/*  9691*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9693*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9695*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9698*/     OPC_EmitMergeInputChains1_0,
/*  9699*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9702*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9712*/    /*Scope*/ 21, /*->9734*/
/*  9713*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9715*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9717*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9720*/     OPC_EmitMergeInputChains1_0,
/*  9721*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9724*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9734*/    0, /*End of Scope*/
/*  9735*/   /*SwitchType*/ 21, MVT::i64,// ->9758
/*  9737*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_xor_64
/*  9739*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9741*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9744*/    OPC_EmitMergeInputChains1_0,
/*  9745*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9748*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  9758*/   0, // EndSwitchType
/*  9759*/  /*Scope*/ 14|128,1/*142*/, /*->9903*/
/*  9761*/   OPC_CheckChild1Type, MVT::i64,
/*  9763*/   OPC_RecordChild2, // #2 = $val
/*  9764*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->9879
/*  9767*/    OPC_Scope, 21, /*->9790*/ // 5 children in Scope
/*  9769*/     OPC_CheckPredicate, 2, // Predicate_atomic_load_xor_32
/*  9771*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9773*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9776*/     OPC_EmitMergeInputChains1_0,
/*  9777*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9780*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9790*/    /*Scope*/ 21, /*->9812*/
/*  9791*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9793*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9795*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9798*/     OPC_EmitMergeInputChains1_0,
/*  9799*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9802*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9812*/    /*Scope*/ 21, /*->9834*/
/*  9813*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9815*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9817*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9820*/     OPC_EmitMergeInputChains1_0,
/*  9821*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9824*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9834*/    /*Scope*/ 21, /*->9856*/
/*  9835*/     OPC_CheckPredicate, 0, // Predicate_atomic_load_xor_8
/*  9837*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9839*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9842*/     OPC_EmitMergeInputChains1_0,
/*  9843*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9846*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9856*/    /*Scope*/ 21, /*->9878*/
/*  9857*/     OPC_CheckPredicate, 1, // Predicate_atomic_load_xor_16
/*  9859*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9861*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9864*/     OPC_EmitMergeInputChains1_0,
/*  9865*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9868*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9878*/    0, /*End of Scope*/
/*  9879*/   /*SwitchType*/ 21, MVT::i64,// ->9902
/*  9881*/    OPC_CheckPredicate, 13, // Predicate_atomic_load_xor_64
/*  9883*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9885*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9888*/    OPC_EmitMergeInputChains1_0,
/*  9889*/    OPC_EmitInteger, MVT::i32, 0, 
/*  9892*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9902*/   0, // EndSwitchType
/*  9903*/  0, /*End of Scope*/
/*  9904*/ /*SwitchOpcode*/ 37|128,2/*293*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->10201
/*  9908*/  OPC_RecordMemRef,
/*  9909*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  9910*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9911*/  OPC_Scope, 14|128,1/*142*/, /*->10056*/ // 2 children in Scope
/*  9914*/   OPC_CheckChild1Type, MVT::i32,
/*  9916*/   OPC_RecordChild2, // #2 = $val
/*  9917*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->10032
/*  9920*/    OPC_Scope, 21, /*->9943*/ // 5 children in Scope
/*  9922*/     OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/*  9924*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9926*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9929*/     OPC_EmitMergeInputChains1_0,
/*  9930*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9933*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9943*/    /*Scope*/ 21, /*->9965*/
/*  9944*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  9946*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9948*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9951*/     OPC_EmitMergeInputChains1_0,
/*  9952*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9955*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9965*/    /*Scope*/ 21, /*->9987*/
/*  9966*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/*  9968*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9970*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9973*/     OPC_EmitMergeInputChains1_0,
/*  9974*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9977*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9987*/    /*Scope*/ 21, /*->10009*/
/*  9988*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/*  9990*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9992*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9995*/     OPC_EmitMergeInputChains1_0,
/*  9996*/     OPC_EmitInteger, MVT::i32, 0, 
/*  9999*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/* 10009*/    /*Scope*/ 21, /*->10031*/
/* 10010*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/* 10012*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10014*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/* 10017*/     OPC_EmitMergeInputChains1_0,
/* 10018*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10021*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/* 10031*/    0, /*End of Scope*/
/* 10032*/   /*SwitchType*/ 21, MVT::i64,// ->10055
/* 10034*/    OPC_CheckPredicate, 13, // Predicate_atomic_swap_64
/* 10036*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10038*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/* 10041*/    OPC_EmitMergeInputChains1_0,
/* 10042*/    OPC_EmitInteger, MVT::i32, 0, 
/* 10045*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/* 10055*/   0, // EndSwitchType
/* 10056*/  /*Scope*/ 14|128,1/*142*/, /*->10200*/
/* 10058*/   OPC_CheckChild1Type, MVT::i64,
/* 10060*/   OPC_RecordChild2, // #2 = $val
/* 10061*/   OPC_SwitchType /*2 cases */, 112, MVT::i32,// ->10176
/* 10064*/    OPC_Scope, 21, /*->10087*/ // 5 children in Scope
/* 10066*/     OPC_CheckPredicate, 2, // Predicate_atomic_swap_32
/* 10068*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10070*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10073*/     OPC_EmitMergeInputChains1_0,
/* 10074*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10077*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/* 10087*/    /*Scope*/ 21, /*->10109*/
/* 10088*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/* 10090*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10092*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10095*/     OPC_EmitMergeInputChains1_0,
/* 10096*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10099*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/* 10109*/    /*Scope*/ 21, /*->10131*/
/* 10110*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/* 10112*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10114*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10117*/     OPC_EmitMergeInputChains1_0,
/* 10118*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10121*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/* 10131*/    /*Scope*/ 21, /*->10153*/
/* 10132*/     OPC_CheckPredicate, 0, // Predicate_atomic_swap_8
/* 10134*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10136*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10139*/     OPC_EmitMergeInputChains1_0,
/* 10140*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10143*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/* 10153*/    /*Scope*/ 21, /*->10175*/
/* 10154*/     OPC_CheckPredicate, 1, // Predicate_atomic_swap_16
/* 10156*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10158*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10161*/     OPC_EmitMergeInputChains1_0,
/* 10162*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/* 10175*/    0, /*End of Scope*/
/* 10176*/   /*SwitchType*/ 21, MVT::i64,// ->10199
/* 10178*/    OPC_CheckPredicate, 13, // Predicate_atomic_swap_64
/* 10180*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10182*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/* 10185*/    OPC_EmitMergeInputChains1_0,
/* 10186*/    OPC_EmitInteger, MVT::i32, 0, 
/* 10189*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/* 10199*/   0, // EndSwitchType
/* 10200*/  0, /*End of Scope*/
/* 10201*/ /*SwitchOpcode*/ 51|128,2/*307*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->10512
/* 10205*/  OPC_RecordMemRef,
/* 10206*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/* 10207*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 10208*/  OPC_Scope, 21|128,1/*149*/, /*->10360*/ // 2 children in Scope
/* 10211*/   OPC_CheckChild1Type, MVT::i32,
/* 10213*/   OPC_RecordChild2, // #2 = $exp
/* 10214*/   OPC_RecordChild3, // #3 = $new
/* 10215*/   OPC_SwitchType /*2 cases */, 117, MVT::i32,// ->10335
/* 10218*/    OPC_Scope, 22, /*->10242*/ // 5 children in Scope
/* 10220*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/* 10222*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10224*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10227*/     OPC_EmitMergeInputChains1_0,
/* 10228*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10231*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10242*/    /*Scope*/ 22, /*->10265*/
/* 10243*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/* 10245*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10247*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10250*/     OPC_EmitMergeInputChains1_0,
/* 10251*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10254*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10265*/    /*Scope*/ 22, /*->10288*/
/* 10266*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/* 10268*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10270*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10273*/     OPC_EmitMergeInputChains1_0,
/* 10274*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10277*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10288*/    /*Scope*/ 22, /*->10311*/
/* 10289*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/* 10291*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10293*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10296*/     OPC_EmitMergeInputChains1_0,
/* 10297*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10300*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10311*/    /*Scope*/ 22, /*->10334*/
/* 10312*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/* 10314*/     OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10316*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10319*/     OPC_EmitMergeInputChains1_0,
/* 10320*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10323*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10334*/    0, /*End of Scope*/
/* 10335*/   /*SwitchType*/ 22, MVT::i64,// ->10359
/* 10337*/    OPC_CheckPredicate, 13, // Predicate_atomic_cmp_swap_64
/* 10339*/    OPC_CheckPatternPredicate, 0, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10341*/    OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/* 10344*/    OPC_EmitMergeInputChains1_0,
/* 10345*/    OPC_EmitInteger, MVT::i32, 0, 
/* 10348*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/* 10359*/   0, // EndSwitchType
/* 10360*/  /*Scope*/ 21|128,1/*149*/, /*->10511*/
/* 10362*/   OPC_CheckChild1Type, MVT::i64,
/* 10364*/   OPC_RecordChild2, // #2 = $exp
/* 10365*/   OPC_RecordChild3, // #3 = $new
/* 10366*/   OPC_SwitchType /*2 cases */, 117, MVT::i32,// ->10486
/* 10369*/    OPC_Scope, 22, /*->10393*/ // 5 children in Scope
/* 10371*/     OPC_CheckPredicate, 2, // Predicate_atomic_cmp_swap_32
/* 10373*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10375*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10378*/     OPC_EmitMergeInputChains1_0,
/* 10379*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10382*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10393*/    /*Scope*/ 22, /*->10416*/
/* 10394*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/* 10396*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10398*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10401*/     OPC_EmitMergeInputChains1_0,
/* 10402*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10405*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10416*/    /*Scope*/ 22, /*->10439*/
/* 10417*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/* 10419*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10421*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10424*/     OPC_EmitMergeInputChains1_0,
/* 10425*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10428*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10439*/    /*Scope*/ 22, /*->10462*/
/* 10440*/     OPC_CheckPredicate, 0, // Predicate_atomic_cmp_swap_8
/* 10442*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10444*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10447*/     OPC_EmitMergeInputChains1_0,
/* 10448*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10451*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10462*/    /*Scope*/ 22, /*->10485*/
/* 10463*/     OPC_CheckPredicate, 1, // Predicate_atomic_cmp_swap_16
/* 10465*/     OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10467*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10470*/     OPC_EmitMergeInputChains1_0,
/* 10471*/     OPC_EmitInteger, MVT::i32, 0, 
/* 10474*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::i32, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/* 10485*/    0, /*End of Scope*/
/* 10486*/   /*SwitchType*/ 22, MVT::i64,// ->10510
/* 10488*/    OPC_CheckPredicate, 13, // Predicate_atomic_cmp_swap_64
/* 10490*/    OPC_CheckPatternPredicate, 1, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/* 10492*/    OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/* 10495*/    OPC_EmitMergeInputChains1_0,
/* 10496*/    OPC_EmitInteger, MVT::i32, 0, 
/* 10499*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  MVT::i64, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/* 10510*/   0, // EndSwitchType
/* 10511*/  0, /*End of Scope*/
/* 10512*/ /*SwitchOpcode*/ 100, TARGET_VAL(ISD::BRCOND),// ->10615
/* 10515*/  OPC_RecordNode, // #0 = 'brcond' chained node
/* 10516*/  OPC_Scope, 78, /*->10596*/ // 2 children in Scope
/* 10518*/   OPC_MoveChild1,
/* 10519*/   OPC_SwitchOpcode /*2 cases */, 24, TARGET_VAL(ISD::XOR),// ->10547
/* 10523*/    OPC_RecordChild0, // #1 = $cond
/* 10524*/    OPC_MoveChild0,
/* 10525*/    OPC_CheckPredicate, 22, // Predicate_bool_node
/* 10527*/    OPC_MoveParent,
/* 10528*/    OPC_CheckChild1Integer, 2, 
/* 10530*/    OPC_CheckType, MVT::i32,
/* 10532*/    OPC_MoveParent,
/* 10533*/    OPC_RecordChild2, // #2 = $dst
/* 10534*/    OPC_MoveChild2,
/* 10535*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 10538*/    OPC_MoveParent,
/* 10539*/    OPC_EmitMergeInputChains1_0,
/* 10540*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_UNLESS), 0|OPFL_Chain,
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 10547*/   /*SwitchOpcode*/ 45, TARGET_VAL(ISD::SETCC),// ->10595
/* 10550*/    OPC_RecordChild0, // #1 = $cond
/* 10551*/    OPC_CheckChild0Type, MVT::i32,
/* 10553*/    OPC_CheckChild1Integer, 0, 
/* 10555*/    OPC_CheckType, MVT::i32,
/* 10557*/    OPC_Scope, 17, /*->10576*/ // 2 children in Scope
/* 10559*/     OPC_CheckChild2CondCode, ISD::SETNE,
/* 10561*/     OPC_MoveParent,
/* 10562*/     OPC_RecordChild2, // #2 = $dst
/* 10563*/     OPC_MoveChild2,
/* 10564*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 10567*/     OPC_MoveParent,
/* 10568*/     OPC_EmitMergeInputChains1_0,
/* 10569*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_IF), 0|OPFL_Chain,
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 10576*/    /*Scope*/ 17, /*->10594*/
/* 10577*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10579*/     OPC_MoveParent,
/* 10580*/     OPC_RecordChild2, // #2 = $dst
/* 10581*/     OPC_MoveChild2,
/* 10582*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 10585*/     OPC_MoveParent,
/* 10586*/     OPC_EmitMergeInputChains1_0,
/* 10587*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_UNLESS), 0|OPFL_Chain,
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/* 10594*/    0, /*End of Scope*/
/* 10595*/   0, // EndSwitchOpcode
/* 10596*/  /*Scope*/ 17, /*->10614*/
/* 10597*/   OPC_RecordChild1, // #1 = $cond
/* 10598*/   OPC_CheckChild1Type, MVT::i32,
/* 10600*/   OPC_RecordChild2, // #2 = $dst
/* 10601*/   OPC_MoveChild2,
/* 10602*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 10605*/   OPC_MoveParent,
/* 10606*/   OPC_EmitMergeInputChains1_0,
/* 10607*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_IF), 0|OPFL_Chain,
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/* 10614*/  0, /*End of Scope*/
/* 10615*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::SHL),// ->10685
/* 10618*/  OPC_RecordChild0, // #0 = $lhs
/* 10619*/  OPC_Scope, 35, /*->10656*/ // 2 children in Scope
/* 10621*/   OPC_MoveChild1,
/* 10622*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->10639
/* 10625*/    OPC_CheckAndImm, 31, 
/* 10627*/    OPC_RecordChild0, // #1 = $rhs
/* 10628*/    OPC_MoveParent,
/* 10629*/    OPC_CheckType, MVT::i32,
/* 10631*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10639*/   /*SwitchType*/ 14, MVT::i64,// ->10655
/* 10641*/    OPC_CheckAndImm, 63, 
/* 10643*/    OPC_RecordChild0, // #1 = $rhs
/* 10644*/    OPC_MoveParent,
/* 10645*/    OPC_CheckType, MVT::i64,
/* 10647*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10655*/   0, // EndSwitchType
/* 10656*/  /*Scope*/ 27, /*->10684*/
/* 10657*/   OPC_RecordChild1, // #1 = $rhs
/* 10658*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->10671
/* 10661*/    OPC_CheckChild1Type, MVT::i32,
/* 10663*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10671*/   /*SwitchType*/ 10, MVT::i64,// ->10683
/* 10673*/    OPC_CheckChild1Type, MVT::i64,
/* 10675*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10683*/   0, // EndSwitchType
/* 10684*/  0, /*End of Scope*/
/* 10685*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::SRA),// ->10755
/* 10688*/  OPC_RecordChild0, // #0 = $lhs
/* 10689*/  OPC_Scope, 35, /*->10726*/ // 2 children in Scope
/* 10691*/   OPC_MoveChild1,
/* 10692*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->10709
/* 10695*/    OPC_CheckAndImm, 31, 
/* 10697*/    OPC_RecordChild0, // #1 = $rhs
/* 10698*/    OPC_MoveParent,
/* 10699*/    OPC_CheckType, MVT::i32,
/* 10701*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10709*/   /*SwitchType*/ 14, MVT::i64,// ->10725
/* 10711*/    OPC_CheckAndImm, 63, 
/* 10713*/    OPC_RecordChild0, // #1 = $rhs
/* 10714*/    OPC_MoveParent,
/* 10715*/    OPC_CheckType, MVT::i64,
/* 10717*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10725*/   0, // EndSwitchType
/* 10726*/  /*Scope*/ 27, /*->10754*/
/* 10727*/   OPC_RecordChild1, // #1 = $rhs
/* 10728*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->10741
/* 10731*/    OPC_CheckChild1Type, MVT::i32,
/* 10733*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10741*/   /*SwitchType*/ 10, MVT::i64,// ->10753
/* 10743*/    OPC_CheckChild1Type, MVT::i64,
/* 10745*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10753*/   0, // EndSwitchType
/* 10754*/  0, /*End of Scope*/
/* 10755*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::SRL),// ->10825
/* 10758*/  OPC_RecordChild0, // #0 = $lhs
/* 10759*/  OPC_Scope, 35, /*->10796*/ // 2 children in Scope
/* 10761*/   OPC_MoveChild1,
/* 10762*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->10779
/* 10765*/    OPC_CheckAndImm, 31, 
/* 10767*/    OPC_RecordChild0, // #1 = $rhs
/* 10768*/    OPC_MoveParent,
/* 10769*/    OPC_CheckType, MVT::i32,
/* 10771*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10779*/   /*SwitchType*/ 14, MVT::i64,// ->10795
/* 10781*/    OPC_CheckAndImm, 63, 
/* 10783*/    OPC_RecordChild0, // #1 = $rhs
/* 10784*/    OPC_MoveParent,
/* 10785*/    OPC_CheckType, MVT::i64,
/* 10787*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10795*/   0, // EndSwitchType
/* 10796*/  /*Scope*/ 27, /*->10824*/
/* 10797*/   OPC_RecordChild1, // #1 = $rhs
/* 10798*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->10811
/* 10801*/    OPC_CheckChild1Type, MVT::i32,
/* 10803*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10811*/   /*SwitchType*/ 10, MVT::i64,// ->10823
/* 10813*/    OPC_CheckChild1Type, MVT::i64,
/* 10815*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10823*/   0, // EndSwitchType
/* 10824*/  0, /*End of Scope*/
/* 10825*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::ROTL),// ->10895
/* 10828*/  OPC_RecordChild0, // #0 = $lhs
/* 10829*/  OPC_Scope, 35, /*->10866*/ // 2 children in Scope
/* 10831*/   OPC_MoveChild1,
/* 10832*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->10849
/* 10835*/    OPC_CheckAndImm, 31, 
/* 10837*/    OPC_RecordChild0, // #1 = $rhs
/* 10838*/    OPC_MoveParent,
/* 10839*/    OPC_CheckType, MVT::i32,
/* 10841*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10849*/   /*SwitchType*/ 14, MVT::i64,// ->10865
/* 10851*/    OPC_CheckAndImm, 63, 
/* 10853*/    OPC_RecordChild0, // #1 = $rhs
/* 10854*/    OPC_MoveParent,
/* 10855*/    OPC_CheckType, MVT::i64,
/* 10857*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10865*/   0, // EndSwitchType
/* 10866*/  /*Scope*/ 27, /*->10894*/
/* 10867*/   OPC_RecordChild1, // #1 = $rhs
/* 10868*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->10881
/* 10871*/    OPC_CheckChild1Type, MVT::i32,
/* 10873*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10881*/   /*SwitchType*/ 10, MVT::i64,// ->10893
/* 10883*/    OPC_CheckChild1Type, MVT::i64,
/* 10885*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10893*/   0, // EndSwitchType
/* 10894*/  0, /*End of Scope*/
/* 10895*/ /*SwitchOpcode*/ 67, TARGET_VAL(ISD::ROTR),// ->10965
/* 10898*/  OPC_RecordChild0, // #0 = $lhs
/* 10899*/  OPC_Scope, 35, /*->10936*/ // 2 children in Scope
/* 10901*/   OPC_MoveChild1,
/* 10902*/   OPC_SwitchType /*2 cases */, 14, MVT::i32,// ->10919
/* 10905*/    OPC_CheckAndImm, 31, 
/* 10907*/    OPC_RecordChild0, // #1 = $rhs
/* 10908*/    OPC_MoveParent,
/* 10909*/    OPC_CheckType, MVT::i32,
/* 10911*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10919*/   /*SwitchType*/ 14, MVT::i64,// ->10935
/* 10921*/    OPC_CheckAndImm, 63, 
/* 10923*/    OPC_RecordChild0, // #1 = $rhs
/* 10924*/    OPC_MoveParent,
/* 10925*/    OPC_CheckType, MVT::i64,
/* 10927*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10935*/   0, // EndSwitchType
/* 10936*/  /*Scope*/ 27, /*->10964*/
/* 10937*/   OPC_RecordChild1, // #1 = $rhs
/* 10938*/   OPC_SwitchType /*2 cases */, 10, MVT::i32,// ->10951
/* 10941*/    OPC_CheckChild1Type, MVT::i32,
/* 10943*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 10951*/   /*SwitchType*/ 10, MVT::i64,// ->10963
/* 10953*/    OPC_CheckChild1Type, MVT::i64,
/* 10955*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ROTR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 10963*/   0, // EndSwitchType
/* 10964*/  0, /*End of Scope*/
/* 10965*/ /*SwitchOpcode*/ 42|128,4/*554*/, TARGET_VAL(ISD::SELECT),// ->11523
/* 10969*/  OPC_Scope, 117, /*->11088*/ // 8 children in Scope
/* 10971*/   OPC_MoveChild0,
/* 10972*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10975*/   OPC_RecordChild0, // #0 = $cond
/* 10976*/   OPC_CheckChild0Type, MVT::i32,
/* 10978*/   OPC_CheckChild1Integer, 0, 
/* 10980*/   OPC_CheckType, MVT::i32,
/* 10982*/   OPC_Scope, 51, /*->11035*/ // 2 children in Scope
/* 10984*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10986*/    OPC_MoveParent,
/* 10987*/    OPC_RecordChild1, // #1 = $lhs
/* 10988*/    OPC_RecordChild2, // #2 = $rhs
/* 10989*/    OPC_SwitchType /*4 cases */, 9, MVT::i32,// ->11001
/* 10992*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                   MVT::i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11001*/    /*SwitchType*/ 9, MVT::i64,// ->11012
/* 11003*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                   MVT::i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11012*/    /*SwitchType*/ 9, MVT::funcref,// ->11023
/* 11014*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_FUNCREF), 0,
                   MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11023*/    /*SwitchType*/ 9, MVT::externref,// ->11034
/* 11025*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXTERNREF), 0,
                   MVT::externref, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11034*/    0, // EndSwitchType
/* 11035*/   /*Scope*/ 51, /*->11087*/
/* 11036*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 11038*/    OPC_MoveParent,
/* 11039*/    OPC_RecordChild1, // #1 = $lhs
/* 11040*/    OPC_RecordChild2, // #2 = $rhs
/* 11041*/    OPC_SwitchType /*4 cases */, 9, MVT::i32,// ->11053
/* 11044*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                   MVT::i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11053*/    /*SwitchType*/ 9, MVT::i64,// ->11064
/* 11055*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                   MVT::i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11064*/    /*SwitchType*/ 9, MVT::funcref,// ->11075
/* 11066*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_FUNCREF), 0,
                   MVT::funcref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11075*/    /*SwitchType*/ 9, MVT::externref,// ->11086
/* 11077*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXTERNREF), 0,
                   MVT::externref, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11086*/    0, // EndSwitchType
/* 11087*/   0, /*End of Scope*/
/* 11088*/  /*Scope*/ 55, /*->11144*/
/* 11089*/   OPC_RecordChild0, // #0 = $cond
/* 11090*/   OPC_CheckChild0Type, MVT::i32,
/* 11092*/   OPC_RecordChild1, // #1 = $lhs
/* 11093*/   OPC_RecordChild2, // #2 = $rhs
/* 11094*/   OPC_SwitchType /*4 cases */, 9, MVT::i32,// ->11106
/* 11097*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I32), 0,
                  MVT::i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11106*/   /*SwitchType*/ 9, MVT::i64,// ->11117
/* 11108*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_I64), 0,
                  MVT::i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11117*/   /*SwitchType*/ 11, MVT::funcref,// ->11130
/* 11119*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11121*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_FUNCREF), 0,
                  MVT::funcref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11130*/   /*SwitchType*/ 11, MVT::externref,// ->11143
/* 11132*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11134*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_EXTERNREF), 0,
                  MVT::externref, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11143*/   0, // EndSwitchType
/* 11144*/  /*Scope*/ 73, /*->11218*/
/* 11145*/   OPC_MoveChild0,
/* 11146*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 11149*/   OPC_RecordChild0, // #0 = $cond
/* 11150*/   OPC_CheckChild0Type, MVT::i32,
/* 11152*/   OPC_CheckChild1Integer, 0, 
/* 11154*/   OPC_CheckType, MVT::i32,
/* 11156*/   OPC_Scope, 29, /*->11187*/ // 2 children in Scope
/* 11158*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 11160*/    OPC_MoveParent,
/* 11161*/    OPC_RecordChild1, // #1 = $lhs
/* 11162*/    OPC_RecordChild2, // #2 = $rhs
/* 11163*/    OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->11175
/* 11166*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                   MVT::f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11175*/    /*SwitchType*/ 9, MVT::f64,// ->11186
/* 11177*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                   MVT::f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11186*/    0, // EndSwitchType
/* 11187*/   /*Scope*/ 29, /*->11217*/
/* 11188*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 11190*/    OPC_MoveParent,
/* 11191*/    OPC_RecordChild1, // #1 = $lhs
/* 11192*/    OPC_RecordChild2, // #2 = $rhs
/* 11193*/    OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->11205
/* 11196*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                   MVT::f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11205*/    /*SwitchType*/ 9, MVT::f64,// ->11216
/* 11207*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                   MVT::f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 11216*/    0, // EndSwitchType
/* 11217*/   0, /*End of Scope*/
/* 11218*/  /*Scope*/ 29, /*->11248*/
/* 11219*/   OPC_RecordChild0, // #0 = $cond
/* 11220*/   OPC_CheckChild0Type, MVT::i32,
/* 11222*/   OPC_RecordChild1, // #1 = $lhs
/* 11223*/   OPC_RecordChild2, // #2 = $rhs
/* 11224*/   OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->11236
/* 11227*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F32), 0,
                  MVT::f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11236*/   /*SwitchType*/ 9, MVT::f64,// ->11247
/* 11238*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_F64), 0,
                  MVT::f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 11247*/   0, // EndSwitchType
/* 11248*/  /*Scope*/ 117, /*->11366*/
/* 11249*/   OPC_MoveChild0,
/* 11250*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 11253*/   OPC_RecordChild0, // #0 = $cond
/* 11254*/   OPC_CheckChild0Type, MVT::i32,
/* 11256*/   OPC_CheckChild1Integer, 0, 
/* 11258*/   OPC_CheckType, MVT::i32,
/* 11260*/   OPC_Scope, 51, /*->11313*/ // 2 children in Scope
/* 11262*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 11264*/    OPC_MoveParent,
/* 11265*/    OPC_RecordChild1, // #1 = $lhs
/* 11266*/    OPC_RecordChild2, // #2 = $rhs
/* 11267*/    OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->11279
/* 11270*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11279*/    /*SwitchType*/ 9, MVT::v8i16,// ->11290
/* 11281*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11290*/    /*SwitchType*/ 9, MVT::v4i32,// ->11301
/* 11292*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11301*/    /*SwitchType*/ 9, MVT::v2i64,// ->11312
/* 11303*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11312*/    0, // EndSwitchType
/* 11313*/   /*Scope*/ 51, /*->11365*/
/* 11314*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 11316*/    OPC_MoveParent,
/* 11317*/    OPC_RecordChild1, // #1 = $lhs
/* 11318*/    OPC_RecordChild2, // #2 = $rhs
/* 11319*/    OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->11331
/* 11322*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11331*/    /*SwitchType*/ 9, MVT::v8i16,// ->11342
/* 11333*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11342*/    /*SwitchType*/ 9, MVT::v4i32,// ->11353
/* 11344*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11353*/    /*SwitchType*/ 9, MVT::v2i64,// ->11364
/* 11355*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11364*/    0, // EndSwitchType
/* 11365*/   0, /*End of Scope*/
/* 11366*/  /*Scope*/ 51, /*->11418*/
/* 11367*/   OPC_RecordChild0, // #0 = $cond
/* 11368*/   OPC_CheckChild0Type, MVT::i32,
/* 11370*/   OPC_RecordChild1, // #1 = $lhs
/* 11371*/   OPC_RecordChild2, // #2 = $rhs
/* 11372*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->11384
/* 11375*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11384*/   /*SwitchType*/ 9, MVT::v8i16,// ->11395
/* 11386*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11395*/   /*SwitchType*/ 9, MVT::v4i32,// ->11406
/* 11397*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11406*/   /*SwitchType*/ 9, MVT::v2i64,// ->11417
/* 11408*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11417*/   0, // EndSwitchType
/* 11418*/  /*Scope*/ 73, /*->11492*/
/* 11419*/   OPC_MoveChild0,
/* 11420*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 11423*/   OPC_RecordChild0, // #0 = $cond
/* 11424*/   OPC_CheckChild0Type, MVT::i32,
/* 11426*/   OPC_CheckChild1Integer, 0, 
/* 11428*/   OPC_CheckType, MVT::i32,
/* 11430*/   OPC_Scope, 29, /*->11461*/ // 2 children in Scope
/* 11432*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 11434*/    OPC_MoveParent,
/* 11435*/    OPC_RecordChild1, // #1 = $lhs
/* 11436*/    OPC_RecordChild2, // #2 = $rhs
/* 11437*/    OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->11449
/* 11440*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11449*/    /*SwitchType*/ 9, MVT::v2f64,// ->11460
/* 11451*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11460*/    0, // EndSwitchType
/* 11461*/   /*Scope*/ 29, /*->11491*/
/* 11462*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 11464*/    OPC_MoveParent,
/* 11465*/    OPC_RecordChild1, // #1 = $lhs
/* 11466*/    OPC_RecordChild2, // #2 = $rhs
/* 11467*/    OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->11479
/* 11470*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v4f32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11479*/    /*SwitchType*/ 9, MVT::v2f64,// ->11490
/* 11481*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                   MVT::v2f64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 11490*/    0, // EndSwitchType
/* 11491*/   0, /*End of Scope*/
/* 11492*/  /*Scope*/ 29, /*->11522*/
/* 11493*/   OPC_RecordChild0, // #0 = $cond
/* 11494*/   OPC_CheckChild0Type, MVT::i32,
/* 11496*/   OPC_RecordChild1, // #1 = $lhs
/* 11497*/   OPC_RecordChild2, // #2 = $rhs
/* 11498*/   OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->11510
/* 11501*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11510*/   /*SwitchType*/ 9, MVT::v2f64,// ->11521
/* 11512*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SELECT_V128), 0,
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 11521*/   0, // EndSwitchType
/* 11522*/  0, /*End of Scope*/
/* 11523*/ /*SwitchOpcode*/ 16|128,1/*144*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->11671
/* 11527*/  OPC_Scope, 67, /*->11596*/ // 2 children in Scope
/* 11529*/   OPC_MoveChild0,
/* 11530*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 11533*/   OPC_RecordChild0, // #0 = $vec
/* 11534*/   OPC_Scope, 29, /*->11565*/ // 2 children in Scope
/* 11536*/    OPC_CheckChild0Type, MVT::v16i8,
/* 11538*/    OPC_RecordChild1, // #1 = $idx
/* 11539*/    OPC_MoveChild1,
/* 11540*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11543*/    OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 11545*/    OPC_CheckType, MVT::i32,
/* 11547*/    OPC_MoveParent,
/* 11548*/    OPC_MoveParent,
/* 11549*/    OPC_MoveChild1,
/* 11550*/    OPC_CheckValueType, MVT::i8,
/* 11552*/    OPC_MoveParent,
/* 11553*/    OPC_CheckType, MVT::i32,
/* 11555*/    OPC_EmitConvertToTarget, 1,
/* 11557*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s), 0,
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11565*/   /*Scope*/ 29, /*->11595*/
/* 11566*/    OPC_CheckChild0Type, MVT::v8i16,
/* 11568*/    OPC_RecordChild1, // #1 = $idx
/* 11569*/    OPC_MoveChild1,
/* 11570*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11573*/    OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 11575*/    OPC_CheckType, MVT::i32,
/* 11577*/    OPC_MoveParent,
/* 11578*/    OPC_MoveParent,
/* 11579*/    OPC_MoveChild1,
/* 11580*/    OPC_CheckValueType, MVT::i16,
/* 11582*/    OPC_MoveParent,
/* 11583*/    OPC_CheckType, MVT::i32,
/* 11585*/    OPC_EmitConvertToTarget, 1,
/* 11587*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s), 0,
                  MVT::i32, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11595*/   0, /*End of Scope*/
/* 11596*/  /*Scope*/ 73, /*->11670*/
/* 11597*/   OPC_RecordChild0, // #0 = $src
/* 11598*/   OPC_MoveChild1,
/* 11599*/   OPC_Scope, 27, /*->11628*/ // 3 children in Scope
/* 11601*/    OPC_CheckValueType, MVT::i8,
/* 11603*/    OPC_MoveParent,
/* 11604*/    OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->11616
/* 11607*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 11609*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 11616*/    /*SwitchType*/ 9, MVT::i64,// ->11627
/* 11618*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 11620*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 11627*/    0, // EndSwitchType
/* 11628*/   /*Scope*/ 27, /*->11656*/
/* 11629*/    OPC_CheckValueType, MVT::i16,
/* 11631*/    OPC_MoveParent,
/* 11632*/    OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->11644
/* 11635*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 11637*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 11644*/    /*SwitchType*/ 9, MVT::i64,// ->11655
/* 11646*/     OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 11648*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 11655*/    0, // EndSwitchType
/* 11656*/   /*Scope*/ 12, /*->11669*/
/* 11657*/    OPC_CheckValueType, MVT::i32,
/* 11659*/    OPC_MoveParent,
/* 11660*/    OPC_CheckPatternPredicate, 7, // (Subtarget->hasSignExt())
/* 11662*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 11669*/   0, /*End of Scope*/
/* 11670*/  0, /*End of Scope*/
/* 11671*/ /*SwitchOpcode*/ 23|128,1/*151*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->11826
/* 11675*/  OPC_RecordMemRef,
/* 11676*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 11677*/  OPC_MoveChild1,
/* 11678*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11681*/  OPC_RecordChild0, // #1 = $addr
/* 11682*/  OPC_MoveChild0,
/* 11683*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11686*/  OPC_MoveParent,
/* 11687*/  OPC_MoveParent,
/* 11688*/  OPC_SwitchType /*12 cases */, 8, MVT::i32,// ->11699
/* 11691*/   OPC_EmitMergeInputChains1_0,
/* 11692*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11699*/  /*SwitchType*/ 8, MVT::i64,// ->11709
/* 11701*/   OPC_EmitMergeInputChains1_0,
/* 11702*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 11709*/  /*SwitchType*/ 10, MVT::funcref,// ->11721
/* 11711*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11713*/   OPC_EmitMergeInputChains1_0,
/* 11714*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11721*/  /*SwitchType*/ 10, MVT::externref,// ->11733
/* 11723*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 11725*/   OPC_EmitMergeInputChains1_0,
/* 11726*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11733*/  /*SwitchType*/ 8, MVT::f32,// ->11743
/* 11735*/   OPC_EmitMergeInputChains1_0,
/* 11736*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11743*/  /*SwitchType*/ 8, MVT::f64,// ->11753
/* 11745*/   OPC_EmitMergeInputChains1_0,
/* 11746*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11753*/  /*SwitchType*/ 10, MVT::v2i64,// ->11765
/* 11755*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11757*/   OPC_EmitMergeInputChains1_0,
/* 11758*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11765*/  /*SwitchType*/ 10, MVT::v4i32,// ->11777
/* 11767*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11769*/   OPC_EmitMergeInputChains1_0,
/* 11770*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11777*/  /*SwitchType*/ 10, MVT::v16i8,// ->11789
/* 11779*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11781*/   OPC_EmitMergeInputChains1_0,
/* 11782*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11789*/  /*SwitchType*/ 10, MVT::v8i16,// ->11801
/* 11791*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11793*/   OPC_EmitMergeInputChains1_0,
/* 11794*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11801*/  /*SwitchType*/ 10, MVT::v4f32,// ->11813
/* 11803*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11805*/   OPC_EmitMergeInputChains1_0,
/* 11806*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11813*/  /*SwitchType*/ 10, MVT::v2f64,// ->11825
/* 11815*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11817*/   OPC_EmitMergeInputChains1_0,
/* 11818*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 11825*/  0, // EndSwitchType
/* 11826*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->12115
/* 11830*/  OPC_RecordMemRef,
/* 11831*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 11832*/  OPC_RecordChild1, // #1 = $src
/* 11833*/  OPC_Scope, 21, /*->11856*/ // 12 children in Scope
/* 11835*/   OPC_CheckChild1Type, MVT::i32,
/* 11837*/   OPC_MoveChild2,
/* 11838*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11841*/   OPC_RecordChild0, // #2 = $addr
/* 11842*/   OPC_MoveChild0,
/* 11843*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11846*/   OPC_MoveParent,
/* 11847*/   OPC_MoveParent,
/* 11848*/   OPC_EmitMergeInputChains1_0,
/* 11849*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 11856*/  /*Scope*/ 21, /*->11878*/
/* 11857*/   OPC_CheckChild1Type, MVT::i64,
/* 11859*/   OPC_MoveChild2,
/* 11860*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11863*/   OPC_RecordChild0, // #2 = $addr
/* 11864*/   OPC_MoveChild0,
/* 11865*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11868*/   OPC_MoveParent,
/* 11869*/   OPC_MoveParent,
/* 11870*/   OPC_EmitMergeInputChains1_0,
/* 11871*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 11878*/  /*Scope*/ 21, /*->11900*/
/* 11879*/   OPC_CheckChild1Type, MVT::f32,
/* 11881*/   OPC_MoveChild2,
/* 11882*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11885*/   OPC_RecordChild0, // #2 = $addr
/* 11886*/   OPC_MoveChild0,
/* 11887*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11890*/   OPC_MoveParent,
/* 11891*/   OPC_MoveParent,
/* 11892*/   OPC_EmitMergeInputChains1_0,
/* 11893*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 11900*/  /*Scope*/ 21, /*->11922*/
/* 11901*/   OPC_CheckChild1Type, MVT::f64,
/* 11903*/   OPC_MoveChild2,
/* 11904*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11907*/   OPC_RecordChild0, // #2 = $addr
/* 11908*/   OPC_MoveChild0,
/* 11909*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11912*/   OPC_MoveParent,
/* 11913*/   OPC_MoveParent,
/* 11914*/   OPC_EmitMergeInputChains1_0,
/* 11915*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 11922*/  /*Scope*/ 23, /*->11946*/
/* 11923*/   OPC_CheckChild1Type, MVT::v4f32,
/* 11925*/   OPC_MoveChild2,
/* 11926*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11929*/   OPC_RecordChild0, // #2 = $addr
/* 11930*/   OPC_MoveChild0,
/* 11931*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11934*/   OPC_MoveParent,
/* 11935*/   OPC_MoveParent,
/* 11936*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11938*/   OPC_EmitMergeInputChains1_0,
/* 11939*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 11946*/  /*Scope*/ 23, /*->11970*/
/* 11947*/   OPC_CheckChild1Type, MVT::v2f64,
/* 11949*/   OPC_MoveChild2,
/* 11950*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11953*/   OPC_RecordChild0, // #2 = $addr
/* 11954*/   OPC_MoveChild0,
/* 11955*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11958*/   OPC_MoveParent,
/* 11959*/   OPC_MoveParent,
/* 11960*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11962*/   OPC_EmitMergeInputChains1_0,
/* 11963*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 11970*/  /*Scope*/ 23, /*->11994*/
/* 11971*/   OPC_CheckChild1Type, MVT::v2i64,
/* 11973*/   OPC_MoveChild2,
/* 11974*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11977*/   OPC_RecordChild0, // #2 = $addr
/* 11978*/   OPC_MoveChild0,
/* 11979*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11982*/   OPC_MoveParent,
/* 11983*/   OPC_MoveParent,
/* 11984*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 11986*/   OPC_EmitMergeInputChains1_0,
/* 11987*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 11994*/  /*Scope*/ 23, /*->12018*/
/* 11995*/   OPC_CheckChild1Type, MVT::v4i32,
/* 11997*/   OPC_MoveChild2,
/* 11998*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12001*/   OPC_RecordChild0, // #2 = $addr
/* 12002*/   OPC_MoveChild0,
/* 12003*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12006*/   OPC_MoveParent,
/* 12007*/   OPC_MoveParent,
/* 12008*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12010*/   OPC_EmitMergeInputChains1_0,
/* 12011*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 12018*/  /*Scope*/ 23, /*->12042*/
/* 12019*/   OPC_CheckChild1Type, MVT::v16i8,
/* 12021*/   OPC_MoveChild2,
/* 12022*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12025*/   OPC_RecordChild0, // #2 = $addr
/* 12026*/   OPC_MoveChild0,
/* 12027*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12030*/   OPC_MoveParent,
/* 12031*/   OPC_MoveParent,
/* 12032*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12034*/   OPC_EmitMergeInputChains1_0,
/* 12035*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 12042*/  /*Scope*/ 23, /*->12066*/
/* 12043*/   OPC_CheckChild1Type, MVT::v8i16,
/* 12045*/   OPC_MoveChild2,
/* 12046*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12049*/   OPC_RecordChild0, // #2 = $addr
/* 12050*/   OPC_MoveChild0,
/* 12051*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12054*/   OPC_MoveParent,
/* 12055*/   OPC_MoveParent,
/* 12056*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12058*/   OPC_EmitMergeInputChains1_0,
/* 12059*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 12066*/  /*Scope*/ 23, /*->12090*/
/* 12067*/   OPC_CheckChild1Type, MVT::funcref,
/* 12069*/   OPC_MoveChild2,
/* 12070*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12073*/   OPC_RecordChild0, // #2 = $addr
/* 12074*/   OPC_MoveChild0,
/* 12075*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12078*/   OPC_MoveParent,
/* 12079*/   OPC_MoveParent,
/* 12080*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12082*/   OPC_EmitMergeInputChains1_0,
/* 12083*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 12090*/  /*Scope*/ 23, /*->12114*/
/* 12091*/   OPC_CheckChild1Type, MVT::externref,
/* 12093*/   OPC_MoveChild2,
/* 12094*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12097*/   OPC_RecordChild0, // #2 = $addr
/* 12098*/   OPC_MoveChild0,
/* 12099*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12102*/   OPC_MoveParent,
/* 12103*/   OPC_MoveParent,
/* 12104*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12106*/   OPC_EmitMergeInputChains1_0,
/* 12107*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 12114*/  0, /*End of Scope*/
/* 12115*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_START),// ->12140
/* 12118*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 12119*/  OPC_RecordChild1, // #1 = $amt
/* 12120*/  OPC_MoveChild1,
/* 12121*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12124*/  OPC_MoveParent,
/* 12125*/  OPC_RecordChild2, // #2 = $amt2
/* 12126*/  OPC_MoveChild2,
/* 12127*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12130*/  OPC_MoveParent,
/* 12131*/  OPC_EmitMergeInputChains1_0,
/* 12132*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 12140*/ /*SwitchOpcode*/ 23, TARGET_VAL(ISD::CALLSEQ_END),// ->12166
/* 12143*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 12144*/  OPC_CaptureGlueInput,
/* 12145*/  OPC_RecordChild1, // #1 = $amt
/* 12146*/  OPC_MoveChild1,
/* 12147*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12150*/  OPC_MoveParent,
/* 12151*/  OPC_RecordChild2, // #2 = $amt2
/* 12152*/  OPC_MoveChild2,
/* 12153*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12156*/  OPC_MoveParent,
/* 12157*/  OPC_EmitMergeInputChains1_0,
/* 12158*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                MVT::i32, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 12166*/ /*SwitchOpcode*/ 72, TARGET_VAL(WebAssemblyISD::MEMORY_COPY),// ->12241
/* 12169*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 12170*/  OPC_RecordChild1, // #1 = $src_idx
/* 12171*/  OPC_MoveChild1,
/* 12172*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12175*/  OPC_CheckType, MVT::i32,
/* 12177*/  OPC_MoveParent,
/* 12178*/  OPC_RecordChild2, // #2 = $dst_idx
/* 12179*/  OPC_MoveChild2,
/* 12180*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12183*/  OPC_CheckType, MVT::i32,
/* 12185*/  OPC_MoveParent,
/* 12186*/  OPC_RecordChild3, // #3 = $dst
/* 12187*/  OPC_Scope, 25, /*->12214*/ // 2 children in Scope
/* 12189*/   OPC_CheckChild3Type, MVT::i32,
/* 12191*/   OPC_RecordChild4, // #4 = $src
/* 12192*/   OPC_CheckChild4Type, MVT::i32,
/* 12194*/   OPC_RecordChild5, // #5 = $len
/* 12195*/   OPC_CheckChild5Type, MVT::i32,
/* 12197*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 12199*/   OPC_EmitMergeInputChains1_0,
/* 12200*/   OPC_EmitConvertToTarget, 1,
/* 12202*/   OPC_EmitConvertToTarget, 2,
/* 12204*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_4730MEMORY_COPY_A32), 0|OPFL_Chain,
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (anonymous_4730MEMORY_COPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 12214*/  /*Scope*/ 25, /*->12240*/
/* 12215*/   OPC_CheckChild3Type, MVT::i64,
/* 12217*/   OPC_RecordChild4, // #4 = $src
/* 12218*/   OPC_CheckChild4Type, MVT::i64,
/* 12220*/   OPC_RecordChild5, // #5 = $len
/* 12221*/   OPC_CheckChild5Type, MVT::i64,
/* 12223*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 12225*/   OPC_EmitMergeInputChains1_0,
/* 12226*/   OPC_EmitConvertToTarget, 1,
/* 12228*/   OPC_EmitConvertToTarget, 2,
/* 12230*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_4731MEMORY_COPY_A64), 0|OPFL_Chain,
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (anonymous_4731MEMORY_COPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 12240*/  0, /*End of Scope*/
/* 12241*/ /*SwitchOpcode*/ 44, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->12288
/* 12244*/  OPC_RecordMemRef,
/* 12245*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 12246*/  OPC_MoveChild1,
/* 12247*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12250*/  OPC_RecordChild0, // #1 = $table
/* 12251*/  OPC_MoveChild0,
/* 12252*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12255*/  OPC_MoveParent,
/* 12256*/  OPC_MoveParent,
/* 12257*/  OPC_RecordChild2, // #2 = $idx
/* 12258*/  OPC_CheckChild2Type, MVT::i32,
/* 12260*/  OPC_SwitchType /*2 cases */, 11, MVT::funcref,// ->12274
/* 12263*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12265*/   OPC_EmitMergeInputChains1_0,
/* 12266*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::funcref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 12274*/  /*SwitchType*/ 11, MVT::externref,// ->12287
/* 12276*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12278*/   OPC_EmitMergeInputChains1_0,
/* 12279*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 MVT::externref, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 12287*/  0, // EndSwitchType
/* 12288*/ /*SwitchOpcode*/ 74, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->12365
/* 12291*/  OPC_RecordMemRef,
/* 12292*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 12293*/  OPC_Scope, 45, /*->12340*/ // 2 children in Scope
/* 12295*/   OPC_MoveChild1,
/* 12296*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 12299*/   OPC_RecordChild0, // #1 = $table
/* 12300*/   OPC_MoveChild0,
/* 12301*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 12304*/   OPC_MoveParent,
/* 12305*/   OPC_MoveParent,
/* 12306*/   OPC_RecordChild2, // #2 = $idx
/* 12307*/   OPC_CheckChild2Type, MVT::i32,
/* 12309*/   OPC_RecordChild3, // #3 = $src
/* 12310*/   OPC_Scope, 13, /*->12325*/ // 2 children in Scope
/* 12312*/    OPC_CheckChild3Type, MVT::funcref,
/* 12314*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12316*/    OPC_EmitMergeInputChains1_0,
/* 12317*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 12325*/   /*Scope*/ 13, /*->12339*/
/* 12326*/    OPC_CheckChild3Type, MVT::externref,
/* 12328*/    OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12330*/    OPC_EmitMergeInputChains1_0,
/* 12331*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 12339*/   0, /*End of Scope*/
/* 12340*/  /*Scope*/ 23, /*->12364*/
/* 12341*/   OPC_RecordChild1, // #1 = $table
/* 12342*/   OPC_MoveChild1,
/* 12343*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 12346*/   OPC_MoveParent,
/* 12347*/   OPC_RecordChild2, // #2 = $idx
/* 12348*/   OPC_CheckChild2Type, MVT::i32,
/* 12350*/   OPC_RecordChild3, // #3 = $r
/* 12351*/   OPC_CheckChild3Type, MVT::funcref,
/* 12353*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12355*/   OPC_EmitMergeInputChains1_0,
/* 12356*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 12364*/  0, /*End of Scope*/
/* 12365*/ /*SwitchOpcode*/ 124|128,9/*1276*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->13645
/* 12369*/  OPC_Scope, 53, /*->12424*/ // 36 children in Scope
/* 12371*/   OPC_CheckChild0Integer, 98|128,26|128,1/*19810*/, 
/* 12375*/   OPC_RecordChild1, // #0 = $src
/* 12376*/   OPC_Scope, 22, /*->12400*/ // 2 children in Scope
/* 12378*/    OPC_CheckChild1Type, MVT::f32,
/* 12380*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12390
/* 12383*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 9905:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 12390*/    /*SwitchType*/ 7, MVT::i64,// ->12399
/* 12392*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 9905:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 12399*/    0, // EndSwitchType
/* 12400*/   /*Scope*/ 22, /*->12423*/
/* 12401*/    OPC_CheckChild1Type, MVT::f64,
/* 12403*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12413
/* 12406*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 9905:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 12413*/    /*SwitchType*/ 7, MVT::i64,// ->12422
/* 12415*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 9905:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 12422*/    0, // EndSwitchType
/* 12423*/   0, /*End of Scope*/
/* 12424*/  /*Scope*/ 53, /*->12478*/
/* 12425*/   OPC_CheckChild0Integer, 100|128,26|128,1/*19812*/, 
/* 12429*/   OPC_RecordChild1, // #0 = $src
/* 12430*/   OPC_Scope, 22, /*->12454*/ // 2 children in Scope
/* 12432*/    OPC_CheckChild1Type, MVT::f32,
/* 12434*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12444
/* 12437*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 9906:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 12444*/    /*SwitchType*/ 7, MVT::i64,// ->12453
/* 12446*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 9906:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 12453*/    0, // EndSwitchType
/* 12454*/   /*Scope*/ 22, /*->12477*/
/* 12455*/    OPC_CheckChild1Type, MVT::f64,
/* 12457*/    OPC_SwitchType /*2 cases */, 7, MVT::i32,// ->12467
/* 12460*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 9906:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 12467*/    /*SwitchType*/ 7, MVT::i64,// ->12476
/* 12469*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 9906:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 12476*/    0, // EndSwitchType
/* 12477*/   0, /*End of Scope*/
/* 12478*/  /*Scope*/ 47, /*->12526*/
/* 12479*/   OPC_CheckChild0Integer, 104|128,25|128,1/*19688*/, 
/* 12483*/   OPC_RecordChild1, // #0 = $vec
/* 12484*/   OPC_Scope, 9, /*->12495*/ // 4 children in Scope
/* 12486*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12488*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 12495*/   /*Scope*/ 9, /*->12505*/
/* 12496*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12498*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 12505*/   /*Scope*/ 9, /*->12515*/
/* 12506*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12508*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 12515*/   /*Scope*/ 9, /*->12525*/
/* 12516*/    OPC_CheckChild1Type, MVT::v2i64,
/* 12518*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ANYTRUE), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9844:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 12525*/   0, /*End of Scope*/
/* 12526*/  /*Scope*/ 55, /*->12582*/
/* 12527*/   OPC_CheckChild0Integer, 102|128,25|128,1/*19686*/, 
/* 12531*/   OPC_RecordChild1, // #0 = $vec
/* 12532*/   OPC_Scope, 11, /*->12545*/ // 4 children in Scope
/* 12534*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12536*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12538*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I8x16), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 12545*/   /*Scope*/ 11, /*->12557*/
/* 12546*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12548*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12550*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I16x8), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 12557*/   /*Scope*/ 11, /*->12569*/
/* 12558*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12560*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12562*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I32x4), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 12569*/   /*Scope*/ 11, /*->12581*/
/* 12570*/    OPC_CheckChild1Type, MVT::v2i64,
/* 12572*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12574*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ALLTRUE_I64x2), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9843:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 12581*/   0, /*End of Scope*/
/* 12582*/  /*Scope*/ 55, /*->12638*/
/* 12583*/   OPC_CheckChild0Integer, 108|128,25|128,1/*19692*/, 
/* 12587*/   OPC_RecordChild1, // #0 = $vec
/* 12588*/   OPC_Scope, 11, /*->12601*/ // 4 children in Scope
/* 12590*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12592*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12594*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I8x16), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9846:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 12601*/   /*Scope*/ 11, /*->12613*/
/* 12602*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12604*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12606*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I16x8), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9846:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 12613*/   /*Scope*/ 11, /*->12625*/
/* 12614*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12616*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12618*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I32x4), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9846:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 12625*/   /*Scope*/ 11, /*->12637*/
/* 12626*/    OPC_CheckChild1Type, MVT::v2i64,
/* 12628*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12630*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITMASK_I64x2), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 9846:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 12637*/   0, /*End of Scope*/
/* 12638*/  /*Scope*/ 12, /*->12651*/
/* 12639*/   OPC_CheckChild0Integer, 26|128,26|128,1/*19738*/, 
/* 12643*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12645*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF), 0,
                 MVT::funcref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 9869:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 12651*/  /*Scope*/ 14, /*->12666*/
/* 12652*/   OPC_CheckChild0Integer, 22|128,26|128,1/*19734*/, 
/* 12656*/   OPC_RecordChild1, // #0 = $ref
/* 12657*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12659*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 9867:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 12666*/  /*Scope*/ 12, /*->12679*/
/* 12667*/   OPC_CheckChild0Integer, 24|128,26|128,1/*19736*/, 
/* 12671*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12673*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF), 0,
                 MVT::externref, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 9868:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 12679*/  /*Scope*/ 14, /*->12694*/
/* 12680*/   OPC_CheckChild0Integer, 20|128,26|128,1/*19732*/, 
/* 12684*/   OPC_RecordChild1, // #0 = $ref
/* 12685*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 12687*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 9866:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 12694*/  /*Scope*/ 14, /*->12709*/
/* 12695*/   OPC_CheckChild0Integer, 64|128,26|128,1/*19776*/, 
/* 12699*/   OPC_RecordChild1, // #0 = $src
/* 12700*/   OPC_RecordChild2, // #1 = $mask
/* 12701*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SWIZZLE), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9888:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 12709*/  /*Scope*/ 121, /*->12831*/
/* 12710*/   OPC_CheckChild0Integer, 110|128,25|128,1/*19694*/, 
/* 12714*/   OPC_RecordChild1, // #0 = $v1
/* 12715*/   OPC_SwitchType /*6 cases */, 17, MVT::v16i8,// ->12735
/* 12718*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12720*/    OPC_RecordChild2, // #1 = $v2
/* 12721*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12723*/    OPC_RecordChild3, // #2 = $c
/* 12724*/    OPC_CheckChild3Type, MVT::v16i8,
/* 12726*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9847:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 12735*/   /*SwitchType*/ 17, MVT::v8i16,// ->12754
/* 12737*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12739*/    OPC_RecordChild2, // #1 = $v2
/* 12740*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12742*/    OPC_RecordChild3, // #2 = $c
/* 12743*/    OPC_CheckChild3Type, MVT::v8i16,
/* 12745*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9847:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 12754*/   /*SwitchType*/ 17, MVT::v4i32,// ->12773
/* 12756*/    OPC_CheckChild1Type, MVT::v4i32,
/* 12758*/    OPC_RecordChild2, // #1 = $v2
/* 12759*/    OPC_CheckChild2Type, MVT::v4i32,
/* 12761*/    OPC_RecordChild3, // #2 = $c
/* 12762*/    OPC_CheckChild3Type, MVT::v4i32,
/* 12764*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9847:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 12773*/   /*SwitchType*/ 17, MVT::v2i64,// ->12792
/* 12775*/    OPC_CheckChild1Type, MVT::v2i64,
/* 12777*/    OPC_RecordChild2, // #1 = $v2
/* 12778*/    OPC_CheckChild2Type, MVT::v2i64,
/* 12780*/    OPC_RecordChild3, // #2 = $c
/* 12781*/    OPC_CheckChild3Type, MVT::v2i64,
/* 12783*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 9847:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 12792*/   /*SwitchType*/ 17, MVT::v4f32,// ->12811
/* 12794*/    OPC_CheckChild1Type, MVT::v4f32,
/* 12796*/    OPC_RecordChild2, // #1 = $v2
/* 12797*/    OPC_CheckChild2Type, MVT::v4f32,
/* 12799*/    OPC_RecordChild3, // #2 = $c
/* 12800*/    OPC_CheckChild3Type, MVT::v4f32,
/* 12802*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 9847:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 12811*/   /*SwitchType*/ 17, MVT::v2f64,// ->12830
/* 12813*/    OPC_CheckChild1Type, MVT::v2f64,
/* 12815*/    OPC_RecordChild2, // #1 = $v2
/* 12816*/    OPC_CheckChild2Type, MVT::v2f64,
/* 12818*/    OPC_RecordChild3, // #2 = $c
/* 12819*/    OPC_CheckChild3Type, MVT::v2f64,
/* 12821*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 9847:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 12830*/   0, // EndSwitchType
/* 12831*/  /*Scope*/ 41, /*->12873*/
/* 12832*/   OPC_CheckChild0Integer, 60|128,26|128,1/*19772*/, 
/* 12836*/   OPC_RecordChild1, // #0 = $lhs
/* 12837*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->12855
/* 12840*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12842*/    OPC_RecordChild2, // #1 = $rhs
/* 12843*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12845*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12847*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9886:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12855*/   /*SwitchType*/ 15, MVT::v8i16,// ->12872
/* 12857*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12859*/    OPC_RecordChild2, // #1 = $rhs
/* 12860*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12862*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12864*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9886:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12872*/   0, // EndSwitchType
/* 12873*/  /*Scope*/ 41, /*->12915*/
/* 12874*/   OPC_CheckChild0Integer, 62|128,26|128,1/*19774*/, 
/* 12878*/   OPC_RecordChild1, // #0 = $lhs
/* 12879*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->12897
/* 12882*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12884*/    OPC_RecordChild2, // #1 = $rhs
/* 12885*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12887*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12889*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9887:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12897*/   /*SwitchType*/ 15, MVT::v8i16,// ->12914
/* 12899*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12901*/    OPC_RecordChild2, // #1 = $rhs
/* 12902*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12904*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12906*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9887:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12914*/   0, // EndSwitchType
/* 12915*/  /*Scope*/ 41, /*->12957*/
/* 12916*/   OPC_CheckChild0Integer, 106|128,25|128,1/*19690*/, 
/* 12920*/   OPC_RecordChild1, // #0 = $lhs
/* 12921*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->12939
/* 12924*/    OPC_CheckChild1Type, MVT::v16i8,
/* 12926*/    OPC_RecordChild2, // #1 = $rhs
/* 12927*/    OPC_CheckChild2Type, MVT::v16i8,
/* 12929*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12931*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9845:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12939*/   /*SwitchType*/ 15, MVT::v8i16,// ->12956
/* 12941*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12943*/    OPC_RecordChild2, // #1 = $rhs
/* 12944*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12946*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12948*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9845:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12956*/   0, // EndSwitchType
/* 12957*/  /*Scope*/ 16, /*->12974*/
/* 12958*/   OPC_CheckChild0Integer, 114|128,25|128,1/*19698*/, 
/* 12962*/   OPC_RecordChild1, // #0 = $lhs
/* 12963*/   OPC_RecordChild2, // #1 = $rhs
/* 12964*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12966*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DOT), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9849:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12974*/  /*Scope*/ 41, /*->13016*/
/* 12975*/   OPC_CheckChild0Integer, 10|128,26|128,1/*19722*/, 
/* 12979*/   OPC_RecordChild1, // #0 = $low
/* 12980*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->12998
/* 12983*/    OPC_CheckChild1Type, MVT::v8i16,
/* 12985*/    OPC_RecordChild2, // #1 = $high
/* 12986*/    OPC_CheckChild2Type, MVT::v8i16,
/* 12988*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 12990*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9861:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 12998*/   /*SwitchType*/ 15, MVT::v8i16,// ->13015
/* 13000*/    OPC_CheckChild1Type, MVT::v4i32,
/* 13002*/    OPC_RecordChild2, // #1 = $high
/* 13003*/    OPC_CheckChild2Type, MVT::v4i32,
/* 13005*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13007*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9861:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 13015*/   0, // EndSwitchType
/* 13016*/  /*Scope*/ 41, /*->13058*/
/* 13017*/   OPC_CheckChild0Integer, 12|128,26|128,1/*19724*/, 
/* 13021*/   OPC_RecordChild1, // #0 = $low
/* 13022*/   OPC_SwitchType /*2 cases */, 15, MVT::v16i8,// ->13040
/* 13025*/    OPC_CheckChild1Type, MVT::v8i16,
/* 13027*/    OPC_RecordChild2, // #1 = $high
/* 13028*/    OPC_CheckChild2Type, MVT::v8i16,
/* 13030*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13032*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9862:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 13040*/   /*SwitchType*/ 15, MVT::v8i16,// ->13057
/* 13042*/    OPC_CheckChild1Type, MVT::v4i32,
/* 13044*/    OPC_RecordChild2, // #1 = $high
/* 13045*/    OPC_CheckChild2Type, MVT::v4i32,
/* 13047*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13049*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9862:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 13057*/   0, // EndSwitchType
/* 13058*/  /*Scope*/ 33, /*->13092*/
/* 13059*/   OPC_CheckChild0Integer, 116|128,25|128,1/*19700*/, 
/* 13063*/   OPC_RecordChild1, // #0 = $vec
/* 13064*/   OPC_SwitchType /*2 cases */, 11, MVT::v8i16,// ->13078
/* 13067*/    OPC_CheckChild1Type, MVT::v16i8,
/* 13069*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13071*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9850:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 13078*/   /*SwitchType*/ 11, MVT::v4i32,// ->13091
/* 13080*/    OPC_CheckChild1Type, MVT::v8i16,
/* 13082*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13084*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9850:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 13091*/   0, // EndSwitchType
/* 13092*/  /*Scope*/ 33, /*->13126*/
/* 13093*/   OPC_CheckChild0Integer, 118|128,25|128,1/*19702*/, 
/* 13097*/   OPC_RecordChild1, // #0 = $vec
/* 13098*/   OPC_SwitchType /*2 cases */, 11, MVT::v8i16,// ->13112
/* 13101*/    OPC_CheckChild1Type, MVT::v16i8,
/* 13103*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13105*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9851:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 13112*/   /*SwitchType*/ 11, MVT::v4i32,// ->13125
/* 13114*/    OPC_CheckChild1Type, MVT::v8i16,
/* 13116*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13118*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9851:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 13125*/   0, // EndSwitchType
/* 13126*/  /*Scope*/ 16, /*->13143*/
/* 13127*/   OPC_CheckChild0Integer, 18|128,26|128,1/*19730*/, 
/* 13131*/   OPC_RecordChild1, // #0 = $lhs
/* 13132*/   OPC_RecordChild2, // #1 = $rhs
/* 13133*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 13135*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9865:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13143*/  /*Scope*/ 16, /*->13160*/
/* 13144*/   OPC_CheckChild0Integer, 46|128,26|128,1/*19758*/, 
/* 13148*/   OPC_RecordChild1, // #0 = $src
/* 13149*/   OPC_RecordChild2, // #1 = $mask
/* 13150*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13152*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9879:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 13160*/  /*Scope*/ 14, /*->13175*/
/* 13161*/   OPC_CheckChild0Integer, 48|128,26|128,1/*19760*/, 
/* 13165*/   OPC_RecordChild1, // #0 = $vec
/* 13166*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13168*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9880:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 13175*/  /*Scope*/ 14, /*->13190*/
/* 13176*/   OPC_CheckChild0Integer, 52|128,26|128,1/*19764*/, 
/* 13180*/   OPC_RecordChild1, // #0 = $vec
/* 13181*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13183*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9882:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 13190*/  /*Scope*/ 14, /*->13205*/
/* 13191*/   OPC_CheckChild0Integer, 50|128,26|128,1/*19762*/, 
/* 13195*/   OPC_RecordChild1, // #0 = $vec
/* 13196*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13198*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9881:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 13205*/  /*Scope*/ 14, /*->13220*/
/* 13206*/   OPC_CheckChild0Integer, 54|128,26|128,1/*19766*/, 
/* 13210*/   OPC_RecordChild1, // #0 = $vec
/* 13211*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13213*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9883:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 13220*/  /*Scope*/ 91, /*->13312*/
/* 13221*/   OPC_CheckChild0Integer, 34|128,26|128,1/*19746*/, 
/* 13225*/   OPC_RecordChild1, // #0 = $a
/* 13226*/   OPC_SwitchType /*4 cases */, 19, MVT::v16i8,// ->13248
/* 13229*/    OPC_CheckChild1Type, MVT::v16i8,
/* 13231*/    OPC_RecordChild2, // #1 = $b
/* 13232*/    OPC_CheckChild2Type, MVT::v16i8,
/* 13234*/    OPC_RecordChild3, // #2 = $c
/* 13235*/    OPC_CheckChild3Type, MVT::v16i8,
/* 13237*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13239*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LANESELECT_I8x16), 0,
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 9873:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 13248*/   /*SwitchType*/ 19, MVT::v8i16,// ->13269
/* 13250*/    OPC_CheckChild1Type, MVT::v8i16,
/* 13252*/    OPC_RecordChild2, // #1 = $b
/* 13253*/    OPC_CheckChild2Type, MVT::v8i16,
/* 13255*/    OPC_RecordChild3, // #2 = $c
/* 13256*/    OPC_CheckChild3Type, MVT::v8i16,
/* 13258*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13260*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LANESELECT_I16x8), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9873:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 13269*/   /*SwitchType*/ 19, MVT::v4i32,// ->13290
/* 13271*/    OPC_CheckChild1Type, MVT::v4i32,
/* 13273*/    OPC_RecordChild2, // #1 = $b
/* 13274*/    OPC_CheckChild2Type, MVT::v4i32,
/* 13276*/    OPC_RecordChild3, // #2 = $c
/* 13277*/    OPC_CheckChild3Type, MVT::v4i32,
/* 13279*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13281*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LANESELECT_I32x4), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9873:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 13290*/   /*SwitchType*/ 19, MVT::v2i64,// ->13311
/* 13292*/    OPC_CheckChild1Type, MVT::v2i64,
/* 13294*/    OPC_RecordChild2, // #1 = $b
/* 13295*/    OPC_CheckChild2Type, MVT::v2i64,
/* 13297*/    OPC_RecordChild3, // #2 = $c
/* 13298*/    OPC_CheckChild3Type, MVT::v2i64,
/* 13300*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13302*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LANESELECT_I64x2), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 9873:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 13311*/   0, // EndSwitchType
/* 13312*/  /*Scope*/ 16, /*->13329*/
/* 13313*/   OPC_CheckChild0Integer, 44|128,26|128,1/*19756*/, 
/* 13317*/   OPC_RecordChild1, // #0 = $lhs
/* 13318*/   OPC_RecordChild2, // #1 = $rhs
/* 13319*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13321*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9878:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13329*/  /*Scope*/ 16, /*->13346*/
/* 13330*/   OPC_CheckChild0Integer, 32|128,26|128,1/*19744*/, 
/* 13334*/   OPC_RecordChild1, // #0 = $lhs
/* 13335*/   OPC_RecordChild2, // #1 = $rhs
/* 13336*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13338*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::RELAXED_DOT), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 9872:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13346*/  /*Scope*/ 18, /*->13365*/
/* 13347*/   OPC_CheckChild0Integer, 30|128,26|128,1/*19742*/, 
/* 13351*/   OPC_RecordChild1, // #0 = $lhs
/* 13352*/   OPC_RecordChild2, // #1 = $rhs
/* 13353*/   OPC_RecordChild3, // #2 = $acc
/* 13354*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13356*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD), 0,
                 MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 9871:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 13365*/  /*Scope*/ 37, /*->13403*/
/* 13366*/   OPC_CheckChild0Integer, 16|128,26|128,1/*19728*/, 
/* 13370*/   OPC_RecordChild1, // #0 = $lhs
/* 13371*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->13387
/* 13374*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13376*/    OPC_RecordChild2, // #1 = $rhs
/* 13377*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13379*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 9864:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 13387*/   /*SwitchType*/ 13, MVT::v2f64,// ->13402
/* 13389*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13391*/    OPC_RecordChild2, // #1 = $rhs
/* 13392*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13394*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 9864:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 13402*/   0, // EndSwitchType
/* 13403*/  /*Scope*/ 37, /*->13441*/
/* 13404*/   OPC_CheckChild0Integer, 14|128,26|128,1/*19726*/, 
/* 13408*/   OPC_RecordChild1, // #0 = $lhs
/* 13409*/   OPC_SwitchType /*2 cases */, 13, MVT::v4f32,// ->13425
/* 13412*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13414*/    OPC_RecordChild2, // #1 = $rhs
/* 13415*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13417*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 9863:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 13425*/   /*SwitchType*/ 13, MVT::v2f64,// ->13440
/* 13427*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13429*/    OPC_RecordChild2, // #1 = $rhs
/* 13430*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13432*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 9863:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 13440*/   0, // EndSwitchType
/* 13441*/  /*Scope*/ 49, /*->13491*/
/* 13442*/   OPC_CheckChild0Integer, 36|128,26|128,1/*19748*/, 
/* 13446*/   OPC_RecordChild1, // #0 = $a
/* 13447*/   OPC_SwitchType /*2 cases */, 19, MVT::v4f32,// ->13469
/* 13450*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13452*/    OPC_RecordChild2, // #1 = $b
/* 13453*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13455*/    OPC_RecordChild3, // #2 = $c
/* 13456*/    OPC_CheckChild3Type, MVT::v4f32,
/* 13458*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13460*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MADD_F32x4), 0,
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 9874:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 13469*/   /*SwitchType*/ 19, MVT::v2f64,// ->13490
/* 13471*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13473*/    OPC_RecordChild2, // #1 = $b
/* 13474*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13476*/    OPC_RecordChild3, // #2 = $c
/* 13477*/    OPC_CheckChild3Type, MVT::v2f64,
/* 13479*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13481*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MADD_F64x2), 0,
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 9874:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 13490*/   0, // EndSwitchType
/* 13491*/  /*Scope*/ 49, /*->13541*/
/* 13492*/   OPC_CheckChild0Integer, 42|128,26|128,1/*19754*/, 
/* 13496*/   OPC_RecordChild1, // #0 = $a
/* 13497*/   OPC_SwitchType /*2 cases */, 19, MVT::v4f32,// ->13519
/* 13500*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13502*/    OPC_RecordChild2, // #1 = $b
/* 13503*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13505*/    OPC_RecordChild3, // #2 = $c
/* 13506*/    OPC_CheckChild3Type, MVT::v4f32,
/* 13508*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13510*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NMADD_F32x4), 0,
                  MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 9877:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 13519*/   /*SwitchType*/ 19, MVT::v2f64,// ->13540
/* 13521*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13523*/    OPC_RecordChild2, // #1 = $b
/* 13524*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13526*/    OPC_RecordChild3, // #2 = $c
/* 13527*/    OPC_CheckChild3Type, MVT::v2f64,
/* 13529*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13531*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NMADD_F64x2), 0,
                  MVT::v2f64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 9877:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 13540*/   0, // EndSwitchType
/* 13541*/  /*Scope*/ 41, /*->13583*/
/* 13542*/   OPC_CheckChild0Integer, 40|128,26|128,1/*19752*/, 
/* 13546*/   OPC_RecordChild1, // #0 = $lhs
/* 13547*/   OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->13565
/* 13550*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13552*/    OPC_RecordChild2, // #1 = $rhs
/* 13553*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13555*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13557*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4), 0,
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 9876:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 13565*/   /*SwitchType*/ 15, MVT::v2f64,// ->13582
/* 13567*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13569*/    OPC_RecordChild2, // #1 = $rhs
/* 13570*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13572*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13574*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 9876:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 13582*/   0, // EndSwitchType
/* 13583*/  /*Scope*/ 41, /*->13625*/
/* 13584*/   OPC_CheckChild0Integer, 38|128,26|128,1/*19750*/, 
/* 13588*/   OPC_RecordChild1, // #0 = $lhs
/* 13589*/   OPC_SwitchType /*2 cases */, 15, MVT::v4f32,// ->13607
/* 13592*/    OPC_CheckChild1Type, MVT::v4f32,
/* 13594*/    OPC_RecordChild2, // #1 = $rhs
/* 13595*/    OPC_CheckChild2Type, MVT::v4f32,
/* 13597*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13599*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4), 0,
                  MVT::v4f32, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 9875:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 13607*/   /*SwitchType*/ 15, MVT::v2f64,// ->13624
/* 13609*/    OPC_CheckChild1Type, MVT::v2f64,
/* 13611*/    OPC_RecordChild2, // #1 = $rhs
/* 13612*/    OPC_CheckChild2Type, MVT::v2f64,
/* 13614*/    OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13616*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 9875:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 13624*/   0, // EndSwitchType
/* 13625*/  /*Scope*/ 18, /*->13644*/
/* 13626*/   OPC_CheckChild0Integer, 28|128,26|128,1/*19740*/, 
/* 13630*/   OPC_RecordChild1, // #0 = $lhs
/* 13631*/   OPC_RecordChild2, // #1 = $rhs
/* 13632*/   OPC_RecordChild3, // #2 = $acc
/* 13633*/   OPC_CheckPatternPredicate, 9, // (Subtarget->hasRelaxedSIMD())
/* 13635*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT), 0,
                 MVT::v4f32, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 9870:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 13644*/  0, /*End of Scope*/
/* 13645*/ /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->13802
/* 13649*/  OPC_RecordChild0, // #0 = $vec
/* 13650*/  OPC_Scope, 24, /*->13676*/ // 6 children in Scope
/* 13652*/   OPC_CheckChild0Type, MVT::v16i8,
/* 13654*/   OPC_RecordChild1, // #1 = $idx
/* 13655*/   OPC_MoveChild1,
/* 13656*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13659*/   OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 13661*/   OPC_CheckType, MVT::i32,
/* 13663*/   OPC_MoveParent,
/* 13664*/   OPC_CheckType, MVT::i32,
/* 13666*/   OPC_EmitConvertToTarget, 1,
/* 13668*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13676*/  /*Scope*/ 24, /*->13701*/
/* 13677*/   OPC_CheckChild0Type, MVT::v8i16,
/* 13679*/   OPC_RecordChild1, // #1 = $idx
/* 13680*/   OPC_MoveChild1,
/* 13681*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13684*/   OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 13686*/   OPC_CheckType, MVT::i32,
/* 13688*/   OPC_MoveParent,
/* 13689*/   OPC_CheckType, MVT::i32,
/* 13691*/   OPC_EmitConvertToTarget, 1,
/* 13693*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13701*/  /*Scope*/ 24, /*->13726*/
/* 13702*/   OPC_CheckChild0Type, MVT::v4i32,
/* 13704*/   OPC_RecordChild1, // #1 = $idx
/* 13705*/   OPC_MoveChild1,
/* 13706*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13709*/   OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 13711*/   OPC_CheckType, MVT::i32,
/* 13713*/   OPC_MoveParent,
/* 13714*/   OPC_CheckType, MVT::i32,
/* 13716*/   OPC_EmitConvertToTarget, 1,
/* 13718*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4), 0,
                 MVT::i32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13726*/  /*Scope*/ 24, /*->13751*/
/* 13727*/   OPC_CheckChild0Type, MVT::v2i64,
/* 13729*/   OPC_RecordChild1, // #1 = $idx
/* 13730*/   OPC_MoveChild1,
/* 13731*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13734*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 13736*/   OPC_CheckType, MVT::i32,
/* 13738*/   OPC_MoveParent,
/* 13739*/   OPC_CheckType, MVT::i64,
/* 13741*/   OPC_EmitConvertToTarget, 1,
/* 13743*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2), 0,
                 MVT::i64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13751*/  /*Scope*/ 24, /*->13776*/
/* 13752*/   OPC_CheckChild0Type, MVT::v4f32,
/* 13754*/   OPC_RecordChild1, // #1 = $idx
/* 13755*/   OPC_MoveChild1,
/* 13756*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13759*/   OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 13761*/   OPC_CheckType, MVT::i32,
/* 13763*/   OPC_MoveParent,
/* 13764*/   OPC_CheckType, MVT::f32,
/* 13766*/   OPC_EmitConvertToTarget, 1,
/* 13768*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4), 0,
                 MVT::f32, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13776*/  /*Scope*/ 24, /*->13801*/
/* 13777*/   OPC_CheckChild0Type, MVT::v2f64,
/* 13779*/   OPC_RecordChild1, // #1 = $idx
/* 13780*/   OPC_MoveChild1,
/* 13781*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13784*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 13786*/   OPC_CheckType, MVT::i32,
/* 13788*/   OPC_MoveParent,
/* 13789*/   OPC_CheckType, MVT::f64,
/* 13791*/   OPC_EmitConvertToTarget, 1,
/* 13793*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2), 0,
                 MVT::f64, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 13801*/  0, /*End of Scope*/
/* 13802*/ /*SwitchOpcode*/ 116, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->13921
/* 13805*/  OPC_RecordChild0, // #0 = $argno
/* 13806*/  OPC_MoveChild0,
/* 13807*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 13810*/  OPC_MoveParent,
/* 13811*/  OPC_SwitchType /*12 cases */, 7, MVT::i32,// ->13821
/* 13814*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_i32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 13821*/  /*SwitchType*/ 7, MVT::i64,// ->13830
/* 13823*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_i64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 13830*/  /*SwitchType*/ 7, MVT::funcref,// ->13839
/* 13832*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_funcref), 0,
                 MVT::funcref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 13839*/  /*SwitchType*/ 7, MVT::externref,// ->13848
/* 13841*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_externref), 0,
                 MVT::externref, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 13848*/  /*SwitchType*/ 7, MVT::f32,// ->13857
/* 13850*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_f32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 13857*/  /*SwitchType*/ 7, MVT::f64,// ->13866
/* 13859*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_f64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 13866*/  /*SwitchType*/ 7, MVT::v16i8,// ->13875
/* 13868*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v16i8), 0,
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 13875*/  /*SwitchType*/ 7, MVT::v8i16,// ->13884
/* 13877*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v8i16), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 13884*/  /*SwitchType*/ 7, MVT::v4i32,// ->13893
/* 13886*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v4i32), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 13893*/  /*SwitchType*/ 7, MVT::v2i64,// ->13902
/* 13895*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v2i64), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 13902*/  /*SwitchType*/ 7, MVT::v4f32,// ->13911
/* 13904*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v4f32), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 13911*/  /*SwitchType*/ 7, MVT::v2f64,// ->13920
/* 13913*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ARGUMENT_v2f64), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 13920*/  0, // EndSwitchType
/* 13921*/ /*SwitchOpcode*/ 17|128,1/*145*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->14070
/* 13925*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 13926*/  OPC_RecordChild1, // #1 = $local
/* 13927*/  OPC_MoveChild1,
/* 13928*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 13931*/  OPC_MoveParent,
/* 13932*/  OPC_SwitchType /*12 cases */, 8, MVT::i32,// ->13943
/* 13935*/   OPC_EmitMergeInputChains1_0,
/* 13936*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_I32), 0|OPFL_Chain,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 13943*/  /*SwitchType*/ 8, MVT::i64,// ->13953
/* 13945*/   OPC_EmitMergeInputChains1_0,
/* 13946*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_I64), 0|OPFL_Chain,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 13953*/  /*SwitchType*/ 10, MVT::funcref,// ->13965
/* 13955*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 13957*/   OPC_EmitMergeInputChains1_0,
/* 13958*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF), 0|OPFL_Chain,
                 MVT::funcref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 13965*/  /*SwitchType*/ 10, MVT::externref,// ->13977
/* 13967*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 13969*/   OPC_EmitMergeInputChains1_0,
/* 13970*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF), 0|OPFL_Chain,
                 MVT::externref, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 13977*/  /*SwitchType*/ 8, MVT::f32,// ->13987
/* 13979*/   OPC_EmitMergeInputChains1_0,
/* 13980*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_F32), 0|OPFL_Chain,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 13987*/  /*SwitchType*/ 8, MVT::f64,// ->13997
/* 13989*/   OPC_EmitMergeInputChains1_0,
/* 13990*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_F64), 0|OPFL_Chain,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 13997*/  /*SwitchType*/ 10, MVT::v2i64,// ->14009
/* 13999*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14001*/   OPC_EmitMergeInputChains1_0,
/* 14002*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v2i64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 14009*/  /*SwitchType*/ 10, MVT::v4i32,// ->14021
/* 14011*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14013*/   OPC_EmitMergeInputChains1_0,
/* 14014*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v4i32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 14021*/  /*SwitchType*/ 10, MVT::v16i8,// ->14033
/* 14023*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14025*/   OPC_EmitMergeInputChains1_0,
/* 14026*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v16i8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 14033*/  /*SwitchType*/ 10, MVT::v8i16,// ->14045
/* 14035*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14037*/   OPC_EmitMergeInputChains1_0,
/* 14038*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v8i16, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 14045*/  /*SwitchType*/ 10, MVT::v4f32,// ->14057
/* 14047*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14049*/   OPC_EmitMergeInputChains1_0,
/* 14050*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v4f32, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 14057*/  /*SwitchType*/ 10, MVT::v2f64,// ->14069
/* 14059*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14061*/   OPC_EmitMergeInputChains1_0,
/* 14062*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOCAL_GET_V128), 0|OPFL_Chain,
                 MVT::v2f64, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 14069*/  0, // EndSwitchType
/* 14070*/ /*SwitchOpcode*/ 30|128,1/*158*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->14232
/* 14074*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 14075*/  OPC_RecordChild1, // #1 = $local
/* 14076*/  OPC_MoveChild1,
/* 14077*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 14080*/  OPC_MoveParent,
/* 14081*/  OPC_RecordChild2, // #2 = $src
/* 14082*/  OPC_Scope, 10, /*->14094*/ // 12 children in Scope
/* 14084*/   OPC_CheckChild2Type, MVT::i32,
/* 14086*/   OPC_EmitMergeInputChains1_0,
/* 14087*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_I32), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 14094*/  /*Scope*/ 10, /*->14105*/
/* 14095*/   OPC_CheckChild2Type, MVT::i64,
/* 14097*/   OPC_EmitMergeInputChains1_0,
/* 14098*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_I64), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 14105*/  /*Scope*/ 10, /*->14116*/
/* 14106*/   OPC_CheckChild2Type, MVT::f32,
/* 14108*/   OPC_EmitMergeInputChains1_0,
/* 14109*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_F32), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 14116*/  /*Scope*/ 10, /*->14127*/
/* 14117*/   OPC_CheckChild2Type, MVT::f64,
/* 14119*/   OPC_EmitMergeInputChains1_0,
/* 14120*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_F64), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 14127*/  /*Scope*/ 12, /*->14140*/
/* 14128*/   OPC_CheckChild2Type, MVT::v4f32,
/* 14130*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14132*/   OPC_EmitMergeInputChains1_0,
/* 14133*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 14140*/  /*Scope*/ 12, /*->14153*/
/* 14141*/   OPC_CheckChild2Type, MVT::v2f64,
/* 14143*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14145*/   OPC_EmitMergeInputChains1_0,
/* 14146*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 14153*/  /*Scope*/ 12, /*->14166*/
/* 14154*/   OPC_CheckChild2Type, MVT::v2i64,
/* 14156*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14158*/   OPC_EmitMergeInputChains1_0,
/* 14159*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 14166*/  /*Scope*/ 12, /*->14179*/
/* 14167*/   OPC_CheckChild2Type, MVT::v4i32,
/* 14169*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14171*/   OPC_EmitMergeInputChains1_0,
/* 14172*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 14179*/  /*Scope*/ 12, /*->14192*/
/* 14180*/   OPC_CheckChild2Type, MVT::v16i8,
/* 14182*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14184*/   OPC_EmitMergeInputChains1_0,
/* 14185*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 14192*/  /*Scope*/ 12, /*->14205*/
/* 14193*/   OPC_CheckChild2Type, MVT::v8i16,
/* 14195*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14197*/   OPC_EmitMergeInputChains1_0,
/* 14198*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_V128), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 14205*/  /*Scope*/ 12, /*->14218*/
/* 14206*/   OPC_CheckChild2Type, MVT::funcref,
/* 14208*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 14210*/   OPC_EmitMergeInputChains1_0,
/* 14211*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 14218*/  /*Scope*/ 12, /*->14231*/
/* 14219*/   OPC_CheckChild2Type, MVT::externref,
/* 14221*/   OPC_CheckPatternPredicate, 4, // (Subtarget->hasReferenceTypes())
/* 14223*/   OPC_EmitMergeInputChains1_0,
/* 14224*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF), 0|OPFL_Chain,
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 14231*/  0, /*End of Scope*/
/* 14232*/ /*SwitchOpcode*/ 12|128,1/*140*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->14376
/* 14236*/  OPC_RecordChild0, // #0 = $addr
/* 14237*/  OPC_MoveChild0,
/* 14238*/  OPC_SwitchOpcode /*3 cases */, 51, TARGET_VAL(ISD::TargetGlobalAddress),// ->14293
/* 14242*/   OPC_MoveParent,
/* 14243*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->14268
/* 14246*/    OPC_Scope, 9, /*->14257*/ // 2 children in Scope
/* 14248*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 14250*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 14257*/    /*Scope*/ 9, /*->14267*/
/* 14258*/     OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14260*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 14267*/    0, /*End of Scope*/
/* 14268*/   /*SwitchType*/ 22, MVT::i64,// ->14292
/* 14270*/    OPC_Scope, 9, /*->14281*/ // 2 children in Scope
/* 14272*/     OPC_CheckPatternPredicate, 12, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 14274*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 14281*/    /*Scope*/ 9, /*->14291*/
/* 14282*/     OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14284*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 14291*/    0, /*End of Scope*/
/* 14292*/   0, // EndSwitchType
/* 14293*/  /*SwitchOpcode*/ 25, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->14321
/* 14296*/   OPC_MoveParent,
/* 14297*/   OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->14309
/* 14300*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 14302*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 14309*/   /*SwitchType*/ 9, MVT::i64,// ->14320
/* 14311*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 14313*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 14320*/   0, // EndSwitchType
/* 14321*/  /*SwitchOpcode*/ 51, TARGET_VAL(ISD::TargetExternalSymbol),// ->14375
/* 14324*/   OPC_MoveParent,
/* 14325*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->14350
/* 14328*/    OPC_Scope, 9, /*->14339*/ // 2 children in Scope
/* 14330*/     OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14332*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 14339*/    /*Scope*/ 9, /*->14349*/
/* 14340*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 14342*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 14349*/    0, /*End of Scope*/
/* 14350*/   /*SwitchType*/ 22, MVT::i64,// ->14374
/* 14352*/    OPC_Scope, 9, /*->14363*/ // 2 children in Scope
/* 14354*/     OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14356*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 14363*/    /*Scope*/ 9, /*->14373*/
/* 14364*/     OPC_CheckPatternPredicate, 12, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 14366*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 14373*/    0, /*End of Scope*/
/* 14374*/   0, // EndSwitchType
/* 14375*/  0, // EndSwitchOpcode
/* 14376*/ /*SwitchOpcode*/ 88, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->14467
/* 14379*/  OPC_RecordChild0, // #0 = $addr
/* 14380*/  OPC_MoveChild0,
/* 14381*/  OPC_SwitchOpcode /*3 cases */, 25, TARGET_VAL(ISD::TargetGlobalAddress),// ->14410
/* 14385*/   OPC_MoveParent,
/* 14386*/   OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->14398
/* 14389*/    OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14391*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 14398*/   /*SwitchType*/ 9, MVT::i64,// ->14409
/* 14400*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14402*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 14409*/   0, // EndSwitchType
/* 14410*/  /*SwitchOpcode*/ 25, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->14438
/* 14413*/   OPC_MoveParent,
/* 14414*/   OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->14426
/* 14417*/    OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 14419*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 14426*/   /*SwitchType*/ 9, MVT::i64,// ->14437
/* 14428*/    OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 14430*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 14437*/   0, // EndSwitchType
/* 14438*/  /*SwitchOpcode*/ 25, TARGET_VAL(ISD::TargetExternalSymbol),// ->14466
/* 14441*/   OPC_MoveParent,
/* 14442*/   OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->14454
/* 14445*/    OPC_CheckPatternPredicate, 11, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14447*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 14454*/   /*SwitchType*/ 9, MVT::i64,// ->14465
/* 14456*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 14458*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 14465*/   0, // EndSwitchType
/* 14466*/  0, // EndSwitchOpcode
/* 14467*/ /*SwitchOpcode*/ 58, TARGET_VAL(WebAssemblyISD::MEMORY_FILL),// ->14528
/* 14470*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 14471*/  OPC_RecordChild1, // #1 = $idx
/* 14472*/  OPC_MoveChild1,
/* 14473*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 14476*/  OPC_CheckType, MVT::i32,
/* 14478*/  OPC_MoveParent,
/* 14479*/  OPC_RecordChild2, // #2 = $dst
/* 14480*/  OPC_Scope, 22, /*->14504*/ // 2 children in Scope
/* 14482*/   OPC_CheckChild2Type, MVT::i32,
/* 14484*/   OPC_RecordChild3, // #3 = $value
/* 14485*/   OPC_CheckChild3Type, MVT::i32,
/* 14487*/   OPC_RecordChild4, // #4 = $size
/* 14488*/   OPC_CheckChild4Type, MVT::i32,
/* 14490*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 14492*/   OPC_EmitMergeInputChains1_0,
/* 14493*/   OPC_EmitConvertToTarget, 1,
/* 14495*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_4730MEMORY_FILL_A32), 0|OPFL_Chain,
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (anonymous_4730MEMORY_FILL_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 14504*/  /*Scope*/ 22, /*->14527*/
/* 14505*/   OPC_CheckChild2Type, MVT::i64,
/* 14507*/   OPC_RecordChild3, // #3 = $value
/* 14508*/   OPC_CheckChild3Type, MVT::i32,
/* 14510*/   OPC_RecordChild4, // #4 = $size
/* 14511*/   OPC_CheckChild4Type, MVT::i64,
/* 14513*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasBulkMemory())
/* 14515*/   OPC_EmitMergeInputChains1_0,
/* 14516*/   OPC_EmitConvertToTarget, 1,
/* 14518*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::anonymous_4731MEMORY_FILL_A64), 0|OPFL_Chain,
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (anonymous_4731MEMORY_FILL_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 14527*/  0, /*End of Scope*/
/* 14528*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::Constant),// ->14556
/* 14531*/  OPC_RecordNode, // #0 = $imm
/* 14532*/  OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->14544
/* 14535*/   OPC_EmitConvertToTarget, 0,
/* 14537*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I32), 0,
                 MVT::i32, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 14544*/  /*SwitchType*/ 9, MVT::i64,// ->14555
/* 14546*/   OPC_EmitConvertToTarget, 0,
/* 14548*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_I64), 0,
                 MVT::i64, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 14555*/  0, // EndSwitchType
/* 14556*/ /*SwitchOpcode*/ 14, TARGET_VAL(ISD::BR),// ->14573
/* 14559*/  OPC_RecordNode, // #0 = 'br' chained node
/* 14560*/  OPC_RecordChild1, // #1 = $dst
/* 14561*/  OPC_MoveChild1,
/* 14562*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 14565*/  OPC_MoveParent,
/* 14566*/  OPC_EmitMergeInputChains1_0,
/* 14567*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR), 0|OPFL_Chain,
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 14573*/ /*SwitchOpcode*/ 24, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->14600
/* 14576*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 14577*/  OPC_RecordChild1, // #1 = $index
/* 14578*/  OPC_Scope, 9, /*->14589*/ // 2 children in Scope
/* 14580*/   OPC_CheckChild1Type, MVT::i32,
/* 14582*/   OPC_EmitMergeInputChains1_0,
/* 14583*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 14589*/  /*Scope*/ 9, /*->14599*/
/* 14590*/   OPC_CheckChild1Type, MVT::i64,
/* 14592*/   OPC_EmitMergeInputChains1_0,
/* 14593*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 14599*/  0, /*End of Scope*/
/* 14600*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->14610
/* 14603*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 14604*/  OPC_EmitMergeInputChains1_0,
/* 14605*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 14610*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRAP),// ->14620
/* 14613*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 14614*/  OPC_EmitMergeInputChains1_0,
/* 14615*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::UNREACHABLE), 0|OPFL_Chain,
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 14620*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::DEBUGTRAP),// ->14630
/* 14623*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 14624*/  OPC_EmitMergeInputChains1_0,
/* 14625*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE), 0|OPFL_Chain,
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 14630*/ /*SwitchOpcode*/ 9, TARGET_VAL(ISD::CLEANUPRET),// ->14642
/* 14633*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 14634*/  OPC_CheckPatternPredicate, 5, // (Subtarget->hasExceptionHandling())
/* 14636*/  OPC_EmitMergeInputChains1_0,
/* 14637*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CLEANUPRET), 0|OPFL_Chain,
                0/*#Ops*/, 
            // Src: (cleanupret) - Complexity = 3
            // Dst: (CLEANUPRET)
/* 14642*/ /*SwitchOpcode*/ 23, TARGET_VAL(ISD::CATCHRET),// ->14668
/* 14645*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 14646*/  OPC_RecordChild1, // #1 = $dst
/* 14647*/  OPC_MoveChild1,
/* 14648*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 14651*/  OPC_MoveParent,
/* 14652*/  OPC_RecordChild2, // #2 = $from
/* 14653*/  OPC_MoveChild2,
/* 14654*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 14657*/  OPC_MoveParent,
/* 14658*/  OPC_CheckPatternPredicate, 5, // (Subtarget->hasExceptionHandling())
/* 14660*/  OPC_EmitMergeInputChains1_0,
/* 14661*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::CATCHRET), 0|OPFL_Chain,
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 14668*/ /*SwitchOpcode*/ 72, TARGET_VAL(ISD::ADD),// ->14743
/* 14671*/  OPC_RecordChild0, // #0 = $lhs
/* 14672*/  OPC_RecordChild1, // #1 = $rhs
/* 14673*/  OPC_SwitchType /*6 cases */, 8, MVT::i32,// ->14684
/* 14676*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14684*/  /*SwitchType*/ 8, MVT::i64,// ->14694
/* 14686*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14694*/  /*SwitchType*/ 10, MVT::v16i8,// ->14706
/* 14696*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14698*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14706*/  /*SwitchType*/ 10, MVT::v8i16,// ->14718
/* 14708*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14710*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14718*/  /*SwitchType*/ 10, MVT::v4i32,// ->14730
/* 14720*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14722*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14730*/  /*SwitchType*/ 10, MVT::v2i64,// ->14742
/* 14732*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14734*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_I64x2), 0,
                 MVT::v2i64, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14742*/  0, // EndSwitchType
/* 14743*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(ISD::SUB),// ->14878
/* 14747*/  OPC_Scope, 24, /*->14773*/ // 3 children in Scope
/* 14749*/   OPC_RecordChild0, // #0 = $lhs
/* 14750*/   OPC_RecordChild1, // #1 = $rhs
/* 14751*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->14762
/* 14754*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14762*/   /*SwitchType*/ 8, MVT::i64,// ->14772
/* 14764*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14772*/   0, // EndSwitchType
/* 14773*/  /*Scope*/ 50, /*->14824*/
/* 14774*/   OPC_MoveChild0,
/* 14775*/   OPC_CheckImmAllZerosV,
/* 14776*/   OPC_MoveParent,
/* 14777*/   OPC_RecordChild1, // #0 = $v
/* 14778*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->14790
/* 14781*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14783*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I8x16), 0,
                  MVT::v16i8, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 14790*/   /*SwitchType*/ 9, MVT::v8i16,// ->14801
/* 14792*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14794*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I16x8), 0,
                  MVT::v8i16, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 14801*/   /*SwitchType*/ 9, MVT::v4i32,// ->14812
/* 14803*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14805*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I32x4), 0,
                  MVT::v4i32, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 14812*/   /*SwitchType*/ 9, MVT::v2i64,// ->14823
/* 14814*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14816*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_I64x2), 0,
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 14823*/   0, // EndSwitchType
/* 14824*/  /*Scope*/ 52, /*->14877*/
/* 14825*/   OPC_RecordChild0, // #0 = $lhs
/* 14826*/   OPC_RecordChild1, // #1 = $rhs
/* 14827*/   OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->14840
/* 14830*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14832*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14840*/   /*SwitchType*/ 10, MVT::v8i16,// ->14852
/* 14842*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14844*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14852*/   /*SwitchType*/ 10, MVT::v4i32,// ->14864
/* 14854*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14856*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14864*/   /*SwitchType*/ 10, MVT::v2i64,// ->14876
/* 14866*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14868*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14876*/   0, // EndSwitchType
/* 14877*/  0, /*End of Scope*/
/* 14878*/ /*SwitchOpcode*/ 1|128,3/*385*/, TARGET_VAL(ISD::MUL),// ->15267
/* 14882*/  OPC_Scope, 24, /*->14908*/ // 3 children in Scope
/* 14884*/   OPC_RecordChild0, // #0 = $lhs
/* 14885*/   OPC_RecordChild1, // #1 = $rhs
/* 14886*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->14897
/* 14889*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14897*/   /*SwitchType*/ 8, MVT::i64,// ->14907
/* 14899*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14907*/   0, // EndSwitchType
/* 14908*/  /*Scope*/ 59|128,2/*315*/, /*->15225*/
/* 14910*/   OPC_MoveChild0,
/* 14911*/   OPC_SwitchOpcode /*4 cases */, 75, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->14990
/* 14915*/    OPC_RecordChild0, // #0 = $lhs
/* 14916*/    OPC_Scope, 23, /*->14941*/ // 3 children in Scope
/* 14918*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14920*/     OPC_MoveParent,
/* 14921*/     OPC_MoveChild1,
/* 14922*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 14925*/     OPC_RecordChild0, // #1 = $rhs
/* 14926*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14928*/     OPC_MoveParent,
/* 14929*/     OPC_CheckType, MVT::v8i16,
/* 14931*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14933*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14941*/    /*Scope*/ 23, /*->14965*/
/* 14942*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14944*/     OPC_MoveParent,
/* 14945*/     OPC_MoveChild1,
/* 14946*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 14949*/     OPC_RecordChild0, // #1 = $rhs
/* 14950*/     OPC_CheckChild0Type, MVT::v8i16,
/* 14952*/     OPC_MoveParent,
/* 14953*/     OPC_CheckType, MVT::v4i32,
/* 14955*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14957*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14965*/    /*Scope*/ 23, /*->14989*/
/* 14966*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14968*/     OPC_MoveParent,
/* 14969*/     OPC_MoveChild1,
/* 14970*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 14973*/     OPC_RecordChild0, // #1 = $rhs
/* 14974*/     OPC_CheckChild0Type, MVT::v4i32,
/* 14976*/     OPC_MoveParent,
/* 14977*/     OPC_CheckType, MVT::v2i64,
/* 14979*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 14981*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14989*/    0, /*End of Scope*/
/* 14990*/   /*SwitchOpcode*/ 75, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->15068
/* 14993*/    OPC_RecordChild0, // #0 = $lhs
/* 14994*/    OPC_Scope, 23, /*->15019*/ // 3 children in Scope
/* 14996*/     OPC_CheckChild0Type, MVT::v16i8,
/* 14998*/     OPC_MoveParent,
/* 14999*/     OPC_MoveChild1,
/* 15000*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 15003*/     OPC_RecordChild0, // #1 = $rhs
/* 15004*/     OPC_CheckChild0Type, MVT::v16i8,
/* 15006*/     OPC_MoveParent,
/* 15007*/     OPC_CheckType, MVT::v8i16,
/* 15009*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15011*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 15019*/    /*Scope*/ 23, /*->15043*/
/* 15020*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15022*/     OPC_MoveParent,
/* 15023*/     OPC_MoveChild1,
/* 15024*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 15027*/     OPC_RecordChild0, // #1 = $rhs
/* 15028*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15030*/     OPC_MoveParent,
/* 15031*/     OPC_CheckType, MVT::v4i32,
/* 15033*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15035*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 15043*/    /*Scope*/ 23, /*->15067*/
/* 15044*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15046*/     OPC_MoveParent,
/* 15047*/     OPC_MoveChild1,
/* 15048*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 15051*/     OPC_RecordChild0, // #1 = $rhs
/* 15052*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15054*/     OPC_MoveParent,
/* 15055*/     OPC_CheckType, MVT::v2i64,
/* 15057*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15059*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 15067*/    0, /*End of Scope*/
/* 15068*/   /*SwitchOpcode*/ 75, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->15146
/* 15071*/    OPC_RecordChild0, // #0 = $lhs
/* 15072*/    OPC_Scope, 23, /*->15097*/ // 3 children in Scope
/* 15074*/     OPC_CheckChild0Type, MVT::v16i8,
/* 15076*/     OPC_MoveParent,
/* 15077*/     OPC_MoveChild1,
/* 15078*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 15081*/     OPC_RecordChild0, // #1 = $rhs
/* 15082*/     OPC_CheckChild0Type, MVT::v16i8,
/* 15084*/     OPC_MoveParent,
/* 15085*/     OPC_CheckType, MVT::v8i16,
/* 15087*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15089*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 15097*/    /*Scope*/ 23, /*->15121*/
/* 15098*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15100*/     OPC_MoveParent,
/* 15101*/     OPC_MoveChild1,
/* 15102*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 15105*/     OPC_RecordChild0, // #1 = $rhs
/* 15106*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15108*/     OPC_MoveParent,
/* 15109*/     OPC_CheckType, MVT::v4i32,
/* 15111*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15113*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 15121*/    /*Scope*/ 23, /*->15145*/
/* 15122*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15124*/     OPC_MoveParent,
/* 15125*/     OPC_MoveChild1,
/* 15126*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 15129*/     OPC_RecordChild0, // #1 = $rhs
/* 15130*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15132*/     OPC_MoveParent,
/* 15133*/     OPC_CheckType, MVT::v2i64,
/* 15135*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15137*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 15145*/    0, /*End of Scope*/
/* 15146*/   /*SwitchOpcode*/ 75, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->15224
/* 15149*/    OPC_RecordChild0, // #0 = $lhs
/* 15150*/    OPC_Scope, 23, /*->15175*/ // 3 children in Scope
/* 15152*/     OPC_CheckChild0Type, MVT::v16i8,
/* 15154*/     OPC_MoveParent,
/* 15155*/     OPC_MoveChild1,
/* 15156*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 15159*/     OPC_RecordChild0, // #1 = $rhs
/* 15160*/     OPC_CheckChild0Type, MVT::v16i8,
/* 15162*/     OPC_MoveParent,
/* 15163*/     OPC_CheckType, MVT::v8i16,
/* 15165*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15167*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 15175*/    /*Scope*/ 23, /*->15199*/
/* 15176*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15178*/     OPC_MoveParent,
/* 15179*/     OPC_MoveChild1,
/* 15180*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 15183*/     OPC_RecordChild0, // #1 = $rhs
/* 15184*/     OPC_CheckChild0Type, MVT::v8i16,
/* 15186*/     OPC_MoveParent,
/* 15187*/     OPC_CheckType, MVT::v4i32,
/* 15189*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15191*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 15199*/    /*Scope*/ 23, /*->15223*/
/* 15200*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15202*/     OPC_MoveParent,
/* 15203*/     OPC_MoveChild1,
/* 15204*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 15207*/     OPC_RecordChild0, // #1 = $rhs
/* 15208*/     OPC_CheckChild0Type, MVT::v4i32,
/* 15210*/     OPC_MoveParent,
/* 15211*/     OPC_CheckType, MVT::v2i64,
/* 15213*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15215*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 15223*/    0, /*End of Scope*/
/* 15224*/   0, // EndSwitchOpcode
/* 15225*/  /*Scope*/ 40, /*->15266*/
/* 15226*/   OPC_RecordChild0, // #0 = $lhs
/* 15227*/   OPC_RecordChild1, // #1 = $rhs
/* 15228*/   OPC_SwitchType /*3 cases */, 10, MVT::v8i16,// ->15241
/* 15231*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15233*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 15241*/   /*SwitchType*/ 10, MVT::v4i32,// ->15253
/* 15243*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15245*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 15253*/   /*SwitchType*/ 10, MVT::v2i64,// ->15265
/* 15255*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 15257*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 15265*/   0, // EndSwitchType
/* 15266*/  0, /*End of Scope*/
/* 15267*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SDIV),// ->15294
/* 15270*/  OPC_RecordChild0, // #0 = $lhs
/* 15271*/  OPC_RecordChild1, // #1 = $rhs
/* 15272*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->15283
/* 15275*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_S_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15283*/  /*SwitchType*/ 8, MVT::i64,// ->15293
/* 15285*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_S_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15293*/  0, // EndSwitchType
/* 15294*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UDIV),// ->15321
/* 15297*/  OPC_RecordChild0, // #0 = $lhs
/* 15298*/  OPC_RecordChild1, // #1 = $rhs
/* 15299*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->15310
/* 15302*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_U_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15310*/  /*SwitchType*/ 8, MVT::i64,// ->15320
/* 15312*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_U_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15320*/  0, // EndSwitchType
/* 15321*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SREM),// ->15348
/* 15324*/  OPC_RecordChild0, // #0 = $lhs
/* 15325*/  OPC_RecordChild1, // #1 = $rhs
/* 15326*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->15337
/* 15329*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_S_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15337*/  /*SwitchType*/ 8, MVT::i64,// ->15347
/* 15339*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_S_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15347*/  0, // EndSwitchType
/* 15348*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UREM),// ->15375
/* 15351*/  OPC_RecordChild0, // #0 = $lhs
/* 15352*/  OPC_RecordChild1, // #1 = $rhs
/* 15353*/  OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->15364
/* 15356*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_U_I32), 0,
                 MVT::i32, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15364*/  /*SwitchType*/ 8, MVT::i64,// ->15374
/* 15366*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REM_U_I64), 0,
                 MVT::i64, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15374*/  0, // EndSwitchType
/* 15375*/ /*SwitchOpcode*/ 109|128,6/*877*/, TARGET_VAL(ISD::OR),// ->16256
/* 15379*/  OPC_Scope, 24, /*->15405*/ // 3 children in Scope
/* 15381*/   OPC_RecordChild0, // #0 = $lhs
/* 15382*/   OPC_RecordChild1, // #1 = $rhs
/* 15383*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->15394
/* 15386*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15394*/   /*SwitchType*/ 8, MVT::i64,// ->15404
/* 15396*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15404*/   0, // EndSwitchType
/* 15405*/  /*Scope*/ 35|128,6/*803*/, /*->16210*/
/* 15407*/   OPC_MoveChild0,
/* 15408*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15411*/   OPC_Scope, 12|128,1/*140*/, /*->15554*/ // 9 children in Scope
/* 15414*/    OPC_RecordChild0, // #0 = $c
/* 15415*/    OPC_RecordChild1, // #1 = $v1
/* 15416*/    OPC_MoveParent,
/* 15417*/    OPC_MoveChild1,
/* 15418*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15421*/    OPC_Scope, 58, /*->15481*/ // 4 children in Scope
/* 15423*/     OPC_MoveChild0,
/* 15424*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15427*/     OPC_CheckChild0Same, 0,
/* 15429*/     OPC_MoveChild1,
/* 15430*/     OPC_CheckImmAllOnesV,
/* 15431*/     OPC_MoveParent,
/* 15432*/     OPC_MoveParent,
/* 15433*/     OPC_RecordChild1, // #2 = $v2
/* 15434*/     OPC_MoveParent,
/* 15435*/     OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->15447
/* 15438*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15447*/     /*SwitchType*/ 9, MVT::v8i16,// ->15458
/* 15449*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15458*/     /*SwitchType*/ 9, MVT::v4i32,// ->15469
/* 15460*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15469*/     /*SwitchType*/ 9, MVT::v2i64,// ->15480
/* 15471*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15480*/     0, // EndSwitchType
/* 15481*/    /*Scope*/ 23, /*->15505*/
/* 15482*/     OPC_RecordChild0, // #2 = $v2
/* 15483*/     OPC_MoveChild1,
/* 15484*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15487*/     OPC_CheckChild0Same, 0,
/* 15489*/     OPC_MoveChild1,
/* 15490*/     OPC_CheckImmAllOnesV,
/* 15491*/     OPC_MoveParent,
/* 15492*/     OPC_MoveParent,
/* 15493*/     OPC_MoveParent,
/* 15494*/     OPC_CheckType, MVT::v16i8,
/* 15496*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15505*/    /*Scope*/ 23, /*->15529*/
/* 15506*/     OPC_MoveChild0,
/* 15507*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15510*/     OPC_CheckChild0Same, 1,
/* 15512*/     OPC_MoveChild1,
/* 15513*/     OPC_CheckImmAllOnesV,
/* 15514*/     OPC_MoveParent,
/* 15515*/     OPC_MoveParent,
/* 15516*/     OPC_RecordChild1, // #2 = $v2
/* 15517*/     OPC_MoveParent,
/* 15518*/     OPC_CheckType, MVT::v16i8,
/* 15520*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15529*/    /*Scope*/ 23, /*->15553*/
/* 15530*/     OPC_RecordChild0, // #2 = $v2
/* 15531*/     OPC_MoveChild1,
/* 15532*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15535*/     OPC_CheckChild0Same, 1,
/* 15537*/     OPC_MoveChild1,
/* 15538*/     OPC_CheckImmAllOnesV,
/* 15539*/     OPC_MoveParent,
/* 15540*/     OPC_MoveParent,
/* 15541*/     OPC_MoveParent,
/* 15542*/     OPC_CheckType, MVT::v16i8,
/* 15544*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15553*/    0, /*End of Scope*/
/* 15554*/   /*Scope*/ 49, /*->15604*/
/* 15555*/    OPC_MoveChild0,
/* 15556*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15559*/    OPC_RecordChild0, // #0 = $c
/* 15560*/    OPC_MoveChild1,
/* 15561*/    OPC_CheckImmAllOnesV,
/* 15562*/    OPC_MoveParent,
/* 15563*/    OPC_MoveParent,
/* 15564*/    OPC_RecordChild1, // #1 = $v2
/* 15565*/    OPC_MoveParent,
/* 15566*/    OPC_MoveChild1,
/* 15567*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15570*/    OPC_Scope, 15, /*->15587*/ // 2 children in Scope
/* 15572*/     OPC_CheckChild0Same, 0,
/* 15574*/     OPC_RecordChild1, // #2 = $v1
/* 15575*/     OPC_MoveParent,
/* 15576*/     OPC_CheckType, MVT::v16i8,
/* 15578*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15587*/    /*Scope*/ 15, /*->15603*/
/* 15588*/     OPC_RecordChild0, // #2 = $v1
/* 15589*/     OPC_CheckChild1Same, 0,
/* 15591*/     OPC_MoveParent,
/* 15592*/     OPC_CheckType, MVT::v16i8,
/* 15594*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15603*/    0, /*End of Scope*/
/* 15604*/   /*Scope*/ 5|128,1/*133*/, /*->15739*/
/* 15606*/    OPC_RecordChild0, // #0 = $v2
/* 15607*/    OPC_Scope, 48, /*->15657*/ // 2 children in Scope
/* 15609*/     OPC_MoveChild1,
/* 15610*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15613*/     OPC_RecordChild0, // #1 = $c
/* 15614*/     OPC_MoveChild1,
/* 15615*/     OPC_CheckImmAllOnesV,
/* 15616*/     OPC_MoveParent,
/* 15617*/     OPC_MoveParent,
/* 15618*/     OPC_MoveParent,
/* 15619*/     OPC_MoveChild1,
/* 15620*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15623*/     OPC_Scope, 15, /*->15640*/ // 2 children in Scope
/* 15625*/      OPC_CheckChild0Same, 1,
/* 15627*/      OPC_RecordChild1, // #2 = $v1
/* 15628*/      OPC_MoveParent,
/* 15629*/      OPC_CheckType, MVT::v16i8,
/* 15631*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15640*/     /*Scope*/ 15, /*->15656*/
/* 15641*/      OPC_RecordChild0, // #2 = $v1
/* 15642*/      OPC_CheckChild1Same, 1,
/* 15644*/      OPC_MoveParent,
/* 15645*/      OPC_CheckType, MVT::v16i8,
/* 15647*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15656*/     0, /*End of Scope*/
/* 15657*/    /*Scope*/ 80, /*->15738*/
/* 15658*/     OPC_RecordChild1, // #1 = $v1
/* 15659*/     OPC_MoveParent,
/* 15660*/     OPC_MoveChild1,
/* 15661*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15664*/     OPC_Scope, 23, /*->15689*/ // 3 children in Scope
/* 15666*/      OPC_RecordChild0, // #2 = $v2
/* 15667*/      OPC_MoveChild1,
/* 15668*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15671*/      OPC_CheckChild0Same, 0,
/* 15673*/      OPC_MoveChild1,
/* 15674*/      OPC_CheckImmAllOnesV,
/* 15675*/      OPC_MoveParent,
/* 15676*/      OPC_MoveParent,
/* 15677*/      OPC_MoveParent,
/* 15678*/      OPC_CheckType, MVT::v8i16,
/* 15680*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15689*/     /*Scope*/ 23, /*->15713*/
/* 15690*/      OPC_MoveChild0,
/* 15691*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15694*/      OPC_CheckChild0Same, 1,
/* 15696*/      OPC_MoveChild1,
/* 15697*/      OPC_CheckImmAllOnesV,
/* 15698*/      OPC_MoveParent,
/* 15699*/      OPC_MoveParent,
/* 15700*/      OPC_RecordChild1, // #2 = $v2
/* 15701*/      OPC_MoveParent,
/* 15702*/      OPC_CheckType, MVT::v8i16,
/* 15704*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15713*/     /*Scope*/ 23, /*->15737*/
/* 15714*/      OPC_RecordChild0, // #2 = $v2
/* 15715*/      OPC_MoveChild1,
/* 15716*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15719*/      OPC_CheckChild0Same, 1,
/* 15721*/      OPC_MoveChild1,
/* 15722*/      OPC_CheckImmAllOnesV,
/* 15723*/      OPC_MoveParent,
/* 15724*/      OPC_MoveParent,
/* 15725*/      OPC_MoveParent,
/* 15726*/      OPC_CheckType, MVT::v8i16,
/* 15728*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15737*/     0, /*End of Scope*/
/* 15738*/    0, /*End of Scope*/
/* 15739*/   /*Scope*/ 49, /*->15789*/
/* 15740*/    OPC_MoveChild0,
/* 15741*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15744*/    OPC_RecordChild0, // #0 = $c
/* 15745*/    OPC_MoveChild1,
/* 15746*/    OPC_CheckImmAllOnesV,
/* 15747*/    OPC_MoveParent,
/* 15748*/    OPC_MoveParent,
/* 15749*/    OPC_RecordChild1, // #1 = $v2
/* 15750*/    OPC_MoveParent,
/* 15751*/    OPC_MoveChild1,
/* 15752*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15755*/    OPC_Scope, 15, /*->15772*/ // 2 children in Scope
/* 15757*/     OPC_CheckChild0Same, 0,
/* 15759*/     OPC_RecordChild1, // #2 = $v1
/* 15760*/     OPC_MoveParent,
/* 15761*/     OPC_CheckType, MVT::v8i16,
/* 15763*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15772*/    /*Scope*/ 15, /*->15788*/
/* 15773*/     OPC_RecordChild0, // #2 = $v1
/* 15774*/     OPC_CheckChild1Same, 0,
/* 15776*/     OPC_MoveParent,
/* 15777*/     OPC_CheckType, MVT::v8i16,
/* 15779*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15788*/    0, /*End of Scope*/
/* 15789*/   /*Scope*/ 5|128,1/*133*/, /*->15924*/
/* 15791*/    OPC_RecordChild0, // #0 = $v2
/* 15792*/    OPC_Scope, 48, /*->15842*/ // 2 children in Scope
/* 15794*/     OPC_MoveChild1,
/* 15795*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15798*/     OPC_RecordChild0, // #1 = $c
/* 15799*/     OPC_MoveChild1,
/* 15800*/     OPC_CheckImmAllOnesV,
/* 15801*/     OPC_MoveParent,
/* 15802*/     OPC_MoveParent,
/* 15803*/     OPC_MoveParent,
/* 15804*/     OPC_MoveChild1,
/* 15805*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15808*/     OPC_Scope, 15, /*->15825*/ // 2 children in Scope
/* 15810*/      OPC_CheckChild0Same, 1,
/* 15812*/      OPC_RecordChild1, // #2 = $v1
/* 15813*/      OPC_MoveParent,
/* 15814*/      OPC_CheckType, MVT::v8i16,
/* 15816*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15825*/     /*Scope*/ 15, /*->15841*/
/* 15826*/      OPC_RecordChild0, // #2 = $v1
/* 15827*/      OPC_CheckChild1Same, 1,
/* 15829*/      OPC_MoveParent,
/* 15830*/      OPC_CheckType, MVT::v8i16,
/* 15832*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15841*/     0, /*End of Scope*/
/* 15842*/    /*Scope*/ 80, /*->15923*/
/* 15843*/     OPC_RecordChild1, // #1 = $v1
/* 15844*/     OPC_MoveParent,
/* 15845*/     OPC_MoveChild1,
/* 15846*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15849*/     OPC_Scope, 23, /*->15874*/ // 3 children in Scope
/* 15851*/      OPC_RecordChild0, // #2 = $v2
/* 15852*/      OPC_MoveChild1,
/* 15853*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15856*/      OPC_CheckChild0Same, 0,
/* 15858*/      OPC_MoveChild1,
/* 15859*/      OPC_CheckImmAllOnesV,
/* 15860*/      OPC_MoveParent,
/* 15861*/      OPC_MoveParent,
/* 15862*/      OPC_MoveParent,
/* 15863*/      OPC_CheckType, MVT::v4i32,
/* 15865*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15874*/     /*Scope*/ 23, /*->15898*/
/* 15875*/      OPC_MoveChild0,
/* 15876*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15879*/      OPC_CheckChild0Same, 1,
/* 15881*/      OPC_MoveChild1,
/* 15882*/      OPC_CheckImmAllOnesV,
/* 15883*/      OPC_MoveParent,
/* 15884*/      OPC_MoveParent,
/* 15885*/      OPC_RecordChild1, // #2 = $v2
/* 15886*/      OPC_MoveParent,
/* 15887*/      OPC_CheckType, MVT::v4i32,
/* 15889*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15898*/     /*Scope*/ 23, /*->15922*/
/* 15899*/      OPC_RecordChild0, // #2 = $v2
/* 15900*/      OPC_MoveChild1,
/* 15901*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15904*/      OPC_CheckChild0Same, 1,
/* 15906*/      OPC_MoveChild1,
/* 15907*/      OPC_CheckImmAllOnesV,
/* 15908*/      OPC_MoveParent,
/* 15909*/      OPC_MoveParent,
/* 15910*/      OPC_MoveParent,
/* 15911*/      OPC_CheckType, MVT::v4i32,
/* 15913*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15922*/     0, /*End of Scope*/
/* 15923*/    0, /*End of Scope*/
/* 15924*/   /*Scope*/ 49, /*->15974*/
/* 15925*/    OPC_MoveChild0,
/* 15926*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15929*/    OPC_RecordChild0, // #0 = $c
/* 15930*/    OPC_MoveChild1,
/* 15931*/    OPC_CheckImmAllOnesV,
/* 15932*/    OPC_MoveParent,
/* 15933*/    OPC_MoveParent,
/* 15934*/    OPC_RecordChild1, // #1 = $v2
/* 15935*/    OPC_MoveParent,
/* 15936*/    OPC_MoveChild1,
/* 15937*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15940*/    OPC_Scope, 15, /*->15957*/ // 2 children in Scope
/* 15942*/     OPC_CheckChild0Same, 0,
/* 15944*/     OPC_RecordChild1, // #2 = $v1
/* 15945*/     OPC_MoveParent,
/* 15946*/     OPC_CheckType, MVT::v4i32,
/* 15948*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15957*/    /*Scope*/ 15, /*->15973*/
/* 15958*/     OPC_RecordChild0, // #2 = $v1
/* 15959*/     OPC_CheckChild1Same, 0,
/* 15961*/     OPC_MoveParent,
/* 15962*/     OPC_CheckType, MVT::v4i32,
/* 15964*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15973*/    0, /*End of Scope*/
/* 15974*/   /*Scope*/ 5|128,1/*133*/, /*->16109*/
/* 15976*/    OPC_RecordChild0, // #0 = $v2
/* 15977*/    OPC_Scope, 48, /*->16027*/ // 2 children in Scope
/* 15979*/     OPC_MoveChild1,
/* 15980*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15983*/     OPC_RecordChild0, // #1 = $c
/* 15984*/     OPC_MoveChild1,
/* 15985*/     OPC_CheckImmAllOnesV,
/* 15986*/     OPC_MoveParent,
/* 15987*/     OPC_MoveParent,
/* 15988*/     OPC_MoveParent,
/* 15989*/     OPC_MoveChild1,
/* 15990*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15993*/     OPC_Scope, 15, /*->16010*/ // 2 children in Scope
/* 15995*/      OPC_CheckChild0Same, 1,
/* 15997*/      OPC_RecordChild1, // #2 = $v1
/* 15998*/      OPC_MoveParent,
/* 15999*/      OPC_CheckType, MVT::v4i32,
/* 16001*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16010*/     /*Scope*/ 15, /*->16026*/
/* 16011*/      OPC_RecordChild0, // #2 = $v1
/* 16012*/      OPC_CheckChild1Same, 1,
/* 16014*/      OPC_MoveParent,
/* 16015*/      OPC_CheckType, MVT::v4i32,
/* 16017*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16026*/     0, /*End of Scope*/
/* 16027*/    /*Scope*/ 80, /*->16108*/
/* 16028*/     OPC_RecordChild1, // #1 = $v1
/* 16029*/     OPC_MoveParent,
/* 16030*/     OPC_MoveChild1,
/* 16031*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16034*/     OPC_Scope, 23, /*->16059*/ // 3 children in Scope
/* 16036*/      OPC_RecordChild0, // #2 = $v2
/* 16037*/      OPC_MoveChild1,
/* 16038*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16041*/      OPC_CheckChild0Same, 0,
/* 16043*/      OPC_MoveChild1,
/* 16044*/      OPC_CheckImmAllOnesV,
/* 16045*/      OPC_MoveParent,
/* 16046*/      OPC_MoveParent,
/* 16047*/      OPC_MoveParent,
/* 16048*/      OPC_CheckType, MVT::v2i64,
/* 16050*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16059*/     /*Scope*/ 23, /*->16083*/
/* 16060*/      OPC_MoveChild0,
/* 16061*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16064*/      OPC_CheckChild0Same, 1,
/* 16066*/      OPC_MoveChild1,
/* 16067*/      OPC_CheckImmAllOnesV,
/* 16068*/      OPC_MoveParent,
/* 16069*/      OPC_MoveParent,
/* 16070*/      OPC_RecordChild1, // #2 = $v2
/* 16071*/      OPC_MoveParent,
/* 16072*/      OPC_CheckType, MVT::v2i64,
/* 16074*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16083*/     /*Scope*/ 23, /*->16107*/
/* 16084*/      OPC_RecordChild0, // #2 = $v2
/* 16085*/      OPC_MoveChild1,
/* 16086*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16089*/      OPC_CheckChild0Same, 1,
/* 16091*/      OPC_MoveChild1,
/* 16092*/      OPC_CheckImmAllOnesV,
/* 16093*/      OPC_MoveParent,
/* 16094*/      OPC_MoveParent,
/* 16095*/      OPC_MoveParent,
/* 16096*/      OPC_CheckType, MVT::v2i64,
/* 16098*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16107*/     0, /*End of Scope*/
/* 16108*/    0, /*End of Scope*/
/* 16109*/   /*Scope*/ 49, /*->16159*/
/* 16110*/    OPC_MoveChild0,
/* 16111*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16114*/    OPC_RecordChild0, // #0 = $c
/* 16115*/    OPC_MoveChild1,
/* 16116*/    OPC_CheckImmAllOnesV,
/* 16117*/    OPC_MoveParent,
/* 16118*/    OPC_MoveParent,
/* 16119*/    OPC_RecordChild1, // #1 = $v2
/* 16120*/    OPC_MoveParent,
/* 16121*/    OPC_MoveChild1,
/* 16122*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16125*/    OPC_Scope, 15, /*->16142*/ // 2 children in Scope
/* 16127*/     OPC_CheckChild0Same, 0,
/* 16129*/     OPC_RecordChild1, // #2 = $v1
/* 16130*/     OPC_MoveParent,
/* 16131*/     OPC_CheckType, MVT::v2i64,
/* 16133*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16142*/    /*Scope*/ 15, /*->16158*/
/* 16143*/     OPC_RecordChild0, // #2 = $v1
/* 16144*/     OPC_CheckChild1Same, 0,
/* 16146*/     OPC_MoveParent,
/* 16147*/     OPC_CheckType, MVT::v2i64,
/* 16149*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16158*/    0, /*End of Scope*/
/* 16159*/   /*Scope*/ 49, /*->16209*/
/* 16160*/    OPC_RecordChild0, // #0 = $v2
/* 16161*/    OPC_MoveChild1,
/* 16162*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16165*/    OPC_RecordChild0, // #1 = $c
/* 16166*/    OPC_MoveChild1,
/* 16167*/    OPC_CheckImmAllOnesV,
/* 16168*/    OPC_MoveParent,
/* 16169*/    OPC_MoveParent,
/* 16170*/    OPC_MoveParent,
/* 16171*/    OPC_MoveChild1,
/* 16172*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16175*/    OPC_Scope, 15, /*->16192*/ // 2 children in Scope
/* 16177*/     OPC_CheckChild0Same, 1,
/* 16179*/     OPC_RecordChild1, // #2 = $v1
/* 16180*/     OPC_MoveParent,
/* 16181*/     OPC_CheckType, MVT::v2i64,
/* 16183*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16192*/    /*Scope*/ 15, /*->16208*/
/* 16193*/     OPC_RecordChild0, // #2 = $v1
/* 16194*/     OPC_CheckChild1Same, 1,
/* 16196*/     OPC_MoveParent,
/* 16197*/     OPC_CheckType, MVT::v2i64,
/* 16199*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16208*/    0, /*End of Scope*/
/* 16209*/   0, /*End of Scope*/
/* 16210*/  /*Scope*/ 44, /*->16255*/
/* 16211*/   OPC_RecordChild0, // #0 = $lhs
/* 16212*/   OPC_RecordChild1, // #1 = $rhs
/* 16213*/   OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->16224
/* 16216*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16224*/   /*SwitchType*/ 8, MVT::v8i16,// ->16234
/* 16226*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16234*/   /*SwitchType*/ 8, MVT::v4i32,// ->16244
/* 16236*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16244*/   /*SwitchType*/ 8, MVT::v2i64,// ->16254
/* 16246*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::OR), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16254*/   0, // EndSwitchType
/* 16255*/  0, /*End of Scope*/
/* 16256*/ /*SwitchOpcode*/ 89|128,12/*1625*/, TARGET_VAL(ISD::XOR),// ->17885
/* 16260*/  OPC_Scope, 24, /*->16286*/ // 17 children in Scope
/* 16262*/   OPC_RecordChild0, // #0 = $lhs
/* 16263*/   OPC_RecordChild1, // #1 = $rhs
/* 16264*/   OPC_SwitchType /*2 cases */, 8, MVT::i32,// ->16275
/* 16267*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_I32), 0,
                  MVT::i32, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 16275*/   /*SwitchType*/ 8, MVT::i64,// ->16285
/* 16277*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR_I64), 0,
                  MVT::i64, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 16285*/   0, // EndSwitchType
/* 16286*/  /*Scope*/ 2|128,1/*130*/, /*->16418*/
/* 16288*/   OPC_MoveChild0,
/* 16289*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16292*/   OPC_MoveChild0,
/* 16293*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16296*/   OPC_RecordChild0, // #0 = $v1
/* 16297*/   OPC_Scope, 77, /*->16376*/ // 2 children in Scope
/* 16299*/    OPC_RecordChild1, // #1 = $v2
/* 16300*/    OPC_MoveParent,
/* 16301*/    OPC_MoveChild1,
/* 16302*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16305*/    OPC_RecordChild0, // #2 = $c
/* 16306*/    OPC_MoveChild1,
/* 16307*/    OPC_CheckImmAllOnesV,
/* 16308*/    OPC_MoveParent,
/* 16309*/    OPC_MoveParent,
/* 16310*/    OPC_MoveParent,
/* 16311*/    OPC_Scope, 48, /*->16361*/ // 2 children in Scope
/* 16313*/     OPC_CheckChild1Same, 1,
/* 16315*/     OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->16327
/* 16318*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16327*/     /*SwitchType*/ 9, MVT::v8i16,// ->16338
/* 16329*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16338*/     /*SwitchType*/ 9, MVT::v4i32,// ->16349
/* 16340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16349*/     /*SwitchType*/ 9, MVT::v2i64,// ->16360
/* 16351*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 16360*/     0, // EndSwitchType
/* 16361*/    /*Scope*/ 13, /*->16375*/
/* 16362*/     OPC_CheckChild1Same, 0,
/* 16364*/     OPC_CheckType, MVT::v16i8,
/* 16366*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16375*/    0, /*End of Scope*/
/* 16376*/   /*Scope*/ 40, /*->16417*/
/* 16377*/    OPC_MoveChild1,
/* 16378*/    OPC_CheckImmAllOnesV,
/* 16379*/    OPC_MoveParent,
/* 16380*/    OPC_MoveParent,
/* 16381*/    OPC_MoveChild1,
/* 16382*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16385*/    OPC_RecordChild0, // #1 = $v1
/* 16386*/    OPC_RecordChild1, // #2 = $v2
/* 16387*/    OPC_MoveParent,
/* 16388*/    OPC_MoveParent,
/* 16389*/    OPC_CheckType, MVT::v16i8,
/* 16391*/    OPC_Scope, 11, /*->16404*/ // 2 children in Scope
/* 16393*/     OPC_CheckChild1Same, 2,
/* 16395*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16404*/    /*Scope*/ 11, /*->16416*/
/* 16405*/     OPC_CheckChild1Same, 1,
/* 16407*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16416*/    0, /*End of Scope*/
/* 16417*/   0, /*End of Scope*/
/* 16418*/  /*Scope*/ 109, /*->16528*/
/* 16419*/   OPC_RecordChild0, // #0 = $v2
/* 16420*/   OPC_MoveChild1,
/* 16421*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16424*/   OPC_MoveChild0,
/* 16425*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16428*/   OPC_Scope, 25, /*->16455*/ // 3 children in Scope
/* 16430*/    OPC_RecordChild0, // #1 = $v1
/* 16431*/    OPC_CheckChild1Same, 0,
/* 16433*/    OPC_MoveParent,
/* 16434*/    OPC_MoveChild1,
/* 16435*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16438*/    OPC_RecordChild0, // #2 = $c
/* 16439*/    OPC_MoveChild1,
/* 16440*/    OPC_CheckImmAllOnesV,
/* 16441*/    OPC_MoveParent,
/* 16442*/    OPC_MoveParent,
/* 16443*/    OPC_MoveParent,
/* 16444*/    OPC_CheckType, MVT::v16i8,
/* 16446*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16455*/   /*Scope*/ 25, /*->16481*/
/* 16456*/    OPC_CheckChild0Same, 0,
/* 16458*/    OPC_RecordChild1, // #1 = $v1
/* 16459*/    OPC_MoveParent,
/* 16460*/    OPC_MoveChild1,
/* 16461*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16464*/    OPC_RecordChild0, // #2 = $c
/* 16465*/    OPC_MoveChild1,
/* 16466*/    OPC_CheckImmAllOnesV,
/* 16467*/    OPC_MoveParent,
/* 16468*/    OPC_MoveParent,
/* 16469*/    OPC_MoveParent,
/* 16470*/    OPC_CheckType, MVT::v16i8,
/* 16472*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16481*/   /*Scope*/ 45, /*->16527*/
/* 16482*/    OPC_RecordChild0, // #1 = $c
/* 16483*/    OPC_MoveChild1,
/* 16484*/    OPC_CheckImmAllOnesV,
/* 16485*/    OPC_MoveParent,
/* 16486*/    OPC_MoveParent,
/* 16487*/    OPC_MoveChild1,
/* 16488*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16491*/    OPC_Scope, 16, /*->16509*/ // 2 children in Scope
/* 16493*/     OPC_RecordChild0, // #2 = $v1
/* 16494*/     OPC_CheckChild1Same, 0,
/* 16496*/     OPC_MoveParent,
/* 16497*/     OPC_MoveParent,
/* 16498*/     OPC_CheckType, MVT::v16i8,
/* 16500*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16509*/    /*Scope*/ 16, /*->16526*/
/* 16510*/     OPC_CheckChild0Same, 0,
/* 16512*/     OPC_RecordChild1, // #2 = $v1
/* 16513*/     OPC_MoveParent,
/* 16514*/     OPC_MoveParent,
/* 16515*/     OPC_CheckType, MVT::v16i8,
/* 16517*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 16526*/    0, /*End of Scope*/
/* 16527*/   0, /*End of Scope*/
/* 16528*/  /*Scope*/ 78, /*->16607*/
/* 16529*/   OPC_MoveChild0,
/* 16530*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16533*/   OPC_MoveChild0,
/* 16534*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16537*/   OPC_RecordChild0, // #0 = $v2
/* 16538*/   OPC_Scope, 25, /*->16565*/ // 2 children in Scope
/* 16540*/    OPC_RecordChild1, // #1 = $v1
/* 16541*/    OPC_MoveParent,
/* 16542*/    OPC_MoveChild1,
/* 16543*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16546*/    OPC_RecordChild0, // #2 = $c
/* 16547*/    OPC_MoveChild1,
/* 16548*/    OPC_CheckImmAllOnesV,
/* 16549*/    OPC_MoveParent,
/* 16550*/    OPC_MoveParent,
/* 16551*/    OPC_MoveParent,
/* 16552*/    OPC_CheckChild1Same, 0,
/* 16554*/    OPC_CheckType, MVT::v8i16,
/* 16556*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16565*/   /*Scope*/ 40, /*->16606*/
/* 16566*/    OPC_MoveChild1,
/* 16567*/    OPC_CheckImmAllOnesV,
/* 16568*/    OPC_MoveParent,
/* 16569*/    OPC_MoveParent,
/* 16570*/    OPC_MoveChild1,
/* 16571*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16574*/    OPC_RecordChild0, // #1 = $v1
/* 16575*/    OPC_RecordChild1, // #2 = $v2
/* 16576*/    OPC_MoveParent,
/* 16577*/    OPC_MoveParent,
/* 16578*/    OPC_CheckType, MVT::v8i16,
/* 16580*/    OPC_Scope, 11, /*->16593*/ // 2 children in Scope
/* 16582*/     OPC_CheckChild1Same, 2,
/* 16584*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16593*/    /*Scope*/ 11, /*->16605*/
/* 16594*/     OPC_CheckChild1Same, 1,
/* 16596*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16605*/    0, /*End of Scope*/
/* 16606*/   0, /*End of Scope*/
/* 16607*/  /*Scope*/ 109, /*->16717*/
/* 16608*/   OPC_RecordChild0, // #0 = $v2
/* 16609*/   OPC_MoveChild1,
/* 16610*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16613*/   OPC_MoveChild0,
/* 16614*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16617*/   OPC_Scope, 25, /*->16644*/ // 3 children in Scope
/* 16619*/    OPC_RecordChild0, // #1 = $v1
/* 16620*/    OPC_CheckChild1Same, 0,
/* 16622*/    OPC_MoveParent,
/* 16623*/    OPC_MoveChild1,
/* 16624*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16627*/    OPC_RecordChild0, // #2 = $c
/* 16628*/    OPC_MoveChild1,
/* 16629*/    OPC_CheckImmAllOnesV,
/* 16630*/    OPC_MoveParent,
/* 16631*/    OPC_MoveParent,
/* 16632*/    OPC_MoveParent,
/* 16633*/    OPC_CheckType, MVT::v8i16,
/* 16635*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16644*/   /*Scope*/ 25, /*->16670*/
/* 16645*/    OPC_CheckChild0Same, 0,
/* 16647*/    OPC_RecordChild1, // #1 = $v1
/* 16648*/    OPC_MoveParent,
/* 16649*/    OPC_MoveChild1,
/* 16650*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16653*/    OPC_RecordChild0, // #2 = $c
/* 16654*/    OPC_MoveChild1,
/* 16655*/    OPC_CheckImmAllOnesV,
/* 16656*/    OPC_MoveParent,
/* 16657*/    OPC_MoveParent,
/* 16658*/    OPC_MoveParent,
/* 16659*/    OPC_CheckType, MVT::v8i16,
/* 16661*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16670*/   /*Scope*/ 45, /*->16716*/
/* 16671*/    OPC_RecordChild0, // #1 = $c
/* 16672*/    OPC_MoveChild1,
/* 16673*/    OPC_CheckImmAllOnesV,
/* 16674*/    OPC_MoveParent,
/* 16675*/    OPC_MoveParent,
/* 16676*/    OPC_MoveChild1,
/* 16677*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16680*/    OPC_Scope, 16, /*->16698*/ // 2 children in Scope
/* 16682*/     OPC_RecordChild0, // #2 = $v1
/* 16683*/     OPC_CheckChild1Same, 0,
/* 16685*/     OPC_MoveParent,
/* 16686*/     OPC_MoveParent,
/* 16687*/     OPC_CheckType, MVT::v8i16,
/* 16689*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16698*/    /*Scope*/ 16, /*->16715*/
/* 16699*/     OPC_CheckChild0Same, 0,
/* 16701*/     OPC_RecordChild1, // #2 = $v1
/* 16702*/     OPC_MoveParent,
/* 16703*/     OPC_MoveParent,
/* 16704*/     OPC_CheckType, MVT::v8i16,
/* 16706*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 16715*/    0, /*End of Scope*/
/* 16716*/   0, /*End of Scope*/
/* 16717*/  /*Scope*/ 78, /*->16796*/
/* 16718*/   OPC_MoveChild0,
/* 16719*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16722*/   OPC_MoveChild0,
/* 16723*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16726*/   OPC_RecordChild0, // #0 = $v2
/* 16727*/   OPC_Scope, 25, /*->16754*/ // 2 children in Scope
/* 16729*/    OPC_RecordChild1, // #1 = $v1
/* 16730*/    OPC_MoveParent,
/* 16731*/    OPC_MoveChild1,
/* 16732*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16735*/    OPC_RecordChild0, // #2 = $c
/* 16736*/    OPC_MoveChild1,
/* 16737*/    OPC_CheckImmAllOnesV,
/* 16738*/    OPC_MoveParent,
/* 16739*/    OPC_MoveParent,
/* 16740*/    OPC_MoveParent,
/* 16741*/    OPC_CheckChild1Same, 0,
/* 16743*/    OPC_CheckType, MVT::v4i32,
/* 16745*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16754*/   /*Scope*/ 40, /*->16795*/
/* 16755*/    OPC_MoveChild1,
/* 16756*/    OPC_CheckImmAllOnesV,
/* 16757*/    OPC_MoveParent,
/* 16758*/    OPC_MoveParent,
/* 16759*/    OPC_MoveChild1,
/* 16760*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16763*/    OPC_RecordChild0, // #1 = $v1
/* 16764*/    OPC_RecordChild1, // #2 = $v2
/* 16765*/    OPC_MoveParent,
/* 16766*/    OPC_MoveParent,
/* 16767*/    OPC_CheckType, MVT::v4i32,
/* 16769*/    OPC_Scope, 11, /*->16782*/ // 2 children in Scope
/* 16771*/     OPC_CheckChild1Same, 2,
/* 16773*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16782*/    /*Scope*/ 11, /*->16794*/
/* 16783*/     OPC_CheckChild1Same, 1,
/* 16785*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16794*/    0, /*End of Scope*/
/* 16795*/   0, /*End of Scope*/
/* 16796*/  /*Scope*/ 109, /*->16906*/
/* 16797*/   OPC_RecordChild0, // #0 = $v2
/* 16798*/   OPC_MoveChild1,
/* 16799*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16802*/   OPC_MoveChild0,
/* 16803*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16806*/   OPC_Scope, 25, /*->16833*/ // 3 children in Scope
/* 16808*/    OPC_RecordChild0, // #1 = $v1
/* 16809*/    OPC_CheckChild1Same, 0,
/* 16811*/    OPC_MoveParent,
/* 16812*/    OPC_MoveChild1,
/* 16813*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16816*/    OPC_RecordChild0, // #2 = $c
/* 16817*/    OPC_MoveChild1,
/* 16818*/    OPC_CheckImmAllOnesV,
/* 16819*/    OPC_MoveParent,
/* 16820*/    OPC_MoveParent,
/* 16821*/    OPC_MoveParent,
/* 16822*/    OPC_CheckType, MVT::v4i32,
/* 16824*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16833*/   /*Scope*/ 25, /*->16859*/
/* 16834*/    OPC_CheckChild0Same, 0,
/* 16836*/    OPC_RecordChild1, // #1 = $v1
/* 16837*/    OPC_MoveParent,
/* 16838*/    OPC_MoveChild1,
/* 16839*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16842*/    OPC_RecordChild0, // #2 = $c
/* 16843*/    OPC_MoveChild1,
/* 16844*/    OPC_CheckImmAllOnesV,
/* 16845*/    OPC_MoveParent,
/* 16846*/    OPC_MoveParent,
/* 16847*/    OPC_MoveParent,
/* 16848*/    OPC_CheckType, MVT::v4i32,
/* 16850*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16859*/   /*Scope*/ 45, /*->16905*/
/* 16860*/    OPC_RecordChild0, // #1 = $c
/* 16861*/    OPC_MoveChild1,
/* 16862*/    OPC_CheckImmAllOnesV,
/* 16863*/    OPC_MoveParent,
/* 16864*/    OPC_MoveParent,
/* 16865*/    OPC_MoveChild1,
/* 16866*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16869*/    OPC_Scope, 16, /*->16887*/ // 2 children in Scope
/* 16871*/     OPC_RecordChild0, // #2 = $v1
/* 16872*/     OPC_CheckChild1Same, 0,
/* 16874*/     OPC_MoveParent,
/* 16875*/     OPC_MoveParent,
/* 16876*/     OPC_CheckType, MVT::v4i32,
/* 16878*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16887*/    /*Scope*/ 16, /*->16904*/
/* 16888*/     OPC_CheckChild0Same, 0,
/* 16890*/     OPC_RecordChild1, // #2 = $v1
/* 16891*/     OPC_MoveParent,
/* 16892*/     OPC_MoveParent,
/* 16893*/     OPC_CheckType, MVT::v4i32,
/* 16895*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 16904*/    0, /*End of Scope*/
/* 16905*/   0, /*End of Scope*/
/* 16906*/  /*Scope*/ 78, /*->16985*/
/* 16907*/   OPC_MoveChild0,
/* 16908*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16911*/   OPC_MoveChild0,
/* 16912*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16915*/   OPC_RecordChild0, // #0 = $v2
/* 16916*/   OPC_Scope, 25, /*->16943*/ // 2 children in Scope
/* 16918*/    OPC_RecordChild1, // #1 = $v1
/* 16919*/    OPC_MoveParent,
/* 16920*/    OPC_MoveChild1,
/* 16921*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16924*/    OPC_RecordChild0, // #2 = $c
/* 16925*/    OPC_MoveChild1,
/* 16926*/    OPC_CheckImmAllOnesV,
/* 16927*/    OPC_MoveParent,
/* 16928*/    OPC_MoveParent,
/* 16929*/    OPC_MoveParent,
/* 16930*/    OPC_CheckChild1Same, 0,
/* 16932*/    OPC_CheckType, MVT::v2i64,
/* 16934*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 16943*/   /*Scope*/ 40, /*->16984*/
/* 16944*/    OPC_MoveChild1,
/* 16945*/    OPC_CheckImmAllOnesV,
/* 16946*/    OPC_MoveParent,
/* 16947*/    OPC_MoveParent,
/* 16948*/    OPC_MoveChild1,
/* 16949*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16952*/    OPC_RecordChild0, // #1 = $v1
/* 16953*/    OPC_RecordChild1, // #2 = $v2
/* 16954*/    OPC_MoveParent,
/* 16955*/    OPC_MoveParent,
/* 16956*/    OPC_CheckType, MVT::v2i64,
/* 16958*/    OPC_Scope, 11, /*->16971*/ // 2 children in Scope
/* 16960*/     OPC_CheckChild1Same, 2,
/* 16962*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 16971*/    /*Scope*/ 11, /*->16983*/
/* 16972*/     OPC_CheckChild1Same, 1,
/* 16974*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 16983*/    0, /*End of Scope*/
/* 16984*/   0, /*End of Scope*/
/* 16985*/  /*Scope*/ 109, /*->17095*/
/* 16986*/   OPC_RecordChild0, // #0 = $v2
/* 16987*/   OPC_MoveChild1,
/* 16988*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16991*/   OPC_MoveChild0,
/* 16992*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16995*/   OPC_Scope, 25, /*->17022*/ // 3 children in Scope
/* 16997*/    OPC_RecordChild0, // #1 = $v1
/* 16998*/    OPC_CheckChild1Same, 0,
/* 17000*/    OPC_MoveParent,
/* 17001*/    OPC_MoveChild1,
/* 17002*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17005*/    OPC_RecordChild0, // #2 = $c
/* 17006*/    OPC_MoveChild1,
/* 17007*/    OPC_CheckImmAllOnesV,
/* 17008*/    OPC_MoveParent,
/* 17009*/    OPC_MoveParent,
/* 17010*/    OPC_MoveParent,
/* 17011*/    OPC_CheckType, MVT::v2i64,
/* 17013*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 17022*/   /*Scope*/ 25, /*->17048*/
/* 17023*/    OPC_CheckChild0Same, 0,
/* 17025*/    OPC_RecordChild1, // #1 = $v1
/* 17026*/    OPC_MoveParent,
/* 17027*/    OPC_MoveChild1,
/* 17028*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17031*/    OPC_RecordChild0, // #2 = $c
/* 17032*/    OPC_MoveChild1,
/* 17033*/    OPC_CheckImmAllOnesV,
/* 17034*/    OPC_MoveParent,
/* 17035*/    OPC_MoveParent,
/* 17036*/    OPC_MoveParent,
/* 17037*/    OPC_CheckType, MVT::v2i64,
/* 17039*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 17048*/   /*Scope*/ 45, /*->17094*/
/* 17049*/    OPC_RecordChild0, // #1 = $c
/* 17050*/    OPC_MoveChild1,
/* 17051*/    OPC_CheckImmAllOnesV,
/* 17052*/    OPC_MoveParent,
/* 17053*/    OPC_MoveParent,
/* 17054*/    OPC_MoveChild1,
/* 17055*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17058*/    OPC_Scope, 16, /*->17076*/ // 2 children in Scope
/* 17060*/     OPC_RecordChild0, // #2 = $v1
/* 17061*/     OPC_CheckChild1Same, 0,
/* 17063*/     OPC_MoveParent,
/* 17064*/     OPC_MoveParent,
/* 17065*/     OPC_CheckType, MVT::v2i64,
/* 17067*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 17076*/    /*Scope*/ 16, /*->17093*/
/* 17077*/     OPC_CheckChild0Same, 0,
/* 17079*/     OPC_RecordChild1, // #2 = $v1
/* 17080*/     OPC_MoveParent,
/* 17081*/     OPC_MoveParent,
/* 17082*/     OPC_CheckType, MVT::v2i64,
/* 17084*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 17093*/    0, /*End of Scope*/
/* 17094*/   0, /*End of Scope*/
/* 17095*/  /*Scope*/ 119, /*->17215*/
/* 17096*/   OPC_MoveChild0,
/* 17097*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17100*/   OPC_Scope, 74, /*->17176*/ // 2 children in Scope
/* 17102*/    OPC_MoveChild0,
/* 17103*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17106*/    OPC_RecordChild0, // #0 = $v1
/* 17107*/    OPC_RecordChild1, // #1 = $v2
/* 17108*/    OPC_MoveParent,
/* 17109*/    OPC_RecordChild1, // #2 = $c
/* 17110*/    OPC_MoveParent,
/* 17111*/    OPC_Scope, 48, /*->17161*/ // 2 children in Scope
/* 17113*/     OPC_CheckChild1Same, 1,
/* 17115*/     OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->17127
/* 17118*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v16i8, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17127*/     /*SwitchType*/ 9, MVT::v8i16,// ->17138
/* 17129*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v8i16, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17138*/     /*SwitchType*/ 9, MVT::v4i32,// ->17149
/* 17140*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v4i32, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17149*/     /*SwitchType*/ 9, MVT::v2i64,// ->17160
/* 17151*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17160*/     0, // EndSwitchType
/* 17161*/    /*Scope*/ 13, /*->17175*/
/* 17162*/     OPC_CheckChild1Same, 0,
/* 17164*/     OPC_CheckType, MVT::v16i8,
/* 17166*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17175*/    0, /*End of Scope*/
/* 17176*/   /*Scope*/ 37, /*->17214*/
/* 17177*/    OPC_RecordChild0, // #0 = $c
/* 17178*/    OPC_MoveChild1,
/* 17179*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17182*/    OPC_RecordChild0, // #1 = $v1
/* 17183*/    OPC_RecordChild1, // #2 = $v2
/* 17184*/    OPC_MoveParent,
/* 17185*/    OPC_MoveParent,
/* 17186*/    OPC_CheckType, MVT::v16i8,
/* 17188*/    OPC_Scope, 11, /*->17201*/ // 2 children in Scope
/* 17190*/     OPC_CheckChild1Same, 2,
/* 17192*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17201*/    /*Scope*/ 11, /*->17213*/
/* 17202*/     OPC_CheckChild1Same, 1,
/* 17204*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17213*/    0, /*End of Scope*/
/* 17214*/   0, /*End of Scope*/
/* 17215*/  /*Scope*/ 92, /*->17308*/
/* 17216*/   OPC_RecordChild0, // #0 = $v2
/* 17217*/   OPC_MoveChild1,
/* 17218*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17221*/   OPC_Scope, 42, /*->17265*/ // 2 children in Scope
/* 17223*/    OPC_MoveChild0,
/* 17224*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17227*/    OPC_Scope, 17, /*->17246*/ // 2 children in Scope
/* 17229*/     OPC_RecordChild0, // #1 = $v1
/* 17230*/     OPC_CheckChild1Same, 0,
/* 17232*/     OPC_MoveParent,
/* 17233*/     OPC_RecordChild1, // #2 = $c
/* 17234*/     OPC_MoveParent,
/* 17235*/     OPC_CheckType, MVT::v16i8,
/* 17237*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17246*/    /*Scope*/ 17, /*->17264*/
/* 17247*/     OPC_CheckChild0Same, 0,
/* 17249*/     OPC_RecordChild1, // #1 = $v1
/* 17250*/     OPC_MoveParent,
/* 17251*/     OPC_RecordChild1, // #2 = $c
/* 17252*/     OPC_MoveParent,
/* 17253*/     OPC_CheckType, MVT::v16i8,
/* 17255*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17264*/    0, /*End of Scope*/
/* 17265*/   /*Scope*/ 41, /*->17307*/
/* 17266*/    OPC_RecordChild0, // #1 = $c
/* 17267*/    OPC_MoveChild1,
/* 17268*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17271*/    OPC_Scope, 16, /*->17289*/ // 2 children in Scope
/* 17273*/     OPC_RecordChild0, // #2 = $v1
/* 17274*/     OPC_CheckChild1Same, 0,
/* 17276*/     OPC_MoveParent,
/* 17277*/     OPC_MoveParent,
/* 17278*/     OPC_CheckType, MVT::v16i8,
/* 17280*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17289*/    /*Scope*/ 16, /*->17306*/
/* 17290*/     OPC_CheckChild0Same, 0,
/* 17292*/     OPC_RecordChild1, // #2 = $v1
/* 17293*/     OPC_MoveParent,
/* 17294*/     OPC_MoveParent,
/* 17295*/     OPC_CheckType, MVT::v16i8,
/* 17297*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v16i8, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 17306*/    0, /*End of Scope*/
/* 17307*/   0, /*End of Scope*/
/* 17308*/  /*Scope*/ 67, /*->17376*/
/* 17309*/   OPC_MoveChild0,
/* 17310*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17313*/   OPC_Scope, 22, /*->17337*/ // 2 children in Scope
/* 17315*/    OPC_MoveChild0,
/* 17316*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17319*/    OPC_RecordChild0, // #0 = $v2
/* 17320*/    OPC_RecordChild1, // #1 = $v1
/* 17321*/    OPC_MoveParent,
/* 17322*/    OPC_RecordChild1, // #2 = $c
/* 17323*/    OPC_MoveParent,
/* 17324*/    OPC_CheckChild1Same, 0,
/* 17326*/    OPC_CheckType, MVT::v8i16,
/* 17328*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17337*/   /*Scope*/ 37, /*->17375*/
/* 17338*/    OPC_RecordChild0, // #0 = $c
/* 17339*/    OPC_MoveChild1,
/* 17340*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17343*/    OPC_RecordChild0, // #1 = $v1
/* 17344*/    OPC_RecordChild1, // #2 = $v2
/* 17345*/    OPC_MoveParent,
/* 17346*/    OPC_MoveParent,
/* 17347*/    OPC_CheckType, MVT::v8i16,
/* 17349*/    OPC_Scope, 11, /*->17362*/ // 2 children in Scope
/* 17351*/     OPC_CheckChild1Same, 2,
/* 17353*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17362*/    /*Scope*/ 11, /*->17374*/
/* 17363*/     OPC_CheckChild1Same, 1,
/* 17365*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17374*/    0, /*End of Scope*/
/* 17375*/   0, /*End of Scope*/
/* 17376*/  /*Scope*/ 92, /*->17469*/
/* 17377*/   OPC_RecordChild0, // #0 = $v2
/* 17378*/   OPC_MoveChild1,
/* 17379*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17382*/   OPC_Scope, 42, /*->17426*/ // 2 children in Scope
/* 17384*/    OPC_MoveChild0,
/* 17385*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17388*/    OPC_Scope, 17, /*->17407*/ // 2 children in Scope
/* 17390*/     OPC_RecordChild0, // #1 = $v1
/* 17391*/     OPC_CheckChild1Same, 0,
/* 17393*/     OPC_MoveParent,
/* 17394*/     OPC_RecordChild1, // #2 = $c
/* 17395*/     OPC_MoveParent,
/* 17396*/     OPC_CheckType, MVT::v8i16,
/* 17398*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17407*/    /*Scope*/ 17, /*->17425*/
/* 17408*/     OPC_CheckChild0Same, 0,
/* 17410*/     OPC_RecordChild1, // #1 = $v1
/* 17411*/     OPC_MoveParent,
/* 17412*/     OPC_RecordChild1, // #2 = $c
/* 17413*/     OPC_MoveParent,
/* 17414*/     OPC_CheckType, MVT::v8i16,
/* 17416*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17425*/    0, /*End of Scope*/
/* 17426*/   /*Scope*/ 41, /*->17468*/
/* 17427*/    OPC_RecordChild0, // #1 = $c
/* 17428*/    OPC_MoveChild1,
/* 17429*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17432*/    OPC_Scope, 16, /*->17450*/ // 2 children in Scope
/* 17434*/     OPC_RecordChild0, // #2 = $v1
/* 17435*/     OPC_CheckChild1Same, 0,
/* 17437*/     OPC_MoveParent,
/* 17438*/     OPC_MoveParent,
/* 17439*/     OPC_CheckType, MVT::v8i16,
/* 17441*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17450*/    /*Scope*/ 16, /*->17467*/
/* 17451*/     OPC_CheckChild0Same, 0,
/* 17453*/     OPC_RecordChild1, // #2 = $v1
/* 17454*/     OPC_MoveParent,
/* 17455*/     OPC_MoveParent,
/* 17456*/     OPC_CheckType, MVT::v8i16,
/* 17458*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v8i16, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 17467*/    0, /*End of Scope*/
/* 17468*/   0, /*End of Scope*/
/* 17469*/  /*Scope*/ 67, /*->17537*/
/* 17470*/   OPC_MoveChild0,
/* 17471*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17474*/   OPC_Scope, 22, /*->17498*/ // 2 children in Scope
/* 17476*/    OPC_MoveChild0,
/* 17477*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17480*/    OPC_RecordChild0, // #0 = $v2
/* 17481*/    OPC_RecordChild1, // #1 = $v1
/* 17482*/    OPC_MoveParent,
/* 17483*/    OPC_RecordChild1, // #2 = $c
/* 17484*/    OPC_MoveParent,
/* 17485*/    OPC_CheckChild1Same, 0,
/* 17487*/    OPC_CheckType, MVT::v4i32,
/* 17489*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17498*/   /*Scope*/ 37, /*->17536*/
/* 17499*/    OPC_RecordChild0, // #0 = $c
/* 17500*/    OPC_MoveChild1,
/* 17501*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17504*/    OPC_RecordChild0, // #1 = $v1
/* 17505*/    OPC_RecordChild1, // #2 = $v2
/* 17506*/    OPC_MoveParent,
/* 17507*/    OPC_MoveParent,
/* 17508*/    OPC_CheckType, MVT::v4i32,
/* 17510*/    OPC_Scope, 11, /*->17523*/ // 2 children in Scope
/* 17512*/     OPC_CheckChild1Same, 2,
/* 17514*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17523*/    /*Scope*/ 11, /*->17535*/
/* 17524*/     OPC_CheckChild1Same, 1,
/* 17526*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17535*/    0, /*End of Scope*/
/* 17536*/   0, /*End of Scope*/
/* 17537*/  /*Scope*/ 92, /*->17630*/
/* 17538*/   OPC_RecordChild0, // #0 = $v2
/* 17539*/   OPC_MoveChild1,
/* 17540*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17543*/   OPC_Scope, 42, /*->17587*/ // 2 children in Scope
/* 17545*/    OPC_MoveChild0,
/* 17546*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17549*/    OPC_Scope, 17, /*->17568*/ // 2 children in Scope
/* 17551*/     OPC_RecordChild0, // #1 = $v1
/* 17552*/     OPC_CheckChild1Same, 0,
/* 17554*/     OPC_MoveParent,
/* 17555*/     OPC_RecordChild1, // #2 = $c
/* 17556*/     OPC_MoveParent,
/* 17557*/     OPC_CheckType, MVT::v4i32,
/* 17559*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17568*/    /*Scope*/ 17, /*->17586*/
/* 17569*/     OPC_CheckChild0Same, 0,
/* 17571*/     OPC_RecordChild1, // #1 = $v1
/* 17572*/     OPC_MoveParent,
/* 17573*/     OPC_RecordChild1, // #2 = $c
/* 17574*/     OPC_MoveParent,
/* 17575*/     OPC_CheckType, MVT::v4i32,
/* 17577*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17586*/    0, /*End of Scope*/
/* 17587*/   /*Scope*/ 41, /*->17629*/
/* 17588*/    OPC_RecordChild0, // #1 = $c
/* 17589*/    OPC_MoveChild1,
/* 17590*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17593*/    OPC_Scope, 16, /*->17611*/ // 2 children in Scope
/* 17595*/     OPC_RecordChild0, // #2 = $v1
/* 17596*/     OPC_CheckChild1Same, 0,
/* 17598*/     OPC_MoveParent,
/* 17599*/     OPC_MoveParent,
/* 17600*/     OPC_CheckType, MVT::v4i32,
/* 17602*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17611*/    /*Scope*/ 16, /*->17628*/
/* 17612*/     OPC_CheckChild0Same, 0,
/* 17614*/     OPC_RecordChild1, // #2 = $v1
/* 17615*/     OPC_MoveParent,
/* 17616*/     OPC_MoveParent,
/* 17617*/     OPC_CheckType, MVT::v4i32,
/* 17619*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v4i32, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 17628*/    0, /*End of Scope*/
/* 17629*/   0, /*End of Scope*/
/* 17630*/  /*Scope*/ 67, /*->17698*/
/* 17631*/   OPC_MoveChild0,
/* 17632*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17635*/   OPC_Scope, 22, /*->17659*/ // 2 children in Scope
/* 17637*/    OPC_MoveChild0,
/* 17638*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17641*/    OPC_RecordChild0, // #0 = $v2
/* 17642*/    OPC_RecordChild1, // #1 = $v1
/* 17643*/    OPC_MoveParent,
/* 17644*/    OPC_RecordChild1, // #2 = $c
/* 17645*/    OPC_MoveParent,
/* 17646*/    OPC_CheckChild1Same, 0,
/* 17648*/    OPC_CheckType, MVT::v2i64,
/* 17650*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17659*/   /*Scope*/ 37, /*->17697*/
/* 17660*/    OPC_RecordChild0, // #0 = $c
/* 17661*/    OPC_MoveChild1,
/* 17662*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17665*/    OPC_RecordChild0, // #1 = $v1
/* 17666*/    OPC_RecordChild1, // #2 = $v2
/* 17667*/    OPC_MoveParent,
/* 17668*/    OPC_MoveParent,
/* 17669*/    OPC_CheckType, MVT::v2i64,
/* 17671*/    OPC_Scope, 11, /*->17684*/ // 2 children in Scope
/* 17673*/     OPC_CheckChild1Same, 2,
/* 17675*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17684*/    /*Scope*/ 11, /*->17696*/
/* 17685*/     OPC_CheckChild1Same, 1,
/* 17687*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                   MVT::v2i64, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17696*/    0, /*End of Scope*/
/* 17697*/   0, /*End of Scope*/
/* 17698*/  /*Scope*/ 56|128,1/*184*/, /*->17884*/
/* 17700*/   OPC_RecordChild0, // #0 = $v2
/* 17701*/   OPC_Scope, 7|128,1/*135*/, /*->17839*/ // 2 children in Scope
/* 17704*/    OPC_MoveChild1,
/* 17705*/    OPC_Scope, 90, /*->17797*/ // 2 children in Scope
/* 17707*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 17710*/     OPC_Scope, 42, /*->17754*/ // 2 children in Scope
/* 17712*/      OPC_MoveChild0,
/* 17713*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17716*/      OPC_Scope, 17, /*->17735*/ // 2 children in Scope
/* 17718*/       OPC_RecordChild0, // #1 = $v1
/* 17719*/       OPC_CheckChild1Same, 0,
/* 17721*/       OPC_MoveParent,
/* 17722*/       OPC_RecordChild1, // #2 = $c
/* 17723*/       OPC_MoveParent,
/* 17724*/       OPC_CheckType, MVT::v2i64,
/* 17726*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17735*/      /*Scope*/ 17, /*->17753*/
/* 17736*/       OPC_CheckChild0Same, 0,
/* 17738*/       OPC_RecordChild1, // #1 = $v1
/* 17739*/       OPC_MoveParent,
/* 17740*/       OPC_RecordChild1, // #2 = $c
/* 17741*/       OPC_MoveParent,
/* 17742*/       OPC_CheckType, MVT::v2i64,
/* 17744*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                     MVT::v2i64, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17753*/      0, /*End of Scope*/
/* 17754*/     /*Scope*/ 41, /*->17796*/
/* 17755*/      OPC_RecordChild0, // #1 = $c
/* 17756*/      OPC_MoveChild1,
/* 17757*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 17760*/      OPC_Scope, 16, /*->17778*/ // 2 children in Scope
/* 17762*/       OPC_RecordChild0, // #2 = $v1
/* 17763*/       OPC_CheckChild1Same, 0,
/* 17765*/       OPC_MoveParent,
/* 17766*/       OPC_MoveParent,
/* 17767*/       OPC_CheckType, MVT::v2i64,
/* 17769*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17778*/      /*Scope*/ 16, /*->17795*/
/* 17779*/       OPC_CheckChild0Same, 0,
/* 17781*/       OPC_RecordChild1, // #2 = $v1
/* 17782*/       OPC_MoveParent,
/* 17783*/       OPC_MoveParent,
/* 17784*/       OPC_CheckType, MVT::v2i64,
/* 17786*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                     MVT::v2i64, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 17795*/      0, /*End of Scope*/
/* 17796*/     0, /*End of Scope*/
/* 17797*/    /*Scope*/ 40, /*->17838*/
/* 17798*/     OPC_CheckImmAllOnesV,
/* 17799*/     OPC_MoveParent,
/* 17800*/     OPC_SwitchType /*4 cases */, 7, MVT::v16i8,// ->17810
/* 17803*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                    MVT::v16i8, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 17810*/     /*SwitchType*/ 7, MVT::v8i16,// ->17819
/* 17812*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                    MVT::v8i16, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 17819*/     /*SwitchType*/ 7, MVT::v4i32,// ->17828
/* 17821*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                    MVT::v4i32, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 17828*/     /*SwitchType*/ 7, MVT::v2i64,// ->17837
/* 17830*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NOT), 0,
                    MVT::v2i64, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 17837*/     0, // EndSwitchType
/* 17838*/    0, /*End of Scope*/
/* 17839*/   /*Scope*/ 43, /*->17883*/
/* 17840*/    OPC_RecordChild1, // #1 = $rhs
/* 17841*/    OPC_SwitchType /*4 cases */, 8, MVT::v16i8,// ->17852
/* 17844*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 17852*/    /*SwitchType*/ 8, MVT::v8i16,// ->17862
/* 17854*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 17862*/    /*SwitchType*/ 8, MVT::v4i32,// ->17872
/* 17864*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 17872*/    /*SwitchType*/ 8, MVT::v2i64,// ->17882
/* 17874*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::XOR), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 17882*/    0, // EndSwitchType
/* 17883*/   0, /*End of Scope*/
/* 17884*/  0, /*End of Scope*/
/* 17885*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::CTLZ),// ->17913
/* 17888*/  OPC_RecordChild0, // #0 = $src
/* 17889*/  OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->17901
/* 17892*/   OPC_CheckChild0Type, MVT::i32,
/* 17894*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CLZ_I32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 17901*/  /*SwitchType*/ 9, MVT::i64,// ->17912
/* 17903*/   OPC_CheckChild0Type, MVT::i64,
/* 17905*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CLZ_I64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 17912*/  0, // EndSwitchType
/* 17913*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::CTTZ),// ->17941
/* 17916*/  OPC_RecordChild0, // #0 = $src
/* 17917*/  OPC_SwitchType /*2 cases */, 9, MVT::i32,// ->17929
/* 17920*/   OPC_CheckChild0Type, MVT::i32,
/* 17922*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CTZ_I32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 17929*/  /*SwitchType*/ 9, MVT::i64,// ->17940
/* 17931*/   OPC_CheckChild0Type, MVT::i64,
/* 17933*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CTZ_I64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 17940*/  0, // EndSwitchType
/* 17941*/ /*SwitchOpcode*/ 38, TARGET_VAL(ISD::CTPOP),// ->17982
/* 17944*/  OPC_RecordChild0, // #0 = $src
/* 17945*/  OPC_SwitchType /*3 cases */, 9, MVT::i32,// ->17957
/* 17948*/   OPC_CheckChild0Type, MVT::i32,
/* 17950*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 17957*/  /*SwitchType*/ 9, MVT::i64,// ->17968
/* 17959*/   OPC_CheckChild0Type, MVT::i64,
/* 17961*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 17968*/  /*SwitchType*/ 11, MVT::v16i8,// ->17981
/* 17970*/   OPC_CheckChild0Type, MVT::v16i8,
/* 17972*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 17974*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::POPCNT_I8x16), 0,
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 17981*/  0, // EndSwitchType
/* 17982*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::TRUNCATE),// ->17993
/* 17985*/  OPC_RecordChild0, // #0 = $src
/* 17986*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                MVT::i32, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 17993*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::SIGN_EXTEND),// ->18004
/* 17996*/  OPC_RecordChild0, // #0 = $src
/* 17997*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32), 0,
                MVT::i64, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 18004*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_SINT),// ->18128
/* 18007*/  OPC_RecordChild0, // #0 = $src
/* 18008*/  OPC_Scope, 52, /*->18062*/ // 3 children in Scope
/* 18010*/   OPC_CheckChild0Type, MVT::f32,
/* 18012*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->18037
/* 18015*/    OPC_Scope, 9, /*->18026*/ // 2 children in Scope
/* 18017*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18019*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18026*/    /*Scope*/ 9, /*->18036*/
/* 18027*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18029*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18036*/    0, /*End of Scope*/
/* 18037*/   /*SwitchType*/ 22, MVT::i64,// ->18061
/* 18039*/    OPC_Scope, 9, /*->18050*/ // 2 children in Scope
/* 18041*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18043*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18050*/    /*Scope*/ 9, /*->18060*/
/* 18051*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18053*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18060*/    0, /*End of Scope*/
/* 18061*/   0, // EndSwitchType
/* 18062*/  /*Scope*/ 52, /*->18115*/
/* 18063*/   OPC_CheckChild0Type, MVT::f64,
/* 18065*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->18090
/* 18068*/    OPC_Scope, 9, /*->18079*/ // 2 children in Scope
/* 18070*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18072*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18079*/    /*Scope*/ 9, /*->18089*/
/* 18080*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18082*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18089*/    0, /*End of Scope*/
/* 18090*/   /*SwitchType*/ 22, MVT::i64,// ->18114
/* 18092*/    OPC_Scope, 9, /*->18103*/ // 2 children in Scope
/* 18094*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18096*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18103*/    /*Scope*/ 9, /*->18113*/
/* 18104*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18106*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18113*/    0, /*End of Scope*/
/* 18114*/   0, // EndSwitchType
/* 18115*/  /*Scope*/ 11, /*->18127*/
/* 18116*/   OPC_CheckType, MVT::v4i32,
/* 18118*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18120*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_sint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 18127*/  0, /*End of Scope*/
/* 18128*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_UINT),// ->18252
/* 18131*/  OPC_RecordChild0, // #0 = $src
/* 18132*/  OPC_Scope, 52, /*->18186*/ // 3 children in Scope
/* 18134*/   OPC_CheckChild0Type, MVT::f32,
/* 18136*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->18161
/* 18139*/    OPC_Scope, 9, /*->18150*/ // 2 children in Scope
/* 18141*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18143*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18150*/    /*Scope*/ 9, /*->18160*/
/* 18151*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18153*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18160*/    0, /*End of Scope*/
/* 18161*/   /*SwitchType*/ 22, MVT::i64,// ->18185
/* 18163*/    OPC_Scope, 9, /*->18174*/ // 2 children in Scope
/* 18165*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18167*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18174*/    /*Scope*/ 9, /*->18184*/
/* 18175*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18177*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18184*/    0, /*End of Scope*/
/* 18185*/   0, // EndSwitchType
/* 18186*/  /*Scope*/ 52, /*->18239*/
/* 18187*/   OPC_CheckChild0Type, MVT::f64,
/* 18189*/   OPC_SwitchType /*2 cases */, 22, MVT::i32,// ->18214
/* 18192*/    OPC_Scope, 9, /*->18203*/ // 2 children in Scope
/* 18194*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18196*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18203*/    /*Scope*/ 9, /*->18213*/
/* 18204*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18206*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64), 0,
                   MVT::i32, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18213*/    0, /*End of Scope*/
/* 18214*/   /*SwitchType*/ 22, MVT::i64,// ->18238
/* 18216*/    OPC_Scope, 9, /*->18227*/ // 2 children in Scope
/* 18218*/     OPC_CheckPatternPredicate, 14, // (Subtarget->hasNontrappingFPToInt())
/* 18220*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18227*/    /*Scope*/ 9, /*->18237*/
/* 18228*/     OPC_CheckPatternPredicate, 15, // (!Subtarget->hasNontrappingFPToInt())
/* 18230*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64), 0,
                   MVT::i64, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18237*/    0, /*End of Scope*/
/* 18238*/   0, // EndSwitchType
/* 18239*/  /*Scope*/ 11, /*->18251*/
/* 18240*/   OPC_CheckType, MVT::v4i32,
/* 18242*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18244*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_uint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 18251*/  0, /*End of Scope*/
/* 18252*/ /*SwitchOpcode*/ 81, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->18336
/* 18255*/  OPC_RecordChild0, // #0 = $src
/* 18256*/  OPC_Scope, 31, /*->18289*/ // 3 children in Scope
/* 18258*/   OPC_CheckChild0Type, MVT::f32,
/* 18260*/   OPC_MoveChild1,
/* 18261*/   OPC_Scope, 12, /*->18275*/ // 2 children in Scope
/* 18263*/    OPC_CheckValueType, MVT::i32,
/* 18265*/    OPC_MoveParent,
/* 18266*/    OPC_CheckType, MVT::i32,
/* 18268*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18275*/   /*Scope*/ 12, /*->18288*/
/* 18276*/    OPC_CheckValueType, MVT::i64,
/* 18278*/    OPC_MoveParent,
/* 18279*/    OPC_CheckType, MVT::i64,
/* 18281*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18288*/   0, /*End of Scope*/
/* 18289*/  /*Scope*/ 31, /*->18321*/
/* 18290*/   OPC_CheckChild0Type, MVT::f64,
/* 18292*/   OPC_MoveChild1,
/* 18293*/   OPC_Scope, 12, /*->18307*/ // 2 children in Scope
/* 18295*/    OPC_CheckValueType, MVT::i32,
/* 18297*/    OPC_MoveParent,
/* 18298*/    OPC_CheckType, MVT::i32,
/* 18300*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18307*/   /*Scope*/ 12, /*->18320*/
/* 18308*/    OPC_CheckValueType, MVT::i64,
/* 18310*/    OPC_MoveParent,
/* 18311*/    OPC_CheckType, MVT::i64,
/* 18313*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18320*/   0, /*End of Scope*/
/* 18321*/  /*Scope*/ 13, /*->18335*/
/* 18322*/   OPC_MoveChild1,
/* 18323*/   OPC_CheckValueType, MVT::i32,
/* 18325*/   OPC_MoveParent,
/* 18326*/   OPC_CheckType, MVT::v4i32,
/* 18328*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_sint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 18335*/  0, /*End of Scope*/
/* 18336*/ /*SwitchOpcode*/ 81, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->18420
/* 18339*/  OPC_RecordChild0, // #0 = $src
/* 18340*/  OPC_Scope, 31, /*->18373*/ // 3 children in Scope
/* 18342*/   OPC_CheckChild0Type, MVT::f32,
/* 18344*/   OPC_MoveChild1,
/* 18345*/   OPC_Scope, 12, /*->18359*/ // 2 children in Scope
/* 18347*/    OPC_CheckValueType, MVT::i32,
/* 18349*/    OPC_MoveParent,
/* 18350*/    OPC_CheckType, MVT::i32,
/* 18352*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18359*/   /*Scope*/ 12, /*->18372*/
/* 18360*/    OPC_CheckValueType, MVT::i64,
/* 18362*/    OPC_MoveParent,
/* 18363*/    OPC_CheckType, MVT::i64,
/* 18365*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 18372*/   0, /*End of Scope*/
/* 18373*/  /*Scope*/ 31, /*->18405*/
/* 18374*/   OPC_CheckChild0Type, MVT::f64,
/* 18376*/   OPC_MoveChild1,
/* 18377*/   OPC_Scope, 12, /*->18391*/ // 2 children in Scope
/* 18379*/    OPC_CheckValueType, MVT::i32,
/* 18381*/    OPC_MoveParent,
/* 18382*/    OPC_CheckType, MVT::i32,
/* 18384*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64), 0,
                  MVT::i32, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 18391*/   /*Scope*/ 12, /*->18404*/
/* 18392*/    OPC_CheckValueType, MVT::i64,
/* 18394*/    OPC_MoveParent,
/* 18395*/    OPC_CheckType, MVT::i64,
/* 18397*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64), 0,
                  MVT::i64, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18404*/   0, /*End of Scope*/
/* 18405*/  /*Scope*/ 13, /*->18419*/
/* 18406*/   OPC_MoveChild1,
/* 18407*/   OPC_CheckValueType, MVT::i32,
/* 18409*/   OPC_MoveParent,
/* 18410*/   OPC_CheckType, MVT::v4i32,
/* 18412*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::fp_to_uint_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 18419*/  0, /*End of Scope*/
/* 18420*/ /*SwitchOpcode*/ 103|128,1/*231*/, TARGET_VAL(ISD::BITCAST),// ->18655
/* 18424*/  OPC_RecordChild0, // #0 = $src
/* 18425*/  OPC_Scope, 11, /*->18438*/ // 10 children in Scope
/* 18427*/   OPC_CheckChild0Type, MVT::f32,
/* 18429*/   OPC_CheckType, MVT::i32,
/* 18431*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32), 0,
                 MVT::i32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 18438*/  /*Scope*/ 11, /*->18450*/
/* 18439*/   OPC_CheckChild0Type, MVT::f64,
/* 18441*/   OPC_CheckType, MVT::i64,
/* 18443*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64), 0,
                 MVT::i64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 18450*/  /*Scope*/ 11, /*->18462*/
/* 18451*/   OPC_CheckChild0Type, MVT::i32,
/* 18453*/   OPC_CheckType, MVT::f32,
/* 18455*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 18462*/  /*Scope*/ 11, /*->18474*/
/* 18463*/   OPC_CheckChild0Type, MVT::i64,
/* 18465*/   OPC_CheckType, MVT::f64,
/* 18467*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 18474*/  /*Scope*/ 29, /*->18504*/
/* 18475*/   OPC_CheckChild0Type, MVT::v8i16,
/* 18477*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->18483
/* 18480*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 18483*/   /*SwitchType*/ 3, MVT::v4i32,// ->18488
/* 18485*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 18488*/   /*SwitchType*/ 3, MVT::v2i64,// ->18493
/* 18490*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 18493*/   /*SwitchType*/ 3, MVT::v4f32,// ->18498
/* 18495*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 18498*/   /*SwitchType*/ 3, MVT::v2f64,// ->18503
/* 18500*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 18503*/   0, // EndSwitchType
/* 18504*/  /*Scope*/ 29, /*->18534*/
/* 18505*/   OPC_CheckChild0Type, MVT::v4i32,
/* 18507*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->18513
/* 18510*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 18513*/   /*SwitchType*/ 3, MVT::v8i16,// ->18518
/* 18515*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 18518*/   /*SwitchType*/ 3, MVT::v2i64,// ->18523
/* 18520*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 18523*/   /*SwitchType*/ 3, MVT::v4f32,// ->18528
/* 18525*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 18528*/   /*SwitchType*/ 3, MVT::v2f64,// ->18533
/* 18530*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 18533*/   0, // EndSwitchType
/* 18534*/  /*Scope*/ 29, /*->18564*/
/* 18535*/   OPC_CheckChild0Type, MVT::v2i64,
/* 18537*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->18543
/* 18540*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 18543*/   /*SwitchType*/ 3, MVT::v8i16,// ->18548
/* 18545*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 18548*/   /*SwitchType*/ 3, MVT::v4i32,// ->18553
/* 18550*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 18553*/   /*SwitchType*/ 3, MVT::v4f32,// ->18558
/* 18555*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 18558*/   /*SwitchType*/ 3, MVT::v2f64,// ->18563
/* 18560*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 18563*/   0, // EndSwitchType
/* 18564*/  /*Scope*/ 29, /*->18594*/
/* 18565*/   OPC_CheckChild0Type, MVT::v4f32,
/* 18567*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->18573
/* 18570*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 18573*/   /*SwitchType*/ 3, MVT::v8i16,// ->18578
/* 18575*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 18578*/   /*SwitchType*/ 3, MVT::v4i32,// ->18583
/* 18580*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 18583*/   /*SwitchType*/ 3, MVT::v2i64,// ->18588
/* 18585*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 18588*/   /*SwitchType*/ 3, MVT::v2f64,// ->18593
/* 18590*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 18593*/   0, // EndSwitchType
/* 18594*/  /*Scope*/ 29, /*->18624*/
/* 18595*/   OPC_CheckChild0Type, MVT::v2f64,
/* 18597*/   OPC_SwitchType /*5 cases */, 3, MVT::v16i8,// ->18603
/* 18600*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 18603*/   /*SwitchType*/ 3, MVT::v8i16,// ->18608
/* 18605*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 18608*/   /*SwitchType*/ 3, MVT::v4i32,// ->18613
/* 18610*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 18613*/   /*SwitchType*/ 3, MVT::v2i64,// ->18618
/* 18615*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 18618*/   /*SwitchType*/ 3, MVT::v4f32,// ->18623
/* 18620*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 18623*/   0, // EndSwitchType
/* 18624*/  /*Scope*/ 29, /*->18654*/
/* 18625*/   OPC_CheckChild0Type, MVT::v16i8,
/* 18627*/   OPC_SwitchType /*5 cases */, 3, MVT::v8i16,// ->18633
/* 18630*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 18633*/   /*SwitchType*/ 3, MVT::v4i32,// ->18638
/* 18635*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 18638*/   /*SwitchType*/ 3, MVT::v2i64,// ->18643
/* 18640*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 18643*/   /*SwitchType*/ 3, MVT::v4f32,// ->18648
/* 18645*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 18648*/   /*SwitchType*/ 3, MVT::v2f64,// ->18653
/* 18650*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 18653*/   0, // EndSwitchType
/* 18654*/  0, /*End of Scope*/
/* 18655*/ /*SwitchOpcode*/ 25, TARGET_VAL(ISD::ConstantFP),// ->18683
/* 18658*/  OPC_RecordNode, // #0 = $imm
/* 18659*/  OPC_SwitchType /*2 cases */, 9, MVT::f32,// ->18671
/* 18662*/   OPC_EmitConvertToTarget, 0,
/* 18664*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_F32), 0,
                 MVT::f32, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 18671*/  /*SwitchType*/ 9, MVT::f64,// ->18682
/* 18673*/   OPC_EmitConvertToTarget, 0,
/* 18675*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_F64), 0,
                 MVT::f64, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 18682*/  0, // EndSwitchType
/* 18683*/ /*SwitchOpcode*/ 61, TARGET_VAL(ISD::SINT_TO_FP),// ->18747
/* 18686*/  OPC_RecordChild0, // #0 = $src
/* 18687*/  OPC_Scope, 22, /*->18711*/ // 3 children in Scope
/* 18689*/   OPC_CheckChild0Type, MVT::i32,
/* 18691*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->18701
/* 18694*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 18701*/   /*SwitchType*/ 7, MVT::f64,// ->18710
/* 18703*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 18710*/   0, // EndSwitchType
/* 18711*/  /*Scope*/ 22, /*->18734*/
/* 18712*/   OPC_CheckChild0Type, MVT::i64,
/* 18714*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->18724
/* 18717*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 18724*/   /*SwitchType*/ 7, MVT::f64,// ->18733
/* 18726*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 18733*/   0, // EndSwitchType
/* 18734*/  /*Scope*/ 11, /*->18746*/
/* 18735*/   OPC_CheckType, MVT::v4f32,
/* 18737*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18739*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::sint_to_fp_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 18746*/  0, /*End of Scope*/
/* 18747*/ /*SwitchOpcode*/ 61, TARGET_VAL(ISD::UINT_TO_FP),// ->18811
/* 18750*/  OPC_RecordChild0, // #0 = $src
/* 18751*/  OPC_Scope, 22, /*->18775*/ // 3 children in Scope
/* 18753*/   OPC_CheckChild0Type, MVT::i32,
/* 18755*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->18765
/* 18758*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 18765*/   /*SwitchType*/ 7, MVT::f64,// ->18774
/* 18767*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 18774*/   0, // EndSwitchType
/* 18775*/  /*Scope*/ 22, /*->18798*/
/* 18776*/   OPC_CheckChild0Type, MVT::i64,
/* 18778*/   OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->18788
/* 18781*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64), 0,
                  MVT::f32, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 18788*/   /*SwitchType*/ 7, MVT::f64,// ->18797
/* 18790*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64), 0,
                  MVT::f64, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 18797*/   0, // EndSwitchType
/* 18798*/  /*Scope*/ 11, /*->18810*/
/* 18799*/   OPC_CheckType, MVT::v4f32,
/* 18801*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18803*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::uint_to_fp_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 18810*/  0, /*End of Scope*/
/* 18811*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::FP_EXTEND),// ->18822
/* 18814*/  OPC_RecordChild0, // #0 = $src
/* 18815*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F64_PROMOTE_F32), 0,
                MVT::f64, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 18822*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::FP_ROUND),// ->18833
/* 18825*/  OPC_RecordChild0, // #0 = $src
/* 18826*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::F32_DEMOTE_F64), 0,
                MVT::f32, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 18833*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FADD),// ->18884
/* 18836*/  OPC_RecordChild0, // #0 = $lhs
/* 18837*/  OPC_RecordChild1, // #1 = $rhs
/* 18838*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->18849
/* 18841*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18849*/  /*SwitchType*/ 8, MVT::f64,// ->18859
/* 18851*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18859*/  /*SwitchType*/ 10, MVT::v4f32,// ->18871
/* 18861*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18863*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18871*/  /*SwitchType*/ 10, MVT::v2f64,// ->18883
/* 18873*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18875*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18883*/  0, // EndSwitchType
/* 18884*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FSUB),// ->18935
/* 18887*/  OPC_RecordChild0, // #0 = $lhs
/* 18888*/  OPC_RecordChild1, // #1 = $rhs
/* 18889*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->18900
/* 18892*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18900*/  /*SwitchType*/ 8, MVT::f64,// ->18910
/* 18902*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18910*/  /*SwitchType*/ 10, MVT::v4f32,// ->18922
/* 18912*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18914*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18922*/  /*SwitchType*/ 10, MVT::v2f64,// ->18934
/* 18924*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18926*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SUB_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18934*/  0, // EndSwitchType
/* 18935*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMUL),// ->18986
/* 18938*/  OPC_RecordChild0, // #0 = $lhs
/* 18939*/  OPC_RecordChild1, // #1 = $rhs
/* 18940*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->18951
/* 18943*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18951*/  /*SwitchType*/ 8, MVT::f64,// ->18961
/* 18953*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18961*/  /*SwitchType*/ 10, MVT::v4f32,// ->18973
/* 18963*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18965*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18973*/  /*SwitchType*/ 10, MVT::v2f64,// ->18985
/* 18975*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 18977*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MUL_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18985*/  0, // EndSwitchType
/* 18986*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FDIV),// ->19037
/* 18989*/  OPC_RecordChild0, // #0 = $lhs
/* 18990*/  OPC_RecordChild1, // #1 = $rhs
/* 18991*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->19002
/* 18994*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 19002*/  /*SwitchType*/ 8, MVT::f64,// ->19012
/* 19004*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 19012*/  /*SwitchType*/ 10, MVT::v4f32,// ->19024
/* 19014*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19016*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 19024*/  /*SwitchType*/ 10, MVT::v2f64,// ->19036
/* 19026*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19028*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::DIV_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 19036*/  0, // EndSwitchType
/* 19037*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FSQRT),// ->19083
/* 19040*/  OPC_RecordChild0, // #0 = $src
/* 19041*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19051
/* 19044*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19051*/  /*SwitchType*/ 7, MVT::f64,// ->19060
/* 19053*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19060*/  /*SwitchType*/ 9, MVT::v4f32,// ->19071
/* 19062*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19064*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19071*/  /*SwitchType*/ 9, MVT::v2f64,// ->19082
/* 19073*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19075*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SQRT_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19082*/  0, // EndSwitchType
/* 19083*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FABS),// ->19129
/* 19086*/  OPC_RecordChild0, // #0 = $src
/* 19087*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19097
/* 19090*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19097*/  /*SwitchType*/ 7, MVT::f64,// ->19106
/* 19099*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19106*/  /*SwitchType*/ 9, MVT::v4f32,// ->19117
/* 19108*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19110*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19117*/  /*SwitchType*/ 9, MVT::v2f64,// ->19128
/* 19119*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19121*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19128*/  0, // EndSwitchType
/* 19129*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FNEG),// ->19175
/* 19132*/  OPC_RecordChild0, // #0 = $src
/* 19133*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19143
/* 19136*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19143*/  /*SwitchType*/ 7, MVT::f64,// ->19152
/* 19145*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19152*/  /*SwitchType*/ 9, MVT::v4f32,// ->19163
/* 19154*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19156*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19163*/  /*SwitchType*/ 9, MVT::v2f64,// ->19174
/* 19165*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19167*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEG_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19174*/  0, // EndSwitchType
/* 19175*/ /*SwitchOpcode*/ 68, TARGET_VAL(ISD::FCOPYSIGN),// ->19246
/* 19178*/  OPC_RecordChild0, // #0 = $lhs
/* 19179*/  OPC_RecordChild1, // #1 = $rhs
/* 19180*/  OPC_Scope, 31, /*->19213*/ // 2 children in Scope
/* 19182*/   OPC_CheckChild1Type, MVT::f32,
/* 19184*/   OPC_SwitchType /*2 cases */, 8, MVT::f32,// ->19195
/* 19187*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F32), 0,
                  MVT::f32, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 19195*/   /*SwitchType*/ 15, MVT::f64,// ->19212
/* 19197*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::F64_PROMOTE_F32), 0,
                  MVT::f64, 1/*#Ops*/, 1,  // Results = #2
/* 19204*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F64), 0,
                  MVT::f64, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 19212*/   0, // EndSwitchType
/* 19213*/  /*Scope*/ 31, /*->19245*/
/* 19214*/   OPC_CheckChild1Type, MVT::f64,
/* 19216*/   OPC_SwitchType /*2 cases */, 8, MVT::f64,// ->19227
/* 19219*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F64), 0,
                  MVT::f64, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 19227*/   /*SwitchType*/ 15, MVT::f32,// ->19244
/* 19229*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::F32_DEMOTE_F64), 0,
                  MVT::f32, 1/*#Ops*/, 1,  // Results = #2
/* 19236*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::COPYSIGN_F32), 0,
                  MVT::f32, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 19244*/   0, // EndSwitchType
/* 19245*/  0, /*End of Scope*/
/* 19246*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMINIMUM),// ->19297
/* 19249*/  OPC_RecordChild0, // #0 = $lhs
/* 19250*/  OPC_RecordChild1, // #1 = $rhs
/* 19251*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->19262
/* 19254*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 19262*/  /*SwitchType*/ 8, MVT::f64,// ->19272
/* 19264*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 19272*/  /*SwitchType*/ 10, MVT::v4f32,// ->19284
/* 19274*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19276*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 19284*/  /*SwitchType*/ 10, MVT::v2f64,// ->19296
/* 19286*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19288*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 19296*/  0, // EndSwitchType
/* 19297*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FMAXIMUM),// ->19348
/* 19300*/  OPC_RecordChild0, // #0 = $lhs
/* 19301*/  OPC_RecordChild1, // #1 = $rhs
/* 19302*/  OPC_SwitchType /*4 cases */, 8, MVT::f32,// ->19313
/* 19305*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F32), 0,
                 MVT::f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 19313*/  /*SwitchType*/ 8, MVT::f64,// ->19323
/* 19315*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F64), 0,
                 MVT::f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 19323*/  /*SwitchType*/ 10, MVT::v4f32,// ->19335
/* 19325*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19327*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F32x4), 0,
                 MVT::v4f32, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 19335*/  /*SwitchType*/ 10, MVT::v2f64,// ->19347
/* 19337*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19339*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_F64x2), 0,
                 MVT::v2f64, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 19347*/  0, // EndSwitchType
/* 19348*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FCEIL),// ->19394
/* 19351*/  OPC_RecordChild0, // #0 = $src
/* 19352*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19362
/* 19355*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19362*/  /*SwitchType*/ 7, MVT::f64,// ->19371
/* 19364*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19371*/  /*SwitchType*/ 9, MVT::v4f32,// ->19382
/* 19373*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19375*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19382*/  /*SwitchType*/ 9, MVT::v2f64,// ->19393
/* 19384*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19386*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CEIL_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19393*/  0, // EndSwitchType
/* 19394*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FFLOOR),// ->19440
/* 19397*/  OPC_RecordChild0, // #0 = $src
/* 19398*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19408
/* 19401*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19408*/  /*SwitchType*/ 7, MVT::f64,// ->19417
/* 19410*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19417*/  /*SwitchType*/ 9, MVT::v4f32,// ->19428
/* 19419*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19421*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19428*/  /*SwitchType*/ 9, MVT::v2f64,// ->19439
/* 19430*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19432*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::FLOOR_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19439*/  0, // EndSwitchType
/* 19440*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FTRUNC),// ->19486
/* 19443*/  OPC_RecordChild0, // #0 = $src
/* 19444*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19454
/* 19447*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19454*/  /*SwitchType*/ 7, MVT::f64,// ->19463
/* 19456*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19463*/  /*SwitchType*/ 9, MVT::v4f32,// ->19474
/* 19465*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19467*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19474*/  /*SwitchType*/ 9, MVT::v2f64,// ->19485
/* 19476*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19478*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TRUNC_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19485*/  0, // EndSwitchType
/* 19486*/ /*SwitchOpcode*/ 43, TARGET_VAL(ISD::FNEARBYINT),// ->19532
/* 19489*/  OPC_RecordChild0, // #0 = $src
/* 19490*/  OPC_SwitchType /*4 cases */, 7, MVT::f32,// ->19500
/* 19493*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 19500*/  /*SwitchType*/ 7, MVT::f64,// ->19509
/* 19502*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 19509*/  /*SwitchType*/ 9, MVT::v4f32,// ->19520
/* 19511*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19513*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32x4), 0,
                 MVT::v4f32, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 19520*/  /*SwitchType*/ 9, MVT::v2f64,// ->19531
/* 19522*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19524*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64x2), 0,
                 MVT::v2f64, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 19531*/  0, // EndSwitchType
/* 19532*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::FRINT),// ->19556
/* 19535*/  OPC_RecordChild0, // #0 = $src
/* 19536*/  OPC_SwitchType /*2 cases */, 7, MVT::f32,// ->19546
/* 19539*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F32), 0,
                 MVT::f32, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 19546*/  /*SwitchType*/ 7, MVT::f64,// ->19555
/* 19548*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NEAREST_F64), 0,
                 MVT::f64, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 19555*/  0, // EndSwitchType
/* 19556*/ /*SwitchOpcode*/ 116|128,3/*500*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->20060
/* 19560*/  OPC_RecordChild0, // #0 = $i0
/* 19561*/  OPC_MoveChild0,
/* 19562*/  OPC_SwitchOpcode /*2 cases */, 27|128,3/*411*/, TARGET_VAL(ISD::Constant),// ->19978
/* 19567*/   OPC_SwitchType /*2 cases */, 123|128,2/*379*/, MVT::i32,// ->19950
/* 19571*/    OPC_Scope, 91|128,1/*219*/, /*->19793*/ // 3 children in Scope
/* 19574*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19576*/     OPC_MoveParent,
/* 19577*/     OPC_RecordChild1, // #1 = $i1
/* 19578*/     OPC_MoveChild1,
/* 19579*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19582*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19584*/     OPC_CheckType, MVT::i32,
/* 19586*/     OPC_MoveParent,
/* 19587*/     OPC_RecordChild2, // #2 = $i2
/* 19588*/     OPC_MoveChild2,
/* 19589*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19592*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19594*/     OPC_CheckType, MVT::i32,
/* 19596*/     OPC_MoveParent,
/* 19597*/     OPC_RecordChild3, // #3 = $i3
/* 19598*/     OPC_MoveChild3,
/* 19599*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19602*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19604*/     OPC_CheckType, MVT::i32,
/* 19606*/     OPC_MoveParent,
/* 19607*/     OPC_RecordChild4, // #4 = $i4
/* 19608*/     OPC_MoveChild4,
/* 19609*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19612*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19614*/     OPC_CheckType, MVT::i32,
/* 19616*/     OPC_MoveParent,
/* 19617*/     OPC_RecordChild5, // #5 = $i5
/* 19618*/     OPC_MoveChild5,
/* 19619*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19622*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19624*/     OPC_CheckType, MVT::i32,
/* 19626*/     OPC_MoveParent,
/* 19627*/     OPC_RecordChild6, // #6 = $i6
/* 19628*/     OPC_MoveChild6,
/* 19629*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19632*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19634*/     OPC_CheckType, MVT::i32,
/* 19636*/     OPC_MoveParent,
/* 19637*/     OPC_RecordChild7, // #7 = $i7
/* 19638*/     OPC_MoveChild7,
/* 19639*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19642*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19644*/     OPC_CheckType, MVT::i32,
/* 19646*/     OPC_MoveParent,
/* 19647*/     OPC_MoveChild, 8,
/* 19649*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19652*/     OPC_RecordNode, // #8 = $i8
/* 19653*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19655*/     OPC_CheckType, MVT::i32,
/* 19657*/     OPC_MoveParent,
/* 19658*/     OPC_MoveChild, 9,
/* 19660*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19663*/     OPC_RecordNode, // #9 = $i9
/* 19664*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19666*/     OPC_CheckType, MVT::i32,
/* 19668*/     OPC_MoveParent,
/* 19669*/     OPC_MoveChild, 10,
/* 19671*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19674*/     OPC_RecordNode, // #10 = $iA
/* 19675*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19677*/     OPC_CheckType, MVT::i32,
/* 19679*/     OPC_MoveParent,
/* 19680*/     OPC_MoveChild, 11,
/* 19682*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19685*/     OPC_RecordNode, // #11 = $iB
/* 19686*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19688*/     OPC_CheckType, MVT::i32,
/* 19690*/     OPC_MoveParent,
/* 19691*/     OPC_MoveChild, 12,
/* 19693*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19696*/     OPC_RecordNode, // #12 = $iC
/* 19697*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19699*/     OPC_CheckType, MVT::i32,
/* 19701*/     OPC_MoveParent,
/* 19702*/     OPC_MoveChild, 13,
/* 19704*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19707*/     OPC_RecordNode, // #13 = $iD
/* 19708*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19710*/     OPC_CheckType, MVT::i32,
/* 19712*/     OPC_MoveParent,
/* 19713*/     OPC_MoveChild, 14,
/* 19715*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19718*/     OPC_RecordNode, // #14 = $iE
/* 19719*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19721*/     OPC_CheckType, MVT::i32,
/* 19723*/     OPC_MoveParent,
/* 19724*/     OPC_MoveChild, 15,
/* 19726*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19729*/     OPC_RecordNode, // #15 = $iF
/* 19730*/     OPC_CheckPredicate, 23, // Predicate_ImmI8
/* 19732*/     OPC_CheckType, MVT::i32,
/* 19734*/     OPC_MoveParent,
/* 19735*/     OPC_CheckType, MVT::v16i8,
/* 19737*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19739*/     OPC_EmitConvertToTarget, 0,
/* 19741*/     OPC_EmitConvertToTarget, 1,
/* 19743*/     OPC_EmitConvertToTarget, 2,
/* 19745*/     OPC_EmitConvertToTarget, 3,
/* 19747*/     OPC_EmitConvertToTarget, 4,
/* 19749*/     OPC_EmitConvertToTarget, 5,
/* 19751*/     OPC_EmitConvertToTarget, 6,
/* 19753*/     OPC_EmitConvertToTarget, 7,
/* 19755*/     OPC_EmitConvertToTarget, 8,
/* 19757*/     OPC_EmitConvertToTarget, 9,
/* 19759*/     OPC_EmitConvertToTarget, 10,
/* 19761*/     OPC_EmitConvertToTarget, 11,
/* 19763*/     OPC_EmitConvertToTarget, 12,
/* 19765*/     OPC_EmitConvertToTarget, 13,
/* 19767*/     OPC_EmitConvertToTarget, 14,
/* 19769*/     OPC_EmitConvertToTarget, 15,
/* 19771*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I8x16), 0,
                   MVT::v16i8, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 19793*/    /*Scope*/ 107, /*->19901*/
/* 19794*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19796*/     OPC_MoveParent,
/* 19797*/     OPC_RecordChild1, // #1 = $i1
/* 19798*/     OPC_MoveChild1,
/* 19799*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19802*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19804*/     OPC_CheckType, MVT::i32,
/* 19806*/     OPC_MoveParent,
/* 19807*/     OPC_RecordChild2, // #2 = $i2
/* 19808*/     OPC_MoveChild2,
/* 19809*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19812*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19814*/     OPC_CheckType, MVT::i32,
/* 19816*/     OPC_MoveParent,
/* 19817*/     OPC_RecordChild3, // #3 = $i3
/* 19818*/     OPC_MoveChild3,
/* 19819*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19822*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19824*/     OPC_CheckType, MVT::i32,
/* 19826*/     OPC_MoveParent,
/* 19827*/     OPC_RecordChild4, // #4 = $i4
/* 19828*/     OPC_MoveChild4,
/* 19829*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19832*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19834*/     OPC_CheckType, MVT::i32,
/* 19836*/     OPC_MoveParent,
/* 19837*/     OPC_RecordChild5, // #5 = $i5
/* 19838*/     OPC_MoveChild5,
/* 19839*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19842*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19844*/     OPC_CheckType, MVT::i32,
/* 19846*/     OPC_MoveParent,
/* 19847*/     OPC_RecordChild6, // #6 = $i6
/* 19848*/     OPC_MoveChild6,
/* 19849*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19852*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19854*/     OPC_CheckType, MVT::i32,
/* 19856*/     OPC_MoveParent,
/* 19857*/     OPC_RecordChild7, // #7 = $i7
/* 19858*/     OPC_MoveChild7,
/* 19859*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19862*/     OPC_CheckPredicate, 24, // Predicate_ImmI16
/* 19864*/     OPC_CheckType, MVT::i32,
/* 19866*/     OPC_MoveParent,
/* 19867*/     OPC_CheckType, MVT::v8i16,
/* 19869*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19871*/     OPC_EmitConvertToTarget, 0,
/* 19873*/     OPC_EmitConvertToTarget, 1,
/* 19875*/     OPC_EmitConvertToTarget, 2,
/* 19877*/     OPC_EmitConvertToTarget, 3,
/* 19879*/     OPC_EmitConvertToTarget, 4,
/* 19881*/     OPC_EmitConvertToTarget, 5,
/* 19883*/     OPC_EmitConvertToTarget, 6,
/* 19885*/     OPC_EmitConvertToTarget, 7,
/* 19887*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                   MVT::v8i16, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 19901*/    /*Scope*/ 47, /*->19949*/
/* 19902*/     OPC_MoveParent,
/* 19903*/     OPC_RecordChild1, // #1 = $i1
/* 19904*/     OPC_MoveChild1,
/* 19905*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19908*/     OPC_CheckType, MVT::i32,
/* 19910*/     OPC_MoveParent,
/* 19911*/     OPC_RecordChild2, // #2 = $i2
/* 19912*/     OPC_MoveChild2,
/* 19913*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19916*/     OPC_CheckType, MVT::i32,
/* 19918*/     OPC_MoveParent,
/* 19919*/     OPC_RecordChild3, // #3 = $i3
/* 19920*/     OPC_MoveChild3,
/* 19921*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19924*/     OPC_CheckType, MVT::i32,
/* 19926*/     OPC_MoveParent,
/* 19927*/     OPC_CheckType, MVT::v4i32,
/* 19929*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19931*/     OPC_EmitConvertToTarget, 0,
/* 19933*/     OPC_EmitConvertToTarget, 1,
/* 19935*/     OPC_EmitConvertToTarget, 2,
/* 19937*/     OPC_EmitConvertToTarget, 3,
/* 19939*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                   MVT::v4i32, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 19949*/    0, /*End of Scope*/
/* 19950*/   /*SwitchType*/ 25, MVT::i64,// ->19977
/* 19952*/    OPC_MoveParent,
/* 19953*/    OPC_RecordChild1, // #1 = $i1
/* 19954*/    OPC_MoveChild1,
/* 19955*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19958*/    OPC_CheckType, MVT::i64,
/* 19960*/    OPC_MoveParent,
/* 19961*/    OPC_CheckType, MVT::v2i64,
/* 19963*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 19965*/    OPC_EmitConvertToTarget, 0,
/* 19967*/    OPC_EmitConvertToTarget, 1,
/* 19969*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 19977*/   0, // EndSwitchType
/* 19978*/  /*SwitchOpcode*/ 78, TARGET_VAL(ISD::ConstantFP),// ->20059
/* 19981*/   OPC_SwitchType /*2 cases */, 47, MVT::f32,// ->20031
/* 19984*/    OPC_MoveParent,
/* 19985*/    OPC_RecordChild1, // #1 = $i1
/* 19986*/    OPC_MoveChild1,
/* 19987*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 19990*/    OPC_CheckType, MVT::f32,
/* 19992*/    OPC_MoveParent,
/* 19993*/    OPC_RecordChild2, // #2 = $i2
/* 19994*/    OPC_MoveChild2,
/* 19995*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 19998*/    OPC_CheckType, MVT::f32,
/* 20000*/    OPC_MoveParent,
/* 20001*/    OPC_RecordChild3, // #3 = $i3
/* 20002*/    OPC_MoveChild3,
/* 20003*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 20006*/    OPC_CheckType, MVT::f32,
/* 20008*/    OPC_MoveParent,
/* 20009*/    OPC_CheckType, MVT::v4f32,
/* 20011*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 20013*/    OPC_EmitConvertToTarget, 0,
/* 20015*/    OPC_EmitConvertToTarget, 1,
/* 20017*/    OPC_EmitConvertToTarget, 2,
/* 20019*/    OPC_EmitConvertToTarget, 3,
/* 20021*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_F32x4), 0,
                  MVT::v4f32, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 20031*/   /*SwitchType*/ 25, MVT::f64,// ->20058
/* 20033*/    OPC_MoveParent,
/* 20034*/    OPC_RecordChild1, // #1 = $i1
/* 20035*/    OPC_MoveChild1,
/* 20036*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 20039*/    OPC_CheckType, MVT::f64,
/* 20041*/    OPC_MoveParent,
/* 20042*/    OPC_CheckType, MVT::v2f64,
/* 20044*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 20046*/    OPC_EmitConvertToTarget, 0,
/* 20048*/    OPC_EmitConvertToTarget, 1,
/* 20050*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_F64x2), 0,
                  MVT::v2f64, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 20058*/   0, // EndSwitchType
/* 20059*/  0, // EndSwitchOpcode
/* 20060*/ /*SwitchOpcode*/ 5|128,11/*1413*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->21477
/* 20064*/  OPC_RecordChild0, // #0 = $x
/* 20065*/  OPC_Scope, 105|128,1/*233*/, /*->20301*/ // 6 children in Scope
/* 20068*/   OPC_CheckChild0Type, MVT::v16i8,
/* 20070*/   OPC_RecordChild1, // #1 = $y
/* 20071*/   OPC_CheckChild1Type, MVT::v16i8,
/* 20073*/   OPC_RecordChild2, // #2 = $m0
/* 20074*/   OPC_MoveChild2,
/* 20075*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20078*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20080*/   OPC_CheckType, MVT::i32,
/* 20082*/   OPC_MoveParent,
/* 20083*/   OPC_RecordChild3, // #3 = $m1
/* 20084*/   OPC_MoveChild3,
/* 20085*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20088*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20090*/   OPC_CheckType, MVT::i32,
/* 20092*/   OPC_MoveParent,
/* 20093*/   OPC_RecordChild4, // #4 = $m2
/* 20094*/   OPC_MoveChild4,
/* 20095*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20098*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20100*/   OPC_CheckType, MVT::i32,
/* 20102*/   OPC_MoveParent,
/* 20103*/   OPC_RecordChild5, // #5 = $m3
/* 20104*/   OPC_MoveChild5,
/* 20105*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20108*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20110*/   OPC_CheckType, MVT::i32,
/* 20112*/   OPC_MoveParent,
/* 20113*/   OPC_RecordChild6, // #6 = $m4
/* 20114*/   OPC_MoveChild6,
/* 20115*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20118*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20120*/   OPC_CheckType, MVT::i32,
/* 20122*/   OPC_MoveParent,
/* 20123*/   OPC_RecordChild7, // #7 = $m5
/* 20124*/   OPC_MoveChild7,
/* 20125*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20128*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20130*/   OPC_CheckType, MVT::i32,
/* 20132*/   OPC_MoveParent,
/* 20133*/   OPC_MoveChild, 8,
/* 20135*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20138*/   OPC_RecordNode, // #8 = $m6
/* 20139*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20141*/   OPC_CheckType, MVT::i32,
/* 20143*/   OPC_MoveParent,
/* 20144*/   OPC_MoveChild, 9,
/* 20146*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20149*/   OPC_RecordNode, // #9 = $m7
/* 20150*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20152*/   OPC_CheckType, MVT::i32,
/* 20154*/   OPC_MoveParent,
/* 20155*/   OPC_MoveChild, 10,
/* 20157*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20160*/   OPC_RecordNode, // #10 = $m8
/* 20161*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20163*/   OPC_CheckType, MVT::i32,
/* 20165*/   OPC_MoveParent,
/* 20166*/   OPC_MoveChild, 11,
/* 20168*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20171*/   OPC_RecordNode, // #11 = $m9
/* 20172*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20174*/   OPC_CheckType, MVT::i32,
/* 20176*/   OPC_MoveParent,
/* 20177*/   OPC_MoveChild, 12,
/* 20179*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20182*/   OPC_RecordNode, // #12 = $mA
/* 20183*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20185*/   OPC_CheckType, MVT::i32,
/* 20187*/   OPC_MoveParent,
/* 20188*/   OPC_MoveChild, 13,
/* 20190*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20193*/   OPC_RecordNode, // #13 = $mB
/* 20194*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20196*/   OPC_CheckType, MVT::i32,
/* 20198*/   OPC_MoveParent,
/* 20199*/   OPC_MoveChild, 14,
/* 20201*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20204*/   OPC_RecordNode, // #14 = $mC
/* 20205*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20207*/   OPC_CheckType, MVT::i32,
/* 20209*/   OPC_MoveParent,
/* 20210*/   OPC_MoveChild, 15,
/* 20212*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20215*/   OPC_RecordNode, // #15 = $mD
/* 20216*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20218*/   OPC_CheckType, MVT::i32,
/* 20220*/   OPC_MoveParent,
/* 20221*/   OPC_MoveChild, 16,
/* 20223*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20226*/   OPC_RecordNode, // #16 = $mE
/* 20227*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20229*/   OPC_CheckType, MVT::i32,
/* 20231*/   OPC_MoveParent,
/* 20232*/   OPC_MoveChild, 17,
/* 20234*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20237*/   OPC_RecordNode, // #17 = $mF
/* 20238*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20240*/   OPC_CheckType, MVT::i32,
/* 20242*/   OPC_MoveParent,
/* 20243*/   OPC_CheckType, MVT::v16i8,
/* 20245*/   OPC_EmitConvertToTarget, 2,
/* 20247*/   OPC_EmitConvertToTarget, 3,
/* 20249*/   OPC_EmitConvertToTarget, 4,
/* 20251*/   OPC_EmitConvertToTarget, 5,
/* 20253*/   OPC_EmitConvertToTarget, 6,
/* 20255*/   OPC_EmitConvertToTarget, 7,
/* 20257*/   OPC_EmitConvertToTarget, 8,
/* 20259*/   OPC_EmitConvertToTarget, 9,
/* 20261*/   OPC_EmitConvertToTarget, 10,
/* 20263*/   OPC_EmitConvertToTarget, 11,
/* 20265*/   OPC_EmitConvertToTarget, 12,
/* 20267*/   OPC_EmitConvertToTarget, 13,
/* 20269*/   OPC_EmitConvertToTarget, 14,
/* 20271*/   OPC_EmitConvertToTarget, 15,
/* 20273*/   OPC_EmitConvertToTarget, 16,
/* 20275*/   OPC_EmitConvertToTarget, 17,
/* 20277*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v16i8, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20301*/  /*Scope*/ 105|128,1/*233*/, /*->20536*/
/* 20303*/   OPC_CheckChild0Type, MVT::v8i16,
/* 20305*/   OPC_RecordChild1, // #1 = $y
/* 20306*/   OPC_CheckChild1Type, MVT::v8i16,
/* 20308*/   OPC_RecordChild2, // #2 = $m0
/* 20309*/   OPC_MoveChild2,
/* 20310*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20313*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20315*/   OPC_CheckType, MVT::i32,
/* 20317*/   OPC_MoveParent,
/* 20318*/   OPC_RecordChild3, // #3 = $m1
/* 20319*/   OPC_MoveChild3,
/* 20320*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20323*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20325*/   OPC_CheckType, MVT::i32,
/* 20327*/   OPC_MoveParent,
/* 20328*/   OPC_RecordChild4, // #4 = $m2
/* 20329*/   OPC_MoveChild4,
/* 20330*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20333*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20335*/   OPC_CheckType, MVT::i32,
/* 20337*/   OPC_MoveParent,
/* 20338*/   OPC_RecordChild5, // #5 = $m3
/* 20339*/   OPC_MoveChild5,
/* 20340*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20343*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20345*/   OPC_CheckType, MVT::i32,
/* 20347*/   OPC_MoveParent,
/* 20348*/   OPC_RecordChild6, // #6 = $m4
/* 20349*/   OPC_MoveChild6,
/* 20350*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20353*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20355*/   OPC_CheckType, MVT::i32,
/* 20357*/   OPC_MoveParent,
/* 20358*/   OPC_RecordChild7, // #7 = $m5
/* 20359*/   OPC_MoveChild7,
/* 20360*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20363*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20365*/   OPC_CheckType, MVT::i32,
/* 20367*/   OPC_MoveParent,
/* 20368*/   OPC_MoveChild, 8,
/* 20370*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20373*/   OPC_RecordNode, // #8 = $m6
/* 20374*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20376*/   OPC_CheckType, MVT::i32,
/* 20378*/   OPC_MoveParent,
/* 20379*/   OPC_MoveChild, 9,
/* 20381*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20384*/   OPC_RecordNode, // #9 = $m7
/* 20385*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20387*/   OPC_CheckType, MVT::i32,
/* 20389*/   OPC_MoveParent,
/* 20390*/   OPC_MoveChild, 10,
/* 20392*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20395*/   OPC_RecordNode, // #10 = $m8
/* 20396*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20398*/   OPC_CheckType, MVT::i32,
/* 20400*/   OPC_MoveParent,
/* 20401*/   OPC_MoveChild, 11,
/* 20403*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20406*/   OPC_RecordNode, // #11 = $m9
/* 20407*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20409*/   OPC_CheckType, MVT::i32,
/* 20411*/   OPC_MoveParent,
/* 20412*/   OPC_MoveChild, 12,
/* 20414*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20417*/   OPC_RecordNode, // #12 = $mA
/* 20418*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20420*/   OPC_CheckType, MVT::i32,
/* 20422*/   OPC_MoveParent,
/* 20423*/   OPC_MoveChild, 13,
/* 20425*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20428*/   OPC_RecordNode, // #13 = $mB
/* 20429*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20431*/   OPC_CheckType, MVT::i32,
/* 20433*/   OPC_MoveParent,
/* 20434*/   OPC_MoveChild, 14,
/* 20436*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20439*/   OPC_RecordNode, // #14 = $mC
/* 20440*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20442*/   OPC_CheckType, MVT::i32,
/* 20444*/   OPC_MoveParent,
/* 20445*/   OPC_MoveChild, 15,
/* 20447*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20450*/   OPC_RecordNode, // #15 = $mD
/* 20451*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20453*/   OPC_CheckType, MVT::i32,
/* 20455*/   OPC_MoveParent,
/* 20456*/   OPC_MoveChild, 16,
/* 20458*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20461*/   OPC_RecordNode, // #16 = $mE
/* 20462*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20464*/   OPC_CheckType, MVT::i32,
/* 20466*/   OPC_MoveParent,
/* 20467*/   OPC_MoveChild, 17,
/* 20469*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20472*/   OPC_RecordNode, // #17 = $mF
/* 20473*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20475*/   OPC_CheckType, MVT::i32,
/* 20477*/   OPC_MoveParent,
/* 20478*/   OPC_CheckType, MVT::v8i16,
/* 20480*/   OPC_EmitConvertToTarget, 2,
/* 20482*/   OPC_EmitConvertToTarget, 3,
/* 20484*/   OPC_EmitConvertToTarget, 4,
/* 20486*/   OPC_EmitConvertToTarget, 5,
/* 20488*/   OPC_EmitConvertToTarget, 6,
/* 20490*/   OPC_EmitConvertToTarget, 7,
/* 20492*/   OPC_EmitConvertToTarget, 8,
/* 20494*/   OPC_EmitConvertToTarget, 9,
/* 20496*/   OPC_EmitConvertToTarget, 10,
/* 20498*/   OPC_EmitConvertToTarget, 11,
/* 20500*/   OPC_EmitConvertToTarget, 12,
/* 20502*/   OPC_EmitConvertToTarget, 13,
/* 20504*/   OPC_EmitConvertToTarget, 14,
/* 20506*/   OPC_EmitConvertToTarget, 15,
/* 20508*/   OPC_EmitConvertToTarget, 16,
/* 20510*/   OPC_EmitConvertToTarget, 17,
/* 20512*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v8i16, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20536*/  /*Scope*/ 105|128,1/*233*/, /*->20771*/
/* 20538*/   OPC_CheckChild0Type, MVT::v4i32,
/* 20540*/   OPC_RecordChild1, // #1 = $y
/* 20541*/   OPC_CheckChild1Type, MVT::v4i32,
/* 20543*/   OPC_RecordChild2, // #2 = $m0
/* 20544*/   OPC_MoveChild2,
/* 20545*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20548*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20550*/   OPC_CheckType, MVT::i32,
/* 20552*/   OPC_MoveParent,
/* 20553*/   OPC_RecordChild3, // #3 = $m1
/* 20554*/   OPC_MoveChild3,
/* 20555*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20558*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20560*/   OPC_CheckType, MVT::i32,
/* 20562*/   OPC_MoveParent,
/* 20563*/   OPC_RecordChild4, // #4 = $m2
/* 20564*/   OPC_MoveChild4,
/* 20565*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20568*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20570*/   OPC_CheckType, MVT::i32,
/* 20572*/   OPC_MoveParent,
/* 20573*/   OPC_RecordChild5, // #5 = $m3
/* 20574*/   OPC_MoveChild5,
/* 20575*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20578*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20580*/   OPC_CheckType, MVT::i32,
/* 20582*/   OPC_MoveParent,
/* 20583*/   OPC_RecordChild6, // #6 = $m4
/* 20584*/   OPC_MoveChild6,
/* 20585*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20588*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20590*/   OPC_CheckType, MVT::i32,
/* 20592*/   OPC_MoveParent,
/* 20593*/   OPC_RecordChild7, // #7 = $m5
/* 20594*/   OPC_MoveChild7,
/* 20595*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20598*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20600*/   OPC_CheckType, MVT::i32,
/* 20602*/   OPC_MoveParent,
/* 20603*/   OPC_MoveChild, 8,
/* 20605*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20608*/   OPC_RecordNode, // #8 = $m6
/* 20609*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20611*/   OPC_CheckType, MVT::i32,
/* 20613*/   OPC_MoveParent,
/* 20614*/   OPC_MoveChild, 9,
/* 20616*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20619*/   OPC_RecordNode, // #9 = $m7
/* 20620*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20622*/   OPC_CheckType, MVT::i32,
/* 20624*/   OPC_MoveParent,
/* 20625*/   OPC_MoveChild, 10,
/* 20627*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20630*/   OPC_RecordNode, // #10 = $m8
/* 20631*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20633*/   OPC_CheckType, MVT::i32,
/* 20635*/   OPC_MoveParent,
/* 20636*/   OPC_MoveChild, 11,
/* 20638*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20641*/   OPC_RecordNode, // #11 = $m9
/* 20642*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20644*/   OPC_CheckType, MVT::i32,
/* 20646*/   OPC_MoveParent,
/* 20647*/   OPC_MoveChild, 12,
/* 20649*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20652*/   OPC_RecordNode, // #12 = $mA
/* 20653*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20655*/   OPC_CheckType, MVT::i32,
/* 20657*/   OPC_MoveParent,
/* 20658*/   OPC_MoveChild, 13,
/* 20660*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20663*/   OPC_RecordNode, // #13 = $mB
/* 20664*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20666*/   OPC_CheckType, MVT::i32,
/* 20668*/   OPC_MoveParent,
/* 20669*/   OPC_MoveChild, 14,
/* 20671*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20674*/   OPC_RecordNode, // #14 = $mC
/* 20675*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20677*/   OPC_CheckType, MVT::i32,
/* 20679*/   OPC_MoveParent,
/* 20680*/   OPC_MoveChild, 15,
/* 20682*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20685*/   OPC_RecordNode, // #15 = $mD
/* 20686*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20688*/   OPC_CheckType, MVT::i32,
/* 20690*/   OPC_MoveParent,
/* 20691*/   OPC_MoveChild, 16,
/* 20693*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20696*/   OPC_RecordNode, // #16 = $mE
/* 20697*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20699*/   OPC_CheckType, MVT::i32,
/* 20701*/   OPC_MoveParent,
/* 20702*/   OPC_MoveChild, 17,
/* 20704*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20707*/   OPC_RecordNode, // #17 = $mF
/* 20708*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20710*/   OPC_CheckType, MVT::i32,
/* 20712*/   OPC_MoveParent,
/* 20713*/   OPC_CheckType, MVT::v4i32,
/* 20715*/   OPC_EmitConvertToTarget, 2,
/* 20717*/   OPC_EmitConvertToTarget, 3,
/* 20719*/   OPC_EmitConvertToTarget, 4,
/* 20721*/   OPC_EmitConvertToTarget, 5,
/* 20723*/   OPC_EmitConvertToTarget, 6,
/* 20725*/   OPC_EmitConvertToTarget, 7,
/* 20727*/   OPC_EmitConvertToTarget, 8,
/* 20729*/   OPC_EmitConvertToTarget, 9,
/* 20731*/   OPC_EmitConvertToTarget, 10,
/* 20733*/   OPC_EmitConvertToTarget, 11,
/* 20735*/   OPC_EmitConvertToTarget, 12,
/* 20737*/   OPC_EmitConvertToTarget, 13,
/* 20739*/   OPC_EmitConvertToTarget, 14,
/* 20741*/   OPC_EmitConvertToTarget, 15,
/* 20743*/   OPC_EmitConvertToTarget, 16,
/* 20745*/   OPC_EmitConvertToTarget, 17,
/* 20747*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v4i32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20771*/  /*Scope*/ 105|128,1/*233*/, /*->21006*/
/* 20773*/   OPC_CheckChild0Type, MVT::v2i64,
/* 20775*/   OPC_RecordChild1, // #1 = $y
/* 20776*/   OPC_CheckChild1Type, MVT::v2i64,
/* 20778*/   OPC_RecordChild2, // #2 = $m0
/* 20779*/   OPC_MoveChild2,
/* 20780*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20783*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20785*/   OPC_CheckType, MVT::i32,
/* 20787*/   OPC_MoveParent,
/* 20788*/   OPC_RecordChild3, // #3 = $m1
/* 20789*/   OPC_MoveChild3,
/* 20790*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20793*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20795*/   OPC_CheckType, MVT::i32,
/* 20797*/   OPC_MoveParent,
/* 20798*/   OPC_RecordChild4, // #4 = $m2
/* 20799*/   OPC_MoveChild4,
/* 20800*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20803*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20805*/   OPC_CheckType, MVT::i32,
/* 20807*/   OPC_MoveParent,
/* 20808*/   OPC_RecordChild5, // #5 = $m3
/* 20809*/   OPC_MoveChild5,
/* 20810*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20813*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20815*/   OPC_CheckType, MVT::i32,
/* 20817*/   OPC_MoveParent,
/* 20818*/   OPC_RecordChild6, // #6 = $m4
/* 20819*/   OPC_MoveChild6,
/* 20820*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20823*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20825*/   OPC_CheckType, MVT::i32,
/* 20827*/   OPC_MoveParent,
/* 20828*/   OPC_RecordChild7, // #7 = $m5
/* 20829*/   OPC_MoveChild7,
/* 20830*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20833*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20835*/   OPC_CheckType, MVT::i32,
/* 20837*/   OPC_MoveParent,
/* 20838*/   OPC_MoveChild, 8,
/* 20840*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20843*/   OPC_RecordNode, // #8 = $m6
/* 20844*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20846*/   OPC_CheckType, MVT::i32,
/* 20848*/   OPC_MoveParent,
/* 20849*/   OPC_MoveChild, 9,
/* 20851*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20854*/   OPC_RecordNode, // #9 = $m7
/* 20855*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20857*/   OPC_CheckType, MVT::i32,
/* 20859*/   OPC_MoveParent,
/* 20860*/   OPC_MoveChild, 10,
/* 20862*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20865*/   OPC_RecordNode, // #10 = $m8
/* 20866*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20868*/   OPC_CheckType, MVT::i32,
/* 20870*/   OPC_MoveParent,
/* 20871*/   OPC_MoveChild, 11,
/* 20873*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20876*/   OPC_RecordNode, // #11 = $m9
/* 20877*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20879*/   OPC_CheckType, MVT::i32,
/* 20881*/   OPC_MoveParent,
/* 20882*/   OPC_MoveChild, 12,
/* 20884*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20887*/   OPC_RecordNode, // #12 = $mA
/* 20888*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20890*/   OPC_CheckType, MVT::i32,
/* 20892*/   OPC_MoveParent,
/* 20893*/   OPC_MoveChild, 13,
/* 20895*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20898*/   OPC_RecordNode, // #13 = $mB
/* 20899*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20901*/   OPC_CheckType, MVT::i32,
/* 20903*/   OPC_MoveParent,
/* 20904*/   OPC_MoveChild, 14,
/* 20906*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20909*/   OPC_RecordNode, // #14 = $mC
/* 20910*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20912*/   OPC_CheckType, MVT::i32,
/* 20914*/   OPC_MoveParent,
/* 20915*/   OPC_MoveChild, 15,
/* 20917*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20920*/   OPC_RecordNode, // #15 = $mD
/* 20921*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20923*/   OPC_CheckType, MVT::i32,
/* 20925*/   OPC_MoveParent,
/* 20926*/   OPC_MoveChild, 16,
/* 20928*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20931*/   OPC_RecordNode, // #16 = $mE
/* 20932*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20934*/   OPC_CheckType, MVT::i32,
/* 20936*/   OPC_MoveParent,
/* 20937*/   OPC_MoveChild, 17,
/* 20939*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20942*/   OPC_RecordNode, // #17 = $mF
/* 20943*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 20945*/   OPC_CheckType, MVT::i32,
/* 20947*/   OPC_MoveParent,
/* 20948*/   OPC_CheckType, MVT::v2i64,
/* 20950*/   OPC_EmitConvertToTarget, 2,
/* 20952*/   OPC_EmitConvertToTarget, 3,
/* 20954*/   OPC_EmitConvertToTarget, 4,
/* 20956*/   OPC_EmitConvertToTarget, 5,
/* 20958*/   OPC_EmitConvertToTarget, 6,
/* 20960*/   OPC_EmitConvertToTarget, 7,
/* 20962*/   OPC_EmitConvertToTarget, 8,
/* 20964*/   OPC_EmitConvertToTarget, 9,
/* 20966*/   OPC_EmitConvertToTarget, 10,
/* 20968*/   OPC_EmitConvertToTarget, 11,
/* 20970*/   OPC_EmitConvertToTarget, 12,
/* 20972*/   OPC_EmitConvertToTarget, 13,
/* 20974*/   OPC_EmitConvertToTarget, 14,
/* 20976*/   OPC_EmitConvertToTarget, 15,
/* 20978*/   OPC_EmitConvertToTarget, 16,
/* 20980*/   OPC_EmitConvertToTarget, 17,
/* 20982*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v2i64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21006*/  /*Scope*/ 105|128,1/*233*/, /*->21241*/
/* 21008*/   OPC_CheckChild0Type, MVT::v4f32,
/* 21010*/   OPC_RecordChild1, // #1 = $y
/* 21011*/   OPC_CheckChild1Type, MVT::v4f32,
/* 21013*/   OPC_RecordChild2, // #2 = $m0
/* 21014*/   OPC_MoveChild2,
/* 21015*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21018*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21020*/   OPC_CheckType, MVT::i32,
/* 21022*/   OPC_MoveParent,
/* 21023*/   OPC_RecordChild3, // #3 = $m1
/* 21024*/   OPC_MoveChild3,
/* 21025*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21028*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21030*/   OPC_CheckType, MVT::i32,
/* 21032*/   OPC_MoveParent,
/* 21033*/   OPC_RecordChild4, // #4 = $m2
/* 21034*/   OPC_MoveChild4,
/* 21035*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21038*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21040*/   OPC_CheckType, MVT::i32,
/* 21042*/   OPC_MoveParent,
/* 21043*/   OPC_RecordChild5, // #5 = $m3
/* 21044*/   OPC_MoveChild5,
/* 21045*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21048*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21050*/   OPC_CheckType, MVT::i32,
/* 21052*/   OPC_MoveParent,
/* 21053*/   OPC_RecordChild6, // #6 = $m4
/* 21054*/   OPC_MoveChild6,
/* 21055*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21058*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21060*/   OPC_CheckType, MVT::i32,
/* 21062*/   OPC_MoveParent,
/* 21063*/   OPC_RecordChild7, // #7 = $m5
/* 21064*/   OPC_MoveChild7,
/* 21065*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21068*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21070*/   OPC_CheckType, MVT::i32,
/* 21072*/   OPC_MoveParent,
/* 21073*/   OPC_MoveChild, 8,
/* 21075*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21078*/   OPC_RecordNode, // #8 = $m6
/* 21079*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21081*/   OPC_CheckType, MVT::i32,
/* 21083*/   OPC_MoveParent,
/* 21084*/   OPC_MoveChild, 9,
/* 21086*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21089*/   OPC_RecordNode, // #9 = $m7
/* 21090*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21092*/   OPC_CheckType, MVT::i32,
/* 21094*/   OPC_MoveParent,
/* 21095*/   OPC_MoveChild, 10,
/* 21097*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21100*/   OPC_RecordNode, // #10 = $m8
/* 21101*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21103*/   OPC_CheckType, MVT::i32,
/* 21105*/   OPC_MoveParent,
/* 21106*/   OPC_MoveChild, 11,
/* 21108*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21111*/   OPC_RecordNode, // #11 = $m9
/* 21112*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21114*/   OPC_CheckType, MVT::i32,
/* 21116*/   OPC_MoveParent,
/* 21117*/   OPC_MoveChild, 12,
/* 21119*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21122*/   OPC_RecordNode, // #12 = $mA
/* 21123*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21125*/   OPC_CheckType, MVT::i32,
/* 21127*/   OPC_MoveParent,
/* 21128*/   OPC_MoveChild, 13,
/* 21130*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21133*/   OPC_RecordNode, // #13 = $mB
/* 21134*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21136*/   OPC_CheckType, MVT::i32,
/* 21138*/   OPC_MoveParent,
/* 21139*/   OPC_MoveChild, 14,
/* 21141*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21144*/   OPC_RecordNode, // #14 = $mC
/* 21145*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21147*/   OPC_CheckType, MVT::i32,
/* 21149*/   OPC_MoveParent,
/* 21150*/   OPC_MoveChild, 15,
/* 21152*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21155*/   OPC_RecordNode, // #15 = $mD
/* 21156*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21158*/   OPC_CheckType, MVT::i32,
/* 21160*/   OPC_MoveParent,
/* 21161*/   OPC_MoveChild, 16,
/* 21163*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21166*/   OPC_RecordNode, // #16 = $mE
/* 21167*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21169*/   OPC_CheckType, MVT::i32,
/* 21171*/   OPC_MoveParent,
/* 21172*/   OPC_MoveChild, 17,
/* 21174*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21177*/   OPC_RecordNode, // #17 = $mF
/* 21178*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21180*/   OPC_CheckType, MVT::i32,
/* 21182*/   OPC_MoveParent,
/* 21183*/   OPC_CheckType, MVT::v4f32,
/* 21185*/   OPC_EmitConvertToTarget, 2,
/* 21187*/   OPC_EmitConvertToTarget, 3,
/* 21189*/   OPC_EmitConvertToTarget, 4,
/* 21191*/   OPC_EmitConvertToTarget, 5,
/* 21193*/   OPC_EmitConvertToTarget, 6,
/* 21195*/   OPC_EmitConvertToTarget, 7,
/* 21197*/   OPC_EmitConvertToTarget, 8,
/* 21199*/   OPC_EmitConvertToTarget, 9,
/* 21201*/   OPC_EmitConvertToTarget, 10,
/* 21203*/   OPC_EmitConvertToTarget, 11,
/* 21205*/   OPC_EmitConvertToTarget, 12,
/* 21207*/   OPC_EmitConvertToTarget, 13,
/* 21209*/   OPC_EmitConvertToTarget, 14,
/* 21211*/   OPC_EmitConvertToTarget, 15,
/* 21213*/   OPC_EmitConvertToTarget, 16,
/* 21215*/   OPC_EmitConvertToTarget, 17,
/* 21217*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v4f32, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21241*/  /*Scope*/ 105|128,1/*233*/, /*->21476*/
/* 21243*/   OPC_CheckChild0Type, MVT::v2f64,
/* 21245*/   OPC_RecordChild1, // #1 = $y
/* 21246*/   OPC_CheckChild1Type, MVT::v2f64,
/* 21248*/   OPC_RecordChild2, // #2 = $m0
/* 21249*/   OPC_MoveChild2,
/* 21250*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21253*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21255*/   OPC_CheckType, MVT::i32,
/* 21257*/   OPC_MoveParent,
/* 21258*/   OPC_RecordChild3, // #3 = $m1
/* 21259*/   OPC_MoveChild3,
/* 21260*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21263*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21265*/   OPC_CheckType, MVT::i32,
/* 21267*/   OPC_MoveParent,
/* 21268*/   OPC_RecordChild4, // #4 = $m2
/* 21269*/   OPC_MoveChild4,
/* 21270*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21273*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21275*/   OPC_CheckType, MVT::i32,
/* 21277*/   OPC_MoveParent,
/* 21278*/   OPC_RecordChild5, // #5 = $m3
/* 21279*/   OPC_MoveChild5,
/* 21280*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21283*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21285*/   OPC_CheckType, MVT::i32,
/* 21287*/   OPC_MoveParent,
/* 21288*/   OPC_RecordChild6, // #6 = $m4
/* 21289*/   OPC_MoveChild6,
/* 21290*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21293*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21295*/   OPC_CheckType, MVT::i32,
/* 21297*/   OPC_MoveParent,
/* 21298*/   OPC_RecordChild7, // #7 = $m5
/* 21299*/   OPC_MoveChild7,
/* 21300*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21303*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21305*/   OPC_CheckType, MVT::i32,
/* 21307*/   OPC_MoveParent,
/* 21308*/   OPC_MoveChild, 8,
/* 21310*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21313*/   OPC_RecordNode, // #8 = $m6
/* 21314*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21316*/   OPC_CheckType, MVT::i32,
/* 21318*/   OPC_MoveParent,
/* 21319*/   OPC_MoveChild, 9,
/* 21321*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21324*/   OPC_RecordNode, // #9 = $m7
/* 21325*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21327*/   OPC_CheckType, MVT::i32,
/* 21329*/   OPC_MoveParent,
/* 21330*/   OPC_MoveChild, 10,
/* 21332*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21335*/   OPC_RecordNode, // #10 = $m8
/* 21336*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21338*/   OPC_CheckType, MVT::i32,
/* 21340*/   OPC_MoveParent,
/* 21341*/   OPC_MoveChild, 11,
/* 21343*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21346*/   OPC_RecordNode, // #11 = $m9
/* 21347*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21349*/   OPC_CheckType, MVT::i32,
/* 21351*/   OPC_MoveParent,
/* 21352*/   OPC_MoveChild, 12,
/* 21354*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21357*/   OPC_RecordNode, // #12 = $mA
/* 21358*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21360*/   OPC_CheckType, MVT::i32,
/* 21362*/   OPC_MoveParent,
/* 21363*/   OPC_MoveChild, 13,
/* 21365*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21368*/   OPC_RecordNode, // #13 = $mB
/* 21369*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21371*/   OPC_CheckType, MVT::i32,
/* 21373*/   OPC_MoveParent,
/* 21374*/   OPC_MoveChild, 14,
/* 21376*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21379*/   OPC_RecordNode, // #14 = $mC
/* 21380*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21382*/   OPC_CheckType, MVT::i32,
/* 21384*/   OPC_MoveParent,
/* 21385*/   OPC_MoveChild, 15,
/* 21387*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21390*/   OPC_RecordNode, // #15 = $mD
/* 21391*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21393*/   OPC_CheckType, MVT::i32,
/* 21395*/   OPC_MoveParent,
/* 21396*/   OPC_MoveChild, 16,
/* 21398*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21401*/   OPC_RecordNode, // #16 = $mE
/* 21402*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21404*/   OPC_CheckType, MVT::i32,
/* 21406*/   OPC_MoveParent,
/* 21407*/   OPC_MoveChild, 17,
/* 21409*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21412*/   OPC_RecordNode, // #17 = $mF
/* 21413*/   OPC_CheckPredicate, 25, // Predicate_LaneIdx32
/* 21415*/   OPC_CheckType, MVT::i32,
/* 21417*/   OPC_MoveParent,
/* 21418*/   OPC_CheckType, MVT::v2f64,
/* 21420*/   OPC_EmitConvertToTarget, 2,
/* 21422*/   OPC_EmitConvertToTarget, 3,
/* 21424*/   OPC_EmitConvertToTarget, 4,
/* 21426*/   OPC_EmitConvertToTarget, 5,
/* 21428*/   OPC_EmitConvertToTarget, 6,
/* 21430*/   OPC_EmitConvertToTarget, 7,
/* 21432*/   OPC_EmitConvertToTarget, 8,
/* 21434*/   OPC_EmitConvertToTarget, 9,
/* 21436*/   OPC_EmitConvertToTarget, 10,
/* 21438*/   OPC_EmitConvertToTarget, 11,
/* 21440*/   OPC_EmitConvertToTarget, 12,
/* 21442*/   OPC_EmitConvertToTarget, 13,
/* 21444*/   OPC_EmitConvertToTarget, 14,
/* 21446*/   OPC_EmitConvertToTarget, 15,
/* 21448*/   OPC_EmitConvertToTarget, 16,
/* 21450*/   OPC_EmitConvertToTarget, 17,
/* 21452*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHUFFLE), 0,
                 MVT::v2f64, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
             // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
             // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21476*/  0, /*End of Scope*/
/* 21477*/ /*SwitchOpcode*/ 33|128,6/*801*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->22282
/* 21481*/  OPC_Scope, 32|128,1/*160*/, /*->21644*/ // 2 children in Scope
/* 21484*/   OPC_MoveChild0,
/* 21485*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 21488*/   OPC_CheckChild0Integer, 0, 
/* 21490*/   OPC_Scope, 75, /*->21567*/ // 2 children in Scope
/* 21492*/    OPC_CheckChild0Type, MVT::i32,
/* 21494*/    OPC_MoveParent,
/* 21495*/    OPC_MoveChild1,
/* 21496*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21499*/    OPC_RecordMemRef,
/* 21500*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 21501*/    OPC_CheckFoldableChainNode,
/* 21502*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21503*/    OPC_CheckType, MVT::i32,
/* 21505*/    OPC_Scope, 29, /*->21536*/ // 2 children in Scope
/* 21507*/     OPC_CheckChild1Type, MVT::i32,
/* 21509*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21511*/     OPC_CheckPredicate, 15, // Predicate_load
/* 21513*/     OPC_MoveParent,
/* 21514*/     OPC_CheckChild2Integer, 0, 
/* 21516*/     OPC_CheckType, MVT::v4i32,
/* 21518*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21520*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21523*/     OPC_EmitMergeInputChains1_0,
/* 21524*/     OPC_EmitInteger, MVT::i32, 0, 
/* 21527*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21536*/    /*Scope*/ 29, /*->21566*/
/* 21537*/     OPC_CheckChild1Type, MVT::i64,
/* 21539*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21541*/     OPC_CheckPredicate, 15, // Predicate_load
/* 21543*/     OPC_MoveParent,
/* 21544*/     OPC_CheckChild2Integer, 0, 
/* 21546*/     OPC_CheckType, MVT::v4i32,
/* 21548*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21550*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21553*/     OPC_EmitMergeInputChains1_0,
/* 21554*/     OPC_EmitInteger, MVT::i32, 0, 
/* 21557*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21566*/    0, /*End of Scope*/
/* 21567*/   /*Scope*/ 75, /*->21643*/
/* 21568*/    OPC_CheckChild0Type, MVT::i64,
/* 21570*/    OPC_MoveParent,
/* 21571*/    OPC_MoveChild1,
/* 21572*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21575*/    OPC_RecordMemRef,
/* 21576*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 21577*/    OPC_CheckFoldableChainNode,
/* 21578*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21579*/    OPC_CheckType, MVT::i64,
/* 21581*/    OPC_Scope, 29, /*->21612*/ // 2 children in Scope
/* 21583*/     OPC_CheckChild1Type, MVT::i32,
/* 21585*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21587*/     OPC_CheckPredicate, 15, // Predicate_load
/* 21589*/     OPC_MoveParent,
/* 21590*/     OPC_CheckChild2Integer, 0, 
/* 21592*/     OPC_CheckType, MVT::v2i64,
/* 21594*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21596*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21599*/     OPC_EmitMergeInputChains1_0,
/* 21600*/     OPC_EmitInteger, MVT::i32, 0, 
/* 21603*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21612*/    /*Scope*/ 29, /*->21642*/
/* 21613*/     OPC_CheckChild1Type, MVT::i64,
/* 21615*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21617*/     OPC_CheckPredicate, 15, // Predicate_load
/* 21619*/     OPC_MoveParent,
/* 21620*/     OPC_CheckChild2Integer, 0, 
/* 21622*/     OPC_CheckType, MVT::v2i64,
/* 21624*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21626*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21629*/     OPC_EmitMergeInputChains1_0,
/* 21630*/     OPC_EmitInteger, MVT::i32, 0, 
/* 21633*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21642*/    0, /*End of Scope*/
/* 21643*/   0, /*End of Scope*/
/* 21644*/  /*Scope*/ 123|128,4/*635*/, /*->22281*/
/* 21646*/   OPC_RecordChild0, // #0 = $vec
/* 21647*/   OPC_Scope, 94|128,2/*350*/, /*->22000*/ // 2 children in Scope
/* 21650*/    OPC_MoveChild1,
/* 21651*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21654*/    OPC_RecordMemRef,
/* 21655*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 21656*/    OPC_CheckFoldableChainNode,
/* 21657*/    OPC_RecordChild1, // #2 = $addr
/* 21658*/    OPC_Scope, 40|128,1/*168*/, /*->21829*/ // 2 children in Scope
/* 21661*/     OPC_CheckChild1Type, MVT::i32,
/* 21663*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21665*/     OPC_Scope, 82, /*->21749*/ // 2 children in Scope
/* 21667*/      OPC_CheckPredicate, 18, // Predicate_extload
/* 21669*/      OPC_CheckType, MVT::i32,
/* 21671*/      OPC_Scope, 37, /*->21710*/ // 2 children in Scope
/* 21673*/       OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 21675*/       OPC_MoveParent,
/* 21676*/       OPC_RecordChild2, // #3 = $idx
/* 21677*/       OPC_MoveChild2,
/* 21678*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21681*/       OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 21683*/       OPC_CheckType, MVT::i32,
/* 21685*/       OPC_MoveParent,
/* 21686*/       OPC_CheckType, MVT::v16i8,
/* 21688*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21690*/       OPC_EmitMergeInputChains1_1,
/* 21691*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21694*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21697*/       OPC_EmitConvertToTarget, 3,
/* 21699*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21710*/      /*Scope*/ 37, /*->21748*/
/* 21711*/       OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 21713*/       OPC_MoveParent,
/* 21714*/       OPC_RecordChild2, // #3 = $idx
/* 21715*/       OPC_MoveChild2,
/* 21716*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21719*/       OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 21721*/       OPC_CheckType, MVT::i32,
/* 21723*/       OPC_MoveParent,
/* 21724*/       OPC_CheckType, MVT::v8i16,
/* 21726*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21728*/       OPC_EmitMergeInputChains1_1,
/* 21729*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21732*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21735*/       OPC_EmitConvertToTarget, 3,
/* 21737*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21748*/      0, /*End of Scope*/
/* 21749*/     /*Scope*/ 78, /*->21828*/
/* 21750*/      OPC_CheckPredicate, 15, // Predicate_load
/* 21752*/      OPC_SwitchType /*2 cases */, 35, MVT::i32,// ->21790
/* 21755*/       OPC_MoveParent,
/* 21756*/       OPC_RecordChild2, // #3 = $idx
/* 21757*/       OPC_MoveChild2,
/* 21758*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21761*/       OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 21763*/       OPC_CheckType, MVT::i32,
/* 21765*/       OPC_MoveParent,
/* 21766*/       OPC_CheckType, MVT::v4i32,
/* 21768*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21770*/       OPC_EmitMergeInputChains1_1,
/* 21771*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21774*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21777*/       OPC_EmitConvertToTarget, 3,
/* 21779*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21790*/      /*SwitchType*/ 35, MVT::i64,// ->21827
/* 21792*/       OPC_MoveParent,
/* 21793*/       OPC_RecordChild2, // #3 = $idx
/* 21794*/       OPC_MoveChild2,
/* 21795*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21798*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 21800*/       OPC_CheckType, MVT::i32,
/* 21802*/       OPC_MoveParent,
/* 21803*/       OPC_CheckType, MVT::v2i64,
/* 21805*/       OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 21807*/       OPC_EmitMergeInputChains1_1,
/* 21808*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21811*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21814*/       OPC_EmitConvertToTarget, 3,
/* 21816*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21827*/      0, // EndSwitchType
/* 21828*/     0, /*End of Scope*/
/* 21829*/    /*Scope*/ 40|128,1/*168*/, /*->21999*/
/* 21831*/     OPC_CheckChild1Type, MVT::i64,
/* 21833*/     OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 21835*/     OPC_Scope, 82, /*->21919*/ // 2 children in Scope
/* 21837*/      OPC_CheckPredicate, 18, // Predicate_extload
/* 21839*/      OPC_CheckType, MVT::i32,
/* 21841*/      OPC_Scope, 37, /*->21880*/ // 2 children in Scope
/* 21843*/       OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 21845*/       OPC_MoveParent,
/* 21846*/       OPC_RecordChild2, // #3 = $idx
/* 21847*/       OPC_MoveChild2,
/* 21848*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21851*/       OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 21853*/       OPC_CheckType, MVT::i32,
/* 21855*/       OPC_MoveParent,
/* 21856*/       OPC_CheckType, MVT::v16i8,
/* 21858*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21860*/       OPC_EmitMergeInputChains1_1,
/* 21861*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21864*/       OPC_EmitInteger, MVT::i64, 0, 
/* 21867*/       OPC_EmitConvertToTarget, 3,
/* 21869*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v16i8, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I8x16_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21880*/      /*Scope*/ 37, /*->21918*/
/* 21881*/       OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 21883*/       OPC_MoveParent,
/* 21884*/       OPC_RecordChild2, // #3 = $idx
/* 21885*/       OPC_MoveChild2,
/* 21886*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21889*/       OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 21891*/       OPC_CheckType, MVT::i32,
/* 21893*/       OPC_MoveParent,
/* 21894*/       OPC_CheckType, MVT::v8i16,
/* 21896*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21898*/       OPC_EmitMergeInputChains1_1,
/* 21899*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21902*/       OPC_EmitInteger, MVT::i64, 0, 
/* 21905*/       OPC_EmitConvertToTarget, 3,
/* 21907*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v8i16, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21918*/      0, /*End of Scope*/
/* 21919*/     /*Scope*/ 78, /*->21998*/
/* 21920*/      OPC_CheckPredicate, 15, // Predicate_load
/* 21922*/      OPC_SwitchType /*2 cases */, 35, MVT::i32,// ->21960
/* 21925*/       OPC_MoveParent,
/* 21926*/       OPC_RecordChild2, // #3 = $idx
/* 21927*/       OPC_MoveChild2,
/* 21928*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21931*/       OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 21933*/       OPC_CheckType, MVT::i32,
/* 21935*/       OPC_MoveParent,
/* 21936*/       OPC_CheckType, MVT::v4i32,
/* 21938*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21940*/       OPC_EmitMergeInputChains1_1,
/* 21941*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21944*/       OPC_EmitInteger, MVT::i64, 0, 
/* 21947*/       OPC_EmitConvertToTarget, 3,
/* 21949*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v4i32, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21960*/      /*SwitchType*/ 35, MVT::i64,// ->21997
/* 21962*/       OPC_MoveParent,
/* 21963*/       OPC_RecordChild2, // #3 = $idx
/* 21964*/       OPC_MoveChild2,
/* 21965*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21968*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 21970*/       OPC_CheckType, MVT::i32,
/* 21972*/       OPC_MoveParent,
/* 21973*/       OPC_CheckType, MVT::v2i64,
/* 21975*/       OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 21977*/       OPC_EmitMergeInputChains1_1,
/* 21978*/       OPC_EmitInteger, MVT::i32, 0, 
/* 21981*/       OPC_EmitInteger, MVT::i64, 0, 
/* 21984*/       OPC_EmitConvertToTarget, 3,
/* 21986*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     MVT::v2i64, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21997*/      0, // EndSwitchType
/* 21998*/     0, /*End of Scope*/
/* 21999*/    0, /*End of Scope*/
/* 22000*/   /*Scope*/ 22|128,2/*278*/, /*->22280*/
/* 22002*/    OPC_RecordChild1, // #1 = $x
/* 22003*/    OPC_Scope, 121, /*->22126*/ // 4 children in Scope
/* 22005*/     OPC_CheckChild1Type, MVT::i32,
/* 22007*/     OPC_Scope, 66, /*->22075*/ // 2 children in Scope
/* 22009*/      OPC_RecordChild2, // #2 = $idx
/* 22010*/      OPC_MoveChild2,
/* 22011*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22014*/      OPC_CheckType, MVT::i32,
/* 22016*/      OPC_Scope, 18, /*->22036*/ // 3 children in Scope
/* 22018*/       OPC_CheckPredicate, 3, // Predicate_LaneIdx16
/* 22020*/       OPC_MoveParent,
/* 22021*/       OPC_CheckType, MVT::v16i8,
/* 22023*/       OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22025*/       OPC_EmitConvertToTarget, 2,
/* 22027*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16), 0,
                     MVT::v16i8, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 22036*/      /*Scope*/ 18, /*->22055*/
/* 22037*/       OPC_CheckPredicate, 7, // Predicate_LaneIdx8
/* 22039*/       OPC_MoveParent,
/* 22040*/       OPC_CheckType, MVT::v8i16,
/* 22042*/       OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22044*/       OPC_EmitConvertToTarget, 2,
/* 22046*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8), 0,
                     MVT::v8i16, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 22055*/      /*Scope*/ 18, /*->22074*/
/* 22056*/       OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 22058*/       OPC_MoveParent,
/* 22059*/       OPC_CheckType, MVT::v4i32,
/* 22061*/       OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22063*/       OPC_EmitConvertToTarget, 2,
/* 22065*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4), 0,
                     MVT::v4i32, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 22074*/      0, /*End of Scope*/
/* 22075*/     /*Scope*/ 49, /*->22125*/
/* 22076*/      OPC_MoveChild2,
/* 22077*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 22080*/      OPC_MoveParent,
/* 22081*/      OPC_SwitchType /*3 cases */, 12, MVT::v16i8,// ->22096
/* 22084*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22087*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16), 0,
                     MVT::v16i8, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 22096*/      /*SwitchType*/ 12, MVT::v8i16,// ->22110
/* 22098*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22101*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8), 0,
                     MVT::v8i16, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 22110*/      /*SwitchType*/ 12, MVT::v4i32,// ->22124
/* 22112*/       OPC_EmitInteger, MVT::i32, 0, 
/* 22115*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4), 0,
                     MVT::v4i32, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 22124*/      0, // EndSwitchType
/* 22125*/     0, /*End of Scope*/
/* 22126*/    /*Scope*/ 50, /*->22177*/
/* 22127*/     OPC_CheckChild1Type, MVT::i64,
/* 22129*/     OPC_Scope, 25, /*->22156*/ // 2 children in Scope
/* 22131*/      OPC_RecordChild2, // #2 = $idx
/* 22132*/      OPC_MoveChild2,
/* 22133*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22136*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 22138*/      OPC_CheckType, MVT::i32,
/* 22140*/      OPC_MoveParent,
/* 22141*/      OPC_CheckType, MVT::v2i64,
/* 22143*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22145*/      OPC_EmitConvertToTarget, 2,
/* 22147*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 22156*/     /*Scope*/ 19, /*->22176*/
/* 22157*/      OPC_MoveChild2,
/* 22158*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 22161*/      OPC_MoveParent,
/* 22162*/      OPC_CheckType, MVT::v2i64,
/* 22164*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22167*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2), 0,
                    MVT::v2i64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 22176*/     0, /*End of Scope*/
/* 22177*/    /*Scope*/ 50, /*->22228*/
/* 22178*/     OPC_CheckChild1Type, MVT::f32,
/* 22180*/     OPC_Scope, 25, /*->22207*/ // 2 children in Scope
/* 22182*/      OPC_RecordChild2, // #2 = $idx
/* 22183*/      OPC_MoveChild2,
/* 22184*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22187*/      OPC_CheckPredicate, 9, // Predicate_LaneIdx4
/* 22189*/      OPC_CheckType, MVT::i32,
/* 22191*/      OPC_MoveParent,
/* 22192*/      OPC_CheckType, MVT::v4f32,
/* 22194*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22196*/      OPC_EmitConvertToTarget, 2,
/* 22198*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4), 0,
                    MVT::v4f32, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 22207*/     /*Scope*/ 19, /*->22227*/
/* 22208*/      OPC_MoveChild2,
/* 22209*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 22212*/      OPC_MoveParent,
/* 22213*/      OPC_CheckType, MVT::v4f32,
/* 22215*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22218*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4), 0,
                    MVT::v4f32, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 22227*/     0, /*End of Scope*/
/* 22228*/    /*Scope*/ 50, /*->22279*/
/* 22229*/     OPC_CheckChild1Type, MVT::f64,
/* 22231*/     OPC_Scope, 25, /*->22258*/ // 2 children in Scope
/* 22233*/      OPC_RecordChild2, // #2 = $idx
/* 22234*/      OPC_MoveChild2,
/* 22235*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22238*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx2
/* 22240*/      OPC_CheckType, MVT::i32,
/* 22242*/      OPC_MoveParent,
/* 22243*/      OPC_CheckType, MVT::v2f64,
/* 22245*/      OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22247*/      OPC_EmitConvertToTarget, 2,
/* 22249*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2), 0,
                    MVT::v2f64, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 22258*/     /*Scope*/ 19, /*->22278*/
/* 22259*/      OPC_MoveChild2,
/* 22260*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 22263*/      OPC_MoveParent,
/* 22264*/      OPC_CheckType, MVT::v2f64,
/* 22266*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22269*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2), 0,
                    MVT::v2f64, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 22278*/     0, /*End of Scope*/
/* 22279*/    0, /*End of Scope*/
/* 22280*/   0, /*End of Scope*/
/* 22281*/  0, /*End of Scope*/
/* 22282*/ /*SwitchOpcode*/ 103|128,1/*231*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->22517
/* 22286*/  OPC_Scope, 95, /*->22383*/ // 2 children in Scope
/* 22288*/   OPC_MoveChild0,
/* 22289*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 22292*/   OPC_MoveChild0,
/* 22293*/   OPC_SwitchOpcode /*2 cases */, 41, TARGET_VAL(ISD::ADD),// ->22338
/* 22297*/    OPC_RecordChild0, // #0 = $lhs
/* 22298*/    OPC_RecordChild1, // #1 = $rhs
/* 22299*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 22301*/    OPC_MoveParent,
/* 22302*/    OPC_MoveChild1,
/* 22303*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 22306*/    OPC_CheckChild0Integer, 2, 
/* 22308*/    OPC_CheckChild0Type, MVT::i32,
/* 22310*/    OPC_MoveParent,
/* 22311*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 22313*/    OPC_MoveParent,
/* 22314*/    OPC_CheckChild1Integer, 2, 
/* 22316*/    OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->22327
/* 22319*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 22327*/    /*SwitchType*/ 8, MVT::v8i16,// ->22337
/* 22329*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22337*/    0, // EndSwitchType
/* 22338*/   /*SwitchOpcode*/ 41, TARGET_VAL(ISD::SPLAT_VECTOR),// ->22382
/* 22341*/    OPC_CheckChild0Integer, 2, 
/* 22343*/    OPC_CheckChild0Type, MVT::i32,
/* 22345*/    OPC_MoveParent,
/* 22346*/    OPC_MoveChild1,
/* 22347*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 22350*/    OPC_RecordChild0, // #0 = $lhs
/* 22351*/    OPC_RecordChild1, // #1 = $rhs
/* 22352*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 22354*/    OPC_MoveParent,
/* 22355*/    OPC_CheckPredicate, 26, // Predicate_add_nuw
/* 22357*/    OPC_MoveParent,
/* 22358*/    OPC_CheckChild1Integer, 2, 
/* 22360*/    OPC_SwitchType /*2 cases */, 8, MVT::v16i8,// ->22371
/* 22363*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 22371*/    /*SwitchType*/ 8, MVT::v8i16,// ->22381
/* 22373*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::AVGR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22381*/    0, // EndSwitchType
/* 22382*/   0, // EndSwitchOpcode
/* 22383*/  /*Scope*/ 3|128,1/*131*/, /*->22516*/
/* 22385*/   OPC_RecordChild0, // #0 = $lhs
/* 22386*/   OPC_Scope, 75, /*->22463*/ // 2 children in Scope
/* 22388*/    OPC_MoveChild1,
/* 22389*/    OPC_Scope, 26, /*->22417*/ // 4 children in Scope
/* 22391*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22394*/     OPC_MoveChild0,
/* 22395*/     OPC_CheckAndImm, 63, 
/* 22397*/     OPC_RecordChild0, // #1 = $rhs
/* 22398*/     OPC_MoveParent,
/* 22399*/     OPC_MoveParent,
/* 22400*/     OPC_CheckType, MVT::v2i64,
/* 22402*/     OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                   MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 22409*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22417*/    /*Scope*/ 14, /*->22432*/
/* 22418*/     OPC_CheckAndImm, 7, 
/* 22420*/     OPC_RecordChild0, // #1 = $rhs
/* 22421*/     OPC_MoveParent,
/* 22422*/     OPC_CheckType, MVT::v16i8,
/* 22424*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22432*/    /*Scope*/ 14, /*->22447*/
/* 22433*/     OPC_CheckAndImm, 15, 
/* 22435*/     OPC_RecordChild0, // #1 = $rhs
/* 22436*/     OPC_MoveParent,
/* 22437*/     OPC_CheckType, MVT::v8i16,
/* 22439*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22447*/    /*Scope*/ 14, /*->22462*/
/* 22448*/     OPC_CheckAndImm, 31, 
/* 22450*/     OPC_RecordChild0, // #1 = $rhs
/* 22451*/     OPC_MoveParent,
/* 22452*/     OPC_CheckType, MVT::v4i32,
/* 22454*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22462*/    0, /*End of Scope*/
/* 22463*/   /*Scope*/ 51, /*->22515*/
/* 22464*/    OPC_RecordChild1, // #1 = $x
/* 22465*/    OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->22478
/* 22468*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22470*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I8x16), 0,
                   MVT::v16i8, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22478*/    /*SwitchType*/ 10, MVT::v8i16,// ->22490
/* 22480*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22482*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I16x8), 0,
                   MVT::v8i16, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22490*/    /*SwitchType*/ 10, MVT::v4i32,// ->22502
/* 22492*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22494*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22502*/    /*SwitchType*/ 10, MVT::v2i64,// ->22514
/* 22504*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22506*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_U_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22514*/    0, // EndSwitchType
/* 22515*/   0, /*End of Scope*/
/* 22516*/  0, /*End of Scope*/
/* 22517*/ /*SwitchOpcode*/ 121|128,4/*633*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->23154
/* 22521*/  OPC_Scope, 107|128,1/*235*/, /*->22759*/ // 4 children in Scope
/* 22524*/   OPC_MoveChild0,
/* 22525*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22528*/   OPC_RecordMemRef,
/* 22529*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22530*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22531*/   OPC_Scope, 112, /*->22645*/ // 2 children in Scope
/* 22533*/    OPC_CheckChild1Type, MVT::i32,
/* 22535*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22537*/    OPC_Scope, 54, /*->22593*/ // 2 children in Scope
/* 22539*/     OPC_CheckPredicate, 18, // Predicate_extload
/* 22541*/     OPC_CheckType, MVT::i32,
/* 22543*/     OPC_Scope, 23, /*->22568*/ // 2 children in Scope
/* 22545*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 22547*/      OPC_MoveParent,
/* 22548*/      OPC_CheckType, MVT::v16i8,
/* 22550*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22552*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22555*/      OPC_EmitMergeInputChains1_0,
/* 22556*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22568*/     /*Scope*/ 23, /*->22592*/
/* 22569*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 22571*/      OPC_MoveParent,
/* 22572*/      OPC_CheckType, MVT::v8i16,
/* 22574*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22576*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22579*/      OPC_EmitMergeInputChains1_0,
/* 22580*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22583*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22592*/     0, /*End of Scope*/
/* 22593*/    /*Scope*/ 50, /*->22644*/
/* 22594*/     OPC_CheckPredicate, 15, // Predicate_load
/* 22596*/     OPC_SwitchType /*2 cases */, 21, MVT::i32,// ->22620
/* 22599*/      OPC_MoveParent,
/* 22600*/      OPC_CheckType, MVT::v4i32,
/* 22602*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22604*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22607*/      OPC_EmitMergeInputChains1_0,
/* 22608*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22611*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22620*/     /*SwitchType*/ 21, MVT::i64,// ->22643
/* 22622*/      OPC_MoveParent,
/* 22623*/      OPC_CheckType, MVT::v2i64,
/* 22625*/      OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22627*/      OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22630*/      OPC_EmitMergeInputChains1_0,
/* 22631*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22634*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22643*/     0, // EndSwitchType
/* 22644*/    0, /*End of Scope*/
/* 22645*/   /*Scope*/ 112, /*->22758*/
/* 22646*/    OPC_CheckChild1Type, MVT::i64,
/* 22648*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22650*/    OPC_Scope, 54, /*->22706*/ // 2 children in Scope
/* 22652*/     OPC_CheckPredicate, 18, // Predicate_extload
/* 22654*/     OPC_CheckType, MVT::i32,
/* 22656*/     OPC_Scope, 23, /*->22681*/ // 2 children in Scope
/* 22658*/      OPC_CheckPredicate, 0, // Predicate_extloadi8
/* 22660*/      OPC_MoveParent,
/* 22661*/      OPC_CheckType, MVT::v16i8,
/* 22663*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22665*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22668*/      OPC_EmitMergeInputChains1_0,
/* 22669*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22672*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v16i8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22681*/     /*Scope*/ 23, /*->22705*/
/* 22682*/      OPC_CheckPredicate, 1, // Predicate_extloadi16
/* 22684*/      OPC_MoveParent,
/* 22685*/      OPC_CheckType, MVT::v8i16,
/* 22687*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22689*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22692*/      OPC_EmitMergeInputChains1_0,
/* 22693*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22696*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v8i16, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22705*/     0, /*End of Scope*/
/* 22706*/    /*Scope*/ 50, /*->22757*/
/* 22707*/     OPC_CheckPredicate, 15, // Predicate_load
/* 22709*/     OPC_SwitchType /*2 cases */, 21, MVT::i32,// ->22733
/* 22712*/      OPC_MoveParent,
/* 22713*/      OPC_CheckType, MVT::v4i32,
/* 22715*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22717*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22720*/      OPC_EmitMergeInputChains1_0,
/* 22721*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22724*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22733*/     /*SwitchType*/ 21, MVT::i64,// ->22756
/* 22735*/      OPC_MoveParent,
/* 22736*/      OPC_CheckType, MVT::v2i64,
/* 22738*/      OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 22740*/      OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22743*/      OPC_EmitMergeInputChains1_0,
/* 22744*/      OPC_EmitInteger, MVT::i32, 0, 
/* 22747*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22756*/     0, // EndSwitchType
/* 22757*/    0, /*End of Scope*/
/* 22758*/   0, /*End of Scope*/
/* 22759*/  /*Scope*/ 65|128,1/*193*/, /*->22954*/
/* 22761*/   OPC_RecordChild0, // #0 = $x
/* 22762*/   OPC_Scope, 8|128,1/*136*/, /*->22901*/ // 3 children in Scope
/* 22765*/    OPC_MoveChild0,
/* 22766*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22769*/    OPC_SwitchType /*2 cases */, 111, MVT::i32,// ->22883
/* 22772*/     OPC_MoveParent,
/* 22773*/     OPC_SwitchType /*3 cases */, 54, MVT::v16i8,// ->22830
/* 22776*/      OPC_EmitConvertToTarget, 0,
/* 22778*/      OPC_EmitConvertToTarget, 0,
/* 22780*/      OPC_EmitConvertToTarget, 0,
/* 22782*/      OPC_EmitConvertToTarget, 0,
/* 22784*/      OPC_EmitConvertToTarget, 0,
/* 22786*/      OPC_EmitConvertToTarget, 0,
/* 22788*/      OPC_EmitConvertToTarget, 0,
/* 22790*/      OPC_EmitConvertToTarget, 0,
/* 22792*/      OPC_EmitConvertToTarget, 0,
/* 22794*/      OPC_EmitConvertToTarget, 0,
/* 22796*/      OPC_EmitConvertToTarget, 0,
/* 22798*/      OPC_EmitConvertToTarget, 0,
/* 22800*/      OPC_EmitConvertToTarget, 0,
/* 22802*/      OPC_EmitConvertToTarget, 0,
/* 22804*/      OPC_EmitConvertToTarget, 0,
/* 22806*/      OPC_EmitConvertToTarget, 0,
/* 22808*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I8x16), 0,
                    MVT::v16i8, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22830*/     /*SwitchType*/ 30, MVT::v8i16,// ->22862
/* 22832*/      OPC_EmitConvertToTarget, 0,
/* 22834*/      OPC_EmitConvertToTarget, 0,
/* 22836*/      OPC_EmitConvertToTarget, 0,
/* 22838*/      OPC_EmitConvertToTarget, 0,
/* 22840*/      OPC_EmitConvertToTarget, 0,
/* 22842*/      OPC_EmitConvertToTarget, 0,
/* 22844*/      OPC_EmitConvertToTarget, 0,
/* 22846*/      OPC_EmitConvertToTarget, 0,
/* 22848*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I16x8), 0,
                    MVT::v8i16, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22862*/     /*SwitchType*/ 18, MVT::v4i32,// ->22882
/* 22864*/      OPC_EmitConvertToTarget, 0,
/* 22866*/      OPC_EmitConvertToTarget, 0,
/* 22868*/      OPC_EmitConvertToTarget, 0,
/* 22870*/      OPC_EmitConvertToTarget, 0,
/* 22872*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I32x4), 0,
                    MVT::v4i32, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22882*/     0, // EndSwitchType
/* 22883*/    /*SwitchType*/ 15, MVT::i64,// ->22900
/* 22885*/     OPC_MoveParent,
/* 22886*/     OPC_CheckType, MVT::v2i64,
/* 22888*/     OPC_EmitConvertToTarget, 0,
/* 22890*/     OPC_EmitConvertToTarget, 0,
/* 22892*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_I64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 22900*/    0, // EndSwitchType
/* 22901*/   /*Scope*/ 37, /*->22939*/
/* 22902*/    OPC_CheckChild0Type, MVT::i32,
/* 22904*/    OPC_SwitchType /*3 cases */, 9, MVT::v16i8,// ->22916
/* 22907*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22909*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I8x16), 0,
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 22916*/    /*SwitchType*/ 9, MVT::v8i16,// ->22927
/* 22918*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22920*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I16x8), 0,
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 22927*/    /*SwitchType*/ 9, MVT::v4i32,// ->22938
/* 22929*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22931*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I32x4), 0,
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 22938*/    0, // EndSwitchType
/* 22939*/   /*Scope*/ 13, /*->22953*/
/* 22940*/    OPC_CheckChild0Type, MVT::i64,
/* 22942*/    OPC_CheckType, MVT::v2i64,
/* 22944*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 22946*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I64x2), 0,
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 22953*/   0, /*End of Scope*/
/* 22954*/  /*Scope*/ 119, /*->23074*/
/* 22955*/   OPC_MoveChild0,
/* 22956*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22959*/   OPC_RecordMemRef,
/* 22960*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22961*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22962*/   OPC_Scope, 54, /*->23018*/ // 2 children in Scope
/* 22964*/    OPC_CheckChild1Type, MVT::i32,
/* 22966*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 22968*/    OPC_CheckPredicate, 15, // Predicate_load
/* 22970*/    OPC_SwitchType /*2 cases */, 21, MVT::f32,// ->22994
/* 22973*/     OPC_MoveParent,
/* 22974*/     OPC_CheckType, MVT::v4f32,
/* 22976*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 22978*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22981*/     OPC_EmitMergeInputChains1_0,
/* 22982*/     OPC_EmitInteger, MVT::i32, 0, 
/* 22985*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22994*/    /*SwitchType*/ 21, MVT::f64,// ->23017
/* 22996*/     OPC_MoveParent,
/* 22997*/     OPC_CheckType, MVT::v2f64,
/* 22999*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 23001*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23004*/     OPC_EmitMergeInputChains1_0,
/* 23005*/     OPC_EmitInteger, MVT::i32, 0, 
/* 23008*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23017*/    0, // EndSwitchType
/* 23018*/   /*Scope*/ 54, /*->23073*/
/* 23019*/    OPC_CheckChild1Type, MVT::i64,
/* 23021*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 23023*/    OPC_CheckPredicate, 15, // Predicate_load
/* 23025*/    OPC_SwitchType /*2 cases */, 21, MVT::f32,// ->23049
/* 23028*/     OPC_MoveParent,
/* 23029*/     OPC_CheckType, MVT::v4f32,
/* 23031*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23033*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23036*/     OPC_EmitMergeInputChains1_0,
/* 23037*/     OPC_EmitInteger, MVT::i32, 0, 
/* 23040*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4f32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23049*/    /*SwitchType*/ 21, MVT::f64,// ->23072
/* 23051*/     OPC_MoveParent,
/* 23052*/     OPC_CheckType, MVT::v2f64,
/* 23054*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23056*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23059*/     OPC_EmitMergeInputChains1_0,
/* 23060*/     OPC_EmitInteger, MVT::i32, 0, 
/* 23063*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2f64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23072*/    0, // EndSwitchType
/* 23073*/   0, /*End of Scope*/
/* 23074*/  /*Scope*/ 78, /*->23153*/
/* 23075*/   OPC_RecordChild0, // #0 = $x
/* 23076*/   OPC_Scope, 46, /*->23124*/ // 3 children in Scope
/* 23078*/    OPC_MoveChild0,
/* 23079*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 23082*/    OPC_SwitchType /*2 cases */, 21, MVT::f32,// ->23106
/* 23085*/     OPC_MoveParent,
/* 23086*/     OPC_CheckType, MVT::v4f32,
/* 23088*/     OPC_EmitConvertToTarget, 0,
/* 23090*/     OPC_EmitConvertToTarget, 0,
/* 23092*/     OPC_EmitConvertToTarget, 0,
/* 23094*/     OPC_EmitConvertToTarget, 0,
/* 23096*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_F32x4), 0,
                   MVT::v4f32, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 23106*/    /*SwitchType*/ 15, MVT::f64,// ->23123
/* 23108*/     OPC_MoveParent,
/* 23109*/     OPC_CheckType, MVT::v2f64,
/* 23111*/     OPC_EmitConvertToTarget, 0,
/* 23113*/     OPC_EmitConvertToTarget, 0,
/* 23115*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::CONST_V128_F64x2), 0,
                   MVT::v2f64, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 23123*/    0, // EndSwitchType
/* 23124*/   /*Scope*/ 13, /*->23138*/
/* 23125*/    OPC_CheckChild0Type, MVT::f32,
/* 23127*/    OPC_CheckType, MVT::v4f32,
/* 23129*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23131*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F32x4), 0,
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 23138*/   /*Scope*/ 13, /*->23152*/
/* 23139*/    OPC_CheckChild0Type, MVT::f64,
/* 23141*/    OPC_CheckType, MVT::v2f64,
/* 23143*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23145*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F64x2), 0,
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 23152*/   0, /*End of Scope*/
/* 23153*/  0, /*End of Scope*/
/* 23154*/ /*SwitchOpcode*/ 66|128,1/*194*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->23352
/* 23158*/  OPC_Scope, 119, /*->23279*/ // 2 children in Scope
/* 23160*/   OPC_MoveChild0,
/* 23161*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 23164*/   OPC_RecordMemRef,
/* 23165*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 23166*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 23167*/   OPC_Scope, 54, /*->23223*/ // 2 children in Scope
/* 23169*/    OPC_CheckChild1Type, MVT::i32,
/* 23171*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 23173*/    OPC_CheckPredicate, 15, // Predicate_load
/* 23175*/    OPC_SwitchType /*2 cases */, 21, MVT::i32,// ->23199
/* 23178*/     OPC_MoveParent,
/* 23179*/     OPC_CheckType, MVT::v4i32,
/* 23181*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 23183*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23186*/     OPC_EmitMergeInputChains1_0,
/* 23187*/     OPC_EmitInteger, MVT::i32, 0, 
/* 23190*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23199*/    /*SwitchType*/ 21, MVT::i64,// ->23222
/* 23201*/     OPC_MoveParent,
/* 23202*/     OPC_CheckType, MVT::v2i64,
/* 23204*/     OPC_CheckPatternPredicate, 2, // (!Subtarget->hasAddr64())
/* 23206*/     OPC_CheckComplexPat, /*CP*/0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23209*/     OPC_EmitMergeInputChains1_0,
/* 23210*/     OPC_EmitInteger, MVT::i32, 0, 
/* 23213*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23222*/    0, // EndSwitchType
/* 23223*/   /*Scope*/ 54, /*->23278*/
/* 23224*/    OPC_CheckChild1Type, MVT::i64,
/* 23226*/    OPC_CheckPredicate, 14, // Predicate_unindexedload
/* 23228*/    OPC_CheckPredicate, 15, // Predicate_load
/* 23230*/    OPC_SwitchType /*2 cases */, 21, MVT::i32,// ->23254
/* 23233*/     OPC_MoveParent,
/* 23234*/     OPC_CheckType, MVT::v4i32,
/* 23236*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23238*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23241*/     OPC_EmitMergeInputChains1_0,
/* 23242*/     OPC_EmitInteger, MVT::i32, 0, 
/* 23245*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v4i32, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23254*/    /*SwitchType*/ 21, MVT::i64,// ->23277
/* 23256*/     OPC_MoveParent,
/* 23257*/     OPC_CheckType, MVT::v2i64,
/* 23259*/     OPC_CheckPatternPredicate, 3, // (Subtarget->hasAddr64())
/* 23261*/     OPC_CheckComplexPat, /*CP*/1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23264*/     OPC_EmitMergeInputChains1_0,
/* 23265*/     OPC_EmitInteger, MVT::i32, 0, 
/* 23268*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   MVT::v2i64, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23277*/    0, // EndSwitchType
/* 23278*/   0, /*End of Scope*/
/* 23279*/  /*Scope*/ 71, /*->23351*/
/* 23280*/   OPC_RecordChild0, // #0 = $x
/* 23281*/   OPC_Scope, 31, /*->23314*/ // 4 children in Scope
/* 23283*/    OPC_CheckChild0Type, MVT::i32,
/* 23285*/    OPC_SwitchType /*3 cases */, 7, MVT::v16i8,// ->23295
/* 23288*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I8x16), 0,
                   MVT::v16i8, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 23295*/    /*SwitchType*/ 7, MVT::v8i16,// ->23304
/* 23297*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I16x8), 0,
                   MVT::v8i16, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 23304*/    /*SwitchType*/ 7, MVT::v4i32,// ->23313
/* 23306*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I32x4), 0,
                   MVT::v4i32, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 23313*/    0, // EndSwitchType
/* 23314*/   /*Scope*/ 11, /*->23326*/
/* 23315*/    OPC_CheckChild0Type, MVT::i64,
/* 23317*/    OPC_CheckType, MVT::v2i64,
/* 23319*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_I64x2), 0,
                  MVT::v2i64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 23326*/   /*Scope*/ 11, /*->23338*/
/* 23327*/    OPC_CheckChild0Type, MVT::f32,
/* 23329*/    OPC_CheckType, MVT::v4f32,
/* 23331*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F32x4), 0,
                  MVT::v4f32, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 23338*/   /*Scope*/ 11, /*->23350*/
/* 23339*/    OPC_CheckChild0Type, MVT::f64,
/* 23341*/    OPC_CheckType, MVT::v2f64,
/* 23343*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SPLAT_F64x2), 0,
                  MVT::v2f64, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 23350*/   0, /*End of Scope*/
/* 23351*/  0, /*End of Scope*/
/* 23352*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->23487
/* 23356*/  OPC_RecordChild0, // #0 = $lhs
/* 23357*/  OPC_Scope, 75, /*->23434*/ // 2 children in Scope
/* 23359*/   OPC_MoveChild1,
/* 23360*/   OPC_Scope, 26, /*->23388*/ // 4 children in Scope
/* 23362*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23365*/    OPC_MoveChild0,
/* 23366*/    OPC_CheckAndImm, 63, 
/* 23368*/    OPC_RecordChild0, // #1 = $rhs
/* 23369*/    OPC_MoveParent,
/* 23370*/    OPC_MoveParent,
/* 23371*/    OPC_CheckType, MVT::v2i64,
/* 23373*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 23380*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23388*/   /*Scope*/ 14, /*->23403*/
/* 23389*/    OPC_CheckAndImm, 7, 
/* 23391*/    OPC_RecordChild0, // #1 = $rhs
/* 23392*/    OPC_MoveParent,
/* 23393*/    OPC_CheckType, MVT::v16i8,
/* 23395*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23403*/   /*Scope*/ 14, /*->23418*/
/* 23404*/    OPC_CheckAndImm, 15, 
/* 23406*/    OPC_RecordChild0, // #1 = $rhs
/* 23407*/    OPC_MoveParent,
/* 23408*/    OPC_CheckType, MVT::v8i16,
/* 23410*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23418*/   /*Scope*/ 14, /*->23433*/
/* 23419*/    OPC_CheckAndImm, 31, 
/* 23421*/    OPC_RecordChild0, // #1 = $rhs
/* 23422*/    OPC_MoveParent,
/* 23423*/    OPC_CheckType, MVT::v4i32,
/* 23425*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23433*/   0, /*End of Scope*/
/* 23434*/  /*Scope*/ 51, /*->23486*/
/* 23435*/   OPC_RecordChild1, // #1 = $x
/* 23436*/   OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->23449
/* 23439*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23441*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23449*/   /*SwitchType*/ 10, MVT::v8i16,// ->23461
/* 23451*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23453*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23461*/   /*SwitchType*/ 10, MVT::v4i32,// ->23473
/* 23463*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23465*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23473*/   /*SwitchType*/ 10, MVT::v2i64,// ->23485
/* 23475*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23477*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHL_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23485*/   0, // EndSwitchType
/* 23486*/  0, /*End of Scope*/
/* 23487*/ /*SwitchOpcode*/ 3|128,1/*131*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->23622
/* 23491*/  OPC_RecordChild0, // #0 = $lhs
/* 23492*/  OPC_Scope, 75, /*->23569*/ // 2 children in Scope
/* 23494*/   OPC_MoveChild1,
/* 23495*/   OPC_Scope, 26, /*->23523*/ // 4 children in Scope
/* 23497*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23500*/    OPC_MoveChild0,
/* 23501*/    OPC_CheckAndImm, 63, 
/* 23503*/    OPC_RecordChild0, // #1 = $rhs
/* 23504*/    OPC_MoveParent,
/* 23505*/    OPC_MoveParent,
/* 23506*/    OPC_CheckType, MVT::v2i64,
/* 23508*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::I32_WRAP_I64), 0,
                  MVT::i32, 1/*#Ops*/, 1,  // Results = #2
/* 23515*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23523*/   /*Scope*/ 14, /*->23538*/
/* 23524*/    OPC_CheckAndImm, 7, 
/* 23526*/    OPC_RecordChild0, // #1 = $rhs
/* 23527*/    OPC_MoveParent,
/* 23528*/    OPC_CheckType, MVT::v16i8,
/* 23530*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23538*/   /*Scope*/ 14, /*->23553*/
/* 23539*/    OPC_CheckAndImm, 15, 
/* 23541*/    OPC_RecordChild0, // #1 = $rhs
/* 23542*/    OPC_MoveParent,
/* 23543*/    OPC_CheckType, MVT::v8i16,
/* 23545*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23553*/   /*Scope*/ 14, /*->23568*/
/* 23554*/    OPC_CheckAndImm, 31, 
/* 23556*/    OPC_RecordChild0, // #1 = $rhs
/* 23557*/    OPC_MoveParent,
/* 23558*/    OPC_CheckType, MVT::v4i32,
/* 23560*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23568*/   0, /*End of Scope*/
/* 23569*/  /*Scope*/ 51, /*->23621*/
/* 23570*/   OPC_RecordChild1, // #1 = $x
/* 23571*/   OPC_SwitchType /*4 cases */, 10, MVT::v16i8,// ->23584
/* 23574*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23576*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I8x16), 0,
                  MVT::v16i8, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23584*/   /*SwitchType*/ 10, MVT::v8i16,// ->23596
/* 23586*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23588*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I16x8), 0,
                  MVT::v8i16, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23596*/   /*SwitchType*/ 10, MVT::v4i32,// ->23608
/* 23598*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23600*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I32x4), 0,
                  MVT::v4i32, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23608*/   /*SwitchType*/ 10, MVT::v2i64,// ->23620
/* 23610*/    OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23612*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SHR_S_I64x2), 0,
                  MVT::v2i64, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23620*/   0, // EndSwitchType
/* 23621*/  0, /*End of Scope*/
/* 23622*/ /*SwitchOpcode*/ 18|128,2/*274*/, TARGET_VAL(ISD::VSELECT),// ->23900
/* 23626*/  OPC_Scope, 103, /*->23731*/ // 4 children in Scope
/* 23628*/   OPC_MoveChild0,
/* 23629*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23632*/   OPC_MoveChild0,
/* 23633*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23636*/   OPC_RecordChild0, // #0 = $rhs
/* 23637*/   OPC_SwitchType /*2 cases */, 44, MVT::v4f32,// ->23684
/* 23640*/    OPC_CheckChild0Type, MVT::v4i32,
/* 23642*/    OPC_MoveParent,
/* 23643*/    OPC_MoveChild1,
/* 23644*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23647*/    OPC_RecordChild0, // #1 = $lhs
/* 23648*/    OPC_CheckChild0Type, MVT::v4i32,
/* 23650*/    OPC_MoveParent,
/* 23651*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23653*/    OPC_MoveParent,
/* 23654*/    OPC_CheckType, MVT::v4i32,
/* 23656*/    OPC_Scope, 12, /*->23670*/ // 2 children in Scope
/* 23658*/     OPC_CheckChild1Same, 0,
/* 23660*/     OPC_CheckChild2Same, 1,
/* 23662*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23670*/    /*Scope*/ 12, /*->23683*/
/* 23671*/     OPC_CheckChild1Same, 1,
/* 23673*/     OPC_CheckChild2Same, 0,
/* 23675*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                   MVT::v4i32, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23683*/    0, /*End of Scope*/
/* 23684*/   /*SwitchType*/ 44, MVT::v2f64,// ->23730
/* 23686*/    OPC_CheckChild0Type, MVT::v2i64,
/* 23688*/    OPC_MoveParent,
/* 23689*/    OPC_MoveChild1,
/* 23690*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23693*/    OPC_RecordChild0, // #1 = $lhs
/* 23694*/    OPC_CheckChild0Type, MVT::v2i64,
/* 23696*/    OPC_MoveParent,
/* 23697*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23699*/    OPC_MoveParent,
/* 23700*/    OPC_CheckType, MVT::v2i64,
/* 23702*/    OPC_Scope, 12, /*->23716*/ // 2 children in Scope
/* 23704*/     OPC_CheckChild1Same, 0,
/* 23706*/     OPC_CheckChild2Same, 1,
/* 23708*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23716*/    /*Scope*/ 12, /*->23729*/
/* 23717*/     OPC_CheckChild1Same, 1,
/* 23719*/     OPC_CheckChild2Same, 0,
/* 23721*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                   MVT::v2i64, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23729*/    0, /*End of Scope*/
/* 23730*/   0, // EndSwitchType
/* 23731*/  /*Scope*/ 49, /*->23781*/
/* 23732*/   OPC_RecordChild0, // #0 = $c
/* 23733*/   OPC_RecordChild1, // #1 = $v1
/* 23734*/   OPC_RecordChild2, // #2 = $v2
/* 23735*/   OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->23747
/* 23738*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v16i8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 23747*/   /*SwitchType*/ 9, MVT::v8i16,// ->23758
/* 23749*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v8i16, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 23758*/   /*SwitchType*/ 9, MVT::v4i32,// ->23769
/* 23760*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4i32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 23769*/   /*SwitchType*/ 9, MVT::v2i64,// ->23780
/* 23771*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2i64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 23780*/   0, // EndSwitchType
/* 23781*/  /*Scope*/ 89, /*->23871*/
/* 23782*/   OPC_MoveChild0,
/* 23783*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23786*/   OPC_RecordChild0, // #0 = $rhs
/* 23787*/   OPC_Scope, 40, /*->23829*/ // 2 children in Scope
/* 23789*/    OPC_CheckChild0Type, MVT::v4f32,
/* 23791*/    OPC_RecordChild1, // #1 = $lhs
/* 23792*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23794*/    OPC_MoveParent,
/* 23795*/    OPC_CheckType, MVT::v4f32,
/* 23797*/    OPC_Scope, 14, /*->23813*/ // 2 children in Scope
/* 23799*/     OPC_CheckChild1Same, 0,
/* 23801*/     OPC_CheckChild2Same, 1,
/* 23803*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23805*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F32x4), 0,
                   MVT::v4f32, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
               // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23813*/    /*Scope*/ 14, /*->23828*/
/* 23814*/     OPC_CheckChild1Same, 1,
/* 23816*/     OPC_CheckChild2Same, 0,
/* 23818*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23820*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F32x4), 0,
                   MVT::v4f32, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
               // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23828*/    0, /*End of Scope*/
/* 23829*/   /*Scope*/ 40, /*->23870*/
/* 23830*/    OPC_CheckChild0Type, MVT::v2f64,
/* 23832*/    OPC_RecordChild1, // #1 = $lhs
/* 23833*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23835*/    OPC_MoveParent,
/* 23836*/    OPC_CheckType, MVT::v2f64,
/* 23838*/    OPC_Scope, 14, /*->23854*/ // 2 children in Scope
/* 23840*/     OPC_CheckChild1Same, 0,
/* 23842*/     OPC_CheckChild2Same, 1,
/* 23844*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23846*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMIN_F64x2), 0,
                   MVT::v2f64, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
               // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23854*/    /*Scope*/ 14, /*->23869*/
/* 23855*/     OPC_CheckChild1Same, 1,
/* 23857*/     OPC_CheckChild2Same, 0,
/* 23859*/     OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23861*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::PMAX_F64x2), 0,
                   MVT::v2f64, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
               // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23869*/    0, /*End of Scope*/
/* 23870*/   0, /*End of Scope*/
/* 23871*/  /*Scope*/ 27, /*->23899*/
/* 23872*/   OPC_RecordChild0, // #0 = $c
/* 23873*/   OPC_RecordChild1, // #1 = $v1
/* 23874*/   OPC_RecordChild2, // #2 = $v2
/* 23875*/   OPC_SwitchType /*2 cases */, 9, MVT::v4f32,// ->23887
/* 23878*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v4f32, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 23887*/   /*SwitchType*/ 9, MVT::v2f64,// ->23898
/* 23889*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::BITSELECT), 0,
                  MVT::v2f64, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 23898*/   0, // EndSwitchType
/* 23899*/  0, /*End of Scope*/
/* 23900*/ /*SwitchOpcode*/ 18, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->23921
/* 23903*/  OPC_RecordChild0, // #0 = $src
/* 23904*/  OPC_CheckChild0Type, MVT::v16i8,
/* 23906*/  OPC_RecordChild1, // #1 = $mask
/* 23907*/  OPC_CheckChild1Type, MVT::v16i8,
/* 23909*/  OPC_CheckType, MVT::v16i8,
/* 23911*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23913*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::SWIZZLE), 0,
                MVT::v16i8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 23921*/ /*SwitchOpcode*/ 47, TARGET_VAL(ISD::ABS),// ->23971
/* 23924*/  OPC_RecordChild0, // #0 = $v
/* 23925*/  OPC_SwitchType /*4 cases */, 9, MVT::v16i8,// ->23937
/* 23928*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23930*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I8x16), 0,
                 MVT::v16i8, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 23937*/  /*SwitchType*/ 9, MVT::v8i16,// ->23948
/* 23939*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23941*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 23948*/  /*SwitchType*/ 9, MVT::v4i32,// ->23959
/* 23950*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23952*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 23959*/  /*SwitchType*/ 9, MVT::v2i64,// ->23970
/* 23961*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23963*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ABS_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 23970*/  0, // EndSwitchType
/* 23971*/ /*SwitchOpcode*/ 28, TARGET_VAL(ISD::SADDSAT),// ->24002
/* 23974*/  OPC_RecordChild0, // #0 = $lhs
/* 23975*/  OPC_RecordChild1, // #1 = $rhs
/* 23976*/  OPC_SwitchType /*2 cases */, 10, MVT::v16i8,// ->23989
/* 23979*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23981*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 23989*/  /*SwitchType*/ 10, MVT::v8i16,// ->24001
/* 23991*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 23993*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24001*/  0, // EndSwitchType
/* 24002*/ /*SwitchOpcode*/ 28, TARGET_VAL(ISD::UADDSAT),// ->24033
/* 24005*/  OPC_RecordChild0, // #0 = $lhs
/* 24006*/  OPC_RecordChild1, // #1 = $rhs
/* 24007*/  OPC_SwitchType /*2 cases */, 10, MVT::v16i8,// ->24020
/* 24010*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24012*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24020*/  /*SwitchType*/ 10, MVT::v8i16,// ->24032
/* 24022*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24024*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24032*/  0, // EndSwitchType
/* 24033*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::SMIN),// ->24076
/* 24036*/  OPC_RecordChild0, // #0 = $lhs
/* 24037*/  OPC_RecordChild1, // #1 = $rhs
/* 24038*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->24051
/* 24041*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24043*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_S_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24051*/  /*SwitchType*/ 10, MVT::v8i16,// ->24063
/* 24053*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24055*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24063*/  /*SwitchType*/ 10, MVT::v4i32,// ->24075
/* 24065*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24067*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_S_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24075*/  0, // EndSwitchType
/* 24076*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::UMIN),// ->24119
/* 24079*/  OPC_RecordChild0, // #0 = $lhs
/* 24080*/  OPC_RecordChild1, // #1 = $rhs
/* 24081*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->24094
/* 24084*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24086*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24094*/  /*SwitchType*/ 10, MVT::v8i16,// ->24106
/* 24096*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24098*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24106*/  /*SwitchType*/ 10, MVT::v4i32,// ->24118
/* 24108*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24110*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MIN_U_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24118*/  0, // EndSwitchType
/* 24119*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::SMAX),// ->24162
/* 24122*/  OPC_RecordChild0, // #0 = $lhs
/* 24123*/  OPC_RecordChild1, // #1 = $rhs
/* 24124*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->24137
/* 24127*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24129*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_S_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24137*/  /*SwitchType*/ 10, MVT::v8i16,// ->24149
/* 24139*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24141*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_S_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24149*/  /*SwitchType*/ 10, MVT::v4i32,// ->24161
/* 24151*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24153*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_S_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24161*/  0, // EndSwitchType
/* 24162*/ /*SwitchOpcode*/ 40, TARGET_VAL(ISD::UMAX),// ->24205
/* 24165*/  OPC_RecordChild0, // #0 = $lhs
/* 24166*/  OPC_RecordChild1, // #1 = $rhs
/* 24167*/  OPC_SwitchType /*3 cases */, 10, MVT::v16i8,// ->24180
/* 24170*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24172*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24180*/  /*SwitchType*/ 10, MVT::v8i16,// ->24192
/* 24182*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24184*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24192*/  /*SwitchType*/ 10, MVT::v4i32,// ->24204
/* 24194*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24196*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MAX_U_I32x4), 0,
                 MVT::v4i32, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24204*/  0, // EndSwitchType
/* 24205*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->24222
/* 24208*/  OPC_RecordChild0, // #0 = $vec
/* 24209*/  OPC_CheckChild0Type, MVT::v2f64,
/* 24211*/  OPC_CheckType, MVT::v4i32,
/* 24213*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24215*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4), 0,
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 24222*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->24239
/* 24225*/  OPC_RecordChild0, // #0 = $vec
/* 24226*/  OPC_CheckChild0Type, MVT::v2f64,
/* 24228*/  OPC_CheckType, MVT::v4i32,
/* 24230*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24232*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4), 0,
                MVT::v4i32, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 24239*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->24284
/* 24242*/  OPC_RecordChild0, // #0 = $vec
/* 24243*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->24257
/* 24246*/   OPC_CheckChild0Type, MVT::v16i8,
/* 24248*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24250*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_s_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24257*/  /*SwitchType*/ 11, MVT::v4i32,// ->24270
/* 24259*/   OPC_CheckChild0Type, MVT::v8i16,
/* 24261*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24263*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_s_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24270*/  /*SwitchType*/ 11, MVT::v2i64,// ->24283
/* 24272*/   OPC_CheckChild0Type, MVT::v4i32,
/* 24274*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24276*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_s_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24283*/  0, // EndSwitchType
/* 24284*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->24329
/* 24287*/  OPC_RecordChild0, // #0 = $vec
/* 24288*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->24302
/* 24291*/   OPC_CheckChild0Type, MVT::v16i8,
/* 24293*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24295*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_s_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24302*/  /*SwitchType*/ 11, MVT::v4i32,// ->24315
/* 24304*/   OPC_CheckChild0Type, MVT::v8i16,
/* 24306*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24308*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_s_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24315*/  /*SwitchType*/ 11, MVT::v2i64,// ->24328
/* 24317*/   OPC_CheckChild0Type, MVT::v4i32,
/* 24319*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24321*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_s_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24328*/  0, // EndSwitchType
/* 24329*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->24374
/* 24332*/  OPC_RecordChild0, // #0 = $vec
/* 24333*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->24347
/* 24336*/   OPC_CheckChild0Type, MVT::v16i8,
/* 24338*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24340*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_u_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24347*/  /*SwitchType*/ 11, MVT::v4i32,// ->24360
/* 24349*/   OPC_CheckChild0Type, MVT::v8i16,
/* 24351*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24353*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_u_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24360*/  /*SwitchType*/ 11, MVT::v2i64,// ->24373
/* 24362*/   OPC_CheckChild0Type, MVT::v4i32,
/* 24364*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24366*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_low_u_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24373*/  0, // EndSwitchType
/* 24374*/ /*SwitchOpcode*/ 42, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->24419
/* 24377*/  OPC_RecordChild0, // #0 = $vec
/* 24378*/  OPC_SwitchType /*3 cases */, 11, MVT::v8i16,// ->24392
/* 24381*/   OPC_CheckChild0Type, MVT::v16i8,
/* 24383*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24385*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_u_I16x8), 0,
                 MVT::v8i16, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24392*/  /*SwitchType*/ 11, MVT::v4i32,// ->24405
/* 24394*/   OPC_CheckChild0Type, MVT::v8i16,
/* 24396*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24398*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_u_I32x4), 0,
                 MVT::v4i32, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24405*/  /*SwitchType*/ 11, MVT::v2i64,// ->24418
/* 24407*/   OPC_CheckChild0Type, MVT::v4i32,
/* 24409*/   OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24411*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::extend_high_u_I64x2), 0,
                 MVT::v2i64, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24418*/  0, // EndSwitchType
/* 24419*/ /*SwitchOpcode*/ 33, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->24455
/* 24422*/  OPC_RecordChild0, // #0 = $left
/* 24423*/  OPC_SwitchType /*2 cases */, 13, MVT::v16i8,// ->24439
/* 24426*/   OPC_CheckChild0Type, MVT::v8i16,
/* 24428*/   OPC_RecordChild1, // #1 = $right
/* 24429*/   OPC_CheckChild1Type, MVT::v8i16,
/* 24431*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_U_I8x16), 0,
                 MVT::v16i8, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 24439*/  /*SwitchType*/ 13, MVT::v8i16,// ->24454
/* 24441*/   OPC_CheckChild0Type, MVT::v4i32,
/* 24443*/   OPC_RecordChild1, // #1 = $right
/* 24444*/   OPC_CheckChild1Type, MVT::v4i32,
/* 24446*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::NARROW_U_I16x8), 0,
                 MVT::v8i16, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 24454*/  0, // EndSwitchType
/* 24455*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->24472
/* 24458*/  OPC_RecordChild0, // #0 = $vec
/* 24459*/  OPC_CheckChild0Type, MVT::v4i32,
/* 24461*/  OPC_CheckType, MVT::v2f64,
/* 24463*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24465*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::convert_low_s_F64x2), 0,
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 24472*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->24489
/* 24475*/  OPC_RecordChild0, // #0 = $vec
/* 24476*/  OPC_CheckChild0Type, MVT::v4i32,
/* 24478*/  OPC_CheckType, MVT::v2f64,
/* 24480*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24482*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::convert_low_u_F64x2), 0,
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 24489*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->24506
/* 24492*/  OPC_RecordChild0, // #0 = $vec
/* 24493*/  OPC_CheckChild0Type, MVT::v2f64,
/* 24495*/  OPC_CheckType, MVT::v4f32,
/* 24497*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24499*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::demote_zero_F32x4), 0,
                MVT::v4f32, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 24506*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->24523
/* 24509*/  OPC_RecordChild0, // #0 = $vec
/* 24510*/  OPC_CheckChild0Type, MVT::v4f32,
/* 24512*/  OPC_CheckType, MVT::v2f64,
/* 24514*/  OPC_CheckPatternPredicate, 6, // (Subtarget->hasSIMD128())
/* 24516*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::promote_low_F64x2), 0,
                MVT::v2f64, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 24523*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 24525 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 323
  // #OPC_RecordNode                           = 125
  // #OPC_RecordChild                          = 773
  // #OPC_RecordMemRef                         = 39
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 476
  // #OPC_MoveParent                           = 741
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 103
  // #OPC_CheckPatternPredicate                = 649
  // #OPC_CheckPredicate                       = 531
  // #OPC_CheckOpcode                          = 406
  // #OPC_SwitchOpcode                         = 9
  // #OPC_CheckType                            = 406
  // #OPC_SwitchType                           = 177
  // #OPC_CheckChildType                       = 431
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 97
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 136
  // #OPC_CheckValueType                       = 15
  // #OPC_CheckComplexPat                      = 318
  // #OPC_CheckAndImm                          = 24
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 5
  // #OPC_EmitInteger                          = 345
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 214
  // #OPC_EmitMergeInputChains                 = 414
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 32
  // #OPC_MorphNodeTo                          = 1122

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable,sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 1: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 2: return (!Subtarget->hasAddr64());
  case 3: return (Subtarget->hasAddr64());
  case 4: return (Subtarget->hasReferenceTypes());
  case 5: return (Subtarget->hasExceptionHandling());
  case 6: return (Subtarget->hasSIMD128());
  case 7: return (Subtarget->hasSignExt());
  case 8: return (Subtarget->hasBulkMemory());
  case 9: return (Subtarget->hasRelaxedSIMD());
  case 10: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 11: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 12: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 13: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 14: return (Subtarget->hasNontrappingFPToInt());
  case 15: return (!Subtarget->hasNontrappingFPToInt());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_atomic_cmp_swap_8
    // Predicate_atomic_load_add_8
    // Predicate_atomic_load_sub_8
    // Predicate_atomic_load_and_8
    // Predicate_atomic_load_or_8
    // Predicate_atomic_load_xor_8
    // Predicate_atomic_swap_8
    // Predicate_atomic_load_8
    // Predicate_atomic_store_8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    // Predicate_extloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 1: {
    // Predicate_atomic_cmp_swap_16
    // Predicate_atomic_load_add_16
    // Predicate_atomic_load_sub_16
    // Predicate_atomic_load_and_16
    // Predicate_atomic_load_or_16
    // Predicate_atomic_load_xor_16
    // Predicate_atomic_swap_16
    // Predicate_atomic_load_16
    // Predicate_atomic_store_16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    // Predicate_extloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_32
    // Predicate_atomic_load_add_32
    // Predicate_atomic_load_sub_32
    // Predicate_atomic_load_and_32
    // Predicate_atomic_load_or_32
    // Predicate_atomic_load_xor_32
    // Predicate_atomic_swap_32
    // Predicate_atomic_load_32
    // Predicate_atomic_store_32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    // Predicate_extloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 3: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 7: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 8: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 9: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 10: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 12: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 13: {
    // Predicate_atomic_store_64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_64
    // Predicate_atomic_load_sub_64
    // Predicate_atomic_load_and_64
    // Predicate_atomic_load_or_64
    // Predicate_atomic_load_xor_64
    // Predicate_atomic_swap_64
    // Predicate_atomic_cmp_swap_64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 14: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 15: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 16: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 17: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 18: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 19: {
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    // Predicate_extloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 20: {
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    // Predicate_extloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 21: {
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    // Predicate_extloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 22: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  case 23: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << (8 - 1));
  }
  case 24: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << (16 - 1));
  }
  case 25: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 26: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
